Package: vivainsights
Type: Package
Title: Analyze and Visualize Data from 'Microsoft Viva Insights'
Version: 0.7.2
Authors@R: c(
    person(given = "Martin", family = "Chan", role = c("aut", "cre"), email = "martin.chan@microsoft.com"),
    person(given = "Carlos", family = "Morales", role = "aut", email = "carlos.morales@microsoft.com")
	)
Maintainer: Martin Chan <martin.chan@microsoft.com>
Description: Provides a versatile range of functions, including exploratory data analysis, time-series analysis, organizational network analysis, and data validation, whilst at the same time implements a set of best practices in analyzing and visualizing data specific to 'Microsoft Viva Insights'.
RoxygenNote: 7.3.3
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Language: en-US
Depends: R (>= 4.1.0)
Imports: dplyr, stats, utils, tidyr, tibble, tidyselect (>= 1.0.0),
        magrittr, ggplot2, reshape2, scales, ggrepel, purrr,
        data.table, methods, htmltools, markdown, networkD3, rmarkdown,
        wpa, ggraph, lifecycle, glue, igraph, rlang, tidytext
Suggests: flexdashboard, testthat (>= 3.0.0), lmtest, sandwich, slider,
        ggwordcloud
URL: https://microsoft.github.io/vivainsights/
BugReports: https://github.com/microsoft/vivainsights/issues/
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-04-28 16:18:03 UTC; martinchan
Author: Martin Chan [aut, cre],
  Carlos Morales [aut]
Repository: CRAN
Date/Publication: 2026-04-28 16:50:02 UTC
Built: R 4.5.2; ; 2026-04-28 20:15:36 UTC; unix

Package: vivainsights
Type: Package
Title: Analyze and Visualize Data from 'Microsoft Viva Insights'
Version: 0.7.2
Authors@R: c(
    person(given = "Martin", family = "Chan", role = c("aut", "cre"), email = "martin.chan@microsoft.com"),
    person(given = "Carlos", family = "Morales", role = "aut", email = "carlos.morales@microsoft.com")
	)
Maintainer: Martin Chan <martin.chan@microsoft.com>
Description: Provides a versatile range of functions, including exploratory data analysis, time-series analysis, organizational network analysis, and data validation, whilst at the same time implements a set of best practices in analyzing and visualizing data specific to 'Microsoft Viva Insights'.
RoxygenNote: 7.3.3
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Language: en-US
Depends: R (>= 4.1.0)
Imports: dplyr, stats, utils, tidyr, tibble, tidyselect (>= 1.0.0),
        magrittr, ggplot2, reshape2, scales, ggrepel, purrr,
        data.table, methods, htmltools, markdown, networkD3, rmarkdown,
        wpa, ggraph, lifecycle, glue, igraph, rlang, tidytext
Suggests: flexdashboard, testthat (>= 3.0.0), lmtest, sandwich, slider,
        ggwordcloud
URL: https://microsoft.github.io/vivainsights/
BugReports: https://github.com/microsoft/vivainsights/issues/
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-04-28 16:18:03 UTC; martinchan
Author: Martin Chan [aut, cre],
  Carlos Morales [aut]
Repository: CRAN
Date/Publication: 2026-04-28 16:50:02 UTC
Built: R 4.5.2; ; 2026-05-01 19:35:24 UTC; unix

# vivainsights <img src="https://raw.githubusercontent.com/microsoft/vivainsights/main/man/figures/logo.png" align="right" width=15% />

[![R build status](https://github.com/microsoft/vivainsights/workflows/R-CMD-check/badge.svg)](https://github.com/microsoft/wpa/actions/)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/license/mit)
[![CRAN status](https://www.r-pkg.org/badges/version/vivainsights)](https://CRAN.R-project.org/package=vivainsights/)
[![CRAN last month downloads](https://cranlogs.r-pkg.org/badges/last-month/vivainsights?color=green/)](https://cran.r-project.org/package=vivainsights/)

## Overview

This is an R package for analyzing and visualizing data from [Microsoft Viva Advanced Insights](https://www.microsoft.com/en-gb/microsoft-viva/insights/) (previously Microsoft Workplace Analytics). 

### With the **vivainsights** package, you can...

1. **Run prebuilt analysis and visualizations** off advanced insights data with settings for HR variables, privacy threshold, etc.

2. Leverage **advanced analytics functions** which are built for Viva Insights metrics

3. Integrate analysis of Viva Insights data with your R workflow seamlessly

This library is compatible with the latest implementation of the Viva Insights Analyst Workbench. For the R library compatible with the legacy implementation, please visit the **wpa** package [website](https://microsoft.github.io/wpa/) or [GitHub repository](https://github.com/microsoft/wpa/) . 

## Installation

```r
# Install from CRAN:
install.packages("vivainsights")

# Install development version from GitHub:
pak::pak("microsoft/vivainsights")
```

## Usage

To get started with the package, please see the following links:

* [Installation and Set-up](https://microsoft.github.io/vivainsights/analyst_guide_getting_started.html)
* [Full function list](https://microsoft.github.io/vivainsights/reference/index.html)
* [Analyst Guide](https://microsoft.github.io/vivainsights/analyst_guide_intro.html)

### Privacy threshold with `mingroup`

Most plotting and analysis functions support the `mingroup` argument (default:
`5`) to suppress very small groups for privacy and readability.

```r
data("pq_data")

# Check available HR variables and how many groups they have
pq_data %>%
  hrvar_count_all(return = "table")

# Set a higher threshold when plotting
pq_data %>%
  meeting_trend(hrvar = "Organization", mingroup = 10, return = "plot")
```

## Cheatsheet

Also check out our package cheat sheet for a quick glimpse of what **vivainsights** offers:

<a href="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/vivainsights_r.pdf"><img src="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/pngs/vivainsights_r_p1.png" align="center" width=50% /></a>

<a href="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/vivainsights_r.pdf"><img src="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/pngs/vivainsights_r_p2.png" align="center" width=50% /></a>

## Related repositories

- [Viva RMarkdown Report Marketplace](https://github.com/microsoft/VivaRMDReportMarketplace/)
- [Viva Insights Sample Code](https://github.com/microsoft/viva-insights-sample-code/)
- [Viva Insights Zoom Integration](https://github.com/microsoft/vivainsights_zoom_int/)
- [Viva Insights OData Query Download](https://github.com/microsoft/vivainsights-odatadl/)
- [Viva Insights R library (legacy)](https://microsoft.github.io/wpa/)
- [Viva Insights Python library](https://github.com/microsoft/vivainsights-py/)

---

## Code of Conduct

We would ask you to please read the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/) prior to engaging with this package.

**Trademarks** 

This project may contain trademarks or logos for projects, products, or services. Authorized use of Microsoft trademarks or logos is subject to and must follow [Microsoft's Trademark & Brand Guidelines](https://www.microsoft.com/en-us/legal/intellectualproperty/trademarks/). Use of Microsoft trademarks or logos in modified versions of this project must not cause confusion or imply Microsoft sponsorship. Any use of third-party trademarks or logos are subject to those third-party's policies.

---

## Finding this project useful? 

:star: Please star this repository to keep us going! 

# vivainsights <img src="https://raw.githubusercontent.com/microsoft/vivainsights/main/man/figures/logo.png" align="right" width=15% />

[![R build status](https://github.com/microsoft/vivainsights/workflows/R-CMD-check/badge.svg)](https://github.com/microsoft/wpa/actions/)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/license/mit)
[![CRAN status](https://www.r-pkg.org/badges/version/vivainsights)](https://CRAN.R-project.org/package=vivainsights/)
[![CRAN last month downloads](https://cranlogs.r-pkg.org/badges/last-month/vivainsights?color=green/)](https://cran.r-project.org/package=vivainsights/)

## Overview

This is an R package for analyzing and visualizing data from [Microsoft Viva Advanced Insights](https://www.microsoft.com/en-gb/microsoft-viva/insights/) (previously Microsoft Workplace Analytics). 

### With the **vivainsights** package, you can...

1. **Run prebuilt analysis and visualizations** off advanced insights data with settings for HR variables, privacy threshold, etc.

2. Leverage **advanced analytics functions** which are built for Viva Insights metrics

3. Integrate analysis of Viva Insights data with your R workflow seamlessly

This library is compatible with the latest implementation of the Viva Insights Analyst Workbench. For the R library compatible with the legacy implementation, please visit the **wpa** package [website](https://microsoft.github.io/wpa/) or [GitHub repository](https://github.com/microsoft/wpa/) . 

## Installation

```r
# Install from CRAN:
install.packages("vivainsights")

# Install development version from GitHub:
pak::pak("microsoft/vivainsights")
```

## Usage

To get started with the package, please see the following links:

* [Installation and Set-up](https://microsoft.github.io/vivainsights/analyst_guide_getting_started.html)
* [Full function list](https://microsoft.github.io/vivainsights/reference/index.html)
* [Analyst Guide](https://microsoft.github.io/vivainsights/analyst_guide_intro.html)

## Cheatsheet

Also check out our package cheat sheet for a quick glimpse of what **vivainsights** offers:

<a href="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/vivainsights_r.pdf"><img src="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/pngs/vivainsights_r_p1.png" align="center" width=50% /></a>

<a href="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/vivainsights_r.pdf"><img src="https://raw.githubusercontent.com/martinctc/cheatsheets/add-vivainsights-r-and-py/pngs/vivainsights_r_p2.png" align="center" width=50% /></a>

## Related repositories

- [Viva RMarkdown Report Marketplace](https://github.com/microsoft/VivaRMDReportMarketplace/)
- [Viva Insights Sample Code](https://github.com/microsoft/viva-insights-sample-code/)
- [Viva Insights Zoom Integration](https://github.com/microsoft/vivainsights_zoom_int/)
- [Viva Insights OData Query Download](https://github.com/microsoft/vivainsights-odatadl/)
- [Viva Insights R library (legacy)](https://microsoft.github.io/wpa/)
- [Viva Insights Python library](https://github.com/microsoft/vivainsights-py/)

---

## Code of Conduct

We would ask you to please read the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/) prior to engaging with this package.

**Trademarks** 

This project may contain trademarks or logos for projects, products, or services. Authorized use of Microsoft trademarks or logos is subject to and must follow [Microsoft's Trademark & Brand Guidelines](https://www.microsoft.com/en-us/legal/intellectualproperty/trademarks/). Use of Microsoft trademarks or logos in modified versions of this project must not cause confusion or imply Microsoft sponsorship. Any use of third-party trademarks or logos are subject to those third-party's policies.

---

## Finding this project useful? 

:star: Please star this repository to keep us going! 

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Check a query to ensure that it is suitable for analysis
#'
#' @description Prints diagnostic data about the data query to the R console,
#' with information such as date range, number of employees, HR attributes
#' identified, etc.
#'
#' @details This can be used with any person-level query, such as the standard
#' person query, Ways of Working assessment query, and the hourly collaboration
#' query. When run, this prints diagnostic data to the R console.
#'
#' @param data A person-level query in the form of a data frame. This includes:
#'   - Standard Person Query
#'   - Ways of Working Assessment Query
#'   - Hourly Collaboration Query
#'
#' All person-level query have a `PersonId` column and a `MetricDate` column.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"message"` (default)
#'   - `"text"`
#'
#' See `Value` for more information.
#'
#' @param validation Logical value to specify whether to show summarized version. Defaults to `FALSE`. To hide checks on variable
#'   names, set `validation` to `TRUE`.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"message"`: a message is returned to the console.
#'   - `"text"`: string containing the diagnostic message.
#'
#' @examples
#' check_query(pq_data)
#'
#' @family Data Validation
#' @import dplyr
#' @importFrom tidyselect all_of
#'
#' @export
check_query <- function(data, return = "message", validation = FALSE){

  if(!is.data.frame(data)){
    stop("Input is not a data frame.")
  }

  if("PersonId" %in% names(data)){

    if(validation == FALSE){

      check_person_query(data = data, return = return)

    } else if(validation == TRUE){

      # Different displays required for validation_report()
      check_query_validation(data = data, return = return)

    }
  } else {
    message("Note: checks are currently unavailable for a non-Person query")
  }
}

#' @title Check a Person Query to ensure that it is suitable for analysis
#'
#' @description
#' Prints diagnostic data about the data query to the R console, with information
#' such as date range, number of employees, HR attributes identified, etc.
#'
#' @inheritParams check_query
#'
#' @details Used as part of `check_query()`.
#'
#' @noRd
#'
check_person_query <- function(data, return){

  ## Query Type - In {wpa}, this uses `identify_query()`
  ## Set as blank for initiation
  main_chunk <- ""

  ## PersonId
  if(!("PersonId" %in% names(data))){
    stop("There is no `PersonId` variable in the input.")
  } else {
    new_chunk <- paste("There are", dplyr::n_distinct(data$PersonId), "employees in this dataset.")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  }

  ## Date
  if(!("MetricDate" %in% names(data))){

    stop("There is no `MetricDate` variable in the input.")

  } else if("Influence_rank" %in% names(data)){

    # Omit date conversion
    new_chunk <- paste0("Date ranges from ", min(data$MetricDate), " to ", max(data$MetricDate), ".")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")

  } else {

    data$MetricDate <- as.Date(data$MetricDate, "%m/%d/%Y")
    new_chunk <- paste0("Date ranges from ", min(data$MetricDate), " to ", max(data$MetricDate), ".")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")

  }

 ## Extract unique identifiers of query ------------------------------------

	extracted_chr <-
	  data %>%
	  hrvar_count_all(return = "table") %>%
	  filter(`Unique values`== 1) %>%
	  pull(Attributes)

	if (length(extracted_chr)>1) {

		extractHRValues <- function(data, hrvar){
			data %>%
		    summarise(FirstValue = first(!!sym(hrvar))) %>%
		    mutate(HRAttribute = wrap(hrvar, wrapper = "`")) %>%
		    select(HRAttribute, FirstValue) %>%
		    mutate(FirstValue = as.character(FirstValue)) # Coerce type
			}

		result <-
		  extracted_chr %>%
		  purrr::map(function(x){ extractHRValues(data = data, hrvar = x)}) %>%
		  bind_rows()

     new_chunk <- paste("Unique identifiers include:",
                        result %>%
                          mutate(identifier = paste(HRAttribute, "is", FirstValue)) %>%
                          pull(identifier) %>%
                          paste(collapse = "; "))

     main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
	 }


  ## HR Variables
  hr_chr <- extract_hr(data, max_unique = 200) %>% wrap(wrapper = "`")
  new_chunk <- paste("There are", length(hr_chr), "(estimated) HR attributes in the data:" )
  main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  new_chunk <- paste(hr_chr, collapse = ", ")
  main_chunk <- paste(main_chunk, new_chunk, sep = "\n")

  ## `IsActive` flag
  if(!("IsActive" %in% names(data))){
    new_chunk <- "The `IsActive` flag is not present in the data."
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n")
  } else {
    data$IsActive <- as.logical(data$IsActive) # Force to logical
    active_n <- dplyr::n_distinct(data[data$IsActive == TRUE, "PersonId"])
    new_chunk <- paste0("There are ", active_n, " active employees out of all in the dataset.")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  }

  ## Return
  if(return == "message"){

    main_chunk <- paste("", main_chunk, sep = "\n")
    message(main_chunk)

  } else if(return == "text"){
    main_chunk
  } else {
    stop("Please check inputs for `return`")
  }
}

#' @title Perform a query check for the validation report
#'
#' @description
#' Prints diagnostic data about the data query to the R console, with information
#' such as date range, number of employees, HR attributes identified, etc.
#' Optimised for the `validation_report()`
#'
#' @inheritParams check_query
#'
#' @details Used as part of `check_query()`.
#'
#' @noRd
check_query_validation <- function(data, return){
  ## Query Type - Initialise
  main_chunk <- ""

  ## PersonId
  if(!("PersonId" %in% names(data))){
    stop("There is no `PersonId` variable in the input.")
  } else {
    new_chunk <- paste("There are", dplyr::n_distinct(data$PersonId), "employees in this dataset.")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  }

  ## Date
  if(!("MetricDate" %in% names(data))){
    stop("There is no `MetricDate` variable in the input.")
  } else {
    data$MetricDate <- as.Date(data$MetricDate, "%m/%d/%Y")
    new_chunk <- paste0("Date ranges from ", min(data$MetricDate), " to ", max(data$MetricDate), ".")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  }

 ## Extract unique identifiers of query ------------------------------------

	extracted_chr <-  data %>%
	  hrvar_count_all(return = "table") %>%
	  filter(`Unique values`==1) %>%
	  pull(Attributes)

	if (length(extracted_chr) > 1) {


	  extractHRValues <- function(data, hrvar){
	    data %>%
	      summarise(FirstValue = first(!!sym(hrvar))) %>%
	      mutate(HRAttribute = wrap(hrvar, wrapper = "`")) %>%
	      select(HRAttribute, FirstValue) %>%
	      mutate(FirstValue = as.character(FirstValue)) # Coerce type
	  }

	  result <-
	    extracted_chr %>%
	    purrr::map(function(x){ extractHRValues(data = data, hrvar = x)}) %>%
	    bind_rows()

	  new_chunk <- paste("Unique identifiers include:",
	                     result %>%
	                       mutate(identifier = paste(HRAttribute, "is", FirstValue)) %>%
	                       pull(identifier) %>%
	                       paste(collapse = "; "))

	  main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")

	 }


  ## HR Variables
  hr_chr <- extract_hr(data, max_unique = 200) %>% wrap(wrapper = "`")
  new_chunk <- paste("There are", length(hr_chr), "(estimated) HR attributes in the data:" )
  main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  new_chunk <- paste(hr_chr, collapse = ", ")
  main_chunk <- paste(main_chunk, new_chunk, sep = "\n")

  ## `IsActive` flag
  if(!("IsActive" %in% names(data))){
    new_chunk <- "The `IsActive` flag is not present in the data."
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n")
  } else {
    data$IsActive <- as.logical(data$IsActive) # Force to logical
    active_n <- dplyr::n_distinct(data[data$IsActive == TRUE, "PersonId"])
    new_chunk <- paste0("There are ", active_n, " active employees out of all in the dataset.")
    main_chunk <- paste(main_chunk, new_chunk, sep = "\n\n")
  }

  ## Return
  if(return == "message"){

    main_chunk <- paste("", main_chunk, sep = "\n")
    message(main_chunk)

  } else if(return == "text"){
    main_chunk
  } else {
    stop("Please check inputs for `return`")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate Rogers Adoption Curve plots for Copilot usage
#'
#' @author Chris Gideon <chris.gideon@@microsoft.com>
#' 
#' @description
#' Creates various visualizations based on the Rogers adoption curve theory,
#' analyzing the adoption patterns of Copilot usage. The function identifies
#' habitual users using the `identify_habit()` function and then creates
#' adoption curve visualizations based on different time frames and
#' organizational groupings.
#'
#' @details
#' This function provides four distinct plot modes to analyze adoption patterns:
#'
#' \strong{Plot Mode 1 - Cumulative Adoption Curve:}
#' Shows the classic Rogers adoption curve with cumulative percentage of habitual
#' users over time. This S-shaped curve helps identify the pace of adoption and
#' when saturation begins. Steep sections indicate rapid adoption periods, while
#' flat sections suggest slower uptake or natural limits.
#'
#' \strong{Plot Mode 2 - Weekly Adoption Rate:}
#' Displays the number of new habitual users identified each week, with a
#' 3-week moving average line to smooth volatility. This view helps identify
#' adoption spikes, seasonal patterns, and the natural ebb and flow of user
#' onboarding. High bars indicate successful onboarding periods.
#'
#' \strong{Plot Mode 3 - Enablement-Based Adoption:}
#' Analyzes adoption relative to when users were first enabled (had access).
#' Users are classified into Rogers segments (Innovators, Early Adopters,
#' Early/Late Majority, Laggards) based on how quickly they adopted after
#' enablement. This helps understand the natural distribution of adoption
#' speed within your organization.
#'
#' \strong{Plot Mode 4 - Cumulative Enablement-Adjusted:}
#' Similar to Mode 1 but only includes users who had enablement data, providing
#' a more accurate view of adoption among those who actually had access to the
#' technology. This removes noise from users who may not have been properly
#' enabled.
#'
#' \strong{Interpretation Guidelines:}
#' \itemize{
#'   \item Early steep curves suggest strong product-market fit
#'   \item Plateaus may indicate training needs or feature limitations
#'   \item Seasonal patterns often reflect organizational training cycles
#'   \item Rogers segments help identify user personas for targeted interventions
#' }
#'
#' @param data Data frame containing Person Query data to be analyzed. Must
#' contain `PersonId`, `MetricDate`, and the specified metrics.
#' @param hrvar Character string specifying the HR attribute or organizational
#'   variable to group by. Default is `NULL`, for no grouping.
#' @param metric Character string containing the name of the metric to analyze
#' for habit identification, e.g. "Total_Copilot_actions". This is passed to
#' `identify_habit()`.
#' @param width Integer specifying the number of qualifying counts to consider
#' for a habit. Passed to `identify_habit()`. Default is 9.
#' @param max_window Integer specifying the maximum unit of dates to consider a
#' qualifying window for a habit. Passed to `identify_habit()`. Default is 12.
#' @param threshold Numeric value specifying the minimum threshold for the
#' metric to be considered a qualifying count. Passed to `identify_habit()`.
#' Default is 1.
#' @param start_metric Character string containing the name of the metric used
#'   for determining enablement start date. This metric should track when users
#'   first gained access to the technology being analyzed. The function identifies
#'   the earliest date where this metric is greater than 0 for each user as their
#'   "enablement date". This is then used in plot modes 3 and 4 to calculate
#'   time-to-adoption and Rogers segment classifications. The suggested variable
#'   is "Total_Copilot_enabled_days", but any metric that indicates access or
#'   licensing status can be used (e.g., "License_assigned_days", "Access_granted").
#'   This parameter is optional for plot modes 1 and 2, but required for plot modes
#'   3 and 4. When `return = "data"` and `start_metric` is provided, Rogers segment
#'   classifications will be included in the returned data frame. Default is `NULL`.
#' @param return Character vector specifying what to return. Valid inputs are
#' "plot", "data", and "table". Default is "plot".
#' @param plot_mode Integer or character string determining which plot to return.
#' Valid inputs are:
#' \itemize{
#'   \item 1 or "cumulative": Rogers Adoption Curve showing cumulative adoption
#'   \item 2 or "weekly": Weekly Rate of adoption showing new habitual users
#'   \item 3 or "enablement": Enablement-based adoption rate with Rogers segments
#'   \item 4 or "cumulative_enablement": Cumulative adoption adjusted for enablement
#' }
#' Default is 1.
#' @param label Logical value to determine whether to show data point labels on
#'   the plot for cumulative adoption curves (plot modes 1 and 4). If `TRUE`, 
#'   both `geom_point()` and `geom_text()` are added to display data labels 
#'   rounded to 1 decimal place above each data point. Defaults to `FALSE`.
#'
#' @import dplyr
#' @import ggplot2
#' @import scales
#' @importFrom rlang .data
#' @importFrom stats as.formula
#'
#' @family Visualization
#' @family Adoption Analysis
#'
#' @examples
#' # Basic Rogers adoption curve
#' create_rogers(
#'   data = pq_data,
#'   metric = "Copilot_actions_taken_in_Teams",
#'   plot_mode = 1
#' )
#'
#' # Weekly adoption rate by organization
#' create_rogers(
#'   data = pq_data,
#'   hrvar = "Organization",
#'   metric = "Copilot_actions_taken_in_Teams",
#'   plot_mode = 2
#' )
#'
#' # Enablement-based adoption
#' create_rogers(
#'   data = pq_data,
#'   metric = "Copilot_actions_taken_in_Teams",
#'   start_metric = "Total_Copilot_enabled_days",
#'   plot_mode = 3
#' )
#'
#' # Return data with Rogers segments
#' rogers_data <- create_rogers(
#'   data = pq_data,
#'   metric = "Copilot_actions_taken_in_Teams",
#'   start_metric = "Total_Copilot_enabled_days",
#'   return = "data"
#' )
#' 
#' # Rogers adoption curve with data point labels
#' create_rogers(
#'   data = pq_data,
#'   metric = "Copilot_actions_taken_in_Teams",
#'   plot_mode = 1,
#'   label = TRUE
#' )
#'
#' @return
#' Returns a 'ggplot' object by default when 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#' When 'data' is passed, the processed data with habit classifications is returned.
#' 
#' When `return = "data"`, the returned data frame includes:
#' \itemize{
#'   \item All original columns from the input data
#'   \item `IsHabit`: Binary indicator of whether the user has developed a habit
#'   \item `adoption_week`: The week when the user first exhibited habitual behavior
#'   \item `enable_week`: (if `start_metric` provided) The week when the user was first enabled
#'   \item `weeks_to_adopt`: (if `start_metric` provided) Number of weeks from enablement to adoption
#'   \item `RogersSegment`: (if `start_metric` provided) Rogers adoption segment classification:
#'     \itemize{
#'       \item "Innovators" (fastest 2.5\%)
#'       \item "Early Adopters" (next 13.5\%)
#'       \item "Early Majority" (next 34\%)
#'       \item "Late Majority" (next 34\%)
#'       \item "Laggards" (slowest 16\%)
#'     }
#' }
#'
#' @export

create_rogers <- function(data,
                         hrvar = NULL,
                         metric,
                         width = 9,
                         max_window = 12,
                         threshold = 1,
                         start_metric = NULL,
                         return = "plot",
                         plot_mode = 1,
                         label = FALSE) {
  
  ## Check inputs
  required_variables <- c("MetricDate", metric, "PersonId")
  
  ## Error message if variables are not present
  data %>%
    check_inputs(requirements = required_variables)
  
  ## Check if start_metric exists for enablement-based plots
  if (plot_mode %in% c(3, 4, "enablement", "cumulative_enablement")) {
    if (is.null(start_metric)) {
      stop(paste("The 'start_metric' parameter is required for plot mode", plot_mode, 
                 "(enablement-based analysis). Please provide a metric that indicates when users gained access to the technology."))
    }
    if (!start_metric %in% names(data)) {
      stop(paste("Column", start_metric, "not found in data for enablement-based analysis."))
    }
  }
  
  ## Apply habit identification
  data_with_habit <- data %>%
    identify_habit(
      metric = metric,
      threshold = threshold,
      width = width,
      max_window = max_window,
      return = "data"
    )
  
  ## Find the earliest "habitual" date per PersonId
  adoption_week_df <- data_with_habit %>%
    filter(.data$IsHabit == TRUE) %>%
    group_by(.data$PersonId) %>%
    summarise(adoption_week = min(.data$MetricDate, na.rm = TRUE), .groups = "drop")
  
  ## Handle hrvar
  if (!is.null(hrvar) && hrvar %in% names(data)) {
    # Add hrvar to adoption data
    hrvar_lookup <- data %>%
      select(.data$PersonId, !!sym(hrvar)) %>%
      distinct()
    
    adoption_week_df <- adoption_week_df %>%
      left_join(hrvar_lookup, by = "PersonId")
  }
  
  ## Return data if requested
  if (return == "data") {
    # Add adoption week information to the data
    data_with_adoption <- data_with_habit %>%
      left_join(
        adoption_week_df %>% select(.data$PersonId, adoption_week),
        by = "PersonId"
      )
    
    # Calculate Rogers segment if start_metric is provided
    if (!is.null(start_metric) && start_metric %in% names(data)) {
      # Calculate enable week (first date where start_metric > 0)
      enable_week_df <- data_with_habit %>%
        filter(!!sym(start_metric) > 0) %>%
        group_by(.data$PersonId) %>%
        summarise(enable_week = min(.data$MetricDate, na.rm = TRUE), .groups = "drop")
      
      # Calculate Rogers segments based on time to adoption
      rogers_segments <- adoption_week_df %>%
        left_join(enable_week_df, by = "PersonId") %>%
        filter(!is.na(.data$enable_week)) %>%
        mutate(
          weeks_to_adopt = as.numeric(difftime(.data$adoption_week, .data$enable_week, units = "weeks")),
          adoption_delay_percent = percent_rank(.data$weeks_to_adopt),
          RogersSegment = case_when(
            .data$adoption_delay_percent <= 0.025 ~ "Innovators",
            .data$adoption_delay_percent <= 0.16  ~ "Early Adopters",
            .data$adoption_delay_percent <= 0.50  ~ "Early Majority",
            .data$adoption_delay_percent <= 0.84  ~ "Late Majority",
            TRUE                                  ~ "Laggards"
          )
        ) %>%
        select(.data$PersonId, .data$enable_week, .data$weeks_to_adopt, .data$RogersSegment)
      
      # Join Rogers segments back to the data
      data_with_adoption <- data_with_adoption %>%
        left_join(rogers_segments, by = "PersonId")
      
      message(paste("Rogers segments calculated based on", start_metric))
      message(paste("Total users with Rogers segments:", sum(!is.na(rogers_segments$RogersSegment))))
    } else {
      message("Note: 'start_metric' not provided. Rogers segment classification not included.")
      message("To include Rogers segments, provide 'start_metric' parameter indicating when users gained access.")
    }
    
    return(data_with_adoption)
  }
  
  ## Convert plot_mode to numeric for easier handling
  if (is.character(plot_mode)) {
    plot_mode <- case_when(
      plot_mode == "cumulative" ~ 1,
      plot_mode == "weekly" ~ 2,
      plot_mode == "enablement" ~ 3,
      plot_mode == "cumulative_enablement" ~ 4,
      TRUE ~ 1
    )
  }
  
  ## Generate plots based on plot_mode
  if (plot_mode == 1) {
    # Rogers Adoption Curve (Cumulative)
    if (!is.null(hrvar) && hrvar %in% names(data)) {
      # By hrvar
      rogers_curve <- adoption_week_df %>%
        count(!!sym(hrvar), .data$adoption_week) %>%
        group_by(!!sym(hrvar)) %>%
        arrange(.data$adoption_week) %>%
        mutate(
          cumulative_adopters = cumsum(.data$n),
          cumulative_percent = .data$cumulative_adopters / sum(.data$n)
        ) %>%
        ungroup()
      
      plot_object <- ggplot(rogers_curve, aes(x = .data$adoption_week, y = .data$cumulative_percent, color = !!sym(hrvar))) +
        geom_line(size = 1) +
        facet_wrap(as.formula(paste("~", hrvar)), scales = "free_y") +
        scale_y_continuous(labels = scales::percent_format()) +
        labs(
          title = "Rogers cumulative adoption curve",
          subtitle = paste("Based on", us_to_space(metric)),
          x = "Week of Habitual Adoption",
          y = "Cumulative % of Habitual Users",
          color = hrvar,
          caption = extract_date_range(data, return = "text")
        ) +
        theme_wpa_basic()
      
      # Conditionally add points and labels if label = TRUE
      if(label == TRUE){
        plot_object <- plot_object +
          geom_point(size = 2) +
          geom_text(aes(label = scales::percent(round(.data$cumulative_percent, 3))), 
                    vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
      }
    } else {
      # Overall
      rogers_curve <- adoption_week_df %>%
        count(.data$adoption_week) %>%
        arrange(.data$adoption_week) %>%
        mutate(
          cumulative_adopters = cumsum(.data$n),
          cumulative_percent = .data$cumulative_adopters / sum(.data$n)
        )
      
      plot_object <- ggplot(rogers_curve, aes(x = .data$adoption_week, y = .data$cumulative_percent)) +
        geom_line(size = 1.2, color = "#1c66b0") +
        scale_y_continuous(labels = scales::percent_format()) +
        labs(
          title = "Rogers cumulative adoption curve",
          subtitle = paste("Based on", us_to_space(metric)),
          x = "Week of Adoption",
          y = "Cumulative % of Habitual Users",
          caption = extract_date_range(data, return = "text")
        ) +
        theme_wpa_basic()
      
      # Conditionally add points and labels if label = TRUE
      if(label == TRUE){
        plot_object <- plot_object +
          geom_point(color = "#1c66b0", size = 2) +
          geom_text(aes(label = scales::percent(round(.data$cumulative_percent, 3))), 
                    vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
      } else {
        plot_object <- plot_object +
          geom_point()
      }
    }
    
  } else if (plot_mode == 2) {
    # Weekly Rate of Adoption
    if (!is.null(hrvar) && hrvar %in% names(data)) {
      # By hrvar
      adoption_rate <- adoption_week_df %>%
        count(!!sym(hrvar), .data$adoption_week) %>%
        group_by(!!sym(hrvar)) %>%
        arrange(.data$adoption_week) %>%
        mutate(
          moving_avg = slider::slide_dbl(.data$n, mean, .before = 2, .complete = TRUE)
        ) %>%
        rename(new_adopters = .data$n) %>%
        ungroup()
      
      plot_object <- ggplot(adoption_rate, aes(x = .data$adoption_week, y = .data$new_adopters)) +
        geom_col(fill = "#1c66b0") +
        geom_line(aes(y = .data$moving_avg), color = "#0c336e", size = 1) +
        facet_wrap(as.formula(paste("~", hrvar)), scales = "free_y") +
        labs(
          title = paste("Weekly Rate of", us_to_space(metric), "Adoption by", hrvar),
          subtitle = "New habitual users each week; line indicating moving average",
          x = "Week",
          y = "New Habitual Users",
          caption = extract_date_range(data, return = "text")
        ) +
        theme_wpa_basic()
      
      # Conditionally add data labels if label = TRUE
      if(label == TRUE){
        plot_object <- plot_object +
          geom_text(aes(label = .data$new_adopters), vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
      }
    } else {
      # Overall
      adoption_rate <- adoption_week_df %>%
        count(.data$adoption_week) %>%
        arrange(.data$adoption_week) %>%
        rename(new_adopters = .data$n) %>%
        mutate(
          moving_avg = slider::slide_dbl(.data$new_adopters, mean, .before = 2, .complete = TRUE)
        )
      
      plot_object <- ggplot(adoption_rate, aes(x = .data$adoption_week, y = .data$new_adopters)) +
        geom_col(fill = "#1c66b0") +
        geom_line(aes(y = .data$moving_avg), color = "#0c336e", size = 1.2) +
        labs(
          title = paste("Weekly Rate of", us_to_space(metric), "Adoption"),
          subtitle = "New habitual users identified each week; line indicating moving average",
          x = "Week",
          y = "New Habitual Users",
          caption = extract_date_range(data, return = "text")
        ) +
        theme_wpa_basic()
      
      # Conditionally add data labels if label = TRUE
      if(label == TRUE){
        plot_object <- plot_object +
          geom_text(aes(label = .data$new_adopters), vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
      }
    }
    
  } else if (plot_mode == 3) {
    # Enablement-based Adoption Rate
    enable_week_df <- data_with_habit %>%
      filter(!!sym(start_metric) > 0) %>%
      group_by(.data$PersonId) %>%
      summarise(enable_week = min(.data$MetricDate, na.rm = TRUE), .groups = "drop")
    
    adoption_week_df2 <- adoption_week_df %>%
      left_join(enable_week_df, by = "PersonId") %>%
      filter(!is.na(.data$enable_week)) %>%
      mutate(
        weeks_to_adopt = as.numeric(difftime(.data$adoption_week, .data$enable_week, units = "weeks")),
        adoption_delay_percent = percent_rank(.data$weeks_to_adopt),
        RogersSegment_delay = case_when(
          .data$adoption_delay_percent <= 0.025 ~ "Innovators",
          .data$adoption_delay_percent <= 0.16  ~ "Early Adopters",
          .data$adoption_delay_percent <= 0.50  ~ "Early Majority",
          .data$adoption_delay_percent <= 0.84  ~ "Late Majority",
          TRUE                                  ~ "Laggards"
        )
      )
    
    weekly_segment_counts <- adoption_week_df2 %>%
      count(.data$adoption_week, .data$RogersSegment_delay) %>%
      rename(new_adopters = .data$n)
    
    # Calculate segment proportions for caption
    segment_proportions <- adoption_week_df2 %>%
      count(.data$RogersSegment_delay) %>%
      mutate(
        total = sum(.data$n),
        percentage = round((.data$n / .data$total) * 100, 0)
      ) %>%
      arrange(factor(.data$RogersSegment_delay, 
                    levels = c("Innovators", "Early Adopters", "Early Majority", "Late Majority", "Laggards")))
    
    # Create caption with proportions
    proportions_text <- paste(
      paste(segment_proportions$RogersSegment_delay, ": ", segment_proportions$percentage, "%", sep = ""),
      collapse = "; "
    )
    
    full_caption <- paste(extract_date_range(data, return = "text"), "\n", proportions_text, sep = "")
    
    plot_object <- ggplot(weekly_segment_counts, aes(x = .data$adoption_week, y = .data$new_adopters, fill = .data$RogersSegment_delay)) +
      geom_col(position = "stack") +
      scale_fill_manual(
        values = c(
          "Innovators"     = "#6a51a3",
          "Early Adopters" = "#3182bd",
          "Early Majority" = "#31a354",
          "Late Majority"  = "#fd8d3c",
          "Laggards"       = "#de2d26"
        )
      ) +
      labs(
        title = paste("Enablement-Based", us_to_space(metric), "Adoption Rate"),
        subtitle = "Weekly new habitual users, segmented by Rogers category (delay from enablement)",
        x = "Week of Adoption",
        y = "Number of New Habitual Users",
        fill = "Rogers Segment",
        caption = full_caption
      ) +
      theme_wpa_basic()
    
    # Conditionally add data labels if label = TRUE
    if(label == TRUE){
      plot_object <- plot_object +
        geom_text(aes(label = .data$new_adopters), position = position_stack(vjust = 0.5), size = 3, colour = "white")
    }
    
  } else if (plot_mode == 4) {
    # Cumulative Enablement-based Adoption
    enable_week_df <- data_with_habit %>%
      filter(!!sym(start_metric) > 0) %>%
      group_by(.data$PersonId) %>%
      summarise(enable_week = min(.data$MetricDate, na.rm = TRUE), .groups = "drop")
    
    adoption_week_df2 <- adoption_week_df %>%
      left_join(enable_week_df, by = "PersonId") %>%
      filter(!is.na(.data$enable_week))
    
    cumulative_df <- adoption_week_df2 %>%
      count(.data$adoption_week) %>%
      arrange(.data$adoption_week) %>%
      mutate(
        cumulative = cumsum(.data$n),
        cumulative_percent = .data$cumulative / sum(.data$n)
      )
    
    plot_object <- ggplot(cumulative_df, aes(x = .data$adoption_week, y = .data$cumulative_percent)) +
      geom_line(size = 1.2, color = "#1c66b0") +
      scale_y_continuous(labels = scales::percent) +
      labs(
        title = "Enablement-adjusted cumulative adoption curve",
        subtitle = paste("Based on", us_to_space(metric)),
        x = "Adoption Week",
        y = "Cumulative % of Users",
        caption = extract_date_range(data, return = "text")
      ) +
      theme_wpa_basic()
    
    # Conditionally add points and labels if label = TRUE
    if(label == TRUE){
      plot_object <- plot_object +
        geom_point(color = "#1c66b0", size = 2) +
        geom_text(aes(label = scales::percent(round(.data$cumulative_percent, 3))), 
                  vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
    } else {
      plot_object <- plot_object +
        geom_point()
    }
    
  } else {
    stop("Invalid plot_mode. Use 1-4 or 'cumulative', 'weekly', 'enablement', 'cumulative_enablement'.")
  }
  
  ## Return based on return parameter
  if (return == "plot") {
    return(plot_object)
  } else if (return == "table") {
    # Return summary table
    summary_table <- adoption_week_df %>%
      summarise(
        total_adopters = n(),
        earliest_adoption = min(.data$adoption_week, na.rm = TRUE),
        latest_adoption = max(.data$adoption_week, na.rm = TRUE),
        median_adoption_week = median(.data$adoption_week, na.rm = TRUE)
      )
    return(summary_table)
  } else {
    stop("Please enter a valid input for `return`: 'plot', 'data', or 'table'.")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)
library(dplyr)

test_that("create_rogers returns a data frame when return = 'data'", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    return = "data"
  )
  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_rogers includes IsHabit column when return = 'data'", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    return = "data"
  )
  # Check if IsHabit column exists
  expect_true("IsHabit" %in% colnames(result))
})

test_that("create_rogers includes adoption_week column when return = 'data'", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    return = "data"
  )
  # Check if adoption_week column exists
  expect_true("adoption_week" %in% colnames(result))
})

test_that("create_rogers includes Rogers segment columns when start_metric is provided", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    return = "data"
  )
  # Check if Rogers segment columns exist
  expect_true("enable_week" %in% colnames(result))
  expect_true("weeks_to_adopt" %in% colnames(result))
  expect_true("RogersSegment" %in% colnames(result))
})

test_that("create_rogers does not include Rogers segment when start_metric is not provided", {
  result <- suppressMessages(create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    return = "data"
  ))
  # Rogers segment columns should not exist when start_metric is not provided
  expect_false("RogersSegment" %in% colnames(result))
})

test_that("create_rogers raises an error when start_metric is missing for plot mode 3", {
  expect_error(
    create_rogers(
      data = pq_data,
      metric = "Copilot_actions_taken_in_Teams",
      plot_mode = 3,
      return = "plot"
    ),
    "The 'start_metric' parameter is required"
  )
})

test_that("create_rogers raises an error when start_metric is missing for plot mode 4", {
  expect_error(
    create_rogers(
      data = pq_data,
      metric = "Copilot_actions_taken_in_Teams",
      plot_mode = 4,
      return = "plot"
    ),
    "The 'start_metric' parameter is required"
  )
})

test_that("create_rogers returns a ggplot with pq_data when return = 'plot'", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 1,
    return = "plot"
  )
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# Test data creation - mock data with required columns
set.seed(123)
test_data <- data.frame(
  PersonId = rep(paste0("Person", 1:20), each = 10),
  MetricDate = rep(seq(as.Date("2023-01-01"), by = "week", length.out = 10), 20),
  Copilot_actions_taken_in_Teams = sample(0:5, 200, replace = TRUE),
  Total_Copilot_enabled_days = sample(c(0, 1), 200, replace = TRUE),
  Organization = rep(c("Org1", "Org2"), each = 100)
)

test_that("create_rogers returns a ggplot with synthetic data when return = 'plot'", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 1
  )
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_rogers returns a summary table when return = 'table'", {
  result <- create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    return = "table"
  )
  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
  # Check if expected summary columns exist
  expect_true("total_adopters" %in% colnames(result))
})

test_that("create_rogers RogersSegment has correct categories", {
  result <- suppressMessages(create_rogers(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    return = "data"
  ))
  
  # Check if RogersSegment column contains expected categories
  unique_segments <- unique(result$RogersSegment[!is.na(result$RogersSegment)])
  expected_segments <- c("Innovators", "Early Adopters", "Early Majority", "Late Majority", "Laggards")
  expect_true(all(unique_segments %in% expected_segments))
})
test_that("create_rogers with label = FALSE behaves as before for plot mode 1", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 1,
    label = FALSE
  )
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should contain geom_point layer (default behavior)
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_true("GeomPoint" %in% layer_classes)
  # Should not contain geom_text layer when label = FALSE
  expect_false("GeomText" %in% layer_classes)
})

test_that("create_rogers with label = TRUE adds text layers for plot mode 1", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 1,
    label = TRUE
  )
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should contain geom_point and geom_text layers when label = TRUE
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_true("GeomPoint" %in% layer_classes)
  expect_true("GeomText" %in% layer_classes)
})

test_that("create_rogers with label = TRUE adds text layers for plot mode 4", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    plot_mode = 4,
    label = TRUE
  )
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should contain geom_point and geom_text layers when label = TRUE
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_true("GeomPoint" %in% layer_classes)
  expect_true("GeomText" %in% layer_classes)
})

test_that("create_rogers plot mode 1 has updated title and subtitle", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 1
  )
  
  # Check title and subtitle
  expect_equal(result$labels$title, "Rogers cumulative adoption curve")
  expect_match(result$labels$subtitle, "Based on Copilot actions taken in Teams")
})

test_that("create_rogers plot mode 4 has updated title and subtitle", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    plot_mode = 4
  )
  
  # Check title and subtitle
  expect_equal(result$labels$title, "Enablement-adjusted cumulative adoption curve")
  expect_match(result$labels$subtitle, "Based on Copilot actions taken in Teams")
})

test_that("create_rogers plot mode 2 has updated subtitle mentioning moving average", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 2
  )
  
  # Check subtitle mentions moving average
  expect_match(result$labels$subtitle, "line indicating moving average")
})

test_that("create_rogers plot mode 3 caption includes segment proportions", {
  result <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    plot_mode = 3
  )
  
  # Check caption includes percentage sign (segments may vary based on data)
  expect_match(result$labels$caption, "%")
})

test_that("create_rogers plot mode 2 respects label parameter", {
  # Plot mode 2 labels should be controlled by label parameter
  result_no_label <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 2,
    label = FALSE
  )
  
  result_with_label <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    plot_mode = 2,
    label = TRUE
  )
  
  # Check if the results are ggplot objects
  expect_s3_class(result_no_label, "ggplot")
  expect_s3_class(result_with_label, "ggplot")
  
  # Should NOT contain geom_text layer when label = FALSE
  layer_classes_no_label <- sapply(result_no_label$layers, function(x) class(x$geom)[1])
  expect_false("GeomText" %in% layer_classes_no_label)
  
  # Should contain geom_text layer when label = TRUE
  layer_classes_with_label <- sapply(result_with_label$layers, function(x) class(x$geom)[1])
  expect_true("GeomText" %in% layer_classes_with_label)
})

test_that("create_rogers plot mode 3 respects label parameter", {
  # Plot mode 3 labels should be controlled by label parameter
  result_no_label <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    plot_mode = 3,
    label = FALSE
  )
  
  result_with_label <- create_rogers(
    data = test_data,
    metric = "Copilot_actions_taken_in_Teams",
    start_metric = "Total_Copilot_enabled_days",
    plot_mode = 3,
    label = TRUE
  )
  
  # Check if the results are ggplot objects
  expect_s3_class(result_no_label, "ggplot")
  expect_s3_class(result_with_label, "ggplot")
  
  # Should NOT contain geom_text layer when label = FALSE
  layer_classes_no_label <- sapply(result_no_label$layers, function(x) class(x$geom)[1])
  expect_false("GeomText" %in% layer_classes_no_label)
  
  # Should contain geom_text layer when label = TRUE
  layer_classes_with_label <- sapply(result_with_label$layers, function(x) class(x$geom)[1])
  expect_true("GeomText" %in% layer_classes_with_label)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Time Trend - Line Chart for any metric
#'
#' @description
#' Provides a week by week view of a selected metric, visualised as line charts.
#' By default returns a line chart for the defined metric,
#' with a separate panel per value in the HR attribute.
#' Additional options available to return a summary table.
#'
#' @details
#' This is a general purpose function that powers all the functions
#' in the package that produce faceted line plots.
#'
#' @template spq-params
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @param ncol Numeric value setting the number of columns on the plot. Defaults
#'   to `NULL` (automatic).
#'
#' @param label Logical value to determine whether to show data point labels on
#'   the plot. If `TRUE`, both `geom_point()` and `geom_text()` are added to
#'   display data labels rounded to 1 decimal place above each data point.
#'   Defaults to `FALSE`.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom tidyselect all_of
#'
#' @family Visualization
#' @family Flexible
#' @family Time-series
#'
#' @examples
#' # Return plot of Email Hours
#' pq_data %>% create_line(metric = "Email_hours", return = "plot")
#'
#' # Return plot of Collaboration Hours
#' pq_data %>% create_line(metric = "Collaboration_hours", return = "plot")
#'
#' # Return plot but coerce plot to two columns
#' pq_data %>%
#'   create_line(
#'     metric = "Collaboration_hours",
#'     hrvar = "Organization",
#'     ncol = 2
#'     )
#'
#' # Return plot of email hours and cut by `LevelDesignation`
#' pq_data %>% create_line(metric = "Email_hours", hrvar = "LevelDesignation")
#'
#' # Return plot with data point labels
#' pq_data %>% create_line(metric = "Email_hours", label = TRUE)
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A faceted line plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @export
create_line <- function(data,
                        metric,
                        hrvar = "Organization",
                        mingroup = 5,
                        ncol = NULL,
                        label = FALSE,
                        return = "plot"){

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Clean metric name
  clean_nm <- us_to_space(metric)
  
  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
    subtitle_nm <- paste("Total",
                         tolower(clean_nm),"over time")
    } else{
    subtitle_nm <- paste("Total",
                         tolower(clean_nm),
                         "by",
                         tolower(camel_clean(hrvar)))
    }

  myTable <-
    data %>%
    mutate(MetricDate = as.Date(MetricDate, "%m/%d/%Y")) %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    select(PersonId, MetricDate, group, all_of(metric)) %>%
    group_by(group) %>%
    mutate(Employee_Count = n_distinct(PersonId)) %>%
    dplyr::filter(Employee_Count >= mingroup)  # Keep only groups above privacy threshold

  myTable <-
    myTable %>%
    group_by(MetricDate, group) %>%
    summarize(Employee_Count = mean(Employee_Count),
              !!sym(metric) := mean(!!sym(metric)),.groups = "drop")

  ## Data frame to return
  myTable_return <-
    myTable %>%
    select(MetricDate, group, all_of(metric)) %>%
    spread(MetricDate, !!sym(metric))

  ## Data frame for creating plot
  myTable_plot <-
    myTable %>%
    select(MetricDate, group, all_of(metric)) %>%
    group_by(MetricDate, group) %>%
    summarise(across(all_of(metric), ~mean(., na.rm = TRUE))) %>%
    ungroup()


  return_plot <- function(){

    plot_base <- myTable_plot %>%
      ggplot(aes(x = MetricDate, y = !!sym(metric))) +
      geom_line(colour = "#1d627e") +
      facet_wrap(.~group, ncol = ncol) +
      scale_fill_gradient(name="Hours", low = "white", high = "red") +
      theme_wpa_basic() +
      theme(strip.background = element_rect(color = "#1d627e",
                                            fill = "#1d627e"),
            strip.text = element_text(size = 10,
                                      colour = "#FFFFFF",
                                      face = "bold")) +
      labs(title = clean_nm,
           subtitle = subtitle_nm,
           x = "Metric Date",
           y = clean_nm,
           caption = extract_date_range(data, return = "text")) +
      ylim(0, NA) # Set origin to zero
    
    # Conditionally add points and labels if label = TRUE
    if(label == TRUE){
      plot_base <- plot_base +
        geom_point(colour = "#1d627e", size = 2) +
        geom_text(aes(label = round(!!sym(metric), 1)), 
                  vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
    }
    
    plot_base

  }


  if(return == "table"){

    myTable_return

  } else if(return == "plot"){

    return_plot()

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_line returns a data frame when return = 'table'", {

  result <- pq_data %>% create_line(metric = "Collaboration_hours", return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_line returns a ggplot when return = 'plot'", {

  result <- pq_data %>% create_line(metric = "Collaboration_hours", return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_line with label = FALSE behaves as before", {

  result <- pq_data %>% create_line(metric = "Collaboration_hours", label = FALSE, return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should not contain geom_point or geom_text layers (default behavior)
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_false("GeomPoint" %in% layer_classes)
  expect_false("GeomText" %in% layer_classes)
})

test_that("create_line with label = TRUE adds point and text layers", {

  result <- pq_data %>% create_line(metric = "Collaboration_hours", label = TRUE, return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should contain geom_point and geom_text layers when label = TRUE
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_true("GeomPoint" %in% layer_classes)
  expect_true("GeomText" %in% layer_classes)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a line chart without aggregation for any metric
#'
#' @description
#' This function creates a line chart directly from the aggregated / summarised data.
#' Unlike `create_line()` which performs a person-level aggregation, there is no
#' calculation for `create_line_asis()` and the values are rendered as they are passed
#' into the function. The only requirement is that a `date_var` is provided for the x-axis.
#'
#' @param data Plotting data as a data frame.
#' @param date_var String containing name of variable for the horizontal axis.
#' @param metric String containing name of variable representing the line.
#' @param title Title of the plot.
#' @param subtitle Subtitle of the plot.
#' @param caption Caption of the plot.
#' @param ylab Y-axis label for the plot (group axis)
#' @param xlab X-axis label of the plot (bar axis).
#' @param line_colour String to specify colour to use for the line.
#' Hex codes are accepted. You can also supply
#' RGB values via `rgb2hex()`.
#' @param label Logical value to determine whether to show data point labels on
#'   the plot. If `TRUE`, both `geom_point()` and `geom_text()` are added to
#'   display data labels rounded to 1 decimal place above each data point.
#'   Defaults to `FALSE`.
#'
#' @import ggplot2
#' @import dplyr
#'
#' @family Visualization
#' @family Flexible
#' @family Time-series
#'
#' @return
#' Returns a 'ggplot' object representing a line plot.
#'
#' @examples
#' library(dplyr)
#'
#' # Median `Emails_sent` grouped by `MetricDate`
#' # Without Person Averaging
#' med_df <-
#'   pq_data %>%
#'   group_by(MetricDate) %>%
#'   summarise(Emails_sent_median = median(Emails_sent))
#'
#' med_df %>%
#'   create_line_asis(
#'     date_var = "MetricDate",
#'     metric = "Emails_sent_median",
#'     title = "Median Emails Sent",
#'     subtitle = "Person Averaging Not Applied",
#'     caption = extract_date_range(pq_data, return = "text")
#'   )
#'
#' # Create line plot with data point labels
#' med_df %>%
#'   create_line_asis(
#'     date_var = "MetricDate",
#'     metric = "Emails_sent_median",
#'     title = "Median Emails Sent",
#'     subtitle = "Person Averaging Not Applied",
#'     caption = extract_date_range(pq_data, return = "text"),
#'     label = TRUE
#'   )
#'
#' @export
create_line_asis <- function(data,
                            date_var = "MetricDate",
                            metric,
                            title = NULL,
                            subtitle = NULL,
                            caption = NULL,
                            ylab = date_var,
                            xlab = metric,
                            line_colour = rgb2hex(0, 120, 212),
                            label = FALSE){

  returnPlot <-
    data %>%
    mutate(across(all_of(date_var), ~as.Date(., format = "%m/%d/%Y"))) %>%
    ggplot(aes(x = !!sym(date_var), y = !!sym(metric))) +
    geom_line(colour = line_colour)

  # Conditionally add points and labels if label = TRUE
  if(label == TRUE){
    returnPlot <- returnPlot +
      geom_point(colour = line_colour, size = 2) +
      geom_text(aes(label = round(!!sym(metric), 1)), 
                vjust = -0.5, hjust = 0.5, size = 3, colour = "black")
  }

  returnPlot +
    labs(title = title,
         subtitle = subtitle,
         caption = caption,
         y = xlab,
         x = ylab) +
    theme_wpa_basic()
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)
library(dplyr)

test_that("create_line_asis returns a ggplot", {

  # Median `Emails_sent` grouped by `MetricDate`
  # Without Person Averaging
  med_df <-
    pq_data %>%
    group_by(MetricDate) %>%
    summarise(Emails_sent_median = median(Emails_sent))

  result <- med_df %>%
                create_line_asis(
                  date_var = "MetricDate",
                  metric = "Emails_sent_median",
                  title = "Median Emails Sent",
                  subtitle = "Person Averaging Not Applied",
                  caption = extract_date_range(pq_data, return = "text")
                )
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_line_asis with label = FALSE behaves as before", {

  # Median `Emails_sent` grouped by `MetricDate`
  med_df <-
    pq_data %>%
    group_by(MetricDate) %>%
    summarise(Emails_sent_median = median(Emails_sent))

  result <- med_df %>%
                create_line_asis(
                  date_var = "MetricDate",
                  metric = "Emails_sent_median",
                  label = FALSE
                )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should not contain geom_point or geom_text layers (default behavior)
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_false("GeomPoint" %in% layer_classes)
  expect_false("GeomText" %in% layer_classes)
})

test_that("create_line_asis with label = TRUE adds point and text layers", {

  # Median `Emails_sent` grouped by `MetricDate`
  med_df <-
    pq_data %>%
    group_by(MetricDate) %>%
    summarise(Emails_sent_median = median(Emails_sent))

  result <- med_df %>%
                create_line_asis(
                  date_var = "MetricDate",
                  metric = "Emails_sent_median",
                  label = TRUE
                )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
  
  # Should contain geom_point and geom_text layers when label = TRUE
  layer_classes <- sapply(result$layers, function(x) class(x$geom)[1])
  expect_true("GeomPoint" %in% layer_classes)
  expect_true("GeomText" %in% layer_classes)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Identify shifts based on outlook time settings for work day start and end
#' time
#'
#' @description
#' This function uses outlook calendar settings for start and end time of work
#' day to identify work shifts. The relevant variables are
#' `WorkingStartTimeSetInOutlook` and `WorkingEndTimeSetInOutlook`.
#'
#'
#' @param data A data frame containing data from the Hourly Collaboration query.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'   - `"data"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: ggplot object. A bar plot for the weekly count of shifts.
#'   - `"table"`: data frame. A summary table for the count of shifts.
#'   - `"data`: data frame. Input data appended with the `Shifts` columns.
#'
#' @importFrom data.table ":=" "%like%" "%between%"
#'
#' @family Data Validation
#' @family Working Patterns
#'
#' @examples
#' # Demo with `pq_data` example where Outlook Start and End times are imputed
#' # Use a small sample for faster runtime
#' pq_data_small <- dplyr::slice_sample(pq_data, prop = 0.1)
#'
#' pq_data_small$WorkingStartTimeSetInOutlook <- "6:30"
#' pq_data_small$WorkingEndTimeSetInOutlook <- "23:30"
#'
#' # Return plot
#' pq_data_small %>% identify_shifts()
#'
#' # Return summary table
#' pq_data_small %>% identify_shifts(return = "table")
#'
#' @export
identify_shifts <- function(data, return = "plot"){

  clean_times <- function(x){
    out <- gsub(pattern = ":00", replacement = "", x = x)
    as.numeric(out)
  }

  data <- data.table::as.data.table(data)
  # data <- data.table::copy(data)

  # Make sure data.table knows we know we're using it
  .datatable.aware = TRUE

  data[, Shifts := paste(WorkingStartTimeSetInOutlook, WorkingEndTimeSetInOutlook, sep = "-")]


  # outputTable <- data[, .(count = .N), by = Shifts]
  outputTable <- data[, list(WeekCount = .N,
                             PersonCount = dplyr::n_distinct(PersonId)), by = Shifts]

  outputTable <- data.table::setorder(outputTable, -PersonCount)


  if(return == "table"){
    dplyr::as_tibble(outputTable)

  } else if(return == "plot"){

    outputTable %>%
      utils::head(10) %>%
      create_bar_asis(group_var = "Shifts",
                      bar_var = "WeekCount",
                      title = "Most frequent outlook shifts",
                      subtitle = "Showing top 10 only",
                      caption = extract_date_range(data, return = "text"),
                      ylab = "Shifts",
                      xlab = "Frequency")

  } else if(return == "data"){

    output_data <- data
    dplyr::as_tibble(output_data)
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
#' @title Standardise variable names for Standard Person Query Quietly for
#' `Collaboration_hours`
#'
#' @noRd
#'
qui_stan_c <- function(data){

  if(!("Collaboration_hours" %in% names(data)) &
     ("Collaboration_hrs" %in% names(data))){

    data <- data %>% mutate(Collaboration_hours = Collaboration_hrs)
    # message("Adding `Collaboration_hours` column based on `Collaboration_hrs`")

  }

  return(data)
}

#' @title Standardise variable names for Standard Person Query Quietly for
#' `Instant_Message_hours`
#'
#' @noRd
#'
qui_stan_im <- function(data){

  if(!("Instant_Message_hours" %in% names(data)) &
     ("Instant_message_hours" %in% names(data))){

    data <- data %>% mutate(Instant_Message_hours = Instant_message_hours)
    # message("Adding `Instant_Message_hours` column based on `Instant_message_hours`")

  }

  return(data)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Employee count over time
#'
#' @description Returns a line chart showing the change in
#' employee count over time. Part of a data validation process to check
#' for unusual license growth / declines over time.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: ggplot object. A line plot showing employee count over time.
#'   - `"table"`: data frame containing a summary table.
#'
#' @import dplyr
#' @import ggplot2
#'
#' @examples
#' # Return plot
#' hr_trend(pq_data)
#'
#' # Return summary table
#' hr_trend(pq_data, return = "table")
#'
#' @family Visualization
#' @family Data Validation
#'
#' @export
hr_trend <- function(data, return = "plot"){

  data$Date <- as.Date(data$MetricDate, format = "%m/%d/%Y")

  ## Date range data frame
  myPeriod <- extract_date_range(data)

  plot_data <-
    data %>%
    group_by(Date) %>%
    summarise(n = n_distinct(PersonId), .groups = "drop_last") %>%
    ungroup()

  if(return == "plot"){
    plot_data %>%
      ggplot(aes(x = Date, y = n)) +
      geom_line(size = 1) +
      labs(title = "Population over time",
           subtitle = "Unique licensed population by week",
           caption = paste("Data from week of", myPeriod$Start, "to week of", myPeriod$End)) +
      ylab("Employee count") +
      xlab("Date") +
      scale_y_continuous(labels = round, limits = c(0,NA)) +
      theme_wpa_basic()

  } else if(return == "table"){
    plot_data
  } else {
    stop("Please enter a valid input for `return`.")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Email Hours as a 100% stacked bar
#'
#' @description
#' Analyze Email Hours distribution.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @family Visualization
#' @family Emails
#'
#' @examples
#' # Return plot
#' email_dist(pq_data, hrvar = "Organization")
#'
#' # Return summary table
#' email_dist(pq_data, hrvar = "Organization", return = "table")
#'
#' # Return result with a custom specified breaks
#' email_dist(pq_data, hrvar = "LevelDesignation", cut = c(1, 2, 3))
#'
#' @export

email_dist <- function(data,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot",
                       cut = c(.5, 1, 1.5)) {

  create_dist(data = data,
              metric = "Email_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              cut = cut)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Add a character at the start and end of a character string
#'
#' @description This function adds a character at the start and end of a character
#' string, where the default behaviour is to add a double quote.
#'
#' @param string Character string to be wrapped around
#' @param wrapper Character to wrap around `string`
#'
#' @family Support
#'
#' @return
#' Character vector containing the modified string.
#'
#' @export
wrap <- function(string, wrapper = '"'){
  paste0(wrapper, string, wrapper)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate a Data Validation report in HTML
#'
#' @description
#' The function generates an interactive HTML report using
#' Standard Person Query data as an input. The report contains checks on
#' Viva Insights query outputs to provide diagnostic information
#' for the Analyst prior to analysis.
#'
#' An additional Standard Meeting Query can be provided to perform meeting
#' subject line related checks. This is optional and the validation report can
#' be run without it.
#'
#' @details
#' For your input to `data` or `meeting_data`, please use the function
#' `vivainsights::import_query()` to import your csv query files into R. This function will
#' standardize format and prepare the data as input for this report.
#'
#' For most variables, a note is returned in-line instead of an error if the variable
#' is not available.
#'
#' @section Checking functions within `validation_report()`:
#'   - `check_query()`
#'   - `flag_ch_ratio()`
#'   - `hrvar_count_all()`
#'   - `identify_privacythreshold()`
#'   - `identify_nkw()`
#'   - `identify_holidayweeks()`
#'   - `subject_validate()` (available in 'wpa')
#'   - `identify_tenure()`
#'   - `flag_outlooktime()`
#'   - `identify_shifts()`
#'   - `track_HR_change()`
#'
#' You can browse each individual function for details on calculations.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param meeting_data An optional Meeting Query dataset in the form of a data
#'   frame.
#' @param hrvar HR Variable by which to split metrics, defaults to "Organization"
#'  but accepts any character vector, e.g. "Organization"
#' @param path Pass the file path and the desired file name, _excluding the file
#'   extension_.
#' @param hrvar_threshold Numeric value determining the maximum number of unique
#'   values to be allowed to qualify as a HR variable. This is passed directly
#'   to the `threshold` argument within `hrvar_count_all()`.
#' @param timestamp Logical vector specifying whether to include a timestamp in
#'   the file name. Defaults to `TRUE`.
#'
#' @section Creating a report:
#'
#' Below is an example on how to run the report.
#'
#' ```
#' validation_report(pq_data,
#'                   hrvar = "Organization")
#' ```
#'
#'
#' @importFrom purrr map_if
#' @importFrom dplyr `%>%`
#'
#' @family Reports
#' @family Data Validation
#'
#' @inherit generate_report return
#'
#' @export
validation_report <- function(data,
                              meeting_data = NULL,
                              hrvar = "Organization",
                              path = "validation report",
                              hrvar_threshold = 150,
                              timestamp = TRUE){

  ## Create timestamped path (if applicable)
  if(timestamp == TRUE){
    newpath <- paste(path, vivainsights::tstamp())
  } else {
    newpath <- path
  }

  ## Handle variable name consistency
  data <- qui_stan_c(data)
  data <- qui_stan_im(data)

  ## Dynamic: if meeting data is not available
  if(is.null(meeting_data)){
    subline_obj <- "[Note] Subject line analysis is unavailable as no meeting query is supplied."
    subline_obj2 <- ""
  } else {
    subline_obj <- meeting_data %>% wpa::subject_validate(return = "text")
    subline_obj2 <- meeting_data %>% wpa::subject_validate(return = "table")
  }

  ## Dynamic: if `HireDate` is not available
  if("HireDate" %in% names(data)){
    tenure_obj <- data %>% identify_tenure(return = "text") %>% suppressWarnings()
    tenure_obj2 <- data %>% identify_tenure(return = "plot") %>% suppressWarnings()
  } else {
    tenure_obj <- "[Note] Tenure analysis is unavailable as the data has no `HireDate` variable."
    tenure_obj2 <- ""
  }

  ## Dynamic: if `WorkingStartTimeSetInOutlook` and `WorkingEndTimeSetInOutlook` is not available
  wktimes_var <- c("WorkingStartTimeSetInOutlook", "WorkingEndTimeSetInOutlook")
  wktimes_msg <- "[Note] Outlook hours analysis is unavailable as the data does not have the following variables:"

  if(all(wktimes_var %in% names(data))){
    wktimes_obj <- data %>% flag_outlooktime(return = "text")
    shift_obj <- data %>% identify_shifts(return = "plot")
  } else {
    wktimes_obj <- paste(wktimes_msg, paste(wrap(wktimes_var, "`"), collapse = ", "), collapse = "\n")
    shift_obj <- paste(wktimes_msg, paste(wrap(wktimes_var, "`"), collapse = ", "), collapse = "\n")
  }

  ## Dynamic: Track HR changes
  mtry <- try(track_HR_change(data, hrvar = hrvar), silent = TRUE)

  if (!inherits(mtry, "try-error")) {
    trackhr_obj <- data %>% track_HR_change(hrvar = hrvar, return = "plot")
    trackhr_obj2 <- data %>% track_HR_change(hrvar = hrvar, return = "table")
  } else {
    trackhr_obj <- "[Error!] unable to parse HR changes."
    trackhr_obj2 <- ""
  }

  ## Dynamic: check for presence of metrics and create appropriate messages
  callthres_p <- NULL
  callthres <- NULL
  
  emailthres_p <- NULL
  emailthres <- NULL
  
  meetingthres_p <- NULL
  meetingthres <- NULL
  
  chatthres_p <- NULL
  chatthres <- NULL
  
  conflictingthres_p <- NULL
  conflictingthres <- NULL
  
  collabthres_p <- NULL
  collabthres <- NULL


  ## Handle Call_hours
  if("Call_hours" %in% names(data)){
    callthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Call_hours",
          threshold = 40,
          person = TRUE,
          return = "text"
        )
    )

    callthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Call_hours",
          threshold = 40,
          person = FALSE,
          return = "text"
        )
      )

  } else {

    callthres_p <-
      "> [Note] Checks for `Call_hours` is not available due to missing variable."
    callthres <- callthres_p

  }
  
  ## Handle Email_hours
  if("Email_hours" %in% names(data)){
    emailthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Email_hours",
          threshold = 80,
          person = TRUE,
          return = "text"
        )
    )

    emailthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Email_hours",
          threshold = 80,
          person = FALSE,
          return = "text"
        )
      )

  } else {

    emailthres_p <-
      "> [Note] Checks for `Email_hours` is not available due to missing variable."
    emailthres <- emailthres_p

  }
  
  ## Handle Meeting_hours
  if("Meeting_hours" %in% names(data)){
    meetingthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Meeting_hours",
          threshold = 80,
          person = TRUE,
          return = "text"
        )
    )

    meetingthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Meeting_hours",
          threshold = 80,
          person = FALSE,
          return = "text"
        )
      )

  } else {

    meetingthres_p <-
      "> [Note] Checks for `Meeting_hours` is not available due to missing variable."
    meetingthres <- meetingthres_p

  }
  
  ## Handle Chat_hours
  if("Chat_hours" %in% names(data)){
    chatthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Chat_hours",
          threshold = 40,
          person = TRUE,
          return = "text"
        )
    )

    chatthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Chat_hours",
          threshold = 40,
          person = FALSE,
          return = "text"
        )
      )

  } else {

    chatthres_p <-
      "> [Note] Checks for `Chat_hours` is not available due to missing variable."
    chatthres <- chatthres_p

  }
  
  ## Handle Conflicting_meeting_hours
  if("Conflicting_meeting_hours" %in% names(data)){
    conflictingthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Conflicting_meeting_hours",
          threshold = 70,
          person = TRUE,
          return = "text"
        )
    )

    conflictingthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Conflicting_meeting_hours",
          threshold = 70,
          person = FALSE,
          return = "text"
        )
      )

  } else {

    conflictingthres_p <-
      "> [Note] Checks for `Conflicting_meeting_hours` is not available due to missing variable."
    conflictingthres <- conflictingthres_p

  }
  
  ## Handle Collaboration_hours
  if("Collaboration_hours" %in% names(data)){
    collabthres_p <- paste(
      ">",
      data %>%
        flag_extreme(
          metric = "Collaboration_hours",
          threshold = 0,
          person = TRUE,
          mode = "equal",
          return = "text"
        )
    )

    collabthres <-
      paste(
        ">",
        data %>% flag_extreme(
          metric = "Collaboration_hours",
          threshold = 0,
          person = FALSE,
          mode = "equal",
          return = "text"
        )
      )

  } else {

    collabthres_p <-
      "> [Note] Checks for `Collaboration_hours` is not available due to missing variable."
    collabthres <- collabthres_p

  }


  ## Outputs as accessed here
  ## Can be data frames, plot objects, or text
  output_list <-
    list(read_preamble("blank.md"), # Header - Data Available
         data %>% check_query(return = "text", validation = TRUE),

         read_preamble("blank.md"), # Header - 1.1 Viva Insights Settings
         read_preamble("outlook_settings_1.md"),

         shift_obj, # See `identify_shifts()` dynamic treatment above

         read_preamble("outlook_settings_2.md"),
         paste(">", wktimes_obj),
         paste(">", data %>% flag_ch_ratio(return = "text")),
         read_preamble("outlook_settings_3.md"),

         read_preamble("meeting_exclusions_1.md"), #item 9, Header - 1.2 Meeting Exclusions
         paste(">", subline_obj),
         subline_obj2,
         read_preamble("meeting_exclusions_2.md"),

         read_preamble("organizational_data_quality.md"), #13, Header - 2. Organizational Data Quality
         read_preamble("attributes_available.md"),#14
         data %>% hrvar_count_all(return = "table", threshold = hrvar_threshold),

         read_preamble("groups_under_privacy_threshold_1.md"), #16, Header - 2.2 Groups under Privacy Threshold
         paste(">", data %>% identify_privacythreshold(return="text")),
         read_preamble("groups_under_privacy_threshold_2.md"),
         data %>% identify_privacythreshold(return="table"),

         read_preamble("distribution_employees_key_attributes.md"), #20, Header - 2.3 Distribution employees key attributes
         data %>% hrvar_count(hrvar = hrvar, return = "plot"),
         data %>% hrvar_count(hrvar = hrvar, return = "table"),

         read_preamble("updates_organizational_data.md"), #23, Header - 2.4 Updates to Organizational Data
         read_preamble("blank.md"), #placeholder for track_HR_change message obj,
		     trackhr_obj,
		     trackhr_obj2,

         read_preamble("quality_tenure_data.md"), #27, Header - 2.5 Quality Tenure Data
         paste(">", tenure_obj), # Text
         tenure_obj2, # Plot

         read_preamble("m365_data_quality.md"), #30, Header - 3. M365 Data Quality
         read_preamble("population_over_time.md"), #Header - 3.1
         data %>% hr_trend(return = "plot"),

         read_preamble("nonknowledge_workers.md"), #33, Header - 3.2 Non-knowledge workers
         paste(">", data %>% identify_nkw(return = "text")),
         data %>% identify_nkw(return = "data_summary"),

         read_preamble("holiday_weeks_1.md"), #36, Header - 3.3 Company Holiday weeks
         paste(">", data %>% identify_holidayweeks(return = "text")),
         read_preamble("holiday_weeks_2.md"),
         data %>% identify_holidayweeks(return = "plot"),

         read_preamble("inactive_weeks_1.md"), #40, Header - 3.4 Inactive weeks
         paste(">", data %>% identify_inactiveweeks(return = "text")),
         read_preamble("inactive_weeks_2.md"),

         read_preamble("extreme_values.md"), #43, Header - 3.5 Extreme values
         emailthres_p,
         emailthres,

         meetingthres_p,
         meetingthres,

         callthres_p,
         callthres,

         chatthres_p,
         chatthres,

         conflictingthres_p,
         conflictingthres,

		     collabthres_p,
		     collabthres
		     ) %>%

    purrr::map_if(is.data.frame, create_dt, rounding = 0) %>%
    purrr::map_if(is.character, md2html)

  ## Title of the outputs
  title_list <-
    c("Data Available",
      "Query Check",

      "1. Viva Insights Settings",
      "1.1 Outlook Settings",
      "",
      "",
      "",
      "",
      "",
      "1.2 Meeting Exclusion Rules",
      "",
      "",
      "",

      "2. Organizational Data Quality",
      "2.1 Attributes Available",
      "",
      "2.2 Groups Under Privacy Threshold",
      "",
      "",
      "",

      "2.3 Distribution of Employees in Key Attributes",
      "",
      "",

      "2.4 Updates to Organizational Data",
      "",
      "",
      "",

      "2.5 Quality of Tenure Data",
      "",
      "",

      "3. M365 Data Quality",
      "3.1 Population Over Time",
      "",
      "3.2 Non-knowledge Workers",
      "",
      "",
      "3.3 Company Holiday Weeks",
      "",
      "",
      "",
      "3.4 Inactive Weeks",
      "",
      "",
      "3.5 Extreme Values",
      "3.5.1 Extreme values: Email",
      "",
      "3.5.2 Extreme values: Meeting",
      "",
      "3.5.3 Extreme values: Calls",
      "",
      "3.5.4 Extreme values: IM",
      "",
      "3.5.5 Extreme values: Conflicting Meetings",
      "",
      "3.5.6 Extreme values: Zero collaboration",
      ""
      )

  # Set header levels
  n_title <- length(title_list)
  levels_list <- rep(4, n_title)
  levels_list[c(1, 3, 14, 31)] <- 2 # Section header

  generate_report(title = "Data Validation Report",
                  filename = newpath,
                  outputs = output_list,
                  titles = title_list,
                  subheaders = rep("", n_title),
                  echos = rep(FALSE, n_title),
                  levels = levels_list,
                  theme = "cosmo",
                  preamble = read_preamble("validation_report.md")) # See inst/preamble/validation_report.md
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a bar chart without aggregation for any metric
#'
#' @description
#' This function creates a bar chart directly from the aggregated / summarised
#' data. Unlike `create_bar()` which performs a person-level aggregation, there
#' is no calculation for `create_bar_asis()` and the values are rendered as they
#' are passed into the function.
#'
#' @param data Plotting data as a data frame.
#' @param group_var String containing name of variable for the group.
#' @param bar_var String containing name of variable representing the value of
#'   the bars.
#' @param title Title of the plot.
#' @param subtitle Subtitle of the plot.
#' @param caption Caption of the plot.
#' @param ylab Y-axis label for the plot (group axis)
#' @param xlab X-axis label of the plot (bar axis).
#' @param percent Logical value to determine whether to show labels as
#'   percentage signs. Defaults to `FALSE`.
#' @param bar_colour String to specify colour to use for bars.
#' In-built accepted values include "default" (default), "alert" (red), and
#' "darkblue". Otherwise, hex codes are also accepted. You can also supply
#' RGB values via `rgb2hex()`.
#' @param rounding Numeric value to specify number of digits to show in data
#'   labels
#'
#' @return
#' 'ggplot' object. A horizontal bar plot.
#'
#' @examples
#' # Creating a custom bar plot without mean aggregation
#' library(dplyr)
#'
#' pq_data %>%
#'   group_by(Organization) %>%
#'   summarise(across(.cols = Meeting_hours,
#'                    .fns = ~sum(., na.rm = TRUE))) %>%
#'   create_bar_asis(group_var = "Organization",
#'                   bar_var = "Meeting_hours",
#'                   title = "Total Meeting Hours over period",
#'                   subtitle = "By Organization",
#'                   caption = extract_date_range(pq_data, return = "text"),
#'                   bar_colour = "darkblue",
#'                   rounding = 0)
#'
#' @import ggplot2
#' @import dplyr
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' library(dplyr)
#'
#' # Summarise Non-person-average median `Emails_sent`
#' med_df <-
#'   pq_data %>%
#'   group_by(Organization) %>%
#'   summarise(Emails_sent_median = median(Emails_sent))
#'
#' med_df %>%
#'   create_bar_asis(
#'     group_var = "Organization",
#'     bar_var = "Emails_sent_median",
#'     title = "Emails sent by organization",
#'     subtitle = "Median values",
#'     bar_colour = "darkblue",
#'     caption = extract_date_range(pq_data, return = "text")
#'   )
#'
#'
#' @export
create_bar_asis <- function(data,
                            group_var,
                            bar_var,
                            title = NULL,
                            subtitle = NULL,
                            caption = NULL,
                            ylab = group_var,
                            xlab = bar_var,
                            percent = FALSE,
                            bar_colour = "default",
                            rounding = 1){

  ## Colour bar override
  if(bar_colour == "default"){

    bar_colour <- "#34b1e2"

  } else if(bar_colour == "alert"){

    bar_colour <- "#FE7F4F"

  } else if(bar_colour == "darkblue"){

    bar_colour <- "#1d627e"

  }

  up_break <- max(data[[bar_var]], na.rm = TRUE) * 1.3

  if(percent == FALSE){
    returnPlot <-
      data %>%
      ggplot(aes(x = reorder(!!sym(group_var), !!sym(bar_var)), y = !!sym(bar_var))) +
      geom_col(fill = bar_colour) +
      geom_text(aes(label = round(!!sym(bar_var), digits = rounding)),
                position = position_stack(vjust = 0.5),
                # hjust = -0.25,
                color = "#FFFFFF",
                fontface = "bold",
                size = 4)

  } else if(percent == TRUE){
    returnPlot <-
      data %>%
      ggplot(aes(x = reorder(!!sym(group_var), !!sym(bar_var)), y = !!sym(bar_var))) +
      geom_col(fill = bar_colour) +
      geom_text(aes(label = scales::percent(!!sym(bar_var),
                                            accuracy = 10 ^ -rounding)),
                position = position_stack(vjust = 0.5),
                # hjust = -0.25,
                color = "#FFFFFF",
                fontface = "bold",
                size = 4)

  }

  returnPlot +
    scale_y_continuous(expand = c(.01, 0), limits = c(0, up_break)) +
    coord_flip() +
    labs(title = title,
         subtitle = subtitle,
         caption = caption,
         y = camel_clean(xlab),
         x = ylab) +
    theme_wpa_basic() +
    theme(
      axis.line = element_blank(),
		  axis.ticks = element_blank(),
		  axis.text.x = element_blank(),
		  axis.title = element_blank()
		  )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)
library(dplyr)

test_that("create_bar_asis returns a ggplot", {

  # Summarise Non-person-average median `Emails_sent`
  med_df <-
    pq_data %>%
    group_by(Organization) %>%
    summarise(Emails_sent_median = median(Emails_sent))
 
  result <- med_df %>%
            create_bar_asis(
            group_var = "Organization",
            bar_var = "Emails_sent_median",
            title = "Emails sent by organization",
            subtitle = "Median values",
            bar_colour = "darkblue",
            caption = extract_date_range(pq_data, return = "text")
            )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Email Hours Ranking
#'
#' @description
#' This function scans a standard query output for groups with high levels of
#' 'Weekly Email Collaboration'. Returns a plot by default, with an option to
#' return a table with a all of groups (across multiple HR attributes) ranked by
#' hours of digital collaboration.
#'
#' @details
#' Uses the metric `Email_hours`.
#' See `create_rank()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_rank
#' @inherit create_rank return
#'
#' @family Visualization
#' @family Emails
#'
#' @examples
#' # Return rank table
#' email_rank(
#'   data = pq_data,
#'   return = "table"
#' )
#'
#' # Return plot
#' email_rank(
#'   data = pq_data,
#'   return = "plot"
#' )
#'
#' @export

email_rank <- function(data,
                       hrvar = extract_hr(data),
                       mingroup = 5,
                       mode = "simple",
                       plot_mode = 1,
                       return = "plot"){

  data %>%
    create_rank(metric = "Email_hours",
                hrvar = hrvar,
                mingroup = mingroup,
                mode = mode,
                plot_mode = plot_mode,
                return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of After-hours Collaboration Hours as a 100% stacked bar
#' @name afterhours_dist
#'
#' @description Analyse the distribution of weekly after-hours collaboration time.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @details
#' Uses the metric \code{After_hours_collaboration_hours}.
#' See `create_dist()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @param cut A vector specifying the cuts to use for the data,
#' accepting "default" or "range-cut" as character vector,
#' or a numeric value of length three to specify the exact breaks to use. e.g. c(1, 3, 5)
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom tidyr spread
#' @importFrom stats median
#' @importFrom stats sd
#'
#' @family Visualization
#' @family After-hours Collaboration
#'
#' @examples
#' # Return plot
#' afterhours_dist(pq_data, hrvar = "Organization")
#'
#' # Return summary table
#' afterhours_dist(pq_data, hrvar = "Organization", return = "table")
#'
#' # Return result with a custom specified breaks
#' afterhours_dist(pq_data, hrvar = "LevelDesignation", cut = c(4, 7, 9))
#' @export
afterhours_dist <- function(data,
                            hrvar = "Organization",
                            mingroup = 5,
                            return = "plot",
                            cut = c(1, 2, 3)) {

  create_dist(data = data,
              metric = "After_hours_collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              cut = cut)


}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Row-bind an identical data frame for computing grouped totals
#'
#' @description Row-bind an identical data frame and impute a specific
#' column with the `target_value`, which defaults as "Total". The purpose of
#' this is to enable to creation of summary tables with a calculated "Total"
#' row. See example below on usage.
#'
#' @examples
#' pq_data %>%
#'   totals_bind(target_col = "LevelDesignation", target_value = "Total") %>%
#'   create_bar(hrvar = "LevelDesignation", metric = "Email_hours", return = "table")
#'
#' @param data data frame
#' @param target_col Character value of the column in which to impute `"Total"`.
#'   This is usually the intended grouping column.
#' @param target_value Character value to impute in the new data frame to
#'   row-bind. Defaults to `"Total"`.
#'
#' @return
#' data frame with twice the number of rows of the input data frame, where half
#' of those rows will have the `target_col` column imputed with the value from
#' `target_value`.
#'
#' @family Support
#'
#' @export
totals_bind <- function(data, target_col, target_value = "Total"){
  data %>%
    dplyr::bind_rows(dplyr::mutate(., !!sym(target_col) := target_value))
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Simulate a person-to-person query using a Watts-Strogatz model
#'
#' @description Generate an person-to-person query / edgelist based on the graph
#'   according to the Watts-Strogatz small-world network model. Organizational
#'   data fields are also simulated for `Organization`, `LevelDesignation`, and
#'   `City`.
#'
#' @param dim Integer constant, the dimension of the starting lattice.
#' @param size Integer constant, the size of the lattice along each dimension.
#' @param nei Integer constant, the neighborhood within which the vertices of
#'  the lattice will be connected.
#' @param p Real constant between zero and one, the rewiring probability.
#'
#' @details
#' This is a wrapper around `igraph::watts.strogatz.game()`. See igraph
#' documentation for details on methodology. Loop edges and multiple edges are
#' disabled. Size of the network can be changing the arguments `size` and `nei`.
#'
#' @examples
#' # Simulate a p2p dataset with 800 edges
#' p2p_data_sim(size = 200, nei = 4)
#'
#' @return
#' data frame with the same column structure as a person-to-person flexible
#' query. This has an edgelist structure and can be used directly as an input
#' to `network_p2p()`.
#'
#' @family Data
#' @family Network
#'
#' @export
p2p_data_sim <- function(dim = 1,
                         size = 300,
                         nei = 5,
                         p = 0.05){

  igraph::watts.strogatz.game(dim = dim,
                              size = size,
                              nei = nei,
                              p = p) %>%
    igraph::as_edgelist() %>%
    as.data.frame() %>%
    dplyr::rename(PrimaryCollaborator_PersonId = "V1",
           SecondaryCollaborator_PersonId = "V2") %>%
    dplyr::mutate(PrimaryCollaborator_Organization = add_cat(PrimaryCollaborator_PersonId, "Organization"),
           SecondaryCollaborator_Organization = add_cat(SecondaryCollaborator_PersonId, "Organization"),
           PrimaryCollaborator_LevelDesignation = add_cat(PrimaryCollaborator_PersonId, "LevelDesignation"),
           SecondaryCollaborator_LevelDesignation = add_cat(SecondaryCollaborator_PersonId, "LevelDesignation"),
           PrimaryCollaborator_City = add_cat(PrimaryCollaborator_PersonId, "City"),
           SecondaryCollaborator_City = add_cat(SecondaryCollaborator_PersonId, "City")) %>%
    dplyr::mutate(across(ends_with("PersonId"),
                     ~paste0("SIM_ID_", .))) %>%
    dplyr::mutate(StrongTieScore = 1)
}

#' Add organizational data to the simulated p2p data
#' @param x Numeric vector to be assigned simulated organizational attributes
#' @param type String with three valid options:
#'   - `Organization`
#'   - `LevelDesignation`
#'   - `City`
#'
#' @noRd
add_cat <- function(x, type){

  if(type == "Organization"){

    dplyr::case_when((x %% 7 == 0) ~ "Org A",
                     (x %% 6 == 0) ~ "Org B",
                     (x %% 5 == 0) ~ "Org C",
                     (x %% 4 == 0) ~ "Org D",
                     (x %% 3 == 0) ~ "Org E",
                     x < 100 ~ "Org F",
                     (x %% 2 == 0) ~ "Org G", # Even number
                     TRUE ~ "Org H")

  } else if(type == "LevelDesignation"){

    paste("Level", substr(x, 1, 1)) # Extract first digit

  } else if(type == "City"){

    dplyr::case_when((x %% 3 == 0) ~ "City A", # Divisible by 3
                     (x %% 2 == 0) ~ "City B",
                     TRUE ~ "City C")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

# Define the unit test
test_that("network_p2p returns a data frame when return = 'table'", {
    # Use p2p_data_sim() to generate test data
    sim_data <- p2p_data_sim(size = 50, nei = 2)
    
    result <- network_p2p(sim_data, return = "table")

    # Check if the result is a data frame
    expect_s3_class(result, "data.frame")
})

test_that("network_p2p errors with informative message when multiple MetricDates are present", {
    # Create test data with multiple MetricDate values using p2p_data_sim()
    base_data <- p2p_data_sim(size = 50, nei = 2)
    
    # Add a MetricDate column to the simulated data
    base_data$MetricDate <- as.Date("2023-01-01")
    
    # Create a second dataset with different MetricDate
    second_date_data <- base_data
    second_date_data$MetricDate <- as.Date("2023-01-08")  # Add 7 days
    
    # Combine both sets
    multi_date_data <- rbind(base_data, second_date_data)
    
    # Test that appropriate error is thrown
    expect_error(
        network_p2p(multi_date_data, return = "table"),
        "Multiple `MetricDate` values detected"
    )
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Copy a data frame to clipboard for pasting in Excel
#'
#' @description
#' This is a pipe-optimised function, that feeds into `vivainsights::export()`,
#' but can be used as a stand-alone function.
#'
#' Based on the original function from
#' <https://github.com/martinctc/surveytoolbox>.
#'
#' @param x Data frame to be passed through. Cannot contain list-columns or
#'   nested data frames.
#' @param row.names A logical vector for specifying whether to allow row names.
#'   Defaults to `FALSE`.
#' @param col.names A logical vector for specifying whether to allow column
#'   names. Defaults to `FALSE`.
#' @param quietly Set this to TRUE to not print data frame on console
#' @param ... Additional arguments for write.table().
#'
#' @importFrom utils write.table
#'
#' @family Import and Export
#'
#' @return
#' Copies a data frame to the clipboard with no return value.
#'
#' @export

copy_df <-function(x,
                   row.names = FALSE,
                   col.names = TRUE,
                   quietly = FALSE,...) {


    utils::write.table(x,"clipboard-50000",
                sep="\t",
                row.names=row.names,
                col.names=col.names,...)

  if(quietly==FALSE) print(x)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Manager 1:1 Time Summary
#'
#' @description
#' Provides an overview analysis of Manager 1:1 Time. Returns a bar plot showing
#' average weekly minutes of Manager 1:1 Time by default. Additional options
#' available to return a summary table.
#'
#' @inheritParams create_bar
#' @inherit create_bar return
#'
#' @family Visualization
#' @family Managerial Relations
#'
#' @examples
#' # Return a ggplot bar chart
#' one2one_sum(pq_data, hrvar = "LevelDesignation")
#'
#' # Return a summary table
#' one2one_sum(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

one2one_sum <- function(data,
                        hrvar = "Organization",
                        mingroup = 5,
                        return = "plot"){

  cleaned_data <-
    data %>%
    mutate(`Scheduled 1:1 meeting and call minutes with manager` = Meeting_and_call_hours_with_manager_1_1 * 60)


  create_bar(data = cleaned_data,
             hrvar = hrvar,
             mingroup = mingroup,
             metric = "Scheduled 1:1 meeting and call minutes with manager",
             return = return,
             bar_colour = "darkblue")

}

#' @rdname one2one_sum
#' @export
one2one_summary <- one2one_sum

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Estimate an effect of intervention on every Viva Insights metric in input
#' file by applying single-group Interrupted Time-Series Analysis (ITSA)
#'
#' @author Aleksey Ashikhmin <alashi@@microsoft.com>
#'
#' @description
#' r lifecycle::badge('experimental')
#'
#' This function implements ITSA method described in the paper 'Conducting
#' interrupted time-series analysis for single- and multiple-group comparisons',
#' Ariel Linden, The Stata Journal (2015), 15, Number 2, pp. 480-500
#'
#' This function further requires the installation of 'sandwich' and 'lmtest' in
#' order to work. These packages can be installed from CRAN using
#' `install.packages()`.
#'
#' @details
#' This function uses the additional package dependencies 'sandwich' and
#' 'lmtest'. Please install these separately from CRAN prior to running the
#' function.
#'
#' As of May 2022, the 'portes' package was archived from CRAN. The dependency
#' has since been removed and dependent functions `Ljungbox()` incorporated into
#' the **wpa** package.
#'
#' @param data Person Query as a dataframe including date column named
#'   `MetricDate`. This function assumes the data format is `%Y-%m-%d` as is
#'   standard in a Viva Insights query output.
#' @param metrics A character vector containing the variable names to perform
#'   the interrupted time series analysis for.
#' @param before_start String specifying the start date of the 'before'
#'   time period in `%Y-%m-%d` format. The 'before' time period refers to the
#'   period before the intervention (e.g. training program, re-org, shift to
#'   remote work) occurs and bounded by `before_start` and `before_end`
#'   parameters. Longer period increases likelihood of achieving more
#'   statistically significant results. Defaults to earliest date in dataset. If
#'   not provided, this defaults to the earliest date in the dataset.
#' @param before_end String specifying the end date of 'before' time
#'   period in `%Y-%m-%d` format. If `NULL`, an error will be raised, as this
#'   value is required.
#' @param after_start String specifying the start date of the 'after'
#'   time period in `%Y-%m-%d` format. If `NULL`, this will default to the value
#'   of `before_end`. The 'after' time period refers to the period after the
#'   intervention occurs and is bounded by `after_start` and `after_end`
#'   parameters. Longer periods increase the likelihood of achieving more
#'   statistically significant results.
#' @param after_end String specifying the end date of the 'after' time
#'   period in `%Y-%m-%d` format. Defaults to the latest date in the dataset.
#' @param ac_lags_max Numeric value specifying the maximum lag for the autocorrelation test.
#'   The Ljung-Box test is used to check for autocorrelation in the model residuals
#'   up to this specified number of lags. Higher values check for longer-term
#'   dependencies in the time series data.
#' @param return String specifying what output to return. Defaults to "table".
#' Valid return options include:
#'   - `'plot'`: return a list of plots.
#'   - `'table'`: return data.frame with estimated models' coefficients and
#'   their corresponding p-values You should look for significant p-values in
#'   beta_2 to indicate an immediate treatment effect, and/or in beta_3 to
#'   indicate a treatment effect over time
#'
#' @import dplyr
#' @import ggplot2
#'
#' @family Flexible Input
#' @family Interrupted Time-Series Analysis
#'
#'
#' @examples
#' \dontrun{
#' # Returns summary table
#' create_itsa(
#'   data = pq_data,
#'   metrics = c("Collaboration_span", "Internal_network_size"),
#'   before_end = "2024-07-01",
#'   after_start = "2024-07-01",
#'   ac_lags_max = 7,
#'   return = "table"
#' )
#'
#' # Returns list of plots
#' plot_list <-
#'   create_itsa(
#'     data = pq_data,
#'     metrics = c("Collaboration_span", "Internal_network_size"),
#'     before_end = "2024-07-01",
#'     after_start = "2024-07-01",
#'     ac_lags_max = 7,
#'     return = "plot"
#'   )
#'
#' # Extract a plot as an example
#' plot_list$Collaboration_span
#' }
#'
#' @return 
#' When 'data' is passed to `return`, a data frame with the following columns:
#' - `metric_name`: Name of the metric being analyzed.
#' - `beta_2`: Coefficient for the immediate treatment effect.
#' - `beta_3`: Coefficient for the treatment effect over time.
#' - `beta_2_pvalue`: P-value for the immediate treatment effect.
#' - `beta_3_pvalue`: P-value for the treatment effect over time.
#' - `AR_flag`: Logical flag indicating whether autocorrelation was detected.
#' - `error_warning`: Error or warning message if applicable.
#' 
#' @export

create_itsa <- function(
    data,
    metrics = NULL,
    before_start = NULL,
    before_end = NULL,
    after_start = NULL,
    after_end = NULL,
    ac_lags_max = 7,
    return = 'table'
    ) {
  
  ## Check inputs types
  stopifnot(is.data.frame(data))  # Ensure 'data' is a data frame
  stopifnot(is.character(metrics) | is.null(metrics))  # 'metrics' can be a character vector or NULL
  stopifnot(is.character(before_start) | inherits(before_start, "Date") | is.null(before_start))  # 'before_start' can be a string, or Date, or NULL
  stopifnot(is.character(before_end) | inherits(before_end, "Date") | is.null(before_end))  # 'before_end' must be a string, Date, or NULL
  stopifnot(is.character(after_start) | inherits(after_start, "Date") | is.null(after_start))  # 'after_start' can be a string, Date, or NULL
  stopifnot(is.character(after_end) | inherits(after_end, "Date") | is.null(after_end))  # 'after_end' can be a string, Date, or NULL
  stopifnot(is.numeric(ac_lags_max))  # 'ac_lags_max' must be numeric
  stopifnot(is.character(return))  # 'return' must be a string

  # Set variables for min and max dates in `data`
  min_date <- min(data$MetricDate, na.rm = TRUE)
  max_date <- max(data$MetricDate, na.rm = TRUE)

  # If `before_start` is not provided, set it to the earliest date in the dataset
  if (is.null(before_start)) {
    before_start <- min_date
  }

  # Raise an error if `before_end` is NULL
  if (is.null(before_end)) {
    stop("The 'before_end' parameter must be provided.")
  }

  # If `after_start` is NULL, set it to the value of `before_end`
  if (is.null(after_start)) {
    after_start <- before_end
  }

  # If `after_end` is not provided, set it to the latest date in the dataset
  if (is.null(after_end)) {
    after_end <- max_date
  }
  
  # Check if dependencies are installed
  check_pkg_installed(pkgname = "sandwich")
  check_pkg_installed(pkgname = "lmtest")
  
  ## Check required columns in data
  required_variables <- c("MetricDate", "PersonId", metrics)
  
  ## Error message if variables are not present
  ## Nothing happens if all present
  check_inputs(data, requirements = required_variables)
  
  # Debugging: Print the provided date strings before parsing
  # message("Provided date strings:")
  # message(paste("  before_start:", before_start))
  # message(paste("  before_end:", before_end))
  # message(paste("  after_start:", after_start))
  # message(paste("  after_end:", after_end))
  
  # Parse the date strings
  before_start <- as.Date(before_start, "%Y-%m-%d")
  before_end <- as.Date(before_end, "%Y-%m-%d")
  after_start <- as.Date(after_start, "%Y-%m-%d")
  after_end <- as.Date(after_end, "%Y-%m-%d")
  
  # Debugging: Print the parsed dates
  message("Parsed dates:")
  message(paste("  before_start:", before_start))
  message(paste("  before_end:", before_end))
  message(paste("  after_start:", after_start))
  message(paste("  after_end:", after_end))
  
  # Check for missing dates
  if (any(is.na(c(before_start, before_end, after_start, after_end)))) {
    stop("One or more dates are missing.")
  }
  
  dateranges <- c(before_start, before_end, after_start, after_end)
  
  prepped_dataset <- 
    data %>%
    mutate(MetricDate = as.Date(MetricDate, "%Y-%m-%d")) %>%
    select(all_of(required_variables))
  
  # Check for dates in data file
  if (!all(dateranges >= min_date & dateranges <= max_date)){
    stop("Not all dates are found in the dataset")
  }
  
  # Create variable => Period
  prepped_dataset_table <-
    prepped_dataset %>%
    mutate(
      Period = case_when(
        (before_start <= MetricDate) & (MetricDate <= before_end) ~ "Before",
        (after_start <= MetricDate) & (MetricDate <= after_end) ~ "After"
      )
    ) %>%
    filter(Period %in% c("Before", "After")) %>%
    mutate(outcome = case_when(Period == "Before" ~ 0, Period == "After" ~ 1))
  
  # Create "train" data with metrics and Date columns
  date_column <- prepped_dataset_table[["MetricDate"]]
  
  train <- 
    prepped_dataset_table %>%
    select(where(is.numeric), MetricDate) %>%
    drop_na()
  
  # Aggregate metric values at Date level
  grouped_by_Date_train <- train %>% group_by(MetricDate)
  
  # Get metric names - exclude MetricDate and outcome columns
  metric_names <- setdiff(colnames(grouped_by_Date_train), c("MetricDate", "outcome"))
  
  # Create empty data.frame to save results (e.g. coefficients, p-values etc) for each metric
  results <- data.frame(
    metric_name = character(),
    beta_2 = double(),
    beta_3 = double(),
    beta_2_pvalue = double(),
    beta_3_pvalue = double(),
    AR_flag = logical(),
    error_warning = character()
  )
  
  # Create empty list to save plots
  results_plot <- list()
  
  # Perform ITSA for every metric in metric_names
  for (metric_name in metric_names) {
    
    # if error_flag = True then there would be no plot generated when return = 'plot'
    error_flag <- FALSE
    # AR_flag = False indicates that lag is equal 0 otherwise it's set to True
    AR_flag <- FALSE
    # lm_train_success_flag indicates model estimation success
    lm_train_success_flag <- FALSE
    
    buf_trycatch <- tryCatch({
      
      # Create a metric time-series by averaging metric values across users
      metric_data <- grouped_by_Date_train %>%
        summarise(
          across(
            c(metric_name, "outcome"), mean, na.rm = TRUE
            )
          )
      
      # Transform metric_data into ITSA format described in the paper page 485
      # X is dummy variable, 0 indicates pre-intervention period and 1 indicates post-intervention period
      X <- metric_data[["outcome"]]
      num_Zeros <- length(X) - sum(X) + 1
      
      data_OLS <- tibble(
        "MetricDate" = metric_data[["MetricDate"]],
        "Y" = metric_data[[metric_name]],
        "T" = seq(1:length(metric_data[["MetricDate"]])),
        "X" = metric_data[["outcome"]],
        "XT" = X * (T - num_Zeros)
        )
      
      single_itsa = stats::lm(Y ~ T + X + XT, data = data_OLS)
      
      # Newey-West variance estimator produces consistent estimates when there
      # is autocorrelation in addition to possible Heteroscedasticity
      coeff_pvalues <- lmtest::coeftest(
        single_itsa,
        vcov = sandwich::NeweyWest(single_itsa, lag = 0, prewhite = FALSE)
        )
      
      beta_2 <- round(single_itsa$coefficients[3], 3)
      beta_3 <- round(single_itsa$coefficients[4], 3)
      beta_2_pvalue <- round(coeff_pvalues[3, 4], 3)
      beta_3_pvalue <- round(coeff_pvalues[4, 4], 3)
      
      lm_train_success_flag <- TRUE
      
      # It is important to test for the presence of autocorrelated errors
      # when using regression-based time-series methods, because such tests
      # provide critical diagnostic information regarding the adequacy of the time-series model
      residuals <- single_itsa$residuals
      N <- length(residuals)
      
      # Run Ljung and Box Test to test for autocorrelation
      lb_test <- wpa::LjungBox(
        single_itsa,
        lags = seq(1, ac_lags_max),
        order = 4,
        season = 1,
        squared.residuals = FALSE
      )
      
      ind_stat_significant_coeff <- which(lb_test[, 'p-value'] <= 0.05)
      
      # LjungBox test identifies statistically significant lags then we use Newey-West method
      # (heteroscedasticity and autocorrelation consistent (HAC) covariance matrix estimators)
      # with maximum lag to estimate lm model coefficients' std errors and p-values with lags accounting
      if (0 < length(ind_stat_significant_coeff)) {
        # The Newey & West (1987) estimator requires specification
        # of the lag and suppression of prewhitening
        coeff_pvalues <- lmtest::coeftest(
          single_itsa,
          vcov = sandwich::NeweyWest(
            single_itsa,
            lag = max(ind_stat_significant_coeff),
            prewhite = FALSE
            )
          )
        
        AR_flag <- TRUE
      }
      
      # Look for significant p-values in beta_2 to indicate an immediate treatment
      # effect, or in beta_3 to indicate a treatment effect over time
      # Yt = Beta0 + beta_1*Tt + beta_2*Xt + beta_3*Xt*Tt + epst
      beta_2 <- round(single_itsa$coefficients[3], 3)
      beta_3 <- round(single_itsa$coefficients[4], 3)
      beta_2_pvalue <- round(coeff_pvalues[3, 4], 3)
      beta_3_pvalue <- round(coeff_pvalues[4, 4], 3)
      
      buf <- dplyr::tibble(
        metric_name = metric_name,
        beta_2 = beta_2,
        beta_3 = beta_3,
        beta_2_pvalue = beta_2_pvalue,
        beta_3_pvalue = beta_3_pvalue,
        AR_flag = AR_flag,
        error_warning = ""
        )
    },
    error = function(c) {
      error_flag <- TRUE
      buf <- dplyr::tibble(
        metric_name = metric_name,
        beta_2 = ifelse(exists("beta_2", inherits = FALSE), beta_2, -1),
        beta_3 = ifelse(exists("beta_3", inherits = FALSE), beta_3, -1),
        beta_2_pvalue = ifelse(exists("beta_2_pvalue", inherits = FALSE), beta_2_pvalue, -1),
        beta_3_pvalue = ifelse(exists("beta_3_pvalue", inherits = FALSE), beta_3_pvalue, -1),
        AR_flag = FALSE,
        error_warning = paste0('Error: ', c$message, "; lm_train_success=", lm_train_success_flag, collapse = " ")
        )
    },
    warning = function(c) {
      buf <- dplyr::tibble(
        metric_name = metric_name,
        beta_2 = ifelse(exists("beta_2", inherits = FALSE), beta_2, -1),
        beta_3 = ifelse(exists("beta_3", inherits = FALSE), beta_3, -1),
        beta_2_pvalue = ifelse(exists("beta_2_pvalue", inherits = FALSE), beta_2_pvalue, -1),
        beta_3_pvalue = ifelse(exists("beta_3_pvalue", inherits = FALSE), beta_3_pvalue, -1),
        AR_flag = AR_flag,
        error_warning = paste0('Warning: ', c$message, "; lm_train_success=", lm_train_success_flag, collapse = " ")
        )
    }
    )
    
    results <- rbind(results, buf_trycatch)
    
    # Create a metric plot with its estimated ITSA model
    # and save it in "results_plot" list. If error_flag is TRUE then
    #save "buf_trycatch" instead for logging error message
    if (return == 'plot' & !error_flag) {
      
      event_T <- which.max(data_OLS[, "X"] == 1)
      hat_Y <- single_itsa$fitted.values
      
      before_intervention_df <- data_OLS[1:event_T,]
      before_intervention_df[event_T, "X"] <- 0
      
      hat_Y_before_and_at_intervention <- data.frame(
        DateTime = data_OLS[1:event_T, "MetricDate"],
        T = data_OLS[1:event_T, "T"],
        Y = stats::predict(single_itsa, before_intervention_df)
      )
      
      hat_Y_after_and_at_intervention <- data.frame(
        DateTime = data_OLS[event_T:dim(data_OLS)[1], "MetricDate"],
        T = data_OLS[event_T:dim(data_OLS)[1], "T"],
        Y = hat_Y[event_T:dim(data_OLS)[1]]
        )
      
      # Create basic graph
      p <- ggplot(data_OLS, aes(x = T, y = Y)) +
        geom_point(aes(y = Y), color = "blue") +
        geom_line(data = hat_Y_before_and_at_intervention, aes(x = T, y = Y), size = 1) +
        geom_line(data = hat_Y_after_and_at_intervention, aes(x = T, y = Y), size = 1)
      
      # Calculate plotting area range and scale
      dY <- (max(data_OLS[, "Y"]) - min(data_OLS[, "Y"])) / 10
      dX <- 1
      
      # Calculate annotation positions on the graph
      Y_at_intervention_when_no_intervention_happened <- hat_Y_before_and_at_intervention[dim(hat_Y_before_and_at_intervention)[1], "Y"]
      Y_at_intervention_when_intervention_happened <- hat_Y_after_and_at_intervention[1, "Y"]
      pos_y_end_beta_2 <- (Y_at_intervention_when_no_intervention_happened + Y_at_intervention_when_intervention_happened) / 2
      pos_y_start_beta_2 <- pos_y_end_beta_2 + dY
      pos_x_end_beta_2 <- event_T
      pos_x_start_beta_2 <- pos_x_end_beta_2 - dX
      
      # Create data.frame with all the annotation info
      annotation <- data.frame(
        x = pos_x_start_beta_2 - dX,
        y = Y_at_intervention_when_intervention_happened + dY,
        label = c(paste0("beta_2=", round(beta_2, 3), collapse = " "))
      )
      
      # Create final plot
      p_final <- p +
        labs(
          title = metric_name,
          subtitle = "Interrupted time-series analysis"
        ) +
        geom_vline(xintercept = event_T,
                   color = "red",
                   size = 1) +
        annotate(
          "segment",
          x = pos_x_start_beta_2,
          xend = pos_x_end_beta_2,
          y = pos_y_start_beta_2,
          yend = pos_y_end_beta_2,
          colour = "black",
          size = 0.5,
          alpha = 0.6,
          arrow = arrow()
        ) +
        annotate(
          "segment",
          x = pos_x_end_beta_2,
          xend = pos_x_end_beta_2,
          y = Y_at_intervention_when_no_intervention_happened,
          yend = Y_at_intervention_when_intervention_happened,
          colour = "purple",
          size = 2,
          alpha = 1
        ) +
        geom_text(
          data = annotation,
          aes(x = x, y = y, label = label),
          color = "orange",
          size = 5,
          angle = 0,
          fontface = "bold"
        ) +
        theme_wpa_basic()
      
      # Save plot in list
      results_plot[[metric_name]] <- p_final
    } else {
      results_plot[[metric_name]] <- buf_trycatch
    }
    
  }
  
  if (return == 'plot') {
    return(results_plot)
  }
  
  # Return ranking table
  return(results)
  
}

library(testthat)
library(vivainsights)

test_that("create_itsa returns a data frame when return = 'table'", {
  result <- create_itsa(
    data = pq_data,
    metrics = c("Collaboration_hours", "Meeting_hours"),
    before_end = "2024-06-30",
    return = "table"
  )
  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

# test_that("create_itsa returns a list of plots when return = 'plot'", {
#   result <- create_itsa(
#     data = pq_data,
#     metrics = c("Collaboration_hours", "Meeting_hours"),
#     before_end = "2024-06-30",
#     return = "plot"
#   )
#   # Check if the result is a list
#   expect_true(is.list(result))
#   # Check if the first element in the list is a ggplot object
#   expect_s3_class(result[[1]], "ggplot")
# })

test_that("create_itsa raises an error when before_end is NULL", {
  expect_error(
    create_itsa(
      data = pq_data,
      metrics = c("Collaboration_hours", "Meeting_hours"),
      before_end = NULL,
      return = "table"
    ),
    "The 'before_end' parameter must be provided."
  )
})

test_that("create_itsa returns a data frame with correct columns", {
  result <- create_itsa(
    data = pq_data,
    metrics = c("Collaboration_hours", "Meeting_hours"),
    before_end = "2024-06-30",
    return = "table"
  )
  # Check if the result contains expected columns
  expect_true(all(c("metric_name", "beta_2", "beta_3", "beta_2_pvalue", "beta_3_pvalue", "AR_flag", "error_warning") %in% colnames(result)))
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Collaboration Summary
#'
#' @description
#' Provides an overview analysis of 'Weekly Digital Collaboration'.
#' Returns a stacked bar plot of Email and Meeting Hours by default.
#' Additional options available to return a summary table.
#'
#' @details
#' Uses the metrics `Meeting_hours`, `Email_hours`, `Unscheduled_Call_hours`,
#' and `Instant_Message_hours`.
#'
#' @template spq-params
#' @param return Character vector specifying what to return, defaults to "plot".
#' Valid inputs are "plot" and "table".
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats reorder
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' # Return a ggplot bar chart
#' collaboration_sum(pq_data, hrvar = "LevelDesignation")
#'
#' # Return a summary table
#' collaboration_sum(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @return
#' Returns a 'ggplot' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @export

collaboration_sum <- function(data,
                              hrvar = "Organization",
                              mingroup=5,
                              return = "plot"){

  if("Instant_message_hours" %in% names(data)){

    data <- rename(data, Instant_Message_hours = "Instant_message_hours")

  }

  if("Unscheduled_Call_hours" %in% names(data)){

    main_vars <- c("Meeting_hours",
                   "Email_hours",
                   "Instant_Message_hours",
                   "Unscheduled_Call_hours")

  } else {

    main_vars <- c("Meeting_hours",
                   "Email_hours")

  }

 create_stacked(data = data,
                hrvar = hrvar,
                metrics = main_vars,
                mingroup = mingroup,
                return = return)

}

#' @rdname collaboration_sum
#' @export
collab_sum <- collaboration_sum

#' @rdname collaboration_sum
#' @export
collaboration_summary <- collaboration_sum

#' @rdname collaboration_sum
#' @export
collab_summary <- collaboration_sum

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Compute Information Value for Predictive Variables
#'
#' @description This function calculates the Information Value (IV) for the
#' selected numeric predictor variables in the dataset, given a specified
#' outcome variable. The Information Value provides a measure of the predictive
#' power of each variable in relation to the outcome variable, which can be
#' useful in feature selection for predictive modeling.
#'
#' @details
#' This is a wrapper around `wpa::create_IV()`.
#'
#' @param data A Person Query dataset in the form of a data frame.
#' @param predictors A character vector specifying the columns to be used as
#'   predictors. Defaults to NULL, where all numeric vectors in the data will be
#'   used as predictors.
#' @param outcome String specifying the column name for a binary variable,
#'   containing only the values 1 or 0.
#' @param bins Number of bins to use, defaults to 5.
#' @param siglevel Significance level to use in comparing populations for the
#'   outcomes, defaults to 0.05
#' @param exc_sig Logical value determining whether to exclude values where the
#'   p-value lies below what is set at `siglevel`. Defaults to `FALSE`, where
#'   p-value calculation does not happen altogether.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"summary"`
#'   - `"list"`
#'   - `"plot-WOE"`
#'   - `"IV"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A bar plot showing the IV value of the top
#'   (maximum 12) variables.
#'   - `"summary"`: data frame. A summary table for the metric.
#'   - `"list"`: list. A list of outputs for all the input variables.
#'   - `"plot-WOE"`: A list of 'ggplot' objects that show the WOE for each
#'   predictor used in the model.
#'   - `"IV"` returns a list object which mirrors the return
#'   in `Information::create_infotables()`.
#'
#' @import dplyr
#'
#' @family Variable Association
#' @family Information Value
#'
#' @examples
#' # Return a summary table of IV
#' pq_data %>%
#'   dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
#'   create_IV(outcome = "X",
#'             predictors = c("Email_hours",
#'                            "Meeting_hours",
#'                            "Chat_hours"),
#'             return = "plot")
#'
#'
#' # Return summary
#' pq_data %>%
#'   dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
#'   create_IV(outcome = "X",
#'             predictors = c("Email_hours", "Meeting_hours"),
#'             return = "summary")
#'
#' @export
create_IV <- function(data,
                      predictors = NULL,
                      outcome,
                      bins = 5,
                      siglevel = 0.05,
                      exc_sig = FALSE,
                      return = "plot"){

  # Input validation
  if (!is.data.frame(data)) {
    stop("The 'data' parameter should be a data frame.")
  }

  if (!is.null(predictors) && !all(predictors %in% names(data))) {
    stop("Some predictors are not present in the data.")
  }

  if (!outcome %in% names(data)) {
    stop("The outcome variable is not present in the data.")
  }

  if (!all(data[[outcome]] %in% c(0, 1))) {
    stop("The outcome variable should be binary (0 or 1).")
  }

  wpa::create_IV(
    data = data,
    predictors = predictors,
    outcome = outcome,
    bins = bins,
    siglevel = siglevel,
    exc_sig = exc_sig,
    return = return
  )

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_IV returns a data frame when return = 'summary'", {

  result <-
    pq_data %>%
    dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
    create_IV(outcome = "X",
              predictors = c("Email_hours", "Meeting_hours"),
              return = "summary")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_IV returns a ggplot when return = 'plot'", {

  result <-
    pq_data %>%
    dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
    create_IV(outcome = "X",
              predictors = c("Email_hours", "Meeting_hours"),
              return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})


test_that("create_IV returns a list when return = 'list'", {

  result <-
    pq_data %>%
    dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
    create_IV(outcome = "X",
              predictors = c("Email_hours", "Meeting_hours"),
              return = "list")

  # Check if the result is a list
  expect_true(is.list(result))
})

test_that("create_IV returns a list when return = 'plot-WOE'", {

  result <-
    pq_data %>%
    dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
    create_IV(outcome = "X",
              predictors = c("Email_hours", "Meeting_hours"),
              return = "plot-WOE")

  # Check if the result is a list
  expect_true(is.list(result))
})

test_that("create_IV returns a list when return = 'IV'", {

  result <-
    pq_data %>%
    dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) %>%
    create_IV(outcome = "X",
              predictors = c("Email_hours", "Meeting_hours"),
              return = "IV")

  # Check if the result is a list
  expect_true(is.list(result))
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Radar Chart for multiple metrics
#'
#' @description
#' Creates a multi-group radar (spider) chart across a set of metrics.
#'
#' Core pipeline:
#' 1) Person-level aggregation within group
#' 2) Group-level aggregation
#' 3) Privacy filtering via `mingroup`
#' 4) Optional indexing modes: "total", "none", "ref_group", "minmax"
#'
#' Optional auto-segmentation:
#' - If `hrvar` is not supplied, the function will call
#'   `identify_usage_segments()` and infer the resulting segment column.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metrics Character vector of metric column names.
#' @param hrvar Character string specifying the grouping column.
#'   Defaults to `"Organization"`. If `NULL`, usage segments will be derived
#'   via `identify_usage_segments()`.
#' @param mingroup Numeric value setting the privacy threshold / minimum group size.
#'   Defaults to 5.
#' @param agg String specifying aggregation method. Either `"mean"` (default) or `"median"`.
#' @param index_mode String specifying indexing mode. One of:
#'   - `"total"` (default): Total = 100 for each metric
#'   - `"none"`: no indexing (raw group values)
#'   - `"ref_group"`: reference group = 100 (requires `index_ref_group`)
#'   - `"minmax"`: scale to \[0, 100\] within observed group ranges per metric
#' @param index_ref_group Character string specifying reference group name when
#'   `index_mode = "ref_group"`.
#' @param na.rm Logical value indicating whether NA rows in required columns are removed
#'   prior to aggregation. Defaults to `FALSE`.
#' @param return String specifying what to return. One of:
#'   - `"plot"` (default)
#'   - `"table"`
#'
#' @return
#' A different output is returned depending on the value passed to `return`:
#'   - `"plot"`: ggplot object (radar chart)
#'   - `"table"`: data frame (group-level indexed table)
#'
#' @import dplyr
#' @import tidyr
#' @import ggplot2
#' @importFrom rlang .data
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' create_radar(
#'   data = pq_data,
#'   metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
#'   hrvar = "Organization",
#'   mingroup = 1
#' )
#'
#' # Return the indexed table instead of a plot
#' create_radar(
#'   data = pq_data,
#'   metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
#'   hrvar = "LevelDesignation",
#'   mingroup = 1,
#'   return = "table"
#' )
#' @export
create_radar <- function(data,
                         metrics,
                         hrvar = "Organization",
                         mingroup = 5,
                         agg = "mean",
                         index_mode = "total",
                         index_ref_group = NULL,
                         na.rm = FALSE,
                         return = "plot") {

  ## Check inputs
  if (!is.character(metrics) || length(metrics) < 1) {
    stop("Please enter a valid input for `metrics` (non-empty character vector).")
  }

  required_variables <- c("PersonId", metrics)

  # Auto-segmentation requires MetricDate
  if (is.null(hrvar)) {
    required_variables <- c(required_variables, "MetricDate")
  } else {
    required_variables <- c(required_variables, hrvar)
  }

  required_variables <- unique(required_variables)

  data %>%
    .check_inputs_safe(requirements = required_variables)

  if (!is.numeric(mingroup) || length(mingroup) != 1 || mingroup < 1) {
    stop("Please enter a valid input for `mingroup` (single numeric >= 1).")
  }

  if (!agg %in% c("mean", "median")) {
    stop("Please enter a valid input for `agg`: 'mean' or 'median'.")
  }

  if (!index_mode %in% c("total", "none", "ref_group", "minmax")) {
    stop("Please enter a valid input for `index_mode`.")
  }

  # Fail fast: index_ref_group must be supplied when needed
  if (index_mode == "ref_group" && is.null(index_ref_group)) {
    stop("Please provide `index_ref_group` when `index_mode = 'ref_group'`.")
  }

  if (!is.logical(na.rm) || length(na.rm) != 1) {
    stop("Please enter a valid input for `na.rm` (TRUE/FALSE).")
  }

  if (!is.character(return) || length(return) != 1) {
    stop("Please enter a valid input for `return`.")
  }

  df <- data
  hrvar_for_calc <- hrvar

  ## Auto-segmentation if hrvar is NULL
  if (is.null(hrvar_for_calc)) {
    seg_out <- .auto_segment_using_identify_usage(
      data = df,
      metrics = metrics
    )
    df <- seg_out$data
    hrvar_for_calc <- seg_out$segment_col
  }

  out <-
    create_radar_calc(
      data = df,
      metrics = metrics,
      hrvar = hrvar_for_calc,
      mingroup = mingroup,
      agg = agg,
      index_mode = index_mode,
      index_ref_group = index_ref_group,
      na.rm = na.rm
    )

  if (return == "table") {

    return(out$table)

  } else if (return == "plot") {

    ## Build caption: date range + index mode label
    date_caption <- tryCatch(
      extract_date_range(data, return = "text"),
      error = function(e) NULL
    )

    index_label <- switch(
      index_mode,
      "total"     = "Index: population average = 100",
      "ref_group" = paste0("Index: ", index_ref_group, " = 100"),
      "minmax"    = "Index: min\u2013max scaled [0, 100]",
      "none"      = "Raw values (no indexing)"
    )

    caption_text <- if (is.null(date_caption)) {
      index_label
    } else {
      paste0(date_caption, " | ", index_label)
    }

    return(
      create_radar_viz(
        data    = out$table,
        metrics = metrics,
        hrvar   = hrvar_for_calc,
        caption = caption_text
      )
    )

  } else {

    stop("Please enter a valid input for `return`.")

  }
}


#' @title Radar Chart (Calculation)
#'
#' @description
#' Computes group-level metric values and applies optional indexing.
#'
#' @param data data.frame.
#' @param metrics character vector of metric column names.
#' @param hrvar character string specifying grouping column.
#' @param id_col character string specifying person id column.
#' @param mingroup numeric minimum unique people per group.
#' @param agg "mean" or "median".
#' @param index_mode "total","none","ref_group","minmax".
#' @param index_ref_group reference group name when index_mode="ref_group".
#' @param na.rm logical.
#'
#' @return list(table=group_level_table, ref=reference_used)
#'
#' @export
create_radar_calc <- function(data,
                              metrics,
                              hrvar,
                              id_col = "PersonId",
                              mingroup = 5,
                              agg = "mean",
                              index_mode = "total",
                              index_ref_group = NULL,
                              na.rm = FALSE) {

  ## Check inputs
  required_variables <- c(id_col, hrvar, metrics) %>% unique()

  data %>%
    .check_inputs_safe(requirements = required_variables)

  df <- data %>%
    dplyr::select(dplyr::all_of(required_variables)) %>%
    dplyr::filter(!is.na(.data[[id_col]]), !is.na(.data[[hrvar]]))

  if (isTRUE(na.rm)) {
    df <- df %>% tidyr::drop_na(dplyr::all_of(metrics))
  }

  # Ensure stable type for grouping key
  df[[hrvar]] <- as.character(df[[hrvar]])

  ## Person-level aggregation within segment
  if (agg == "mean") {
    person_level <-
      df %>%
      dplyr::group_by(.data[[id_col]], .data[[hrvar]]) %>%
      dplyr::summarise(
        dplyr::across(dplyr::all_of(metrics), \(x) mean(x, na.rm = TRUE)),
        .groups = "drop"
      )
  } else {
    person_level <-
      df %>%
      dplyr::group_by(.data[[id_col]], .data[[hrvar]]) %>%
      dplyr::summarise(
        dplyr::across(dplyr::all_of(metrics), \(x) stats::median(x, na.rm = TRUE)),
        .groups = "drop"
      )
  }

  ## Group-level aggregation across people
  if (agg == "mean") {
    group_level <-
      person_level %>%
      dplyr::group_by(.data[[hrvar]]) %>%
      dplyr::summarise(
        dplyr::across(dplyr::all_of(metrics), \(x) mean(x, na.rm = TRUE)),
        .groups = "drop"
      )
  } else {
    group_level <-
      person_level %>%
      dplyr::group_by(.data[[hrvar]]) %>%
      dplyr::summarise(
        dplyr::across(dplyr::all_of(metrics), \(x) stats::median(x, na.rm = TRUE)),
        .groups = "drop"
      )
  }

  ## Enforce mingroup (distinct people per segment)
  counts <-
    person_level %>%
    dplyr::group_by(.data[[hrvar]]) %>%
    dplyr::summarise(n = dplyr::n_distinct(.data[[id_col]]), .groups = "drop")

  group_level <-
    group_level %>%
    dplyr::left_join(counts, by = hrvar) %>%
    dplyr::filter(.data$n >= mingroup)

  if (nrow(group_level) == 0) {
    out_tbl <- group_level
    ref <- numeric(0)
    return(list(table = out_tbl, ref = ref))
  }

  ## Reference + indexing
  ref <- numeric(0)
  out_tbl <- group_level

  if (index_mode == "total") {

    ref <- if (agg == "mean") {
      colMeans(person_level[, metrics, drop = FALSE], na.rm = TRUE)
    } else {
      apply(person_level[, metrics, drop = FALSE], 2, stats::median, na.rm = TRUE)
    }

    # Check for zero denominators
    zero_metrics <- names(ref)[ref == 0 | is.na(ref)]
    if (length(zero_metrics) > 0) {
      warning("Metric(s) with zero or NA reference values detected in 'total' mode: ",
              paste(zero_metrics, collapse = ", "),
              ". Setting indexed values to 100 (neutral baseline).")
    }

    for (m in metrics) {
      den <- ref[[m]]
      if (is.na(den) || den == 0) {
        out_tbl[[m]] <- 100  # Set to neutral baseline
      } else {
        out_tbl[[m]] <- (out_tbl[[m]] / den) * 100
      }
    }

  } else if (index_mode == "ref_group") {

    if (is.null(index_ref_group)) {
      stop("Please provide `index_ref_group` when `index_mode = 'ref_group'`.")
    }

    if (!index_ref_group %in% out_tbl[[hrvar]]) {
      # Give a more specific message depending on whether mingroup filtering removed it
      if (index_ref_group %in% data[[hrvar]]) {
        stop("Reference group '", index_ref_group, "' was removed by the mingroup filter ",
             "(n < ", mingroup, "). Lower `mingroup` or choose a different reference group.")
      } else {
        stop("'", index_ref_group, "' not found in `hrvar`. ",
             "Check the spelling or use `return = 'table'` to see available groups.")
      }
    }

    ref_row <- out_tbl %>%
      dplyr::filter(.data[[hrvar]] == index_ref_group) %>%
      dplyr::slice(1)

    ref <- as.numeric(ref_row[, metrics, drop = FALSE])
    names(ref) <- metrics

    # Check for zero denominators
    zero_metrics <- names(ref)[ref == 0 | is.na(ref)]
    if (length(zero_metrics) > 0) {
      warning("Metric(s) with zero or NA values in reference group '", index_ref_group, "': ",
              paste(zero_metrics, collapse = ", "),
              ". Setting indexed values to 100 (neutral baseline).")
    }

    for (m in metrics) {
      den <- ref[[m]]
      if (is.na(den) || den == 0) {
        out_tbl[[m]] <- 100  # Set to neutral baseline
      } else {
        out_tbl[[m]] <- (out_tbl[[m]] / den) * 100
      }
    }

  } else if (index_mode == "minmax") {

    mins <- vapply(metrics, function(m) min(out_tbl[[m]], na.rm = TRUE), numeric(1))
    maxs <- vapply(metrics, function(m) max(out_tbl[[m]], na.rm = TRUE), numeric(1))
    ref <- cbind(min = mins, max = maxs)

    # Identify metrics where scaling cannot be computed:
    #   - non-finite min/max (e.g. all-NA column -> Inf/-Inf from min/max)
    #   - max == min (all groups have identical values; range is zero)
    #   - max < min  (degenerate; should not occur but guard defensively)
    bad_metrics <- metrics[
      !is.finite(mins) | !is.finite(maxs) | maxs <= mins
    ]

    if (length(bad_metrics) > 0) {
      warning(
        "Metric(s) with non-finite or zero range in 'minmax' mode: ",
        paste(bad_metrics, collapse = ", "),
        ". Indexed values set to NA_real_."
      )
    }

    for (m in metrics) {
      if (!is.finite(mins[[m]]) || !is.finite(maxs[[m]]) || maxs[[m]] <= mins[[m]]) {
        out_tbl[[m]] <- NA_real_
      } else {
        out_tbl[[m]] <- 100 * (out_tbl[[m]] - mins[[m]]) / (maxs[[m]] - mins[[m]])
      }
    }

  } else {
    # "none": return raw group values
  }

  list(table = out_tbl, ref = ref)
}


#' @title Radar Chart (Visualization)
#'
#' @description
#' Renders a multi-group radar chart using `ggplot2` + `coord_polar()`.
#'
#' @param data Output table from `create_radar_calc()`.
#' @param metrics Character vector of metric column names.
#' @param hrvar Character string of grouping column name.
#' @param fill_missing Character string specifying how to handle missing values.
#'   If `"zero"` (default), fill NA values as 0 for plotting. This ensures
#'   polygons close properly in the radar visualization.
#' @param caption Character string for the plot caption. Typically the output
#'   of `extract_date_range(data, return = "text")` plus an index-mode label,
#'   as constructed by `create_radar()`. Defaults to `NULL` (no caption).
#'
#' @return ggplot object.
#'
#' @export
create_radar_viz <- function(data,
                             metrics,
                             hrvar,
                             fill_missing = "zero",
                             caption = NULL) {

  # Warn if too few metrics for effective radar chart
  if (length(metrics) < 3) {
    warning("Radar charts work best with 3 or more metrics. ",
            "Consider using a different visualization for ", length(metrics), " metric(s).")
  }

  # Long format
  plot_df <-
    data %>%
    dplyr::select(dplyr::all_of(c(hrvar, metrics))) %>%
    tidyr::pivot_longer(
      cols = dplyr::all_of(metrics),
      names_to = "metric",
      values_to = "value"
    ) %>%
    dplyr::mutate(
      metric = factor(.data$metric, levels = metrics),
      seg = as.character(.data[[hrvar]]),
      metric_idx = as.integer(.data$metric) - 1L
    )

  if (fill_missing == "zero") {
    plot_df$value[is.na(plot_df$value)] <- 0
  }

  # Close polygons
  first_points <-
    plot_df %>%
    dplyr::group_by(.data$seg) %>%
    dplyr::arrange(.data$metric_idx, .by_group = TRUE) %>%
    dplyr::slice(1) %>%
    dplyr::ungroup()

  max_idx <- if (nrow(plot_df) > 0) max(plot_df$metric_idx, na.rm = TRUE) else 0L

  poly_df <-
    dplyr::bind_rows(
      plot_df %>% dplyr::arrange(.data$seg, .data$metric_idx),
      first_points %>% dplyr::mutate(metric_idx = max_idx + 1L)
    ) %>%
    dplyr::arrange(.data$seg, .data$metric_idx)

  # Friendly labels: underscores -> spaces, then wrap at 15 chars
  axis_labs <- wrap_text(.pretty_metric_names(metrics))

  ggplot2::ggplot(poly_df, ggplot2::aes(x = .data$metric_idx, y = .data$value, group = .data$seg)) +
    ggplot2::geom_polygon(ggplot2::aes(fill = .data$seg), alpha = 0.10, colour = NA,
                          show.legend = FALSE) +
    ggplot2::geom_path(ggplot2::aes(colour = .data$seg), linewidth = 1.2, lineend = "round") +
    ggplot2::coord_polar(theta = "x", start = pi/2, direction = -1) +
    ggplot2::scale_x_continuous(
      breaks = seq(0, length(metrics) - 1),
      labels = axis_labs,
      expand = ggplot2::expansion(mult = c(0, 0))
    ) +
    ggplot2::guides(colour = ggplot2::guide_legend(title = NULL)) +
    ggplot2::labs(title = "Radar chart", subtitle = paste("By", .pretty_hrvar_name(hrvar)),
                  caption = caption) +
    .theme_wpa_safe() +
    ggplot2::theme(
      plot.title = ggplot2::element_text(face = "bold"),
      plot.title.position = "plot",
      axis.title = ggplot2::element_blank(),
      panel.grid.major = ggplot2::element_line(linewidth = 0.3),
      panel.grid.minor = ggplot2::element_blank(),
      legend.position = "right"
    )
}

# =========================
# Internal helpers (file-local)
# =========================

.pretty_metric_names <- function(metrics) {

  if (exists("us_to_space", mode = "function")) {
    return(vapply(metrics, us_to_space, character(1)))
  }

  gsub("_", " ", metrics, fixed = TRUE)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

# Basic functionality tests ---------------------------------------------------------------

test_that("create_radar returns a ggplot when return = 'plot'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
    hrvar = "Organization",
    mingroup = 1,
    return = "plot"
  )

  expect_s3_class(result, "ggplot")
})

test_that("create_radar returns a data frame when return = 'table'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
    hrvar = "Organization",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Check that expected columns are present
  expect_true("Organization" %in% names(result))
  expect_true("Collaboration_hours" %in% names(result))
  expect_true("Email_hours" %in% names(result))
  expect_true("Meeting_hours" %in% names(result))
  expect_true("n" %in% names(result))
})

# Indexing mode tests ---------------------------------------------------------------------

test_that("create_radar works with index_mode = 'total'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    index_mode = "total",
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(all(!is.na(result$Collaboration_hours)))
  expect_true(all(!is.na(result$Email_hours)))
})

test_that("create_radar works with index_mode = 'none'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    index_mode = "none",
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Raw values should be different from indexed values
  result_indexed <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    index_mode = "total",
    return = "table"
  )

  # Values should differ (unless by coincidence all groups are exactly average)
  expect_false(identical(result$Collaboration_hours, result_indexed$Collaboration_hours))
})

test_that("create_radar works with index_mode = 'ref_group'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    index_mode = "ref_group",
    index_ref_group = "Finance",
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Reference group should be indexed to 100
  ref_row <- result[result$Organization == "Finance", ]
  expect_equal(ref_row$Collaboration_hours, 100, tolerance = 0.01)
  expect_equal(ref_row$Email_hours, 100, tolerance = 0.01)
})

test_that("create_radar works with index_mode = 'minmax'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    index_mode = "minmax",
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Check that values are scaled to [0, 100]
  expect_true(all(result$Collaboration_hours >= 0 & result$Collaboration_hours <= 100))
  expect_true(all(result$Email_hours >= 0 & result$Email_hours <= 100))

  # Min should be near 0 and max should be near 100 for each metric
  expect_true(min(result$Collaboration_hours) < 5)
  expect_true(max(result$Collaboration_hours) > 95)
})

# Aggregation method tests ----------------------------------------------------------------

test_that("create_radar works with agg = 'median'", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    agg = "median",
    return = "table"
  )

  expect_s3_class(result, "data.frame")
})

test_that("create_radar gives different results for mean vs median", {

  result_mean <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    agg = "mean",
    index_mode = "none",
    return = "table"
  )

  result_median <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    agg = "median",
    index_mode = "none",
    return = "table"
  )

  # Mean and median should generally differ
  expect_false(identical(result_mean$Collaboration_hours, result_median$Collaboration_hours))
})

# Privacy filtering tests -----------------------------------------------------------------

test_that("create_radar respects mingroup threshold", {

  # Create a small test dataset with groups below threshold
  small_data <- pq_data[1:20, ]
  small_data$SmallGroup <- rep(c("A", "B", "C", "D"), each = 5)

  result <- create_radar(
    data = small_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "SmallGroup",
    mingroup = 10,
    return = "table"
  )

  # No groups should pass the threshold
  expect_equal(nrow(result), 0)
})

test_that("create_radar includes groups meeting mingroup", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 5,
    return = "table"
  )

  # All groups should have n >= mingroup
  expect_true(all(result$n >= 5))
})

# Edge cases and error handling -----------------------------------------------------------

test_that("create_radar handles single metric", {

  expect_warning(
    result <- create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours"),
      hrvar = "Organization",
      mingroup = 1,
      return = "plot"
    ),
    "Radar charts work best with 3 or more metrics"
  )

  expect_s3_class(result, "ggplot")
})

test_that("create_radar handles two metrics with warning", {

  expect_warning(
    result <- create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      return = "plot"
    ),
    "Radar charts work best with 3 or more metrics"
  )

  expect_s3_class(result, "ggplot")
})

test_that("create_radar handles na.rm = TRUE", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1,
    na.rm = TRUE,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
})

test_that("create_radar errors on empty metrics", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c(),
      hrvar = "Organization",
      mingroup = 1
    ),
    "valid input for `metrics`"
  )
})

test_that("create_radar errors on missing metrics columns", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("NonExistentColumn"),
      hrvar = "Organization",
      mingroup = 1
    ),
    "not included in the input data frame"
  )
})

test_that("create_radar errors on invalid agg parameter", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      agg = "mode"
    ),
    "valid input for `agg`"
  )
})

test_that("create_radar errors on invalid index_mode", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "invalid"
    ),
    "valid input for `index_mode`"
  )
})

test_that("create_radar errors on ref_group mode without ref group specified", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "ref_group"
    ),
    "index_ref_group"
  )
})

test_that("create_radar errors on invalid ref group", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "ref_group",
      index_ref_group = "NonExistentGroup"
    ),
    "not found in `hrvar`"
  )
})

test_that("create_radar errors on invalid return value", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      return = "invalid"
    ),
    "valid input for `return`"
  )
})

test_that("create_radar errors on invalid mingroup", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = -1
    ),
    "valid input for `mingroup`"
  )
})

test_that("create_radar errors on invalid na.rm", {

  expect_error(
    create_radar(
      data = pq_data,
      metrics = c("Collaboration_hours", "Email_hours"),
      hrvar = "Organization",
      mingroup = 1,
      na.rm = "yes"
    ),
    "valid input for `na.rm`"
  )
})

# Helper function tests -------------------------------------------------------------------

test_that("create_radar_calc returns list with correct structure", {

  result <- create_radar_calc(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours"),
    hrvar = "Organization",
    mingroup = 1
  )

  expect_type(result, "list")
  expect_true("table" %in% names(result))
  expect_true("ref" %in% names(result))
  expect_s3_class(result$table, "data.frame")
})

test_that("create_radar_viz returns ggplot", {

  calc_result <- create_radar_calc(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
    hrvar = "Organization",
    mingroup = 1
  )

  viz_result <- create_radar_viz(
    data = calc_result$table,
    metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
    hrvar = "Organization"
  )

  expect_s3_class(viz_result, "ggplot")
})

# Multiple metrics test -------------------------------------------------------------------

test_that("create_radar works with many metrics", {

  result <- create_radar(
    data = pq_data,
    metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours",
                "After_hours_collaboration_hours", "Internal_network_size"),
    hrvar = "Organization",
    mingroup = 1,
    return = "plot"
  )

  expect_s3_class(result, "ggplot")
})

# Zero denominator handling tests ---------------------------------------------------------

test_that("create_radar handles zero denominator in 'total' mode with warning", {

  test_data <- pq_data
  test_data[["Zero_Metric"]] <- 0

  expect_warning(
    result <- create_radar(
      data = test_data,
      metrics = c("Collaboration_hours", "Zero_Metric"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "total",
      return = "table"
    ),
    "zero or NA reference values"
  )

  # Check that zero metric is set to 100 (neutral baseline)
  expect_true(all(result$Zero_Metric == 100, na.rm = TRUE))

  # Check that other metric is still indexed normally
  expect_true(any(result$Collaboration_hours != 100))

  # Check no NaN values
  expect_false(any(is.nan(result$Zero_Metric)))
})

test_that("create_radar handles zero denominator in 'ref_group' mode with warning", {

  test_data <- pq_data
  test_data[["Zero_Metric"]] <- 0

  expect_warning(
    result <- create_radar(
      data = test_data,
      metrics = c("Collaboration_hours", "Zero_Metric"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "ref_group",
      index_ref_group = "Finance",
      return = "table"
    ),
    "zero or NA values in reference group"
  )

  # Check that zero metric is set to 100 (neutral baseline)
  expect_true(all(result$Zero_Metric == 100, na.rm = TRUE))

  # Check no NaN values
  expect_false(any(is.nan(result$Zero_Metric)))
})

test_that("create_radar handles multiple zero metrics", {

  test_data <- pq_data
  test_data[["Zero_Metric_1"]] <- 0
  test_data[["Zero_Metric_2"]] <- 0

  expect_warning(
    result <- create_radar(
      data = test_data,
      metrics = c("Collaboration_hours", "Zero_Metric_1", "Zero_Metric_2"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "total",
      return = "table"
    ),
    "Zero_Metric_1, Zero_Metric_2"
  )

  # Both zero metrics should be set to 100
  expect_true(all(result$Zero_Metric_1 == 100, na.rm = TRUE))
  expect_true(all(result$Zero_Metric_2 == 100, na.rm = TRUE))
})

test_that("create_radar handles NA denominator gracefully", {

  test_data <- pq_data
  test_data[["NA_Metric"]] <- NA_real_

  expect_warning(
    result <- create_radar(
      data = test_data,
      metrics = c("Collaboration_hours", "NA_Metric"),
      hrvar = "Organization",
      mingroup = 1,
      index_mode = "total",
      return = "table"
    ),
    "zero or NA reference values"
  )

  # NA metric should be set to 100
  expect_true(all(result$NA_Metric == 100, na.rm = TRUE))
})

# minmax edge-case guard tests ------------------------------------------------------------

test_that("create_radar_calc minmax: all-NA metric yields NA_real_ with warning", {

  test_data <- data.frame(
    PersonId     = paste0("p", 1:10),
    Organization = rep(c("A", "B"), each = 5),
    Good_Metric  = c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
    All_NA       = rep(NA_real_, 10),
    stringsAsFactors = FALSE
  )

  expect_warning(
    result <- create_radar_calc(
      data       = test_data,
      metrics    = c("Good_Metric", "All_NA"),
      hrvar      = "Organization",
      mingroup   = 1,
      index_mode = "minmax"
    ),
    "non-finite or zero range"
  )

  # All-NA metric must produce NA_real_ output, not NaN or Inf
  expect_true(all(is.na(result$table$All_NA)))
  # Normal metric still scaled to [0, 100]
  expect_true(all(result$table$Good_Metric >= 0 & result$table$Good_Metric <= 100))
})

test_that("create_radar_calc minmax: constant metric (min == max) yields NA_real_ with warning", {

  test_data <- data.frame(
    PersonId     = paste0("p", 1:10),
    Organization = rep(c("A", "B"), each = 5),
    Normal       = c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
    Constant     = rep(5, 10),
    stringsAsFactors = FALSE
  )

  expect_warning(
    result <- create_radar_calc(
      data       = test_data,
      metrics    = c("Normal", "Constant"),
      hrvar      = "Organization",
      mingroup   = 1,
      index_mode = "minmax"
    ),
    "non-finite or zero range"
  )

  # Constant metric: all groups identical -> cannot distinguish -> NA
  expect_true(all(is.na(result$table$Constant)))
  # Normal metric still scaled correctly
  expect_true(all(result$table$Normal >= 0 & result$table$Normal <= 100, na.rm = TRUE))
})

test_that("create_radar_calc minmax: valid metrics produce no warning and finite output", {

  test_data <- data.frame(
    PersonId     = paste0("p", 1:10),
    Organization = rep(c("A", "B"), each = 5),
    MetricA      = c(1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
    MetricB      = c(10, 20, 30, 40, 50, 60, 70, 80, 90, 100),
    stringsAsFactors = FALSE
  )

  expect_no_warning(
    result <- create_radar_calc(
      data       = test_data,
      metrics    = c("MetricA", "MetricB"),
      hrvar      = "Organization",
      mingroup   = 1,
      index_mode = "minmax"
    )
  )

  expect_true(all(is.finite(result$table$MetricA)))
  expect_true(all(is.finite(result$table$MetricB)))
  expect_true(all(result$table$MetricA >= 0 & result$table$MetricA <= 100))
  expect_true(all(result$table$MetricB >= 0 & result$table$MetricB <= 100))
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' Pipe operator
#'
#' See \code{magrittr::\link[magrittr:pipe]{\%>\%}} for details.
#'
#' @name %>%
#' @rdname pipe
#' @keywords internal
#' @export
#' @importFrom magrittr %>%
#' @usage lhs \%>\% rhs
#' @return
#' Returns immediate object.
NULL

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Sankey chart of organizational movement between HR attributes and
#'   missing values (outside company move) (Data Overview)
#'
#' @description
#' Creates a list of everyone at a specified start date and a specified end date
#' then aggregates up people who have moved between organizations between this
#' to points of time and visualizes the move through a sankey chart.
#'
#' Through this chart you can see:
#' -  The HR attribute/orgs that have the highest move out
#' -  The HR attribute/orgs that have the highest move in
#' -  The number of people that do not have that HR attribute or if they are no
#' longer in the system
#'
#' @author Tannaz Sattari Tabrizi <Tannaz.Sattari@@microsoft.com>
#'
#' @param data A Person Query dataset in the form of a data frame.
#' @param start_date A start date to compare changes. See `end_date`.
#' @param end_date An end date to compare changes. See `start_date`.
#' @param hrvar HR Variable by which to compare changes between, defaults to
#'   `"Organization"` but accepts any character vector, e.g.
#'   `"LevelDesignation"`
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#' @param return Character vector specifying what to return, defaults to
#'   `"plot"`. Valid inputs are `"plot"` and `"table"`.
#' @param NA_replacement Character replacement for NA defaults to "out of
#'   company"
#'
#' @import dplyr
#'
#' @family Data Validation
#'
#' @return
#' Returns a 'NetworkD3' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @examples
#'
#' pq_data %>% track_HR_change()
#'
#' @export
track_HR_change <- function(data,
                            start_date = min(data$MetricDate),
                            end_date = max(data$MetricDate),
                            hrvar = "Organization",
                            mingroup = 5,
                            return = "plot",
                            NA_replacement = "Out of Company"){

  ## Check inputs
  required_variables <- c("MetricDate",
                          "PersonId",
                          hrvar)

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Define Start and End Dates
  data_start_date <- min(as.Date(data$MetricDate,"%m/%d/%Y"))
  data_end_date <- max(as.Date(data$MetricDate,"%m/%d/%Y"))

  ## Validate dates

  if (as.Date(end_date,"%m/%d/%Y") < data_start_date){
    stop("Please enter a valid start date.")
  }
  if (as.Date(start_date,"%m/%d/%Y") > data_end_date ){
    stop("Please enter a valid end date.")
  }

  ## filter data to starting point
  start_data <- data %>%
    filter(MetricDate == start_date) %>%
    select("PersonId", hrvar) %>%
    rename(group := !!sym(hrvar))

  ## filter data to end point
  end_data <- data %>%
    filter(MetricDate == end_date) %>%
    select("PersonId", hrvar) %>%
    rename(pre_group := !!sym(hrvar))

  ## Join the data to track the changes
  dt <- merge(start_data, end_data, by = "PersonId", all.x = TRUE)

  # aggregate the data over different orgs
  moves <-
    dt %>%
    group_by(pre_group, group) %>%
    summarise(Employee_Count = n(), .groups = "drop") %>%
    # clean the data to changes and replace NAs
    mutate(group = tidyr::replace_na(group, NA_replacement),
           pre_group = tidyr::replace_na(pre_group, NA_replacement)) %>%
    arrange(desc(Employee_Count))

  if(length(moves) == 0){
    stop("No change has happened.")
  }

  ## Save summary table to myTableReturn
  myTableReturn <- moves


  if(return == "table"){

    return(myTableReturn)

  } else if(return == "plot"){

    ## Plotting for sankey chart
    ## Set up `nodes`
    group_source <- unique(moves$pre_group)
    group_target <- paste0(unique(moves$group), " ")

    groups <- c(group_source, group_target)

    nodes_source <- tibble(name = group_source)
    nodes_target <- tibble(name = group_target)
    nodes <- rbind(nodes_source, nodes_target) %>% mutate(node = 0:(nrow(.) - 1))

    ## Set up `links`
    links <-
      moves %>%
      mutate(group = paste0(group, " ")) %>%
      select(source = "pre_group",
             target = "group",
             value = "Employee_Count")

    nodes_source <- nodes_source %>% select(name) # Make `nodes` a single column data frame
    nodes_target <- nodes_target %>% select(name) # Make `nodes` a single column data frame

    links <-
      links %>%
      left_join(nodes %>% rename(IDsource = "node"), by = c("source" = "name")) %>%
      left_join(nodes %>% rename(IDtarget = "node"), by = c("target" = "name"))


    networkD3::sankeyNetwork(Links = as.data.frame(links),
                             Nodes = as.data.frame(nodes),
                             Source = 'IDsource', # Change reference to IDsource
                             Target = 'IDtarget', # Change reference to IDtarget
                             Value = 'value',
                             NodeID = 'name',
                             units="count",
                             sinksRight = FALSE)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

#' @title Perform a pairwise count of words by id
#'
#' @description This is a 'data.table' implementation that mimics the output of
#'   `pairwise_count()` from 'widyr' to reduce package dependency. This is used
#'   internally within `tm_cooc()`.
#'
#' @param data Data frame output from `tm_clean()`.
#' @param id String to represent the id variable. Defaults to `"line"`.
#' @param word String to represent the word variable. Defaults to `"word"`.
#'
#' @return
#' data frame with the following columns representing a pairwise count:
#'   - `"item1"`
#'   - `"item2"`
#'   - `"n"`
#'
#' @importFrom data.table ":=" "%like%" "%between%" rbindlist as.data.table
#'
#' @family Support
#' @family Text-mining
#'
#' @examples
#' td <- data.frame(line = c(1, 1, 2, 2),
#'                  word = c("work", "meeting", "catch", "up"))
#'
#' pairwise_count(td, id = "line", word = "word")
#'
#' @export
pairwise_count <- function(data,
                           id = "line",
                           word = "word"){

  # Make sure data.table knows we know we're using it
  .datatable.aware = TRUE

  data <-
    data %>%
    dplyr::rename(word := !!sym(word),
                  id := !!sym(id))


  DT <- data.table::as.data.table(data)

  # convert to character
  DT[, word := as.character(word)]

  # subset those with >1 per id
  DT2 <- DT[, N := .N, by = id][N>1]

  # create all combinations of 2
  # return as a data.table with these as columns `V1` and `V2`
  # then count the numbers in each id
  out_data <-
    DT2[, rbindlist(utils::combn(word,2,
                        FUN = function(x) as.data.table(as.list(x)),
                        simplify = FALSE)), by = id] %>%
    .[, .N, by = list(V1,V2)]

  # format and sort
  out_data %>%
    dplyr::as_tibble() %>%
    dplyr::rename(item1 = "V1",
                  item2 = "V2",
                  n = "N") %>%
    dplyr::arrange(desc(n))
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Flag Persons with unusually high Email Hours to Emails Sent ratio
#'
#' @description This function flags persons who have an unusual ratio
#' of email hours to emails sent. If the ratio between Email Hours and
#' Emails Sent is greater than the threshold, then observations tied to
#' a `PersonId` is flagged as unusual.
#'
#' @import dplyr
#'
#' @family Data Validation
#'
#' @param data A data frame containing a Person Query.
#' @param threshold Numeric value specifying the threshold for flagging.
#'   Defaults to 1.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"text"`
#'   - `"data"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"text"`: string. A diagnostic message.
#'   - `"data"`: data frame. Person-level data with those flagged with unusual
#'   ratios.
#'
#' @examples
#' flag_em_ratio(pq_data)
#'
#' @export
flag_em_ratio <- function(data, threshold = 1, return = "text"){

  ## Check for high collab hours but lower afterhour collab hours
  ## Because of faulty outlook settings
  em_summary <-
    data %>%
    group_by(PersonId) %>%
    summarise(across(c(Email_hours, Emails_sent), ~mean(.))) %>%
    mutate(Email_ratio = Email_hours / Emails_sent) %>%
    arrange(desc(Email_ratio)) %>%
    mutate(Email_Flag = ifelse(Email_ratio > threshold, TRUE, FALSE))

  ## Percent of people with high collab hours + low afterhour collab hours
  EmailFlagN <- sum(em_summary$Email_Flag, na.rm = TRUE)
  EmailFlagProp <- mean(em_summary$Email_Flag, na.rm = TRUE)
  EmailFlagProp2 <- paste(round(EmailFlagProp * 100), "%") # Formatted
  EmailFlagMessage <- paste0(EmailFlagProp2, " (", EmailFlagN, ") ",
                         "of the population have an unusually high email hours to emails sent ratio.")

  if(return == "text"){

    EmailFlagMessage

  } else if(return == "data"){

    em_summary

  } else {

    stop("Invalid input to `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Collaboration Time Trend - Line Chart
#'
#' @description
#' Provides a week by week view of collaboration time, visualised as line charts.
#' By default returns a line chart for collaboration hours,
#' with a separate panel per value in the HR attribute.
#' Additional options available to return a summary table.
#'
#' @template ch
#'
#' @inheritParams create_line
#' @inherit create_line return
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' # Return a line plot
#' collaboration_line(pq_data, hrvar = "LevelDesignation")
#'
#' # Return summary table
#' collaboration_line(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

collaboration_line <- function(data,
                                hrvar = "Organization",
                                mingroup = 5,
                                return = "plot",
                                label = FALSE){

  ## Inherit arguments
  create_line(data = data,
              metric = "Collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              label = label)
}

#' @rdname collaboration_line
#' @export
collab_line <- collaboration_line

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Convert a numeric variable for hours into categorical
#'
#' @description
#' Supply a numeric variable, e.g. `Collaboration_hours`, and return a character
#' vector.
#'
#' @details
#' This is used within `create_dist()` for numeric to categorical conversion.
#'
#' @param metric A numeric variable representing hours.
#' @param cuts A numeric vector of minimum length 3 to represent the
#' cut points required. The minimum and maximum values provided in the vector
#' are inclusive.
#' @param unit String to specify the unit of the labels. Defaults to "hours".
#' @param lbound Numeric. Specifies the lower bound (inclusive) value for the
#'   minimum label. Defaults to 0.
#' @param ubound Numeric. Specifies the upper bound (inclusive) value for the
#'   maximum label. Defaults to 100.
#'
#' @family Support
#'
#' @return
#' Character vector representing a converted categorical variable, appended
#' with the label of the unit. See `examples` for more information.
#'
#' @examples
#' # Direct use
#' cut_hour(1:30, cuts = c(15, 20, 25))
#'
#' # Use on a query
#' cut_hour(pq_data$Collaboration_hours, cuts = c(10, 15, 20), ubound = 150)
#'
#' @export

cut_hour <- function(metric,
                     cuts,
                     unit = "hours",
                     lbound = 0,
                     ubound = 100){


  cuts <- unique(cuts) # No duplicates allowed
  ncuts <- length(cuts)

  if(ncuts < 2){
    stop("Please provide a numeric vector of at least length 2 to `cuts`")
  }

  # Extract min, max, and middle values
  mincut <- min(cuts, na.rm = TRUE)
  maxcut <- max(cuts, na.rm = TRUE)

  midcut <- cuts[!cuts %in% mincut] # Excludes mincut only
  midcut_min_1 <- cuts[match(midcut, cuts) - 1] # one value smaller
  mincut_2 <- midcut_min_1[[1]] # second smallest cut

  # Min and max values of `metric`
  minval <- min(metric, na.rm = TRUE)
  maxval <- max(metric, na.rm = TRUE)

  # Warn if smaller lbound or larger ubound
  if(minval < lbound){
    warning("`lbound` does not capture the smallest value in `metric`. ",
            "Values smaller than `lbound` will be classified as NA. ",
            "Adjusting `lbound` is recommended.")
  }

  if(maxval > ubound){
    warning("`ubound` does not capture the largest value in `metric`. ",
            "Values larger than `ubound` will be classified as NA. ",
            "Adjusting `ubound` is recommended.")
  }

  # Take smallest or largest of both values
  lbound <- min(c(mincut, lbound), na.rm = TRUE)
  ubound <- max(c(maxcut, ubound), na.rm = TRUE)

  # Individual labels
  label_mincut <- paste0("< ", mincut, " ", unit)
  label_maxcut <- paste0(maxcut, "+ ", unit)
  label_midcut <- paste0(midcut_min_1, " - ", midcut, " ", unit)

  # All labels
  all_labels <- unique(c(label_mincut, label_midcut, label_maxcut))

  # If `lbound` or `ubound` conflict with cuts
  if(lbound == mincut){

    all_labels <- all_labels[all_labels != label_mincut]

  }

  if(ubound == maxcut){

    all_labels <- all_labels[all_labels != label_maxcut]

  }

  # Debugging chunk ---------------------------------------------------------
  # list(
  #   breaks = unique(c(lbound, cuts, ubound)),
  #   lbound,
  #   ubound,
  #   all_labels
  # )

  # Return result
  cut(metric,
      breaks = unique(c(lbound, cuts, ubound)),
      include.lowest = TRUE,
      labels = all_labels)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Export 'vivainsights' outputs to CSV, clipboard, or save as images
#'
#' @description
#' A general use function to export 'vivainsights' outputs to CSV, clipboard, or save as
#' images. By default, `export()` copies a data frame to the clipboard. If the
#' input is a 'ggplot' object, the default behaviour is to export a PNG.
#'
#' @author Martin Chan <martin.chan@@microsoft.com>
#'
#' @param x Data frame or 'ggplot' object to be passed through.
#' @param method Character string specifying the method of export.
#' Valid inputs include:
#'   - `"clipboard"` (default if input is data frame)
#'   - `"csv"`
#'   - `"png"` (default if input is 'ggplot' object)
#'   - `"svg"`
#'   - `"jpeg"`
#'   - `"pdf"`
#' @param path If exporting a file, enter the path and the desired file name,
#'   _excluding the file extension_. For example, `"Analysis/SQ Overview"`.
#' @param timestamp Logical vector specifying whether to include a timestamp in
#'   the file name. Defaults to `TRUE`.
#' @param width Width of the plot
#' @param height Height of the plot
#'
#' @return
#' A different output is returned depending on the value passed to the `method`
#' argument:
#'   - `"clipboard"`: no return - data frame is saved to clipboard.
#'   - `"csv"`: CSV file containing data frame is saved to specified path.
#'   - `"png"`: PNG file containing 'ggplot' object is saved to specified path.
#'   - `"svg"`: SVG file containing 'ggplot' object is saved to specified path.
#'   - `"jpeg"`: JPEG file containing 'ggplot' object is saved to specified path.
#'   - `"pdf"`: PDF file containing 'ggplot' object is saved to specified path.
#'
#' @importFrom utils write.csv
#'
#' @family Import and Export
#'
#' @export

export <- function(x,
                   method = "clipboard",
                   path = "insights export",
                   timestamp = TRUE,
                   width = 12,
                   height = 9){

  ## Create timestamped path (if applicable)

  if(timestamp == TRUE){
    newpath <- paste(path, vivainsights::tstamp())
  } else {
    newpath <- path
  }

  ## Force method to png if is.ggplot and method not appropriate
  if(is.ggplot(x) & method %in% c("clipboard", "csv")){
    message("Input is a 'ggplot' object. Defaulted to exporting as PNG...")
    method <- "png"
  }

  ## Main export function
  if(method == "clipboard"){
    copy_df(x)
    message(c("Data frame copied to clipboard.\n",
              "You may paste the contents directly to Excel."))

  ## Export option: CSV
  } else if(method == "csv"){

    newpath <- paste0(newpath, ".csv")

    write.csv(x = x, file = newpath, row.names = FALSE)

  ## Export option: any ggsave methods
  } else if(method %in% c("png", "svg", "jpeg", "pdf")){

    newpath <- paste0(newpath, ".", method)

    ggsave(filename = newpath, plot = x, width = width, height = height)

  } else {

    stop("Please check inputs. Enter `?export` for more details.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Sample Person Query dataset
#'
#' @description
#' A dataset generated from a Person Query from Viva Insights.
#'
#' @family Data
#'
#' @return data frame.
#'
#' @format A data frame with 6900 rows and 73 variables:
#' \describe{
#' \item{PersonId}{}
#' \item{MetricDate}{}
#' \item{Collaboration_hours}{}
#' \item{Copilot_actions_taken_in_Teams}{}
#' \item{Meeting_and_call_hours}{}
#' \item{Internal_network_size}{}
#' \item{Email_hours}{}
#' \item{Channel_message_posts}{}
#' \item{Conflicting_meeting_hours}{}
#' \item{Large_and_long_meeting_hours}{}
#' \item{External_collaboration_hours}{}
#' \item{Active_connected_hours}{}
#' \item{Meetings}{}
#' \item{After_hours_collaboration_hours}{}
#' \item{Call_hours}{}
#' \item{Calls}{}
#' \item{Channel_message_hours}{}
#' \item{Chat_hours}{}
#' \item{Collaboration_span}{}
#' \item{Emails_read}{}
#' \item{Emails_sent}{}
#' \item{External_network_size}{}
#' \item{Meeting_and_call_hours_with_manager}{}
#' \item{Meeting_and_call_hours_with_manager_1_1}{}
#' \item{Meeting_and_call_hours_with_skip_level}{}
#' \item{Meeting_hours}{}
#' \item{Multitasking_hours}{}
#' \item{Network_outside_company}{}
#' \item{Network_outside_organisation}{}
#' \item{Time_with_leadership}{}
#' \item{Unscheduled_call_hours}{}
#' \item{Weekend_collaboration_hours}{}
#' \item{Copilot_actions_taken_in_Copilot_chat__work_}{}
#' \item{Copilot_actions_taken_in_Excel}{}
#' \item{Copilot_actions_taken_in_Outlook}{}
#' \item{Copilot_actions_taken_in_Powerpoint}{}
#' \item{Copilot_actions_taken_in_Word}{}
#' \item{Days_of_active_Copilot_chat__work__usage}{}
#' \item{Days_of_active_Copilot_usage_in_Excel}{}
#' \item{Days_of_active_Copilot_usage_in_Loop}{}
#' \item{Days_of_active_Copilot_usage_in_OneNote}{}
#' \item{Days_of_active_Copilot_usage_in_Outlook}{}
#' \item{Days_of_active_Copilot_usage_in_Powerpoint}{}
#' \item{Days_of_active_Copilot_usage_in_Teams}{}
#' \item{Days_of_active_Copilot_usage_in_Word}{}
#' \item{Total_Copilot_active_days}{}
#' \item{Total_Copilot_enabled_days}{}
#' \item{Barriers_to_Execution}{}
#' \item{Change_Adaptation}{}
#' \item{Collaboration}{}
#' \item{Communication_Flow}{}
#' \item{Continuous_Improvement}{}
#' \item{eSat}{}
#' \item{Initiative}{}
#' \item{Manager_Recommend}{}
#' \item{Resources}{}
#' \item{Speak_My_Mind}{}
#' \item{Wellbeing}{}
#' \item{Work_Life_Balance}{}
#' \item{Workload}{}
#' \item{Create_Excel_formula_actions_taken_using_Copilot}{}
#' \item{Create_presentation_actions_taken_using_Copilot}{}
#' \item{Generate_email_draft_actions_taken_using_Copilot_in_Outlook}{}
#' \item{Summarise_chat_actions_taken_using_Copilot_in_Teams}{}
#' \item{Summarise_email_thread_actions_taken_using_Copilot_in_Outlook}{}
#' \item{Summarise_meeting_actions_taken_using_Copilot_in_Teams}{}
#' \item{Summarise_presentation_actions_taken_using_Copilot_in_PowerPoint}{}
#' \item{Summarise_Word_document_actions_taken_using_Copilot_in_Word}{}
#' \item{FunctionType}{}
#' \item{SupervisorIndicator}{}
#' \item{Level}{}
#' \item{Organization}{}
#' \item{LevelDesignation}{}
#' }
#' @source \url{https://learn.microsoft.com/en-us/viva/insights/advanced/analyst/person-query/}
"pq_data"

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Check whether a data frame contains all the required variable
#'
#' @description
#' Checks whether a data frame contains all the required variables.
#' Matching works via variable names, and used to support individual
#' functions in the package. Not used directly.
#'
#' @param input Pass a data frame for checking
#' @param requirements A character vector specifying the required variable names
#' @param return A character string specifying what to return.
#' The default value is "stop". Also accepts "names" and "warning".
#'
#'
#' @return The default behaviour is to return an error message, informing the
#'   user what variables are not included. When `return` is set to "names", a
#'   character vector containing the unmatched variable names is returned.
#'
#' @family Support
#'
#' @examples
#'
#' # Return error message
#' \dontrun{
#' check_inputs(iris, c("Sepal.Length", "mpg"))
#' }
#'
#' #' # Return warning message
#' check_inputs(iris, c("Sepal.Length", "mpg"), return = "warning")
#'
#' # Return variable names
#' check_inputs(iris, c("Sepal.Length", "Sepal.Width", "RandomVariable"), return = "names")
#'
#' @export
check_inputs <- function(input, requirements, return = "stop"){

  ## Get variable names of input df
  nm_input <- names(input)

  ## Get logical vector
  test_results <- requirements %in% nm_input

  ## Return FALSE results
  not_in <- requirements[!test_results]

  ## Comma separated
  not_in_p <- paste(not_in, collapse = ", ")

  ## Create warning message
  warning_string <-
    paste("The following variables are not included in the input data frame:\n",
          not_in_p)

  if(length(not_in) > 0){

    if(return == "names"){

      return(not_in)

    } else if(return == "warning"){

      warning(warning_string)

    } else if(return == "stop"){

      stop(warning_string)

    } else {

      stop("Invalid input: please check `return` argument for `check_inputs()`")

    }
  }
}

#' @title Convert "CamelCase" to "Camel Case"
#'
#' @description
#' Convert a text string from the format "CamelCase" to "Camel Case".
#' This is used for converting variable names such as
#' "LevelDesignation" to "Level Designation" for the purpose
#' of prettifying plot labels.
#'
#' @param string A string vector in 'CamelCase' format to format
#'
#' @family Support
#'
#' @examples
#' camel_clean("NoteHowTheStringIsFormatted")
#'
#' @return Returns a formatted string.
#'
#' @export
camel_clean <- function(string){

  gsub("([a-z])([A-Z])", "\\1 \\2", string)

}

#' @title Convert rgb to HEX code
#'
#' @param r,g,b Values that correspond to the three RGB parameters
#'
#' @family Support
#'
#' @return Returns a string containing a HEX code.
#'
#' @export
rgb2hex <- function(r,g,b){
  grDevices::rgb(r, g, b, maxColorValue = 255)
}

#' @title Extract date period
#'
#' @description
#' Return a data frame with the start and end date
#' of the query data by default. There are options to return a descriptive
#' string, which is used in the caption of plots in this package.
#'
#' @param data Data frame containing a query to pass through.
#' The data frame must contain a `Date` column.
#' Accepts a Person query or a Meeting query.
#'
#' @param return String specifying what output to return.
#' Returns a table by default ("table"), but allows returning
#' a descriptive string ("text").
#'
#' @family Support
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"table"`: data frame. A summary table containing the start and end date
#'   for the dataset.
#'   - `"text"`: string. Contains a descriptive string on the start and end date
#'   for the dataset.
#'
#' @export
extract_date_range <- function(data, return = "table"){

  if("Date" %in% names(data)){

    date_var <- as.Date(data$Date, "%m/%d/%Y")

  } else if("MetricDate" %in% names(data)){

    date_var <- as.Date(data$MetricDate, "%m/%d/%Y")

  } else if(all(c("StartDate", "EndDate") %in% names(data))){

    ## meeting query
    date_var <- c(data$StartDate, data$EndDate)
    date_var <- as.Date(date_var, "%m/%d/%Y")

  } else {

    stop("Error: no date variable found.")

  }

  myPeriod <-
    data.frame(Start = min(date_var),
               End = max(date_var))

  ## Alternative return
  if(return == "table"){

    myPeriod

  } else if(return == "text"){

    paste("Data from week of", myPeriod$Start, "to week of", myPeriod$End)

  }
}

#' @title Add comma separator for thousands
#'
#' @description
#' Takes a numeric value and returns a character value
#' which is rounded to the whole number, and adds a comma
#' separator at the thousands. A convenient wrapper function
#' around `round()` and `format()`.
#'
#' @param x A numeric value
#'
#' @return Returns a formatted string.
#'
#' @export
comma <- function(x){
  x <- round(x, 0)
  format(x, nsmall = 0, big.mark=",")
}

#' @title Check whether package is installed and return an error message
#'
#' @description Checks whether a package is installed in the user's machine
#' based on a search on the package name string. If the package is not
#' installed, an error message is returned.
#'
#' @param pkgname String containing the name of the package to check whether is
#' installed.
#'
#' @noRd
#'
check_pkg_installed <- function(pkgname) {

  mtry <- try(find.package(package = pkgname))

  if (inherits(mtry, "try-error")) {
    stop(
      paste0(
        "\n\nPackage ", wrap(pkgname, wrapper = "`"),
        " is required to run this function and is currently not installed.\n",
        "Please install package ",
            wrap(pkgname, wrapper = "`"),
            " to proceed. "
            )
      )
  }
}

#' @title Wrap text based on character threshold
#'
#' @description Wrap text in visualizations according to a preset character
#' threshold. The next space in the string is replaced with `\n`, which will
#' render as next line in plots and messages.
#'
#' @param x String to wrap text
#' @param threshold Numeric, defaults to 15. Number of character units by which
#' the next space would be replaced with `\n` to move text to next line.
#'
#' @examples
#' wrapped <- wrap_text(
#'   "The total entropy of an isolated system can never decrease."
#'   )
#' message(wrapped)
#'
#' @return
#' String output representing a processed version of `x`, with spaces replaced
#' by `\n.`
#'
#' @export
wrap_text <- function(x, threshold = 15){

  patt <- paste0(
    '(.{1,',
    threshold,
    '})(\\s|$)'
  )

  gsub(
    pattern = patt,
    replacement = '\\1\n',
    x = x
  )
}

#' @title
#' Create the two-digit zero-padded format
#'
#' @param x numeric value or vector with maximum two characters.
#'
#' @return
#' Numeric value containing two-digit zero-padded values.
#'
#' @export

pad2 <- function(x){
  x <- as.character(x)

  ifelse(nchar(x) == 1, paste0("0", x), x)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate a wordcloud with meeting subject lines
#'
#' @description
#' Generate a wordcloud with the meeting query.
#' This is a sub-function that feeds into `meeting_tm_report()`.
#'
#' @details
#' Uses the 'ggwordcloud' package for the underlying implementation, thus
#' returning a 'ggplot' object. Additional layers can be added onto the plot
#' using a ggplot `+` syntax.
#' The recommendation is not to return over 100 words in a word cloud.
#'
#' @details
#' This function uses `tm_clean()` as the underlying data wrangling function.
#' There is an option to remove stopwords by passing a data frame into the
#' `stopwords` argument.
#'
#' @param data A Meeting Query dataset in the form of a data frame.
#' @param stopwords A character vector OR a single-column data frame labelled
#'   `'word'` containing custom stopwords to remove.
#' @param seed A numeric vector to set seed for random generation.
#' @param keep A numeric vector specifying maximum number of words to keep.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#' @param ... Additional parameters to be passed to
#'   `ggwordcloud::geom_text_wordcloud()`
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object containing a word cloud.
#'   - `"table"`: data frame returning the data used to generate the word cloud.
#'
#' @import dplyr
#' @examples
#' tm_wordcloud(mt_data, keep = 30)
#'
#' # Removing stopwords
#' tm_wordcloud(mt_data, keep = 30, stopwords = c("weekly", "update"))
#'
#' @family Text-mining
#'
#' @export

tm_wordcloud <- function(data,
                         stopwords = NULL,
                         seed = 100,
                         keep = 100,
                         return = "plot",
                         ...){

  set.seed(seed)

  clean_data <-
    suppressMessages(tm_clean(
      data = data,
      token = "words",
      stopwords = stopwords
    ))

  plot_data <-
    clean_data %>% # Remove additional stop words
    count(word, name = "freq") %>%
    arrange(desc(freq))

  if(nrow(plot_data) < keep){
    keep <- nrow(plot_data)
  }

  plot_data <- plot_data %>% slice(1:keep)

  if(return == "plot"){
    output <-
      plot_data %>%
      ggplot(aes(label = word, size = freq)) +
      ggwordcloud::geom_text_wordcloud(rm_outside = TRUE, ...) +
      scale_size_area(max_size = 15) +
      theme_minimal()

    return(output)
  } else if (return == "table"){
    return(plot_data)
  } else {
    stop("Please enter a valid input for `return`.")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Import a query from Viva Insights Analyst Experience
#'
#' @description Import a Viva Insights Query from a .csv file, with variable
#'   classifications optimised for other functions in the package.
#'
#' @details `import_query()` uses `data.table::fread()` to import .csv files for
#' speed, and by default `stringsAsFactors` is set to FALSE. A data frame is
#' returned by the function (not a `data.table`). Column names are automatically
#' cleaned, replacing spaces and special characters with underscores.
#'
#' @param x String containing the path to the Viva Insights query to be
#'   imported. The input file must be a .csv file, and the file extension must
#'   be explicitly entered, e.g. `"/files/standard query.csv"`
#' @param pid String specifying the unique person or individual identifier
#'   variable. `import_query` renames this to `PersonId` so that this is
#'   compatible with other functions in the package. Defaults to `NULL`, where
#'   no action is taken.
#' @param dateid String specifying the date variable. `import_query` renames
#'   this to `MetricDate` so that this is compatible with other functions in the
#'   package. Defaults to `NULL`, where no action is taken.
#' @inheritParams prep_query
#'
#' @param encoding String to specify encoding to be used within
#'   `data.table::fread()`. See `data.table::fread()` documentation for more
#'   information. Defaults to `'UTF-8'`.
#'   
#'
#' @return A `tibble` is returned.
#'
#' @family Import and Export
#'
#' @export
import_query <- function(x,
                         pid = NULL,
                         dateid = NULL,
                         date_format = "%m/%d/%Y",
                         convert_date = TRUE,
                         encoding = 'UTF-8') {

  # import data
  return_data <-
    data.table::fread(x,
                      stringsAsFactors = FALSE,
                      encoding = encoding) %>%
    as.data.frame()

  # rename specified names
  if(!is.null(pid)){
    names(return_data)[names(return_data) == pid] <- "PersonId"
  }

  if(!is.null(dateid)){
    names(return_data)[names(return_data) == dateid] <- "MetricDate"
  }
  
  prep_query(
    data = return_data,
    date_format = date_format,
    convert_date = convert_date
  )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Calculate the Lorenz Curve and Gini Coefficient in a Person Query
#'
#' @description
#' This function computes the Gini coefficient and plots the Lorenz curve based
#' on a selected metric from a Person Query data frame. It provides a way to
#' measure inequality in the distribution of the selected metric.This function
#' can be integrated into a larger analysis pipeline to assess inequality in
#' metric distribution.
#' 
#' @section Gini coefficient:
#'  The Gini coefficient is a measure of statistical dispersion most commonly
#'  used to represent income inequality within a population. It is calculated as
#'  the ratio of the area between the Lorenz curve and the line of perfect
#'  equality (the 45-degree line) to the total area under the line of perfect
#'  equality. It has a range of 0 to 1, where 0 represents perfect equality and
#'  1 represents perfect inequality. It can be applied to any Viva Insights
#'  metric where inequality is of interest.
#'
#' @param data Data frame containing a Person Query.
#' @param metric Character string identifying the metric to be used for the
#'   Lorenz curve and Gini coefficient calculation.
#' @param return Character string identifying the return type. Options are:
#'   - `"gini"` - Numeric value representing the Gini coefficient.
#'   - `"table"` - Data frame containing a summary table of population share and 
#'   value share.
#'   - `"plot"` (default) - `ggplot` object representing a plot of the Lorenz 
#'   curve.
#'
#' @import dplyr
#' @import ggplot2
#'
#' @examples
#' create_lorenz(data = pq_data, metric = "Emails_sent", return = "gini")
#' 
#' create_lorenz(data = pq_data, metric = "Emails_sent", return = "plot")
#'
#' create_lorenz(data = pq_data, metric = "Emails_sent", return = "table")
#' @export
create_lorenz <- function(data, metric, return = "plot") {
  # Ensure the input data frame and metric are valid
  if (!is.data.frame(data)) {
    stop("Input must be a data frame")
  }
  if (!is.character(metric) || length(metric) != 1) {
    stop("Metric must be a single character string")
  }
  
  # Helper function to calculate the proportion of value for a given population share
  get_value_proportion <- function(df, population_share) {
    # Ensure the population_share is between 0 and 1
    if (population_share < 0 || population_share > 1) {
      stop("Population share must be between 0 and 1")
    }
    
    # Find the closest cumulative population share
    closest_row <- df %>%
      filter(cum_population >= population_share) %>%
      slice(1)
    
    return(closest_row$cum_values_prop)
  }
  
  # Helper function to compute the Gini coefficient
  compute_gini <- function(x) {
    # Ensure the input is a numeric vector
    if (!is.numeric(x)) {
      stop("Input must be a numeric vector")
    }
    
    # Sort the vector
    x <- sort(x)
    
    # Number of observations
    n <- length(x)
    
    # Compute the Gini coefficient
    gini <- (2 * sum((1:n) * x) - (n + 1) * sum(x)) / (n * sum(x))
    
    return(gini)
  }
  
  # Compute the Gini coefficient if "gini" is specified
  if (return == "gini") {
    gini_coef <- compute_gini(data[[metric]])
    return(gini_coef)
  }
  
  # Generate the Lorenz data frame if "table" or "plot" is specified
  lorenz_df <- 
    data %>%
    select(n = !!sym(metric)) %>% 
    arrange(n) %>%
    mutate(
      cum_values = cumsum(n),
      cum_population = cumsum(rep(1, n())) / n(),
      cum_values_prop = cum_values / sum(n)
    )
  
  if (return == "table") {
    # Return a summary table of population share and value share
      seq(0, 1, by = 0.1) %>%
      purrr::map_dfr(function(x) {
        tibble(
          population_share = x,
          value_share = get_value_proportion(lorenz_df, population_share = x)
        )
      })
    
  } else if (return == "plot") {
    # Plot the Lorenz curve
    gini_coef <- compute_gini(data[[metric]])
    
      lorenz_df %>%
      ggplot(aes(x = cum_population, y = cum_values_prop)) +
      geom_line(color = "#C75B7A") +
      geom_abline(intercept = 0, slope = 1, linetype = "dashed", color = "darkgrey") +
      labs(
        title = paste("% of Population Sharing % of", us_to_space(metric)),
        subtitle = paste("Lorenz Curve for", us_to_space(metric)),
        caption = paste0("Gini Coefficient: ", round(gini_coef, 2)),
        x = "Cumulative Share of Population",
        y = "Cumulative Share of Values"
      ) +
      theme_wpa_basic() +
      scale_x_continuous(limits = c(0, 1)) +
      scale_y_continuous(limits = c(0, 1))
      
  } else {
    stop("Invalid return type specified. Choose 'gini', 'table', or 'plot'.")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)


test_that("create_lorenz returns a data frame when return = 'table'", {

  result <- create_lorenz(data = pq_data, metric = "Emails_sent", return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_lorenz returns a ggplot when return = 'plot'", {

  result <- create_lorenz(data = pq_data, metric = "Emails_sent", return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_lorenz returns a numeric when return = 'gini'", {

  result <- create_lorenz(data = pq_data, metric = "Emails_sent", return = "gini")

  # Check if the result is a numeric
  expect_true(is.numeric(result))
})

#' @title Replace underscore with space
#'
#' @description Convenience function to convert underscores to space
#'
#' @param x String to replace all occurrences of `_` with a single space
#'
#' @return
#' Character vector containing the modified string.
#'
#' @family Support
#'
#' @examples
#' us_to_space("Meeting_and_call_hours_with_manager_1_on_1")
#'
#' @export
us_to_space <- function(x){
  gsub(pattern = "_", replacement = " ", x = x)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create count of distinct fields and percentage of employees with
#'   missing values for all HR variables
#'
#' @description `r lifecycle::badge('experimental')`
#'
#' This function enables you to create a summary table to validate
#' organizational data. This table will provide a summary of the data found in
#' the Viva Insights _Data sources_ page. This function will return a summary
#' table with the count of distinct fields per HR attribute and the percentage
#' of employees with missing values for that attribute. See `hrvar_count()`
#' function for more detail on the specific HR attribute of interest.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param n_var number of HR variables to include in report as rows. Default is
#'   set to 50 HR variables.
#' @param return String to specify what to return
#' @param threshold The max number of unique values allowed for any attribute.
#'   Default is 100.
#' @param maxna The max percentage of NAs allowable for any column. Default is
#'   20.
#'
#' @import dplyr
#'
#' @family Data Validation
#'
#' @examples
#' # Return a summary table of all HR attributes
#' hrvar_count_all(pq_data, return = "table")
#'
#' @return
#' Returns an error message by default, where 'text' is passed in `return`.
#'   - `'table'`: data frame. A summary table listing the number of distinct
#' fields and percentage of missing values for the specified number of HR
#' attributes will be returned.
#'   - `'message'`: outputs a message indicating which values are
#' beyond the specified thresholds.
#'
#' @export
hrvar_count_all <- function(data,
                            n_var = 50,
                            return = "message",
                            threshold = 100,
                            maxna = 20
                            ){

  ## Character vector of HR attributes
  extracted_chr <- extract_hr(
    data,
    return = "names",
    max_unique = threshold,
    exclude_constants = FALSE
    )

  summary_table_n <-
    data %>%
    select(PersonId, tidyselect::all_of(extracted_chr)) %>%
    summarise(
      across(
        .cols = tidyselect::all_of(extracted_chr),
        .fns = ~n_distinct(., na.rm = TRUE)
      )
    )

  ## Note: WPA here is used for a matching separator
  results <-
    data %>%
    select(PersonId, all_of(extracted_chr)) %>%
    summarise(across(all_of(extracted_chr),
                 list(`WPAn_unique` = ~n_distinct(., na.rm = TRUE), # Excludes NAs from unique count
                      `WPAper_na` = ~(sum(is.na(.))/ nrow(data) * 100),
                      `WPAsum_na` = ~sum(is.na(.)) # Number of missing values
                      ))) %>% # % of missing values
    tidyr::gather(attribute, values) %>%
    tidyr::separate(col = attribute, into = c("attribute", "calculation"), sep = "_WPA") %>%
    tidyr::spread(calculation, values)

    ## Single print message
    if(sum(results$n_unique >= threshold)==0){

      printMessage <- paste("No attributes have greater than", threshold, "unique values.")
    }

    if(sum(results$per_na >= maxna)==0){
      newMessage <- paste("No attributes have more than", maxna, "percent NA values.")
      printMessage <- paste(printMessage, newMessage, collapse = "\n")

    }

    for (i in 1:nrow(results)) {
      if(results$n_unique[i] >= threshold){

        newMessage <- paste0("The attribute '",results$attribute[i],"' has a large amount of unique values. Please check.")
        printMessage <- paste(printMessage, newMessage, collapse = "\n")
        }

      if(results$per_na[i]>=maxna){

        newMessage <- paste0("The attribute '",results$attribute[i],"' has a large amount of NA values. Please check.")
        printMessage <- paste(printMessage, newMessage, collapse = "\n")
        }
    }

    if(return == "table"){

      results <-
        results %>%
        select(Attributes = "attribute",
               `Unique values` = "n_unique",
               `Total missing values` = "sum_na",
               `% missing values` = "per_na")

      return(utils::head(results, n_var))

    } else if(return == "text"){

      printMessage

    } else if(return == "message"){

      message(printMessage)

    } else {

      stop("Error: please check inputs for `return`")

    }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Create a Scatter plot with two selected Viva Insights metrics (General Purpose)
#'
#' @description
#' Returns a scatter plot of two selected metrics, using colour to map
#' an HR attribute.
#' Returns a scatter plot by default, with additional options
#' to return a summary table.
#'
#' @details
#' This is a general purpose function that powers all the functions
#' in the package that produce scatter plots.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric_x Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param metric_y Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param hrvar HR Variable by which to split metrics, defaults to "Organization"
#'  but accepts any character vector, e.g. "LevelDesignation"
#' @param mingroup Numeric value setting the privacy threshold / minimum group size. Defaults to 5.
#' @param return Character vector specifying what to return, defaults to "plot".
#' Valid inputs are "plot" and "table".
#'
#' @import dplyr
#' @import ggplot2
#' @import scales
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' create_scatter(
#'   pq_data,
#'   metric_x = "Collaboration_hours",
#'   metric_y = "Multitasking_hours",
#'   hrvar = "Organization"
#'   )
#'
#' create_scatter(
#'   pq_data,
#'   metric_x = "Collaboration_hours",
#'   metric_y = "Multitasking_hours",
#'   hrvar = "Organization",
#'   mingroup = 100,
#'   return = "plot"
#' )
#'
#' @return
#' Returns a 'ggplot' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @export
create_scatter <- function(data,
                           metric_x,
                           metric_y,
                           hrvar = "Organization",
                           mingroup = 5,
                           return = "plot"){

  ## Check inputs
  required_variables <- c(hrvar,
                          metric_x,
                          metric_y,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Extract values violating privacy threshold
  violate_thres_chr <-
    data %>%
    group_by(!!sym(hrvar)) %>%
    summarise(n = n_distinct(PersonId)) %>%
    filter(n < mingroup) %>%
    pull(!!sym(hrvar))

  ## Clean metric names
  clean_x <- us_to_space(metric_x)
  clean_y <- us_to_space(metric_y)

  myTable <-
    data %>%
    filter(!(!!sym(hrvar) %in% violate_thres_chr)) %>%
    group_by(PersonId, !!sym(hrvar)) %>%
    summarise(across(c(!!sym(metric_x),
                      !!sym(metric_y)),
                 ~mean(.))) %>%
    ungroup()

  plot_object <-
    myTable %>%
    ggplot(aes(x = !!sym(metric_x),
               y = !!sym(metric_y),
               colour = !!sym(hrvar))) +
    geom_point(alpha = 0.5) +
    labs(title = paste0(clean_x, " and ", clean_y),
	subtitle = paste("Distribution of employees by", tolower(camel_clean(hrvar))),
         caption = extract_date_range(data, return = "text")) +
    xlab(clean_x) +
    ylab(clean_y) +
    theme_wpa_basic()

  myTable_return <-
    myTable %>%
    group_by(!!sym(hrvar)) %>%
    summarise(across(c(!!sym(metric_x),
                      !!sym(metric_y)),
                 ~mean(.)))

  if(return == "table"){

    return(myTable_return)

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_scatter returns a data frame when return = 'table'", {

  result <- create_scatter(
			   pq_data,
			   metric_x = "Collaboration_hours",
			   metric_y = "Multitasking_hours",
			   hrvar = "Organization",
			   return = "table"
			   )

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_scatter returns a ggplot when return = 'plot'", {

    result <- create_scatter(
			   pq_data,
			   metric_x = "Collaboration_hours",
			   metric_y = "Multitasking_hours",
			   hrvar = "Organization",
			   return = "plot"
			   )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Run a summary of Key Metrics from the Standard Person Query data
#'
#' @description
#' Returns a heatmapped table by default, with options to return a table.
#'
#' @template spq-params
#' @param metrics A character vector containing the variable names to calculate
#'   averages of.
#' @param return Character vector specifying what to return, defaults to "plot".
#'   Valid inputs are "plot" and "table".
#' @param low String specifying colour code to use for low-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param mid String specifying colour code to use for mid-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param high String specifying colour code to use for high-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param textsize A numeric value specifying the text size to show in the plot.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @importFrom stats reorder
#'
#' @return
#' Returns a ggplot object by default, when `'plot'` is passed in `return`.
#' When `'table'` is passed, a summary table is returned as a data frame.
#'
#' @family Visualization
#'
#' @examples
#' \dontrun{
#' # Heatmap plot is returned by default
#' keymetrics_scan(pq_data)
#'
#' # Heatmap plot with custom colours
#' keymetrics_scan(pq_data, low = "purple", high = "yellow")
#' 
#' # Return summary table
#' keymetrics_scan(pq_data, hrvar = "LevelDesignation", return = "table")
#' }
#' 
#' @export

keymetrics_scan <- function(data,
                            hrvar = "Organization",
                            mingroup = 5,
                            metrics = c("Collaboration_span",
                                        "Collaboration_hours",
                                        "After_hours_collaboration_hours",
                                        "Meetings",
                                        "Meeting_hours",
                                        "After_hours_meeting_hours",
                                        "Meeting_and_call_hours_with_manager_1_1",
                                        "Meeting_and_call_hours_with_manager",
                                        "Emails_sent",
                                        "Email_hours",
                                        "After_hours_email_hours",
                                        "Internal_network_size",
                                        "External_network_size"),
                            return = "plot",
                            low = rgb2hex(7, 111, 161),
                            mid = rgb2hex(241, 204, 158),
                            high = rgb2hex(216, 24, 42),
                            textsize = 2){

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Omit if metrics do not exist in dataset
  metrics <- dplyr::intersect(metrics, names(data))


  ## Summary table
  myTable <-
    data %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    group_by(group, PersonId) %>%
    summarise(across(all_of(metrics), ~mean(., na.rm = TRUE))) %>%
    group_by(group) %>%
    summarise(across(all_of(metrics), ~mean(., na.rm = TRUE))) %>%
    left_join(hrvar_count(data, hrvar = hrvar, return = "table") %>%
                rename(Employee_Count = "n"),
              by = c("group" = hrvar)) %>%
    filter(Employee_Count >= mingroup)  # Keep only groups above privacy threshold

  myTable %>%
    reshape2::melt(id.vars = "group") %>%
    reshape2::dcast(variable ~ group) -> myTable_wide

  myTable_long <- reshape2::melt(myTable, id.vars=c("group")) %>%
    mutate(variable = factor(variable)) %>%
    group_by(variable) %>%
    # Heatmap by row
    mutate(value_rescaled = maxmin(value)) %>%
    ungroup()

  plot_object <-
    myTable_long %>%
    filter(variable != "Employee_Count") %>%
    ggplot(aes(x = group,
               y = stats::reorder(variable, desc(variable)))) +
    geom_tile(aes(fill = value_rescaled),
              colour = "#FFFFFF",
              size = 2) +
    geom_text(aes(label=round(value, 1)), size = textsize) +
    # Fill is contingent on max-min scaling
    scale_fill_gradient2(low = low,
                         mid = mid,
                         high = high,
                         midpoint = 0.5,
                         breaks = c(0, 0.5, 1),
                         labels = c("Minimum", "", "Maximum"),
                         limits = c(0, 1)) +
    scale_x_discrete(position = "top") +
    scale_y_discrete(labels = us_to_space) +
    theme_wpa_basic() +
    theme(axis.line = element_line(color = "#FFFFFF")) +
    labs(title = "Key metrics",
         subtitle = paste("Weekly average by", camel_clean(hrvar)),
         y =" ",
         x =" ",
         fill = " ",
         caption = extract_date_range(data, return = "text")) +
    theme(axis.text.x = element_text(angle = 90, hjust = 0),
          plot.title = element_text(color="grey40", face="bold", size=20))


  if(return == "table"){

    myTable_wide %>%
      as_tibble() %>%
      return()

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Run a summary of Key Metrics without aggregation
#'
#' @description
#' Return a heatmapped table directly from the aggregated / summarised data.
#' Unlike `keymetrics_scan()` which performs a person-level aggregation, there
#' is no calculation for `keymetrics_scan_asis()` and the values are rendered as
#' they are passed into the function.
#'
#' @param data data frame containing data to plot. It is recommended to provide
#'   data in a 'long' table format where one grouping column forms the rows, a
#'   second column forms the columns, and a third numeric columns forms the
#' @param row_var String containing name of the grouping variable that will form
#'   the rows of the heatmapped table.
#' @param col_var String containing name of the grouping variable that will form
#'   the columns of the heatmapped table.
#' @param group_var String containing name of the grouping variable by which
#' heatmapping would apply. Defaults to `col_var`.
#' @param value_var String containing name of the value variable that will form
#' the values of the heatmapped table. Defaults to `"value"`.
#' @param title Title of the plot.
#' @param subtitle Subtitle of the plot.
#' @param caption Caption of the plot.
#' @param ylab Y-axis label for the plot (group axis)
#' @param xlab X-axis label of the plot (bar axis).
#' @param rounding Numeric value to specify number of digits to show in data
#'   labels
#' @param low String specifying colour code to use for low-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param mid String specifying colour code to use for mid-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param high String specifying colour code to use for high-value metrics.
#'   Arguments are passed directly to `ggplot2::scale_fill_gradient2()`.
#' @param textsize A numeric value specifying the text size to show in the plot.
#'
#' @return
#' ggplot object for a heatmap table.
#'
#' @examples
#'
#' library(dplyr)
#'
#' # Compute summary table
#' out_df <-
#'   pq_data %>%
#'   group_by(Organization) %>%
#'   summarise(
#'     across(
#'       .cols = c(
#'         Email_hours,
#'         Collaboration_hours
#'         ),
#'       .fns = ~median(., na.rm = TRUE)
#'       ),
#'       .groups = "drop"
#'     ) %>%
#' tidyr::pivot_longer(
#'   cols = c("Email_hours", "Collaboration_hours"),
#'   names_to = "metrics"
#' )
#'
#' keymetrics_scan_asis(
#'   data = out_df,
#'   col_var = "metrics",
#'   row_var = "Organization"
#' )
#'
#' # Show data the other way round
#' keymetrics_scan_asis(
#'   data = out_df,
#'   col_var = "Organization",
#'   row_var = "metrics",
#'   group_var = "metrics"
#' )
#'
#' @export
#'
keymetrics_scan_asis <- function(
  data,
  row_var,
  col_var,
  group_var = col_var,
  value_var = "value",
  title = NULL,
  subtitle = NULL,
  caption = NULL,
  ylab = row_var,
  xlab = "Metrics",
  rounding = 1,
  low = rgb2hex(7, 111, 161),
  mid = rgb2hex(241, 204, 158),
  high = rgb2hex(216, 24, 42),
  textsize = 2
){

  # Transform to long data format
  myTable_long <-
    data %>%
    mutate(!!sym(group_var) := factor(!!sym(group_var))) %>%
    group_by(!!sym(group_var)) %>%
    # Heatmap by row
    mutate(value_rescaled = maxmin(!!sym(value_var))) %>%
    ungroup()

  plot_object <-
    myTable_long %>%
    ggplot(aes(x = !!sym(row_var),
               y = stats::reorder(!!sym(col_var), desc(!!sym(col_var))))) +
    geom_tile(aes(fill = value_rescaled),
              colour = "#FFFFFF",
              size = 2) +
    geom_text(aes(label = round(value, rounding)), size = textsize) +
    # Fill is contingent on max-min scaling
    scale_fill_gradient2(
      low = low,
      mid = mid,
      high = high,
      midpoint = 0.5,
      breaks = c(0, 0.5, 1),
      labels = c("Minimum", "", "Maximum"),
      limits = c(0, 1)
      ) +
    scale_x_discrete(position = "top") +
    scale_y_discrete(labels = us_to_space) +
    theme_wpa_basic() +
    theme(axis.line = element_line(color = "#FFFFFF")) +
    labs(title = title,
         subtitle = subtitle,
         y = " ",
         x = " ",
         fill = " ",
         caption = caption) +
    theme(
      axis.text.x = element_text(angle = 90, hjust = 0),
      plot.title = element_text(color="grey40", face="bold", size=20)
      )

  plot_object

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Sample Group-to-Group dataset
#'
#' @description
#' A demo dataset representing a Group-to-Group Query. The grouping
#' organizational attribute used here is `Organization`, where the variable have
#' been prefixed with `PrimaryCollaborator_` and `SecondaryCollaborator_` to represent the
#' direction of collaboration.
#'
#' @family Data
#' @family Network
#'
#' @return data frame.
#'
#' @format A data frame with 150 rows and 11 variables:
#' \describe{
#'   \item{PrimaryCollaborator_Organization}{ }
#'   \item{PrimaryCollaborator_GroupSize}{ }
#'   \item{SecondaryCollaborator_Organization}{ }
#'   \item{SecondaryCollaborator_GroupSize}{ }
#'   \item{MetricDate}{ }
#'   \item{Percent_Group_collaboration_time_invested}{ }
#'   \item{Group_collaboration_time_invested}{ }
#'   \item{Group_email_sent_count}{ }
#'   \item{Group_email_time_invested}{ }
#'   \item{Group_meeting_count}{ }
#'   \item{Group_meeting_time_invested}{ }
#'   ...
#' }
#' @source \url{https://analysis.insights.cloud.microsoft/analyst/analysis/}
"g2g_data"

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title External Collaboration Summary
#'
#' @description
#' Provides an overview analysis of 'External Collaboration'.
#' Returns a stacked bar plot of internal and external collaboration.
#' Additional options available to return a summary table.
#'
#' @inheritParams create_stacked
#' @inherit create_stacked return
#'
#' @family Visualization
#' @family External Collaboration
#'
#' @examples
#' # Return a plot
#' external_sum(pq_data, hrvar = "LevelDesignation")
#'
#' # Return summary table
#' external_sum(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

external_sum <- function(data,
								hrvar = "Organization",
                                mingroup = 5,
								stack_colours = c("#1d327e", "#1d7e6a"),
                                return = "plot"){


# Calculate Internal / External Collaboration time
plot_data <-  data %>% mutate(Internal_hours=  Collaboration_hours - External_collaboration_hours)   %>%  mutate(External_hours=  External_collaboration_hours)

# Plot Internal / External Collaboration time by Organization
plot_data %>%  create_stacked(hrvar = hrvar, metrics = c("Internal_hours", "External_hours"),   plot_title = "Internal and External Collaboration Hours",  stack_colours = stack_colours, mingroup = mingroup, return = return)

}


#' @rdname external_sum
#' @export
external_summary <- external_sum

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Prepare Survival Data from a Panel Dataset
#'
#' @description
#' Converts a Standard Person Query (panel) dataset into a person-level survival
#' table suitable for direct use with \code{\link{create_survival}}.
#'
#' Each person's weekly rows are reduced to a single row containing:
#' \itemize{
#'   \item \code{time}: the number of periods from the first observation until
#'     the event condition is first met. If the condition is never met,
#'     \code{time} equals the total number of observed periods (censored).
#'   \item \code{event}: \code{1} if the condition was met at any point in the
#'     observation window, \code{0} if the person was censored (never met it).
#' }
#'
#' Although rooted in survival analysis, the \code{event_condition} is typically
#' a **positive milestone** in a workforce context — first use of a tool, first
#' week as a power user, first week crossing a collaboration threshold.
#' The resulting curve is therefore often better described as a
#' **time-to-adoption**, **conversion**, or **graduation** curve.
#' See \code{\link{create_survival}} for further framing guidance.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric Character string containing the name of the metric column to
#'   evaluate the event condition on.
#' @param event_condition A function that takes a numeric vector and returns a
#'   logical vector. Applied to \code{metric} to mark whether the event occurred
#'   in a given period. Defaults to \code{function(x) x > 0} (any non-zero
#'   value is treated as the event).
#' @param hrvar Character string containing the name of the HR attribute column
#'   to carry through into the output. The most recent (last observed) value per
#'   person is used. Defaults to \code{"Organization"}. Set to \code{NULL} to
#'   omit.
#'
#' @return A data frame with one row per person containing:
#' \itemize{
#'   \item \code{PersonId}
#'   \item \code{time}: numeric — periods until event, or total observed periods
#'     if censored
#'   \item \code{event}: integer — \code{1} (event) or \code{0} (censored)
#'   \item The \code{hrvar} column, if supplied
#' }
#'
#' @import dplyr
#' @importFrom rlang .data
#'
#' @family Transformation
#' @seealso \code{\link{create_survival}}
#'
#' @examples
#' # \dontrun{
#' # library(vivainsights)
#' # data("pq_data", package = "vivainsights")
#' #
#' # # Step 1: derive person-level survival data
#' # surv_data <- create_survival_prep(
#' #   data = pq_data,
#' #   metric = "Copilot_actions_taken_in_Teams",
#' #   event_condition = function(x) x > 0
#' # )
#' #
#' # # Step 2: visualise
#' # create_survival(
#' #   data = surv_data,
#' #   time_col = "time",
#' #   event_col = "event",
#' #   hrvar = "Organization"
#' # )
#' # }
#' @export
create_survival_prep <- function(data,
                                 metric,
                                 event_condition = function(x) x > 0,
                                 hrvar = "Organization") {

  ## Input validation
  required_cols <- unique(c("PersonId", "MetricDate", metric))
  if (!is.null(hrvar)) required_cols <- c(required_cols, hrvar)

  data %>% .check_inputs_safe(requirements = required_cols)

  if (!is.function(event_condition)) {
    stop("`event_condition` must be a function, e.g. `function(x) x > 0`.")
  }

  ## Sort chronologically within each person so period indices are meaningful
  df <- data %>%
    dplyr::arrange(.data$PersonId, .data$MetricDate)

  ## Evaluate event condition row-by-row
  flags <- event_condition(df[[metric]])

  if (!is.logical(flags)) {
    stop("`event_condition` must return a logical vector.")
  }

  if (length(flags) != nrow(df)) {
    stop(
      "`event_condition` must return a vector with one element per row of `data` (",
      nrow(df), "), but returned ", length(flags), " element(s)."
    )
  }

  df$.event_flag <- flags

  hrvar_cols <- if (!is.null(hrvar)) hrvar else character(0)

  ## Reduce to one row per person -------------------------------------------------
  ## .first_event: index of the first period where the condition is TRUE.
  ##   which() ignores NAs; min() of an empty vector returns Inf (with a
  ##   suppressable warning), signalling that the person is censored.
  per_person <- df %>%
    dplyr::group_by(.data$PersonId) %>%
    dplyr::summarise(
      .n_periods   = dplyr::n(),
      .first_event = suppressWarnings(min(which(.data$.event_flag))),
      event        = as.integer(any(.data$.event_flag, na.rm = TRUE)),
      dplyr::across(dplyr::all_of(hrvar_cols), dplyr::last),
      .groups = "drop"
    ) %>%
    dplyr::mutate(
      time = dplyr::if_else(
        is.infinite(.data$.first_event),
        as.numeric(.data$.n_periods),   # censored: survived the full window
        as.numeric(.data$.first_event)  # event: period of first occurrence
      )
    ) %>%
    dplyr::select(dplyr::all_of(c("PersonId", "time", "event", hrvar_cols)))

  per_person
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

# Deterministic test panel: 3 people, known expected output
make_test_panel <- function() {
  data.frame(
    PersonId = c(rep("A", 5), rep("B", 4), rep("C", 3)),
    MetricDate = as.Date(c(
      "2023-01-01", "2023-02-01", "2023-03-01", "2023-04-01", "2023-05-01",
      "2023-01-01", "2023-02-01", "2023-03-01", "2023-04-01",
      "2023-01-01", "2023-02-01", "2023-03-01"
    )),
    metric = c(
      0, 0, 3, 1, 0,   # Person A: event at period 3
      0, 0, 0, 0,       # Person B: never (censored at period 4)
      5, 0, 0            # Person C: event at period 1
    ),
    Organization = c(rep("Sales", 5), rep("Finance", 4), rep("Sales", 3)),
    stringsAsFactors = FALSE
  )
}

# Basic output structure ------------------------------------------------------------------

test_that("create_survival_prep returns a data frame", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_s3_class(result, "data.frame")
})

test_that("create_survival_prep returns one row per PersonId", {
  panel <- make_test_panel()
  result <- create_survival_prep(panel, metric = "metric")
  expect_equal(nrow(result), dplyr::n_distinct(panel$PersonId))
})

test_that("create_survival_prep output has expected columns", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_true("PersonId"      %in% names(result))
  expect_true("time"          %in% names(result))
  expect_true("event"         %in% names(result))
  expect_true("Organization"  %in% names(result))
})

test_that("create_survival_prep column order is PersonId, time, event, hrvar", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_equal(names(result)[1:4], c("PersonId", "time", "event", "Organization"))
})

# Correct time values ---------------------------------------------------------------------

test_that("time equals period of first event for person who has the event", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")

  # Person A: event at period 3 (rows 1,2,3 -> first TRUE at index 3)
  expect_equal(result$time[result$PersonId == "A"], 3)

  # Person C: event at period 1 (first row is already > 0)
  expect_equal(result$time[result$PersonId == "C"], 1)
})

test_that("time equals total observed periods for censored person", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")

  # Person B: 4 periods, never meets condition -> censored at 4
  expect_equal(result$time[result$PersonId == "B"], 4)
})

# Correct event values --------------------------------------------------------------------

test_that("event = 1 for persons who meet the condition", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_equal(result$event[result$PersonId == "A"], 1L)
  expect_equal(result$event[result$PersonId == "C"], 1L)
})

test_that("event = 0 for censored persons", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_equal(result$event[result$PersonId == "B"], 0L)
})

test_that("event column is integer", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  expect_type(result$event, "integer")
})

# hrvar handling --------------------------------------------------------------------------

test_that("hrvar column is the last observed value per person", {
  result <- create_survival_prep(make_test_panel(), metric = "metric")
  # All persons have a stable org in this panel, so last == only value
  expect_equal(result$Organization[result$PersonId == "A"], "Sales")
  expect_equal(result$Organization[result$PersonId == "B"], "Finance")
})

test_that("hrvar = NULL produces output without grouping column", {
  result <- create_survival_prep(make_test_panel(), metric = "metric", hrvar = NULL)
  expect_false("Organization" %in% names(result))
  expect_equal(names(result), c("PersonId", "time", "event"))
})

# Date ordering ---------------------------------------------------------------------------

test_that("periods are counted in date order regardless of row order in input", {
  # Shuffle the rows; result should be identical to sorted input
  panel <- make_test_panel()
  shuffled <- panel[sample(nrow(panel)), ]

  result_ordered  <- create_survival_prep(panel,    metric = "metric")
  result_shuffled <- create_survival_prep(shuffled, metric = "metric")

  # Align by PersonId before comparing
  result_ordered  <- result_ordered[order(result_ordered$PersonId), ]
  result_shuffled <- result_shuffled[order(result_shuffled$PersonId), ]

  expect_equal(result_ordered$time,  result_shuffled$time)
  expect_equal(result_ordered$event, result_shuffled$event)
})

# Custom event_condition ------------------------------------------------------------------

test_that("custom event_condition is applied correctly", {
  panel <- make_test_panel()

  # Use a higher threshold: event only when metric > 2
  # Person A: values 0,0,3,1,0 -> first > 2 at period 3, same as default
  # Person C: values 5,0,0     -> first > 2 at period 1, same as default
  result_gt2 <- create_survival_prep(panel, metric = "metric",
                                     event_condition = function(x) x > 2)
  expect_equal(result_gt2$time[result_gt2$PersonId == "A"], 3)

  # With threshold > 3: Person A's value of 3 no longer qualifies;
  # only period 4 (value 1) also doesn't qualify -> Person A now censored
  result_gt3 <- create_survival_prep(panel, metric = "metric",
                                     event_condition = function(x) x > 3)
  expect_equal(result_gt3$event[result_gt3$PersonId == "A"], 0L)
  expect_equal(result_gt3$time[result_gt3$PersonId == "A"], 5)  # full 5 periods
})

# Integration with pq_data ----------------------------------------------------------------

test_that("create_survival_prep works with pq_data and returns one row per PersonId", {
  result <- create_survival_prep(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams"
  )

  expect_s3_class(result, "data.frame")
  expect_equal(nrow(result), dplyr::n_distinct(pq_data$PersonId))
})

test_that("create_survival_prep output from pq_data has valid time and event values", {
  result <- create_survival_prep(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams"
  )

  expect_true(all(result$time >= 1))
  expect_true(all(result$event %in% c(0L, 1L)))
})

test_that("create_survival_prep output can be passed directly to create_survival", {
  surv_data <- create_survival_prep(
    data = pq_data,
    metric = "Copilot_actions_taken_in_Teams"
  )

  result <- create_survival(
    data = surv_data,
    time_col = "time",
    event_col = "event",
    hrvar = "Organization",
    mingroup = 1,
    return = "plot"
  )

  expect_s3_class(result, "ggplot")
})

# Error handling --------------------------------------------------------------------------

test_that("create_survival_prep errors when metric column is missing", {
  expect_error(
    create_survival_prep(make_test_panel(), metric = "NonExistent"),
    "not included in the input data frame"
  )
})

test_that("create_survival_prep errors when hrvar column is missing", {
  expect_error(
    create_survival_prep(make_test_panel(), metric = "metric", hrvar = "NonExistent"),
    "not included in the input data frame"
  )
})

test_that("create_survival_prep errors when event_condition is not a function", {
  expect_error(
    create_survival_prep(make_test_panel(), metric = "metric",
                         event_condition = 0),
    "`event_condition` must be a function"
  )
})

test_that("create_survival_prep errors when event_condition returns non-logical", {
  expect_error(
    create_survival_prep(make_test_panel(), metric = "metric",
                         event_condition = function(x) as.character(x > 0)),
    "`event_condition` must return a logical vector"
  )
})

test_that("create_survival_prep errors when event_condition returns wrong length", {
  expect_error(
    create_survival_prep(make_test_panel(), metric = "metric",
                         event_condition = function(x) TRUE),
    "one element per row"
  )

  expect_error(
    create_survival_prep(make_test_panel(), metric = "metric",
                         event_condition = function(x) c(TRUE, FALSE)),
    "one element per row"
  )
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a density plot for any metric
#'
#' @description
#' Provides an analysis of the distribution of a selected metric.
#' Returns a faceted density plot by default.
#' Additional options available to return the underlying frequency table.
#'
#' @template spq-params
#' @param metric String containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @param ncol Numeric value setting the number of columns on the plot. Defaults
#'   to `NULL` (automatic).
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'   - `"data"`
#'   - `"frequency"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A faceted density plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric, containing the 
#'   following columns:
#'     - `group`: The HR variable by which the metric is split.
#'     - `mean`: The mean of the metric.
#'     - `min`: The minimum value of the metric.
#'     - `p10`: The 10th percentile of the metric.
#'     - `p25`: The 25th percentile of the metric.
#'     - `p50`: The 50th percentile of the metric.
#'     - `p75`: The 75th percentile of the metric.
#'     - `p90`: The 90th percentile of the metric.
#'     - `max`: The maximum value of the metric.
#'     - `sd`: The standard deviation of the metric.
#'     - `range`: The range of the metric.
#'     - `n`: The number of observations.
#'   - `"data"`: data frame. Data with calculated person averages.
#'   - `"frequency`: list of data frames. Each data frame contains the
#'   frequencies used in each panel of the plotted histogram.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom tidyr spread
#' @importFrom stats median
#' @importFrom stats sd
#' @importFrom stats quantile
#'
#' @family Flexible
#'
#' @examples
#' # Return plot for whole organization
#' create_density(pq_data, metric = "Collaboration_hours", hrvar = NULL)
#'
#' # Return plot
#' create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization")
#'
#' # Return plot but coerce plot to three columns
#' create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", ncol = 3)
#'
#' # Return summary table
#' create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")
#' @export

create_density <- function(data,
                           metric,
                           hrvar = "Organization",
                           mingroup = 5,
                           ncol = NULL,
                           return = "plot") {

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Create NULL variables
  density <- scaled <- ndensity <- NULL

  ## Clean metric name
  clean_nm <- us_to_space(metric)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Basic Data for bar plot
  ## Calculate person-averages
  plot_data <-
    data %>%
    rename(group = !!sym(hrvar)) %>%
    group_by(PersonId, group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric))) %>%
    ungroup() %>%
    left_join(data %>%
                rename(group = !!sym(hrvar)) %>%
                group_by(group) %>%
                summarise(Employee_Count = n_distinct(PersonId)),
              by = "group") %>%
    filter(Employee_Count >= mingroup)

  ## Employee count / base size table
  plot_legend <-
    plot_data %>%
    group_by(group) %>%
    summarize(Employee_Count = first(Employee_Count)) %>%
    mutate(Employee_Count = paste("n=",Employee_Count))


  if(return == "table"){

    ## Table to return
    calculate_distribution_summary(plot_data, metric)

  } else if(return == "plot"){

    ## Density plot

    plot_data %>%
      ggplot(aes(x = !!sym(metric))) +
      geom_density(lwd = 1, colour = 4, fill = 4, alpha = 0.25) +
      facet_wrap(group ~ ., ncol = ncol) +
      theme_wpa_basic() +
      theme(strip.background = element_rect(color = "#1d627e",
                                            fill = "#1d627e"),
            strip.text = element_text(size = 10,
                                      colour = "#FFFFFF",
                                      face = "bold")) +
      labs(title = clean_nm,
           subtitle = paste("Distribution of", tolower(clean_nm), "by", tolower(camel_clean(hrvar)))) +
      xlab(clean_nm) +
      ylab("Density") +
      labs(caption = extract_date_range(data, return = "text"))

  } else if(return == "frequency"){

    hist_obj <-
      plot_data %>%
      ggplot(aes(x = !!sym(metric))) +
      geom_density() +
      facet_wrap(group ~ ., ncol = ncol)

    ggplot2::ggplot_build(hist_obj)$data[[1]] %>%
      select(
        group,
        PANEL,
        y,
        x,
        density,
        scaled,
        ndensity,
        count,
        n
      ) %>%
      group_split(PANEL)

  } else if(return == "data"){

    plot_data

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_density returns a data frame when return = 'table'", {

  result <- create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
  
  # Check that the new enhanced columns are present
  expected_cols <- c("group", "mean", "min", "p10", "p25", "p50", "p75", "p90", "max", "sd", "range", "n")
  expect_true(all(expected_cols %in% names(result)))
  
  # Check that we have 12 columns (enhanced output)
  expect_equal(ncol(result), 12)
  
  # Check that 'n' column is present (not 'Employee_Count')
  expect_true("n" %in% names(result))
  expect_false("Employee_Count" %in% names(result))
})

test_that("create_density returns a data frame when return = 'data'", {

  result <- create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "data")
  
  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_density returns a ggplot when return = 'plot'", {

  result <- create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "plot")
  
  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_density returns a list when return = 'frequency'", {

  result <- create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "frequency")
  
  # Check if the result is a list
  expect_true(is.list(result))
})

#' @title Meeting Hours Time Trend
#'
#' @description
#' Provides a week by week view of meeting time. By default returns a week by
#' week heatmap, highlighting the points in time with most activity. Additional
#' options available to return a summary table.
#'
#' @details
#' Uses the metric `Meeting_hours`.
#'
#' @inheritParams create_trend
#' @inherit create_trend return
#'
#' @family Visualization
#' @family Meetings
#'
#'
#' @examples
#' # Run plot
#' meeting_trend(pq_data)
#'
#' # Run table
#' meeting_trend(pq_data, hrvar = "LevelDesignation", return = "table")
#' @export

meeting_trend <- function(data,
                        hrvar = "Organization",
                        mingroup = 5,
                        return = "plot"){

  create_trend(data,
               metric = "Meeting_hours",
               hrvar = hrvar,
               mingroup = mingroup,
               return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a bubble plot with two selected Viva Insights metrics (General
#'   Purpose), with size representing the number of employees in the group.
#'
#' @description Returns a bubble plot of two selected metrics, using size to map
#'   the number of employees.
#'
#' @details This is a general purpose function that powers all the functions in
#'   the package that produce bubble plots.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric_x Character string containing the name of the metric, e.g.
#'   "Collaboration_hours"
#' @param metric_y Character string containing the name of the metric, e.g.
#'   "Collaboration_hours"
#' @param hrvar HR Variable by which to split metrics, defaults to
#'   "Organization" but accepts any character vector, e.g. "LevelDesignation"
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings: - `"plot"` - `"table"`
#'
#' @param bubble_size A numeric vector of length two to specify the size range
#'   of the bubbles
#'
#' @import dplyr
#' @import ggplot2
#' @import scales
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' create_bubble(pq_data, "Collaboration_hours", "Multitasking_hours", hrvar ="Organization")
#'
#'
#' @return A different output is returned depending on the value passed to the
#' `return` argument:
#'  - `"plot"`: 'ggplot' object. A bubble plot for the metric.
#'  - `"table"`: data frame. A summary table for the metric.
#'
#' @export
create_bubble <- function(data,
                          metric_x,
                          metric_y,
                          hrvar = "Organization",
                          mingroup = 5,
                          return = "plot",
                          bubble_size = c(1, 10)){

  ## Check inputs
  required_variables <- c(hrvar,
                          metric_x,
                          metric_y,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Clean metric names
  clean_x <- us_to_space(metric_x)
  clean_y <- us_to_space(metric_y)

  myTable <-
    data %>%
    group_by(PersonId, !!sym(hrvar)) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(., na.rm = TRUE))) %>%
    group_by(!!sym(hrvar)) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(., na.rm = TRUE))) %>%
    ungroup() %>%
    left_join(hrvar_count(data, hrvar = hrvar, return = "table"),
              by = hrvar) %>%
    filter(n >= mingroup)

  plot_object <-
    myTable %>%
    ggplot(aes(x = !!sym(metric_x),
               y = !!sym(metric_y),
               label = !!sym(hrvar))) +
    geom_point(alpha = 0.5, color = rgb2hex(0, 120, 212), aes(size = n)) +
    ggrepel::geom_text_repel(size = 3) +
    labs(title = paste0(clean_x, " and ", clean_y),
         subtitle = paste("By", camel_clean(hrvar)),
         caption = paste("Total employees =", sum(myTable$n), "|",
                         extract_date_range(data, return = "text"))) +
    xlab(clean_x) +
    ylab(clean_y) +
    scale_size(range = bubble_size) +
    theme_wpa_basic()

  if(return == "table"){

    return(myTable)

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title 
#' Identify whether a habitual behaviour exists over a given interval of time
#' 
#' @description `r lifecycle::badge('experimental')`
#' 
#' Based on the principle of consistency, this function identifies whether a
#' habit exists over a given interval of time. A habit is defined as a behaviour
#' (action taken) that is repeated at least x number of times consistently over
#' n weeks.
#' 
#' @details
#' Each week is considered as a binary variable on whether sufficient action has
#' been taken for that given week (a qualifying count). Sufficiency is
#' determined by the `threshold` parameter. For instance, if the threshold is
#' set to 2, this means that there must be 2 qualifying actions (e.g. summarise
#' meeting in Copilot) in a week for there to be a qualifying count for the
#' week.
#' One way of determining the parameters would be to consider, _how many counts
#' of `width` should occur within a `max_window` period for it to be considered
#' a habit?_
#' 
#' 
#' @param data Data frame containing Person Query to be analysed. The data frame
#' must have a `PersonId`, `MetricDate` and a column containing a metric for 
#' classifying behaviour. 
#' @param metric Character string specifying the metric to be analysed.
#' @param threshold Numeric value specifying the minimum number of times the
#' metric sum up to in order to be a valid count. A 'greater than or equal to' 
#' logic is used.
#' @param width Integer specifying the number of qualifying counts to consider
#'   for a habit. The function assumes a **weekly** interval is used.
#' @param max_window Integer specifying the maximum unit of dates to consider a
#' qualifying window for a habit. If your data is grouped at a weekly level, 
#' then `max_window = 12` would consider 12 weeks.   
#' @param hrvar Character string specifying the HR attribute or organisational
#' variable to group by. Default is `NULL`.
#' @param return Character string specifying the type of output to be returned.
#' Valid options include:
#'  - `"data"`: Returns the data frame with the habit classification.
#'  - `"plot"`: Returns a ggplot object of a boxplot, showing the percentage of 
#'  periods with where habitual behaviour occurred.
#'  - `"summary"`: Returns a summary table of the habit analysis.
#' @param plot_mode Character string specifying the type of plot to be returned.
#' Only applicable when `return = "plot"`. Valid options include:
#'  - `"time"`: Returns a time series plot with the breakdown of users with 
#'  habitual behaviour.
#'  - `"boxplot"`: Returns a boxplot of the percentage of periods with habitual
#'  behaviour.
#' @param fill_col Character vector of length 2 specifying the colours to be
#' used in the plot. Only applicable when `return = "plot"` and `plot_mode = "time"`.
#'  
#' @import dplyr
#' @import tidyr
#' @importFrom glue glue
#' 
#' @examples
#' # Return a plot
#' identify_habit(
#'   pq_data,
#'   metric = "Multitasking_hours",
#'   threshold = 1,
#'   width = 9,
#'   max_window = 12,
#'   return = "plot"
#' )
#' 
#' # Return a summary
#' identify_habit(
#'   pq_data,
#'   metric = "Multitasking_hours",
#'   threshold = 1,
#'   width = 9,
#'   max_window = 12,
#'   return = "summary"
#' )
#' 
#' @export
identify_habit <- function(
    data,
    metric,
    threshold = 1,
    width,
    max_window,
    hrvar = NULL,
    return = "plot",
    plot_mode = "time",
    fill_col = c("#E5E5E5", "#0078D4")
    ){
  
  habit_df <-
    data %>%
    group_by(PersonId) %>%
    arrange(MetricDate) %>% # Ensure ranked order from low to high
    mutate(
      cumsum_value = cumsum(!!sym(metric) >= threshold),
      lagged_cumsum = lag(cumsum_value, max_window, default = 0),
      sum_last_w = cumsum_value - lagged_cumsum,
      IsHabit = sum_last_w >= width,
      HabitCurve = paste(as.numeric(IsHabit), collapse = "")
    ) %>%
    ungroup()
  
  if(return == "data"){
    
    habit_df
    
  } else if(return == "plot"){
    
    date_text <- extract_date_range(data, return = "text")
    
    new_caption <-
      glue(
        "Habit is defined as active usage in {width} periods",
        "\n with at least {threshold} counts per period, ",
        "within a maximum of {max_window} periods.",
        "\n{date_text}"
      )
    
    if(plot_mode == "time"){
      
      suppressMessages(
        habit_df %>%
          # Filter out the first max_window periods for plotting
          arrange(MetricDate) %>%
          slice(-(1:(max_window * n_distinct(PersonId)))) %>%
          group_by(MetricDate, IsHabit) %>%
          summarise(n = n_distinct(PersonId), .groups = "drop") %>%
          ggplot(aes(x = MetricDate, y = n, fill = IsHabit)) +
          geom_bar(stat = "identity", position = "fill") +
          scale_y_continuous(labels = scales::percent) +
          scale_fill_manual(values = fill_col) +
          labs(y = "Percentage", fill = "Is Habit") +
          theme_wpa_basic() +
          labs(
            title = paste("Habitual Behaviour -", us_to_space(metric)),
            subtitle = "% with habitual behaviour by time period",
            caption = new_caption
          )
      )
      
      
    } else if(plot_mode == "boxplot"){
      
      suppressMessages(
        habit_df %>%
          # Filter out the first max_window periods for plotting
          arrange(MetricDate) %>%
          slice(-(1:(max_window * n_distinct(PersonId)))) %>%
          create_boxplot(hrvar = hrvar, metric = "IsHabit") +
          labs(
            title = paste("Habitual Behaviour -", us_to_space(metric)),
            subtitle = "% of periods with habitual behaviour",
            y = "% of periods where habitual behaviour occurred",
            caption = new_caption
          ) +
          scale_y_continuous(labels = scales::percent)
      )
      
    } else {
      
      stop("Invalid plot mode")
      
    }
    
  } else if(return == "summary"){
    
    # Latest period / week stats
    recent_tb <-
      habit_df %>%
      group_by(PersonId) %>%
      mutate(
        LostHabit = grepl(x = HabitCurve, pattern = "10"),
        GainedHabit = grepl(x = HabitCurve, pattern = "01")
      ) %>%
      ungroup() %>%
      filter(MetricDate == max(MetricDate)) %>%
      summarise(
        `Most recent week - Total persons with habit` = sum(IsHabit, na.rm = TRUE),
        `Most recent week - % of pop with habit` =
          `Most recent week - Total persons with habit` / n_distinct(PersonId),
        `Total Persons who have lost habit` = sum(LostHabit, na.rm = TRUE),
        `% of Persons who have lost habit` = mean(LostHabit, na.rm = TRUE),
        `Total Persons who have gained habit` = sum(GainedHabit, na.rm = TRUE),
        `% of Persons who have gained habit` = mean(GainedHabit, na.rm = TRUE)
      ) %>%
      pivot_longer(
        cols = everything(),
        names_to = "Statistics",
        values_to = "Value"
      ) 
    
    
    # Distribution stats
    dist_tb <-
      habit_df %>%
      create_boxplot(hrvar = NULL, metric = "IsHabit", return = "table") %>%
      select(-group, -n) %>%
      rename(
        `Mean - % of Person-weeks with habit` = "mean",
        `Median - % of Person-weeks with habit` = "p50",
        `Min - % of Person-weeks with habit` = "min",
        `Max - % of Person-weeks with habit` = "max",
        `SD - % of Person-weeks with habit` = "sd",
        `Range - % of Person-weeks with habit` = "range"
      ) %>%
      pivot_longer(
        cols = everything(),
        names_to = "Statistics",
        values_to = "Value"
      ) 
    
    # Person-week analysis
    pw_tb <-
      habit_df %>%
      summarise(
        `Total Person-weeks with habit` = sum(IsHabit),
        `Total Person-weeks` = n(),
        `% of Person-weeks with habit` = `Total Person-weeks with habit` / `Total Person-weeks`,
        `Total Persons` = n_distinct(PersonId),
        `Total Weeks` = n_distinct(MetricDate)
      ) %>%
      pivot_longer(
        cols = everything(),
        names_to = "Statistics",
        values_to = "Value"
      ) %>%
      mutate(Value = round(Value, 2))
    
    # Combine summary
    bind_rows(
      recent_tb,
      dist_tb,
      pw_tb
    )
    
  } else {
    
    stop("Invalid return type")
    
  }
}

# Test for verifying the fix truncates max_window from plot output
# This test demonstrates the fix for issue #62

test_that("identify_habit truncates first max_window weeks from plot output", {
  # Skip if packages not available
  skip_if_not_installed("dplyr")
  skip_if_not_installed("ggplot2")
  skip_if_not_installed("glue")
  
  # Load required packages
  library(dplyr)
  library(ggplot2)
  library(glue)
  
  # Create mock data with 8 weeks
  mock_data <- data.frame(
    PersonId = rep(c("A", "B", "C"), each = 8),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", "2024-01-22", 
                               "2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19")), 3),
    Total_actions = c(0, 5, 10, 20, 15, 12, 8, 18,    # Person A
                      1, 8, 15, 25, 20, 18, 22, 30,   # Person B  
                      0, 0, 2, 5, 3, 1, 0, 4),        # Person C
    stringsAsFactors = FALSE
  )
  
  # Test with max_window=3 - should show only last 5 weeks
  suppressMessages({
    plot_obj <- identify_habit(
      data = mock_data,
      metric = "Total_actions",
      threshold = 1,
      width = 2,
      max_window = 3,
      return = "plot",
      plot_mode = "time"
    )
  })
  
  # Extract the dates used in the plot data
  plot_data <- ggplot_build(plot_obj)$data[[1]]
  
  # Should show 5 unique time points (8 total - 3 filtered = 5)
  expect_equal(length(unique(plot_data$x)), 5)
  
  # Convert back to dates and check they are the expected last 5 weeks
  dates_in_plot <- as.Date(unique(plot_data$x), origin = "1970-01-01")
  expected_dates <- as.Date(c("2024-01-22", "2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19"))
  expect_equal(sort(dates_in_plot), sort(expected_dates))
})

test_that("identify_usage_segments truncates first max_window weeks from plot output", {
  # Skip if packages not available
  skip_if_not_installed("dplyr")
  skip_if_not_installed("ggplot2")
  skip_if_not_installed("tidyr")
  
  # Load required packages
  library(dplyr)
  library(ggplot2)
  library(tidyr)
  
  # Create mock data with 10 weeks
  mock_data <- data.frame(
    PersonId = rep(c("A", "B", "C"), each = 10),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", "2024-01-22", 
                               "2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19",
                               "2024-02-26", "2024-03-05")), 3),
    Total_actions = c(0, 5, 10, 20, 15, 12, 8, 18, 22, 25,    # Person A
                      1, 8, 15, 25, 20, 18, 22, 30, 28, 32,   # Person B  
                      0, 0, 2, 5, 3, 1, 0, 4, 6, 8),          # Person C
    stringsAsFactors = FALSE
  )
  
  # Test custom parameters with max_window=4 - should show only last 6 weeks
  suppressMessages({
    plot_obj <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 1,
      width = 3,
      max_window = 4,
      return = "plot"
    )
  })
  
  # Extract the dates used in the plot data
  plot_data <- ggplot_build(plot_obj)$data[[1]]
  
  # Should show 6 unique time points (10 total - 4 filtered = 6)
  expect_equal(length(unique(plot_data$x)), 6)
  
  # Convert back to dates and check they are the expected last 6 weeks
  dates_in_plot <- as.Date(unique(plot_data$x), origin = "1970-01-01")
  expected_dates <- as.Date(c("2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19", "2024-02-26", "2024-03-05"))
  expect_equal(sort(dates_in_plot), sort(expected_dates))
})

test_that("identify_usage_segments truncates correctly for predefined versions", {
  # Skip if packages not available
  skip_if_not_installed("dplyr")
  skip_if_not_installed("ggplot2")
  skip_if_not_installed("tidyr")
  
  # Load required packages
  library(dplyr)
  library(ggplot2) 
  library(tidyr)
  
  # Create mock data with 8 weeks
  mock_data <- data.frame(
    PersonId = rep(c("A", "B", "C"), each = 8),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", "2024-01-22", 
                               "2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19")), 3),
    Total_actions = c(0, 5, 10, 20, 15, 12, 8, 18,    # Person A
                      1, 8, 15, 25, 20, 18, 22, 30,   # Person B  
                      0, 0, 2, 5, 3, 1, 0, 4),        # Person C
    stringsAsFactors = FALSE
  )
  
  # Test 4w version - max_window=4, should show only last 4 weeks
  suppressMessages({
    plot_obj_4w <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "4w",
      return = "plot"
    )
  })
  
  # Extract the dates used in the plot data
  plot_data_4w <- ggplot_build(plot_obj_4w)$data[[1]]
  
  # Should show 4 unique time points (8 total - 4 filtered = 4) 
  expect_equal(length(unique(plot_data_4w$x)), 4)
  
  # Convert back to dates and check they are the expected last 4 weeks
  dates_in_plot_4w <- as.Date(unique(plot_data_4w$x), origin = "1970-01-01")
  expected_dates_4w <- as.Date(c("2024-01-29", "2024-02-05", "2024-02-12", "2024-02-19"))
  expect_equal(sort(dates_in_plot_4w), sort(expected_dates_4w))
})

test_that("data output is not affected by plot filtering", {
  # Skip if packages not available
  skip_if_not_installed("dplyr")
  skip_if_not_installed("tidyr")
  
  # Load required packages
  library(dplyr)
  library(tidyr)
  
  # Create mock data
  mock_data <- data.frame(
    PersonId = rep(c("A", "B"), each = 6),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", 
                               "2024-01-22", "2024-01-29", "2024-02-05")), 2),
    Total_actions = c(5, 10, 15, 20, 25, 30, 8, 12, 18, 22, 28, 32),
    stringsAsFactors = FALSE
  )
  
  # Data output should still contain all dates
  suppressMessages({
    data_result <- identify_habit(
      data = mock_data,
      metric = "Total_actions",
      threshold = 1,
      width = 2,
      max_window = 3,
      return = "data"
    )
  })
  
  # Should have all 6 unique dates in data output
  expect_equal(length(unique(data_result$MetricDate)), 6)
  
  # Test usage segments data output too
  suppressMessages({
    data_result_us <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 1,
      width = 2,
      max_window = 3,
      return = "data"
    )
  })
  
  # Should have all 6 unique dates in data output
  expect_equal(length(unique(data_result_us$MetricDate)), 6)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a count of distinct people in a specified HR variable
#'
#' @description
#' This function enables you to create a count of the distinct people
#' by the specified HR attribute.The default behaviour is to return a
#' bar chart as typically seen in 'Analysis Scope'.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param hrvar HR Variable by which to split metrics, defaults to
#'   "Organization" but accepts any character vector, e.g. "LevelDesignation".
#'   If a vector with more than one value is provided, the HR attributes are
#'   automatically concatenated.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object containing a bar plot.
#'   - `"table"`: data frame containing a count table.
#'
#' @import ggplot2
#' @import dplyr
#' @importFrom data.table ":=" "%like%" "%between%"
#'
#' @family Visualization
#' @family Data Validation
#'
#' @examples
#' # Return a bar plot
#' hrvar_count(pq_data, hrvar = "LevelDesignation")
#'
#' # Return a summary table
#' hrvar_count(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#'@export

hrvar_count <- function(data,
                        hrvar = "Organization",
                        return = "plot"){

  ## Allow multiple HRvar inputs
  if(length(hrvar) > 1){
    hrvar_flat <- paste(hrvar, collapse = ", ")

    summary_table <-
      data %>%
      select(PersonId, all_of(hrvar)) %>%
      mutate(!!sym(hrvar_flat) := select(., hrvar) %>%
               apply(1, paste, collapse = ", ")) %>%
      group_by(!!sym(hrvar_flat)) %>%
      summarise(n = n_distinct(PersonId)) %>%
      arrange(desc(n))

    # Single reference for single and multiple org attributes
    hrvar_label <- hrvar_flat

  } else {

    summary_table <-
      data %>%
      select(PersonId, all_of(hrvar)) %>%
      group_by(!!sym(hrvar)) %>%
      summarise(n = n_distinct(PersonId)) %>%
      arrange(desc(n))

    # Single reference for single and multiple org attributes
    hrvar_label <- hrvar
  }

  if(return == "table"){

    data %>%
      data.table::as.data.table() %>%
      .[, .(n = n_distinct(PersonId)), by = hrvar] %>%
      as_tibble() %>%
      arrange(desc(n))

  } else if(return == "plot"){

    ## This is re-run to enable multi-attribute grouping without concatenation
    summary_table %>%
      ggplot(aes(x = stats::reorder(!!sym(hrvar_label), -n),
                 y = n)) +
      geom_col(fill = rgb2hex(0, 120, 212)) +
      geom_text(aes(label = n),
                vjust = -1,
                fontface = "bold",
                size = 4)+
      theme_wpa_basic() +
      theme(axis.text.x = element_text(angle = 45, hjust = 1)) +
      labs(title = paste("People by", camel_clean(hrvar_label))) +
      scale_y_continuous(limits = c(0, max(summary_table$n) * 1.1)) +
      xlab(camel_clean(hrvar_label)) +
      ylab("Number of employees")

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

#' @rdname hrvar_count
#' @export
analysis_scope <- hrvar_count

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)


test_that("create_dt returns a htmlwidget", {

    output <- hrvar_count(pq_data, return = "table")
    result <- create_dt(output)

  # Check if the result is a htmlwidget object
  expect_s3_class(result, "htmlwidget")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Kaplan–Meier Survival Curve
#'
#' @description
#' Computes Kaplan–Meier survival curves and returns a step-function plot by default,
#' with an option to return the underlying long-format survival table.
#'
#' Although this function is built on **survival analysis**, the framing applies
#' equally to positive milestones in a workforce context. In classical survival
#' analysis the "event" is typically something negative (death, failure); here it
#' is often a positive outcome — first use of a tool, first week as a power user,
#' first week crossing a collaboration threshold. The curve is therefore better
#' read as a **time-to-adoption**, **conversion**, or **graduation** curve:
#'
#' - The y-axis ("survival probability") represents the share of people who have
#'   *not yet* reached the milestone.
#' - A curve that drops steeply early means most people converted quickly.
#' - A curve that stays high means many people had not yet converted by the end
#'   of the observation window.
#'
#' Supports:
#' - Flexible grouping via `hrvar`
#' - Privacy filtering via `mingroup`
#'
#' This function expects **one row per person** with a pre-computed time-to-event
#' column and an event indicator. Use \code{\link{create_survival_prep}} to derive
#' these from a Standard Person Query panel dataset.
#'
#' @param data A person-level data frame with one row per person, as produced by
#'
#' @param data A person-level data frame with one row per person, as produced by
#'   \code{\link{create_survival_prep}}. Must contain `time_col`, `event_col`, and
#'   (when `hrvar` is not `NULL`) the grouping column.
#' @param time_col Character string containing the name of the time-to-event column.
#' @param event_col Character string containing the name of the event indicator column.
#'   Accepted forms:
#'   - Logical (TRUE/FALSE)
#'   - Numeric 0/1
#'   - Numeric event-like (>=0): values >0 treated as event, 0 as censored
#'   - Character tokens ("true"/"false", "yes"/"no", "1"/"0")
#' @param hrvar Character string containing the name of the grouping column.
#'   Supply `NULL` (without quotes) to compute a single overall curve.
#' @param mingroup Numeric value setting the privacy threshold / minimum group size. Defaults to 5.
#' @param na.rm A logical value indicating whether `NA` should be stripped before computation proceeds.
#'   Defaults to `TRUE`.
#' @param return String specifying what to return. This must be one of:
#'   - `"plot"` (default)
#'   - `"table"`
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A Kaplan–Meier survival curve by group.
#'   - `"table"`: data frame. A long-format survival table by group.
#'
#' @import dplyr
#' @import ggplot2
#' @importFrom rlang .data
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' \dontrun{
#' library(vivainsights)
#' data("pq_data", package = "vivainsights")
#'
#' # Step 1: convert panel data to person-level survival format
#' surv_data <- create_survival_prep(
#'   data = pq_data,
#'   metric = "Copilot_actions_taken_in_Teams"
#' )
#'
#' # Step 2: plot Kaplan-Meier curves by organisation
#' create_survival(
#'   data = surv_data,
#'   time_col = "time",
#'   event_col = "event",
#'   hrvar = "Organization"
#' )
#'
#' # Return the survival table instead
#' create_survival(
#'   data = surv_data,
#'   time_col = "time",
#'   event_col = "event",
#'   hrvar = "Organization",
#'   return = "table"
#' )
#' }
#' @export
create_survival <- function(data,
                            time_col,
                            event_col,
                            hrvar = NULL,
                            mingroup = 5,
                            na.rm = TRUE,
                            return = "plot"){

  ## Check inputs
  required_variables <- c(time_col, event_col)

  if(!is.null(hrvar)){
    required_variables <- c(required_variables, hrvar)
  }

  required_variables <- unique(required_variables)

  data %>%
    .check_inputs_safe(requirements = required_variables)

  if(!is.numeric(mingroup) || length(mingroup) != 1 || mingroup < 1){
    stop("Please enter a valid input for `mingroup` (single numeric >= 1).")
  }

  if(!is.logical(na.rm) || length(na.rm) != 1){
    stop("Please enter a valid input for `na.rm` (TRUE/FALSE).")
  }

  if(is.null(return) || !is.character(return) || length(return) != 1){
    stop("Please enter a valid input for `return`.")
  }

  df <- data
  hrvar_for_calc <- hrvar

  if(!is.null(hrvar_for_calc)){

    if(!is.character(hrvar_for_calc) || length(hrvar_for_calc) != 1){
      stop("Please enter a valid input for `hrvar` (single character or NULL).")
    }

    if(!hrvar_for_calc %in% names(df)){
      stop("`hrvar` not found in data: ", hrvar_for_calc)
    }
  }

  out <-
    create_survival_calc(
      data = df,
      time_col = time_col,
      event_col = event_col,
      hrvar = hrvar_for_calc,
      mingroup = mingroup,
      na.rm = na.rm
    )

  if(return == "table"){

    return(out$table)

  } else if(return == "plot"){

    ## Titles
    if(is.null(hrvar_for_calc)){
      ttl  <- "Survival Curve"
      sub  <- "Kaplan\u2013Meier estimate"
      gcol <- "group"
    } else {
      ttl  <- "Survival Curve by Group"
      sub  <- paste("Kaplan\u2013Meier estimate by", hrvar_for_calc)
      gcol <- hrvar_for_calc
    }

    ## Caption: date range (person-level data may not carry MetricDate)
    caption_text <- tryCatch(
      extract_date_range(data, return = "text"),
      error = function(e) NULL
    )

    return(
      create_survival_viz(
        data     = out$table,
        hrvar    = gcol,
        title    = ttl,
        subtitle = sub,
        caption  = caption_text
      )
    )

  } else {

    stop("Please enter a valid input for `return`.")

  }
}


#' @title Kaplan–Meier Survival Curve (Calculation)
#'
#' @description
#' Computes a long-format Kaplan–Meier survival table by group and applies a minimum group
#' size threshold (`mingroup`).
#'
#' @param data data.frame.
#' @param time_col Character. Time-to-event column name.
#' @param event_col Character. Event indicator column name.
#' @param hrvar Character or NULL. Grouping column name.
#' @param id_col Character. Optional id column name for distinct counts.
#' @param mingroup Numeric. Minimum group size.
#' @param na.rm Logical. Drop missing values in required columns.
#'
#' @return A list with elements:
#'   - `table`: long survival table with columns (group, time, survival, at_risk, events, n)
#'   - `counts`: group size table
#'
#' @export
create_survival_calc <- function(data,
                                 time_col,
                                 event_col,
                                 hrvar = NULL,
                                 id_col = "PersonId",
                                 mingroup = 5,
                                 na.rm = TRUE){

  ## Check inputs
  required_variables <- c(time_col, event_col)

  if(!is.null(hrvar)){
    required_variables <- c(required_variables, hrvar)
  }

  required_variables <- unique(required_variables)

  data %>%
    .check_inputs_safe(requirements = required_variables)

  df <- data

  ## Handle overall curve
  if(is.null(hrvar)){
    df$group <- "Overall"
    hrvar <- "group"
  }

  ## Drop NA in required fields
  if(isTRUE(na.rm)){

    df <-
      df %>%
      dplyr::filter(!is.na(.data[[hrvar]])) %>%
      dplyr::filter(!is.na(.data[[time_col]]), !is.na(.data[[event_col]]))

  } else {

    df <-
      df %>%
      dplyr::filter(!is.na(.data[[hrvar]]))

  }

  ## Ensure join key is stable
  df[[hrvar]] <- as.character(df[[hrvar]])

  # Track original row count for warning
  n_before <- nrow(df)

  df <-
    df %>%
    dplyr::mutate(
      .time = suppressWarnings(as.numeric(.data[[time_col]])),
      .event = .coerce_event(.data[[event_col]])
    ) %>%
    dplyr::filter(!is.na(.data$.time), !is.na(.data$.event))

  n_after <- nrow(df)
  n_dropped <- n_before - n_after

  # Warn if coercion dropped rows
  if (n_dropped > 0) {
    warning(n_dropped, " row(s) dropped due to NA values in time or event columns after coercion. ",
            "Original rows: ", n_before, ", remaining: ", n_after, ".")
  }

  ## Group counts for mingroup (unique ids if possible, else row counts)
  if(!is.null(id_col) && is.character(id_col) && id_col %in% names(df)){

    counts <-
      df %>%
      dplyr::group_by(.data[[hrvar]]) %>%
      dplyr::summarise(n = dplyr::n_distinct(.data[[id_col]], na.rm = TRUE), .groups = "drop")

  } else {

    counts <-
      df %>%
      dplyr::group_by(.data[[hrvar]]) %>%
      dplyr::summarise(n = dplyr::n(), .groups = "drop")

  }

  counts[[hrvar]] <- as.character(counts[[hrvar]])

  keep_groups <-
    counts %>%
    dplyr::filter(.data$n >= mingroup) %>%
    dplyr::pull(.data[[hrvar]])

  df <-
    df %>%
    dplyr::filter(.data[[hrvar]] %in% keep_groups)

  counts <-
    counts %>%
    dplyr::filter(.data[[hrvar]] %in% keep_groups)

  if(nrow(df) == 0){

    empty_tbl <- data.frame(
      group = character(0),
      time = numeric(0),
      survival = numeric(0),
      at_risk = integer(0),
      events = integer(0),
      n = integer(0),
      check.names = FALSE
    )

    names(empty_tbl)[1] <- hrvar

    return(list(table = empty_tbl, counts = counts))
  }

  split_list <- split(df, df[[hrvar]], drop = TRUE)

  km_list <- lapply(names(split_list), function(g){

    x <- split_list[[g]]

    km <- .km_curve(durations = x$.time, events = x$.event)
    km[[hrvar]] <- as.character(g)

    km
  })

  surv_tbl <-
    dplyr::bind_rows(km_list) %>%
    dplyr::select(dplyr::all_of(c(hrvar, "time", "survival", "at_risk", "events"))) %>%
    dplyr::left_join(counts, by = hrvar) %>%
    dplyr::relocate(.data$n, .after = dplyr::all_of(hrvar))

  list(table = surv_tbl, counts = counts)
}


#' @title Kaplan–Meier Survival Curve (Visualization)
#'
#' @description
#' Renders a Kaplan–Meier step curve by group from a long-format survival table.
#'
#' @param data Long survival table produced by `create_survival_calc()`.
#' @param hrvar Character. Group column name in `data`.
#' @param title,subtitle Character. Plot annotations.
#' @param caption Character string for the plot caption. Typically the output
#'   of `extract_date_range(data, return = "text")`, as constructed by
#'   `create_survival()`. Defaults to `NULL` (no caption).
#'
#' @return ggplot object.
#'
#' @export
create_survival_viz <- function(data,
                                hrvar = "group",
                                title = "Survival Curve",
                                subtitle = "Kaplan\u2013Meier estimate",
                                caption = NULL){

  ggplot2::ggplot(
    data,
    ggplot2::aes(
      x = .data$time,
      y = .data$survival,
      colour = .data[[hrvar]],
      group = .data[[hrvar]]
    )
  ) +
    ggplot2::geom_step(linewidth = 0.8, na.rm = TRUE) +
    ggplot2::scale_y_continuous(limits = c(0, 1)) +
    ggplot2::labs(
      x = "Time",
      y = "Survival probability",
      colour = NULL,
      title = title,
      subtitle = subtitle,
      caption = caption
    ) +
    .theme_wpa_safe()
}

# =========================
# Internal helpers (file-local)
# =========================

.coerce_event <- function(x){

  if(is.logical(x)) return(as.integer(x))

  if(is.numeric(x)){

    ok01 <- x %in% c(0, 1) | is.na(x)
    if(all(ok01)) return(as.integer(x))

    if(all(x >= 0 | is.na(x))) return(as.integer(x > 0))

    return(rep(NA_integer_, length(x)))
  }

  if(is.character(x)){
    xl <- tolower(x)
    return(ifelse(xl %in% c("1", "true", "t", "yes", "y"), 1L,
                  ifelse(xl %in% c("0", "false", "f", "no", "n"), 0L, NA_integer_)))
  }

  rep(NA_integer_, length(x))
}

.km_curve <- function(durations, events){

  d <- as.numeric(durations)
  e <- as.integer(events)

  ok <- !is.na(d) & !is.na(e)
  d <- d[ok]
  e <- e[ok]

  n <- length(d)

  if(n == 0){
    return(data.frame(
      time = numeric(0),
      at_risk = integer(0),
      events = integer(0),
      survival = numeric(0),
      check.names = FALSE
    ))
  }

  timeline <- sort(unique(d))
  k        <- length(timeline)

  # Map each observation to its position in the sorted timeline — O(n).
  # tabulate() then counts in a single pass — O(n).
  # This replaces the previous O(n * k) loop that called sum(d >= t) and
  # sum(d == t & e == 1L) for every unique time point.
  idx          <- match(d, timeline)
  all_counts   <- tabulate(idx, nbins = k)          # total obs (events + censorings) per time
  event_counts <- tabulate(idx[e == 1L], nbins = k) # events only per time

  # at_risk[i] = n minus all observations that occurred strictly before t_i.
  # Equivalent to n - cumsum(all_counts)[i-1], with a leading zero for i=1.
  at_risk_seq <- as.integer(n - c(0L, cumsum(all_counts)[-k]))

  # Kaplan–Meier product-limit: O(k) loop, purely arithmetic.
  S    <- 1.0
  surv <- numeric(k)
  for(i in seq_len(k)){
    if(at_risk_seq[i] > 0L) S <- S * (1 - event_counts[i] / at_risk_seq[i])
    surv[i] <- S
  }

  # Prepend t = 0 anchor: everyone is at risk, survival = 1
  data.frame(
    time     = c(0, timeline),
    at_risk  = c(as.integer(n), at_risk_seq),
    events   = c(0L, as.integer(event_counts)),
    survival = c(1.0, surv),
    check.names = FALSE
  )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

# Basic functionality tests ---------------------------------------------------------------

test_that("create_survival returns a ggplot when return = 'plot'", {

  test_data <- data.frame(
    PersonId = 1:50,
    time = runif(50, 1, 100),
    event = sample(0:1, 50, replace = TRUE),
    group = sample(c("A", "B"), 50, replace = TRUE)
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "plot"
  )

  expect_s3_class(result, "ggplot")
})

test_that("create_survival returns a data frame when return = 'table'", {

  test_data <- data.frame(
    PersonId = 1:50,
    time = runif(50, 1, 100),
    event = sample(0:1, 50, replace = TRUE),
    group = sample(c("A", "B"), 50, replace = TRUE)
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Check expected columns
  expect_true("time" %in% names(result))
  expect_true("survival" %in% names(result))
  expect_true("at_risk" %in% names(result))
  expect_true("events" %in% names(result))
  expect_true("n" %in% names(result))
})

test_that("create_survival works with overall curve (no grouping)", {

  test_data <- data.frame(
    PersonId = 1:30,
    time = runif(30, 1, 50),
    event = sample(0:1, 30, replace = TRUE)
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = NULL,
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true("group" %in% names(result))
  expect_equal(unique(result$group), "Overall")
})

# Event coercion tests --------------------------------------------------------------------

test_that("create_survival handles logical event column", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = 1:20,
    event = sample(c(TRUE, FALSE), 20, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(nrow(result) > 0)
})

test_that("create_survival handles numeric 0/1 event column", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = 1:20,
    event = sample(0:1, 20, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(nrow(result) > 0)
})

test_that("create_survival handles positive numeric event column", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = 1:20,
    event = sample(c(0, 2, 5), 20, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(nrow(result) > 0)
})

test_that("create_survival handles character event column", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = 1:20,
    event = sample(c("yes", "no"), 20, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(nrow(result) > 0)
})

test_that("create_survival handles mixed character formats", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = 1:20,
    event = c(rep("true", 5), rep("false", 5), rep("1", 5), rep("0", 5)),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_true(nrow(result) > 0)
})

# Privacy filtering tests -----------------------------------------------------------------

test_that("create_survival respects mingroup threshold", {

  test_data <- data.frame(
    PersonId = 1:15,
    time = 1:15,
    event = sample(0:1, 15, replace = TRUE),
    group = c(rep("A", 3), rep("B", 12))  # A has only 3, B has 12
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 5,
    return = "table"
  )

  # Only group B should pass threshold
  expect_true(all(result$group == "B"))
  expect_false("A" %in% result$group)
})

test_that("create_survival returns empty table when no groups meet mingroup", {

  test_data <- data.frame(
    PersonId = 1:8,
    time = 1:8,
    event = sample(0:1, 8, replace = TRUE),
    group = c(rep("A", 4), rep("B", 4))
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 10,
    return = "table"
  )

  expect_equal(nrow(result), 0)
})

# Edge cases and Kaplan-Meier calculation -------------------------------------------------

test_that("create_survival handles all events scenario", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = rep(1, 10),  # All have events
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Survival should decrease to 0
  expect_equal(min(result$survival), 0)
})

test_that("create_survival handles no events scenario", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = rep(0, 10),  # No events
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_s3_class(result, "data.frame")

  # Survival should remain at 1
  expect_true(all(result$survival == 1))
})

test_that("create_survival survival probabilities are between 0 and 1", {

  test_data <- data.frame(
    PersonId = 1:50,
    time = runif(50, 1, 100),
    event = sample(0:1, 50, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  expect_true(all(result$survival >= 0 & result$survival <= 1))
})

test_that("create_survival survival is non-increasing", {

  test_data <- data.frame(
    PersonId = 1:30,
    time = 1:30,
    event = sample(0:1, 30, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  # Survival should be non-increasing
  diffs <- diff(result$survival)
  expect_true(all(diffs <= 0))
})

test_that("create_survival at_risk is non-increasing", {

  test_data <- data.frame(
    PersonId = 1:30,
    time = 1:30,
    event = sample(0:1, 30, replace = TRUE),
    group = "A"
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1,
    return = "table"
  )

  # At risk should be non-increasing
  diffs <- diff(result$at_risk)
  expect_true(all(diffs <= 0))
})

# na.rm parameter tests -------------------------------------------------------------------

test_that("create_survival with na.rm = TRUE removes NA rows", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = c(1:15, rep(NA, 5)),
    event = c(rep(1, 10), rep(0, 10)),
    group = "A"
  )

  # Should not error with na.rm = TRUE
  expect_silent(
    result <- create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      na.rm = TRUE,
      return = "table"
    )
  )

  expect_s3_class(result, "data.frame")
})

test_that("create_survival with na.rm = FALSE keeps NA rows (but they get filtered in coercion)", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = c(1:15, rep(NA, 5)),
    event = c(rep(1, 10), rep(0, 10)),
    group = "A"
  )

  # With na.rm = FALSE, NAs still get filtered in coercion step
  expect_warning(
    result <- create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      na.rm = FALSE,
      return = "table"
    ),
    "row\\(s\\) dropped"
  )

  expect_s3_class(result, "data.frame")
})

# Warning tests ---------------------------------------------------------------------------

test_that("create_survival warns when coercion drops rows", {

  test_data <- data.frame(
    PersonId = 1:20,
    time = c(1:15, "invalid", "bad", "text", "here", "!"),
    event = rep(1, 20),
    group = "A"
  )

  expect_warning(
    result <- create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      return = "table"
    ),
    "row\\(s\\) dropped due to NA values"
  )
})

test_that("create_survival warns with correct count of dropped rows", {

  test_data <- data.frame(
    PersonId = 1:25,
    time = c(1:20, rep(NA, 5)),
    event = rep(1, 25),
    group = "A"
  )

  expect_warning(
    result <- create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      na.rm = FALSE,  # Need na.rm = FALSE to trigger coercion warning
      return = "table"
    ),
    "5 row\\(s\\) dropped"
  )
})

# Error handling tests --------------------------------------------------------------------

test_that("create_survival errors on missing time_col", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "NonExistent",
      event_col = "event",
      hrvar = "group",
      mingroup = 1
    ),
    "not included in the input data frame"
  )
})

test_that("create_survival errors on missing event_col", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "time",
      event_col = "NonExistent",
      hrvar = "group",
      mingroup = 1
    ),
    "not included in the input data frame"
  )
})

test_that("create_survival errors on missing hrvar", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "NonExistent",
      mingroup = 1
    ),
    "not included in the input data frame|not found in data"
  )
})

test_that("create_survival errors on invalid mingroup", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = -1
    ),
    "valid input for `mingroup`"
  )
})

test_that("create_survival errors on invalid na.rm", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      na.rm = "yes"
    ),
    "valid input for `na.rm`"
  )
})

test_that("create_survival errors on invalid return", {

  test_data <- data.frame(
    PersonId = 1:10,
    time = 1:10,
    event = sample(0:1, 10, replace = TRUE),
    group = "A"
  )

  expect_error(
    create_survival(
      data = test_data,
      time_col = "time",
      event_col = "event",
      hrvar = "group",
      mingroup = 1,
      return = "invalid"
    ),
    "valid input for `return`"
  )
})

# Helper function tests -------------------------------------------------------------------

test_that("create_survival_calc returns list with correct structure", {

  test_data <- data.frame(
    PersonId = 1:30,
    time = runif(30, 1, 50),
    event = sample(0:1, 30, replace = TRUE),
    group = sample(c("A", "B"), 30, replace = TRUE)
  )

  result <- create_survival_calc(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1
  )

  expect_type(result, "list")
  expect_true("table" %in% names(result))
  expect_true("counts" %in% names(result))
  expect_s3_class(result$table, "data.frame")
  expect_s3_class(result$counts, "data.frame")
})

test_that("create_survival_viz returns ggplot", {

  test_data <- data.frame(
    PersonId = 1:30,
    time = runif(30, 1, 50),
    event = sample(0:1, 30, replace = TRUE),
    group = "A"
  )

  calc_result <- create_survival_calc(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 1
  )

  viz_result <- create_survival_viz(
    data = calc_result$table,
    hrvar = "group"
  )

  expect_s3_class(viz_result, "ggplot")
})

# Multiple groups test --------------------------------------------------------------------

test_that("create_survival works with multiple groups", {

  test_data <- data.frame(
    PersonId = 1:60,
    time = runif(60, 1, 100),
    event = sample(0:1, 60, replace = TRUE),
    group = rep(c("A", "B", "C"), each = 20)
  )

  result <- create_survival(
    data = test_data,
    time_col = "time",
    event_col = "event",
    hrvar = "group",
    mingroup = 5,
    return = "table"
  )

  expect_s3_class(result, "data.frame")
  expect_equal(length(unique(result$group)), 3)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify Usage Segments based on a metric
#'   
#' @description `r lifecycle::badge('experimental')`
#'
#' This function identifies users into usage segments based on their usage
#' volume and consistency. The segments 'Power Users', 'Habitual Users', 'Novice
#' Users', 'Low Users', and 'Non-users' are created. There are two versions, one
#' based on a rolling 12-week average (`version = "12w"`) and the other on a
#' rolling 4-week average (`version = "4w"`). While a main use case is for
#' Copilot metrics e.g. 'Total_Copilot_actions', this function can be applied to
#' other metrics, such as 'Chats_sent'.
#'
#' @details
#' There are three ways to use this function for usage segments classification:
#' 
#' 1. **12-week version** (`version = "12w"`): Based on a rolling 12-week period
#' 2. **4-week version** (`version = "4w"`): Based on a rolling 4-week period  
#' 3. **Custom parameters** (`version = NULL`): Based on user-defined parameters
#' 
#' This function assumes that the input dataset is grouped at the weekly level 
#' by the `MetricDate` column.
#' 
#' The definitions of the segments as per the 12-week definition are
#' as follows:
#' 
#'   - **Power User**: Averaging 15+ weekly actions (customizable via `power_thres`) and any actions in at least 
#'   9 out of past 12 weeks
#'   - **Habitual User**: Any action in at least 9 out of past 12 weeks
#'   - **Novice User**: Averaging at least one action over the last 12 weeks
#'   - **Low User**: Any action in the past 12 weeks
#'   - **Non-user**: No actions in the past 12 weeks
#'   
#' The definitions of the segments as per the 4-week definition are
#' as follows:
#' 
#'  - **Power User**: Averaging 15+ weekly actions (customizable via `power_thres`) and any actions in at least 4
#'   out of past 4 weeks
#'  - **Habitual User**: Any action in at least 4 out of past 4 weeks
#'  - **Novice User**: Averaging at least one action over the last 4 weeks
#'  - **Low User**: Any action in the past 4 weeks
#'  - **Non-user**: No actions in the past 4 weeks
#'  
#' When using custom parameters (`version = NULL`), you must provide values for
#' `threshold`, `width`, `max_window`, and optionally `power_thres`. The segment definitions become:
#' 
#'  - **Power User**: Minimum of `threshold` actions per week in at least `width` 
#'  out of past `max_window` weeks, with 15+ average weekly actions (customizable via `power_thres`)
#'  - **Habitual User**: Minimum of `threshold` actions per week in at least 
#'  `width` out of past `max_window` weeks
#'  - **Novice User**: Average of at least one action over the last `max_window` weeks
#'  - **Low User**: Any action in the past `max_window` weeks
#'  - **Non-user**: No actions in the past `max_window` weeks
#'   
#' @param data A data frame with a Person query containing the metric to be
#'   classified. The data frame must include a `PersonId` column and a
#'   `MetricDate` column.
#' @param metric A string representing the name of the metric column to be
#'   classified. This parameter is used when a single column represents the
#'   metric.
#' @param metric_str A character vector representing the names of multiple
#'   columns to be aggregated for calculating a target metric, using row sum for
#'   aggregation. This is used when `metric` is not provided.
#' @param version A string indicating the version of the classification to be
#'   used. Valid options are `"12w"` for a 12-week rolling average, `"4w"`
#'   for a 4-week rolling average, or `NULL` when using custom parameters. Defaults to `"12w"`.
#' @param threshold Numeric value specifying the minimum number of times the
#'   metric sum up to in order to be a valid count. A 'greater than or equal to' 
#'   logic is used. Only used when `version` is `NULL`.
#' @param width Integer specifying the number of qualifying counts to consider
#'   for a habit. Only used when `version` is `NULL`.
#' @param max_window Integer specifying the maximum unit of dates to consider a
#'   qualifying window for a habit. Only used when `version` is `NULL`.
#' @param power_thres Numeric value specifying the minimum weekly average 
#'   actions required to be classified as a 'Power User'. Defaults to 15.
#' @param return A string indicating what to return from the function. Valid
#'   options are: 
#'   - `"data"`: Returns the data frame with usage segments.
#'   - `"plot"`: Returns a plot of the usage segments.
#'   - `"table"`: Returns a summary table with usage segments as columns.
#'   
#' @return Depending on the `return` parameter, either a data frame with usage 
#'   segments or a plot visualizing the segments over time. If `"data"` is passed
#'   to `return`, the following additional columns are appended:
#'   
#'   - When `version` is `"12w"` or `"4w"`:
#'     - `IsHabit12w`: Indicates whether the user has a habit based on the 12-week 
#'     rolling average.
#'     - `IsHabit4w`: Indicates whether the user has a habit based on the 4-week
#'     rolling average.
#'     - `UsageSegments_12w`: The usage segment classification based on the 
#'     12-week rolling average.
#'     - `UsageSegments_4w`: The usage segment classification based on the 4-week 
#'     rolling average.
#'   - When `version` is `NULL`:
#'     - `IsHabit`: Indicates whether the user has a habit based on the provided
#'     parameters.
#'     - `UsageSegments`: The usage segment classification based on the provided
#'     parameters.
#'   - `IsHabit12w`: Indicates whether the user has a habit based on the 12-week 
#'   rolling average.
#'   - `IsHabit4w`: Indicates whether the user has a habit based on the 4-week
#'   rolling average.
#'   - `UsageSegments_12w`: The usage segment classification based on the 
#'   12-week rolling average.
#'   - `UsageSegments_4w`: The usage segment classification based on the 4-week 
#'   rolling average.
#'   
#'   If `"table"` is passed to `return`, a summary table is returned with one row
#'   per `MetricDate` and usage segments as columns containing percentages. The 
#'   table includes:
#'   - `MetricDate`: The date of the metric
#'   - Segment columns (in order): `Non-user`, `Low User`, `Novice User`, 
#'     `Habitual User`, `Power User` (only segments present in the data are included)
#'   - `n`: The total number of distinct persons for that date
#'   
#'  @import slider slide_dbl
#'  @import tidyr  
#'   
#' @examples
#' # Example usage with a single metric column
#' identify_usage_segments(
#'   data = pq_data,
#'   metric = "Emails_sent",
#'   version = "12w",
#'   return = "plot"
#' )
#' 
#' # Example usage with multiple metric columns
#' identify_usage_segments(
#'   data = pq_data,
#'   metric_str = c(
#'     "Copilot_actions_taken_in_Teams",
#'     "Copilot_actions_taken_in_Outlook",
#'     "Copilot_actions_taken_in_Excel",
#'     "Copilot_actions_taken_in_Word",
#'     "Copilot_actions_taken_in_Powerpoint"
#'   ),
#'   version = "4w",
#'   return = "plot"
#' )
#' 
#' # Example usage with custom parameters
#' identify_usage_segments(
#'   data = pq_data,
#'   metric = "Emails_sent",
#'   version = NULL,
#'   threshold = 2,
#'   width = 5,
#'   max_window = 8,
#'   return = "plot"
#' )
#' 
#' # Example usage with custom power user threshold
#' identify_usage_segments(
#'   data = pq_data,
#'   metric = "Emails_sent",
#'   version = "12w",
#'   power_thres = 20,
#'   return = "plot"
#' )
#' 
#' # Return summary table
#' identify_usage_segments(
#'   data = pq_data,
#'   metric = "Emails_sent",
#'   version = "12w",
#'   return = "table"
#' )
#' @export
identify_usage_segments <- function(
    data,
    metric = NULL,
    metric_str = NULL,
    version = "12w",
    threshold = NULL,
    width = NULL,
    max_window = NULL,
    power_thres = 15,
    return = "data"
    ) {
  
  if(is.null(metric) & is.null(metric_str)){
    stop("Please provide either a metric or a metric_str")
  } else if(!is.null(metric) & !is.null(metric_str)){
    stop("Please provide either a metric or a metric_str, not both")
  }
  
  # Validate version and custom parameters
  if(!is.null(version) && !version %in% c("12w", "4w")){
    stop("Please provide either `12w`, `4w`, or NULL to `version`")
  }
  
  if(is.null(version)){
    if(is.null(threshold) || is.null(width) || is.null(max_window)){
      stop("When `version` is NULL, please provide values for `threshold`, `width`, and `max_window`")
    }
  }
  
  # Define warning message
  na_warning_msg <- "NAs detected in the metric variable. Consider filtering or imputing the missing values before running."
  
  if(is.null(metric_str)){
    # Check for NA values in the single metric column before creating prep_df
    if(any(is.na(data[[metric]]))){
      warning(na_warning_msg)
    }
    
    prep_df <- data %>%
      mutate(target_metric = !!sym(metric))
  } else if(is.null(metric)){
    # Check for NA values in any of the metric_str columns before aggregation
    if(any(is.na(data[, metric_str, drop = FALSE]))){
      warning(na_warning_msg)
    }
    
    prep_df <- data %>%
      mutate(target_metric =
               select(., all_of(metric_str)) %>%
               rowSums(., na.rm = TRUE))
  }
  
  # Create rolling averages
  prep_df_2 <-
    prep_df %>%
    group_by(PersonId) %>%
    # Rolling averages of the metric from the last 12 weeks
    mutate(
      target_metric_l12w = slider::slide_dbl(
        target_metric,
        mean,
        na.rm = TRUE,
        .before = 11,
        .after = 0
      )) %>%
    # Rolling averages - last 4 weeks
    mutate(
      target_metric_l4w = slider::slide_dbl(
        target_metric,
        mean,
        na.rm = TRUE,
        .before = 3,
        .after = 0
      )) %>%
    ungroup()
  
  # Create habits based on provided parameters or default versions
  if(is.null(version)){
    # Create habits based on custom parameters
    habit_df <-
      prep_df_2 %>%
      identify_habit(
        metric = "target_metric",
        threshold = threshold,
        width = width,
        max_window = max_window,
        return = "data"
      ) %>%
      select(PersonId, MetricDate, IsHabit)
    
    # Calculate the appropriate metric window average based on max_window
    # Add a new column to prep_df_2 for the custom window average
    prep_df_custom <- 
      prep_df_2 %>%
      group_by(PersonId) %>%
      # Rolling averages for the custom window
      mutate(
        target_metric_custom = slider::slide_dbl(
          target_metric,
          mean,
          na.rm = TRUE,
          .before = max_window - 1,
          .after = 0
        )
      ) %>%
      ungroup()
    
    # Main data frame with custom Usage Segments
    main_us_df <-
      prep_df_custom %>%
      left_join(habit_df, by = c("PersonId", "MetricDate")) %>%
      mutate(
        UsageSegments = case_when(
          IsHabit == TRUE & target_metric_custom >= power_thres ~ "Power User",
          IsHabit == TRUE ~ "Habitual User",
          target_metric_custom >= 1 ~ "Novice User",
          target_metric_custom > 0 ~ "Low User",
          target_metric_custom == 0 ~ "Non-user",
          TRUE ~ NA_character_
        ) %>%
          factor(levels = c(
            "Power User",
            "Habitual User",
            "Novice User",
            "Low User",
            "Non-user"
          ))
      )
  } else {
    # Create habits based on 12 weeks
    habit_df_12w <-
      prep_df_2 %>%
      identify_habit(
        metric = "target_metric",
        threshold = 1,
        width = 9,
        max_window = 12,
        return = "data"
      ) %>%
      rename(IsHabit12w = "IsHabit") %>%
      select(PersonId, MetricDate, IsHabit12w)
    
    # Create habits based on 4 weeks
    habit_df_4w <-
      prep_df_2 %>%
      identify_habit(
        metric = "target_metric",
        threshold = 1,
        width = 4,
        max_window = 4,
        return = "data"
      ) %>%
      rename(IsHabit4w = "IsHabit") %>%
      select(PersonId, MetricDate, IsHabit4w)
    
    # Main data frame with Usage Segments
    main_us_df <-
      prep_df_2 %>%
      left_join(habit_df_4w, by = c("PersonId", "MetricDate")) %>%
      left_join(habit_df_12w, by = c("PersonId", "MetricDate")) %>%
      mutate(
        UsageSegments_12w = case_when(
          IsHabit12w == TRUE & target_metric_l12w >= power_thres ~ "Power User",
          IsHabit12w == TRUE ~ "Habitual User",
          target_metric_l12w >= 1 ~ "Novice User",
          target_metric_l12w > 0 ~ "Low User",
          target_metric_l12w == 0 ~ "Non-user",
          TRUE ~ NA_character_
        ) %>%
          factor(levels = c(
            "Power User",
            "Habitual User",
            "Novice User",
            "Low User",
            "Non-user"
          ))
      ) %>%
      mutate(
        UsageSegments_4w = case_when(
          IsHabit4w == TRUE & target_metric_l4w >= power_thres ~ "Power User",
          IsHabit4w == TRUE ~ "Habitual User",
          target_metric_l4w >= 1 ~ "Novice User",
          target_metric_l4w > 0 ~ "Low User",
          target_metric_l4w == 0 ~ "Non-user",
          TRUE ~ NA_character_
        ) %>%
          factor(levels = c(
            "Power User",
            "Habitual User",
            "Novice User",
            "Low User",
            "Non-user"
          ))
      )
  }
  
  if(return == "data"){
    
    main_us_df
    
  } else if(return == "plot"){
    
    if(is.null(version)){
      main_us_df %>%
        plot_ts_us(
          data = ., 
          metric = metric,
          cus = "UsageSegments", 
          caption = "",
          threshold = threshold,
          width = width,
          max_window = max_window,
          power_thres = power_thres,
          version = NULL
        )
    } else if(version == "12w"){
      main_us_df %>%
        plot_ts_us(
          metric = metric,
          cus = "UsageSegments_12w",
          caption = "",
          power_thres = power_thres,
          version = "12w",
          max_window = 12
        )
    } else if(version == "4w"){
      main_us_df %>%
        plot_ts_us(
          metric = metric,
          cus = "UsageSegments_4w",
          caption = "",
          power_thres = power_thres,
          version = "4w",
          max_window = 4
        )
    } else {
      stop("Please provide either `12w`, `4w`, or NULL to `version`")
    }
    
  } else if(return == "table"){
    
    # Determine which usage segments column to use based on version
    if(is.null(version)){
      segments_col <- "UsageSegments"
      caption_text <- paste0(
        "Usage segments summary table (custom parameters - ",
        "threshold: ", threshold, ", width: ", width, ", max window: ", max_window, ", power threshold: ", power_thres, ")"
      )
    } else if(version == "12w"){
      segments_col <- "UsageSegments_12w"
      caption_text <- "Usage segments summary table (12-week version)"
    } else if(version == "4w"){
      segments_col <- "UsageSegments_4w"
      caption_text <- "Usage segments summary table (4-week version)"
    } else {
      stop("Please provide either `12w`, `4w`, or NULL to `version`")
    }
    
    # Print diagnostic message
    message(caption_text)
    
    # Create summary table
    # Define the desired column order for segments
    segment_order <- c("Non-user", "Low User", "Novice User", "Habitual User", "Power User")
    
    summary_table <- main_us_df %>%
      group_by(MetricDate, !!sym(segments_col)) %>%
      summarise(segment_count = n_distinct(PersonId), .groups = "drop") %>%
      group_by(MetricDate) %>%
      mutate(
        pct = segment_count / sum(segment_count),
        n = sum(segment_count)
      ) %>%
      ungroup() %>%
      select(-segment_count) %>%
      pivot_wider(
        names_from = !!sym(segments_col),
        values_from = pct,
        values_fill = 0
      )
    
    # Reorder columns: MetricDate, then segments in logical order, then n
    # Only include segments that are actually present in the data
    available_segments <- intersect(segment_order, names(summary_table))
    column_order <- c("MetricDate", available_segments, "n")
    
    summary_table %>%
      select(all_of(column_order))
      
  } else {
    stop("Please enter a valid input for `return`. Valid options are 'data', 'plot', or 'table'.")
  }
}


#' @title Plot Usage Segments over time
#' 
#' @description Returns a vertical stacked bar plot that displays the proportion
#'   of the Usage Segments over time. This visualization helps to understand the
#'   distribution of user segments across different time periods. While a main
#'   use case is for Copilot metrics, this function can be applied to other
#'   metrics, such as 'Chats_sent'.
#' 
#' @param data A data frame with a column containing the Usage Segments, denoted
#'   by `cus`. The data frame must also include a `MetricDate` column.
#' @param metric A string representing the name of the metric column to be
#'   classified.
#' @param cus A string representing the name of the column containing the usage
#'   segment classifications (e.g., "UsageSegments_12w").
#' @param caption A string representing the caption for the plot. This is
#'   typically used to provide additional context or information about the
#'   visualization.
#' @param threshold Numeric value specifying the minimum threshold for a valid
#'   count. Only used when creating custom parameter captions. Defaults to NULL.
#' @param width Integer specifying the number of qualifying counts to consider
#'   for a habit. Only used when creating custom parameter captions. Defaults to
#'   NULL.
#' @param max_window Integer specifying the maximum window to consider for a
#'   habit. Only used when creating custom parameter captions. Defaults to NULL.
#' @param power_thres Numeric value specifying the minimum weekly average 
#'   actions required to be classified as a 'Power User'. Defaults to 15.
#' @param version A string indicating the version of the classification. Valid
#'   options are "12w", "4w", or NULL for custom parameters. Used to determine
#'   which definitions to show in the caption.
#' 
#' @return A ggplot object representing the stacked bar plot of usage segments.
#' 
#' @export

plot_ts_us <- function(data,
                       metric,
                       cus,
                       caption,
                       threshold = NULL,
                       width = NULL,
                       max_window = NULL,
                       power_thres = 15,
                       version = NULL) {
  
  # Create detailed captions based on version
  date_text <- extract_date_range(data, return = "text")
  
  # Usage Segments text
  if(is.null(metric)){
    
    us_text <- "Usage Segments"
    
  } else {
    
    us_text <- paste("Usage Segments for", us_to_space(metric))
    
  }
  
  if(!is.null(threshold) && !is.null(width) && !is.null(max_window)){
    # Custom parameters caption
    custom_caption <- paste0(
      "Usage Segments - Definition:\n",
      "Power User: Minimum of ", threshold, " actions per week in at least ", width, " out of ", max_window, " weeks, with ", power_thres, "+ average weekly actions\n",
      "Habitual User: Minimum of ", threshold, " actions per week in at least ", width, " out of ", max_window, " weeks\n",
      "Novice User: Average of at least one action over ", max_window, " weeks\n",
      "Low User: At least one action in the last ", max_window, " weeks\n",
      "\n", date_text
    )
    
    final_caption <- custom_caption
    plot_title <- plot_title <- paste(us_text, "- Custom Parameters")
    plot_subtitle <- "Proportion of users in each segment based on custom definition"
  } else if(version == "12w"){
    # 12-week version caption
    caption_12w <- paste0(
      "Usage Segments - Definition:\n",
      "Power User: ", power_thres, "+ average weekly actions and any actions in at least 9 out of past 12 weeks\n",
      "Habitual User: Any action in at least 9 out of past 12 weeks\n",
      "Novice User: Average of at least one action over the last 12 weeks\n",
      "Low User: Any action in the past 12 weeks\n",
      "\n", date_text
    )
    
    final_caption <- caption_12w
    plot_title <- paste(us_text, "- 12 Weeks")
    plot_subtitle <- "Proportion of users in each segment based on 12-week rolling average"
  } else if(version == "4w"){
    # 4-week version caption
    caption_4w <- paste0(
      "Usage Segments - Definition:\n",
      "Power User: ", power_thres, "+ average weekly actions and any actions in at least 4 out of past 4 weeks\n",
      "Habitual User: Any action in at least 4 out of past 4 weeks\n",
      "Novice User: Average of at least one action over the last 4 weeks\n",
      "Low User: Any action in the past 4 weeks\n",
      "\n", date_text
    )
    
    final_caption <- caption_4w
    plot_title <- paste(us_text, "- 4 Weeks")
    plot_subtitle <- "Proportion of users in each segment based on 4-week rolling average"
  } else {
    # Fallback to provided caption
    final_caption <- caption
    plot_title <- paste(us_text, "- 12 Weeks")
    plot_subtitle <- "Proportion of users in each segment"
  }
  
  
  plot_data <- data
  
  # Filter out the first max_window periods for plotting if max_window is provided
  if(!is.null(max_window) && max_window > 0) {
    unique_dates <- sort(unique(data$MetricDate))
    if(length(unique_dates) > max_window) {
      # Keep only dates after the first max_window periods
      dates_to_keep <- unique_dates[(max_window + 1):length(unique_dates)]
      plot_data <- data %>% filter(MetricDate %in% dates_to_keep)
    }
  }
  
  plot_data %>%
    count(MetricDate, !!sym(cus)) %>%
    group_by(MetricDate) %>%
    mutate(prop = n / sum(n)) %>%
    ggplot(aes(x = MetricDate, y = prop, fill = !!sym(cus))) +
    geom_bar(stat = "identity") +
    scale_y_continuous(labels = scales::percent) +
    scale_fill_manual(values = c("#0c336e", "#1c66b0", "#80baea", "grey", "#808080")) +
    labs(
      title = plot_title,
      subtitle = plot_subtitle,
      x = "Date",
      y = "Proportion of users",
      fill = "Usage Segment",
      caption = final_caption
    ) +
    theme_wpa_basic() +
    theme(plot.caption = element_text(hjust = 0))
  
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)

skip_if_not_installed("dplyr")
skip_if_not_installed("tidyr")
skip_if_not_installed("slider")

library(dplyr)
library(tidyr)
library(slider)

# Helper function to create mock data
create_mock_data <- function(
    persons = c("A", "B", "C"),
    weeks = 4,
    values = NULL
) {
  n_persons <- length(persons)
  dates <- seq(as.Date("2024-01-01"), by = "week", length.out = weeks)
  
  if (is.null(values)) {
    values <- rep(sample(0:30, n_persons * weeks, replace = TRUE), 1)
  }
  
  data.frame(
    PersonId = rep(persons, each = weeks),
    MetricDate = rep(dates, n_persons),
    Total_actions = values,
    stringsAsFactors = FALSE
  )
}

# Expected segment names for validation
expected_segments <- c("Power User", "Habitual User", "Novice User", "Low User", "Non-user")

test_that("identify_usage_segments returns table correctly", {
  mock_data <- create_mock_data(
    values = c(0, 5, 10, 20, 1, 8, 15, 25, 0, 0, 2, 5)
  )
  
  # Test table return for 12w version
  suppressMessages({
    result_12w <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "table"
    )
  })
  
  # Test table return for 4w version
  suppressMessages({
    result_4w <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "4w",
      return = "table"
    )
  })
  
  # Basic checks

  expect_true(is.data.frame(result_12w))
  expect_true(is.data.frame(result_4w))
  expect_true("MetricDate" %in% names(result_12w))
  expect_true("MetricDate" %in% names(result_4w))
  expect_true("n" %in% names(result_12w))
  expect_true("n" %in% names(result_4w))
  
  # Check that usage segments columns exist
  expect_true(any(expected_segments %in% names(result_12w)))
  expect_true(any(expected_segments %in% names(result_4w)))
})

test_that("identify_usage_segments prints message for table return", {
  mock_data <- create_mock_data(
    persons = c("A", "B"),
    weeks = 2,
    values = c(5, 10, 15, 20)
  )
  
  # Test that message is printed for 12w
  expect_message(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "table"
    ),
    "Usage segments summary table \\(12-week version\\)"
  )
  
  # Test that message is printed for 4w
  expect_message(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "4w",
      return = "table"
    ),
    "Usage segments summary table \\(4-week version\\)"
  )
})

test_that("identify_usage_segments validates return parameter", {
  mock_data <- create_mock_data(
    persons = c("A", "B"),
    weeks = 2,
    values = c(5, 10, 15, 20)
  )
  
  # Test invalid return parameter
  expect_error(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "invalid"
    ),
    "Please enter a valid input for `return`. Valid options are 'data', 'plot', or 'table'."
  )
})

test_that("identify_usage_segments returns table correctly with custom parameters", {
  # Create mock data with more weeks to test custom parameters
  mock_data <- create_mock_data(
    weeks = 8,
    values = c(
      0, 5, 10, 20, 15, 12, 8, 18,   # Person A
      1, 8, 15, 25, 20, 18, 22, 30,  # Person B
      0, 0, 2, 5, 3, 1, 0, 4         # Person C
    )
  )
  
  # Test table return with custom parameters
  suppressMessages({
    result_custom <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 3,
      width = 5,
      max_window = 8,
      return = "table"
    )
  })
  
  # Basic checks
  expect_true(is.data.frame(result_custom))
  expect_true("MetricDate" %in% names(result_custom))
  expect_true("n" %in% names(result_custom))
  
  # Check that usage segments columns exist
  expect_true(any(expected_segments %in% names(result_custom)))
  
  # Check that proportions sum to 1 for each date (allowing for rounding errors)
  segment_cols <- names(result_custom)[names(result_custom) %in% expected_segments]
  if (length(segment_cols) > 0) {
    row_sums <- rowSums(result_custom[segment_cols], na.rm = TRUE)
    expect_true(all(abs(row_sums - 1) < 0.001))
  }
})

test_that("identify_usage_segments prints custom parameters message for table return", {
  mock_data <- create_mock_data(
    persons = c("A", "B"),
    values = c(5, 10, 15, 20, 8, 12, 18, 25)
  )
  
  # Test that custom parameters message is printed
  expect_message(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 2,
      width = 3,
      max_window = 4,
      return = "table"
    ),
    "Usage segments summary table \\(custom parameters - threshold: 2, width: 3, max window: 4, power threshold: 15\\)"
  )
  
  # Test that custom parameters message includes custom power_thres
  expect_message(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 2,
      width = 3,
      max_window = 4,
      power_thres = 20,
      return = "table"
    ),
    "Usage segments summary table \\(custom parameters - threshold: 2, width: 3, max window: 4, power threshold: 20\\)"
  )
})

test_that("identify_usage_segments works with custom power_thres parameter", {
  # Create mock data with high values to test power user classification
  mock_data <- create_mock_data(
    values = c(
      20, 25, 30, 35,  # Person A: high usage
      10, 12, 8, 6,    # Person B: medium usage
      1, 2, 1, 3       # Person C: low usage
    )
  )
  
  # Test with default power_thres (15)
  suppressMessages({
    result_default <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "data"
    )
  })
  
  # Test with higher power_thres (25)
  suppressMessages({
    result_high <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      power_thres = 25,
      return = "data"
    )
  })
  
  # Test with lower power_thres (10)
  suppressMessages({
    result_low <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      power_thres = 10,
      return = "data"
    )
  })
  
  # Basic checks - all results should be data frames
  expect_true(is.data.frame(result_default))
  expect_true(is.data.frame(result_high))
  expect_true(is.data.frame(result_low))
  
  # Check that the results have the expected columns
  expect_true("UsageSegments_12w" %in% names(result_default))
  expect_true("UsageSegments_12w" %in% names(result_high))
  expect_true("UsageSegments_12w" %in% names(result_low))
  
  # All should have the same number of rows (same input data)
  expect_equal(nrow(result_default), nrow(result_high))
  expect_equal(nrow(result_high), nrow(result_low))
})

test_that("identify_usage_segments works with power_thres in custom parameters", {
  # Create mock data
  mock_data <- create_mock_data(
    persons = c("A", "B"),
    weeks = 6,
    values = c(
      20, 25, 18, 22, 30, 28,  # Person A: consistently high
      5, 8, 12, 6, 10, 9       # Person B: consistently low
    )
  )
  
  # Test custom parameters with custom power_thres
  suppressMessages({
    result_custom <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = NULL,
      threshold = 3,
      width = 4,
      max_window = 6,
      power_thres = 20,
      return = "data"
    )
  })
  
  # Basic checks
  expect_true(is.data.frame(result_custom))
  expect_true("UsageSegments" %in% names(result_custom))
  expect_true("PersonId" %in% names(result_custom))
  expect_true("MetricDate" %in% names(result_custom))
})

test_that("identify_usage_segments table returns correct n count and column order", {
  # Create mock data with one row per person per date
  mock_data <- data.frame(
    PersonId = c("A", "B", "C"),
    MetricDate = as.Date(rep("2024-01-01", 3)),
    Total_actions = c(10, 15, 5),
    stringsAsFactors = FALSE
  )
  
  # Test table return
  suppressMessages({
    result <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "table"
    )
  })
  
  # Check that n equals the number of distinct PersonIds (3)
  expect_equal(result$n[1], 3)
  
  # Check column order: MetricDate should be first, n should be last
  expect_equal(names(result)[1], "MetricDate")
  expect_equal(names(result)[length(names(result))], "n")
  
  # Check that segment columns are in the middle (between MetricDate and n)
  segment_cols <- names(result)[2:(length(names(result)) - 1)]
  expected_segments <- c("Non-user", "Low User", "Novice User", "Habitual User", "Power User")
  expect_true(all(segment_cols %in% expected_segments))
})

test_that("identify_usage_segments warns when NA values are present in metric", {
  # Create mock data with NA values in the metric
  mock_data <- data.frame(
    PersonId = rep(c("A", "B", "C"), each = 4),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", "2024-01-22")), 3),
    Total_actions = c(10, 15, NA, 20, 5, NA, 10, 15, 2, 3, 4, NA),
    stringsAsFactors = FALSE
  )
  
  # Skip if NA warning feature not available in current package version
  # This test validates the NA warning feature once it's deployed
  has_na_warning <- tryCatch({
    test_result <- suppressMessages(
      identify_usage_segments(
        data = mock_data,
        metric = "Total_actions",
        version = "12w",
        return = "data"
      )
    )
    FALSE
  }, warning = function(w) {
    grepl("NAs detected", w$message)
  })
  
  skip_if(!has_na_warning, "NA warning feature not available in installed package")
  
  # Test that warning is displayed when NAs are present
  expect_warning(
    identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "data"
    ),
    "NAs detected in the metric variable"
  )
})

test_that("identify_usage_segments table handles missing segments gracefully", {
  # Create mock data where all users are non-users (no actions)
  mock_data <- data.frame(
    PersonId = c("A", "B", "C"),
    MetricDate = as.Date(rep("2024-01-01", 3)),
    Total_actions = c(0, 0, 0),
    stringsAsFactors = FALSE
  )
  
  # Test table return - should not error even when only one segment is present
  suppressMessages({
    result <- identify_usage_segments(
      data = mock_data,
      metric = "Total_actions",
      version = "12w",
      return = "table"
    )
  })
  
  # Basic checks
  expect_true(is.data.frame(result))
  expect_true("MetricDate" %in% names(result))
  expect_true("n" %in% names(result))
  
  # Check that "Non-user" column exists and has value 1 (100%)
  expect_true("Non-user" %in% names(result))
  expect_equal(result$`Non-user`[1], 1)
  
  # Check that n equals 3
  expect_equal(result$n[1], 3)
  
  # Check column order is maintained: MetricDate first, n last
  expect_equal(names(result)[1], "MetricDate")
  expect_equal(names(result)[length(names(result))], "n")
})

test_that("identify_usage_segments does not warn when no NA values are present", {
  mock_data <- create_mock_data(
    persons = c("A", "B"),
    values = c(10, 15, 20, 25, 5, 8, 10, 12)
  )
  
  # Test that no warning is displayed when there are no NAs
  expect_no_warning(
    suppressMessages(
      identify_usage_segments(
        data = mock_data,
        metric = "Total_actions",
        version = "12w",
        return = "data"
      )
    )
  )
})

test_that("identify_usage_segments warns when NA values are present in metric_str", {
  # Create mock data with NA values in multiple metric columns
  mock_data <- data.frame(
    PersonId = rep(c("A", "B", "C"), each = 4),
    MetricDate = rep(as.Date(c("2024-01-01", "2024-01-08", "2024-01-15", "2024-01-22")), 3),
    Metric1 = c(5, 10, NA, 15, 3, NA, 5, 8, 1, 2, 3, NA),
    Metric2 = c(5, 5, 5, 5, 2, 2, NA, 7, 1, 1, 1, 1),
    stringsAsFactors = FALSE
  )
  
  # Skip if NA warning feature not available in current package version
  has_na_warning <- tryCatch({
    test_result <- suppressMessages(
      identify_usage_segments(
        data = mock_data,
        metric_str = c("Metric1", "Metric2"),
        version = "12w",
        return = "data"
      )
    )
    FALSE
  }, warning = function(w) {
    grepl("NAs detected", w$message)
  })
  
  skip_if(!has_na_warning, "NA warning feature not available in installed package")
  
  # Test that warning is displayed when NAs are present in metric_str columns
  expect_warning(
    identify_usage_segments(
      data = mock_data,
      metric_str = c("Metric1", "Metric2"),
      version = "12w",
      return = "data"
    ),
    "NAs detected in the metric variable"
  )
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Period comparison scatter plot for any two metrics
#'
#' @description
#' Returns two side-by-side scatter plots representing two selected metrics,
#' using colour to map an HR attribute and size to represent number of employees.
#' Returns a faceted scatter plot by default, with additional options
#' to return a summary table.
#'
#' @details
#' This is a general purpose function that powers all the functions
#' in the package that produce faceted scatter plots.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param hrvar HR Variable by which to split metrics. Accepts a character vector,
#' defaults to "Organization" but accepts any character vector, e.g. "LevelDesignation"
#' @param metric_x Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param metric_y Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param before_start Start date of "before" time period in YYYY-MM-DD
#' @param before_end End date of "before" time period in YYYY-MM-DD
#' @param after_start Start date of "after" time period in YYYY-MM-DD
#' @param after_end End date of "after" time period in YYYY-MM-DD
#' @param before_label String to specify a label for the "before" period. Defaults to "Period 1".
#' @param after_label String to specify a label for the "after" period. Defaults to "Period 2".
#' @param mingroup Numeric value setting the privacy threshold / minimum group size.
#' Defaults to 5.
#' @param return Character vector specifying what to return, defaults to "plot".
#' Valid inputs are "plot" and "table".
#'
#' @import dplyr
#' @import ggplot2
#'
#' @family Visualization
#' @family Flexible
#' @family Time-series
#'
#' @return
#' Returns a 'ggplot' object showing two scatter plots side by side representing
#' the two periods.
#'
#' @examples
#' # Return plot
#' create_period_scatter(pq_data,
#'                       hrvar = "LevelDesignation",
#'                       before_start = "2024-05-01",
#'                       before_end = "2024-05-31",
#'                       after_start = "2024-06-01",
#'                       after_end = "2024-07-03")
#'
#' # Return a summary table
#' create_period_scatter(pq_data, before_end = "2024-05-31", return = "table")
#'
#'
#' @export
create_period_scatter <- function(data,
                                  hrvar = "Organization",
                                  metric_x = "Large_and_long_meeting_hours",
                                  metric_y = "Meeting_hours",
                                  before_start = min(as.Date(data$MetricDate, "%m/%d/%Y")),
                                  before_end,
                                  after_start = as.Date(before_end) + 1,
                                  after_end = max(as.Date(data$MetricDate, "%m/%d/%Y")),
                                  before_label = "Period 1",
                                  after_label = "Period 2",
                                  mingroup = 5,
                                  return = "plot"){

  ## Check inputs
  ## Update these column names as per appropriate
  required_variables <- c("MetricDate",
                          hrvar,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)


  daterange_1_start <- as.Date(before_start)
  daterange_1_end <- as.Date(before_end)
  daterange_2_start <- as.Date(after_start)
  daterange_2_end <- as.Date(after_end)

  # Fix dates format for queries
  WpA_dataset <- data %>% mutate(Date = as.Date(MetricDate, "%m/%d/%Y"))

  # Check for dates in data file
  if (daterange_1_start < min(WpA_dataset$Date) |
      daterange_1_start > max(WpA_dataset$Date) |
      daterange_1_end < min(WpA_dataset$Date) |
      daterange_1_end > max(WpA_dataset$Date) |
      daterange_2_start < min(WpA_dataset$Date) |
      daterange_2_start > max(WpA_dataset$Date) |
      daterange_2_end < min(WpA_dataset$Date) |
      daterange_2_end > max(WpA_dataset$Date)) {
    stop('Dates not found in dataset')
    geterrmessage()
  }

  ## Employee count
  emp_count <-
    WpA_dataset %>%
    group_by(!!sym(hrvar)) %>%
    summarise(n = n_distinct(PersonId))

  data_p1 <-
    WpA_dataset %>%
    rename(group = hrvar) %>%
    filter(between(Date, daterange_1_start, daterange_1_end)) %>%
    group_by(PersonId, group) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(.))) %>%
    ungroup() %>%
    group_by(group) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(., na.rm = TRUE))) %>%
    mutate(Period = before_label) %>%
    left_join(emp_count, by = c(group = hrvar)) %>%
    filter(n >= mingroup)

  data_p2 <-
    WpA_dataset %>%
    rename(group = hrvar) %>%
    filter(between(Date, daterange_2_start, daterange_2_end)) %>%
    group_by(PersonId, group) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(.))) %>%
    ungroup() %>%
    group_by(group) %>%
    summarise(across(c(!!sym(metric_x), !!sym(metric_y)), ~mean(., na.rm = TRUE))) %>%
    mutate(Period = after_label) %>%
    left_join(emp_count, by = c(group = hrvar)) %>%
    filter(n >= mingroup)

  ## bind data
  data_both <- rbind(data_p1, data_p2)

  date_range_str <-
    paste("Data from",
          daterange_1_start,
          "to",
          daterange_1_end,
          "and",
          daterange_2_start,
          "to",
          daterange_2_end)

  clean_x <- us_to_space(metric_x)
  clean_y <- us_to_space(metric_y)

  plot_title <-
    paste(clean_x, "and", clean_y)


  plot_object <-
    data_both %>%
    ggplot(aes(x = !!sym(metric_x),
               y = !!sym(metric_y),
               colour = group,
               size = n)) +
    geom_point(alpha = 0.5) +
    scale_size(range = c(1, 20)) +
    facet_wrap(.~Period) +
    guides(size = "none") +
	theme_wpa_basic() +
    theme(legend.position = "bottom",
	strip.background = element_rect(color = "#1d627e",
                                          fill = "#1d627e"),
          strip.text = element_text(size = 10,
                                    colour = "#FFFFFF",
                                    face = "bold")) +
    ggtitle(plot_title,
            subtitle = paste("Comparison of weekly averages by ", tolower(camel_clean(hrvar)))) +
    ylab(clean_y) +
    xlab(clean_x) +
    labs(caption = date_range_str)


  if(return == "table"){

    # return(myTable_return)
    return(data_both)

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_period_scatter returns a data frame when return = 'table'", {

  result<-  create_period_scatter(pq_data,
                        hrvar = "LevelDesignation",
                        before_start = "2024-05-01",
                        before_end = "2024-05-31",
                        after_start = "2024-06-01",
                        after_end = "2024-07-03",
                        return = "table"
                        )

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_period_scatter returns a ggplot when return = 'plot'", {

  result<-  create_period_scatter(pq_data,
                        hrvar = "LevelDesignation",
                        before_start = "2024-05-01",
                        before_end = "2024-05-31",
                        after_start = "2024-06-01",
                        after_end = "2024-07-03",
                        return = "plot"
                        )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate HTML report with list inputs
#'
#' @description
#' This is a support function using a list-pmap workflow to
#' create a HTML document, using RMarkdown as the engine.
#'
#' @author Martin Chan <martin.chan@@microsoft.com>
#'
#' @param title Character string to specify the title of the chunk.
#' @param filename File name to be used in the exported HTML.
#' @param outputs A list of outputs to be added to the HTML report.
#' Note that `outputs`, `titles`, `echos`, and `levels` must have the same
#' length
#' @param titles A list/vector of character strings to specify the title of the
#'   chunks.
#' @param subheaders A list/vector of character strings to specify the
#'   subheaders for each chunk.
#' @param echos A list/vector of logical values to specify whether to display
#'   code.
#' @param levels A list/vector of numeric value to specify the header level of
#'   the chunk.
#' @param theme Character vector to specify theme to be used for the report.
#' E.g. `"united"`, `"default"`.
#' @param preamble A preamble to appear at the beginning of the report, passed
#'   as a text string.
#'
#' @importFrom purrr pmap
#' @importFrom purrr reduce
#'
#' @family Reports
#'
#' @section Creating a custom report:
#'
#' Below is an example on how to set up a custom report.
#'
#' The first step is to define the content that will go into a report and assign
#' the outputs to a list.
#'
#' ```
#' # Step 1: Define Content
#' output_list <-
#'   list(pq_data %>% workloads_summary(return = "plot"),
#'        pq_data %>% workloads_summary(return = "table")) %>%
#'   purrr::map_if(is.data.frame, create_dt)
#' ```
#'
#' The next step is to add a list of titles for each of the objects on the list:
#'
#' ```
#' # Step 2: Add Corresponding Titles
#' title_list <- c("Workloads Summary - Plot", "Workloads Summary - Table")
#' n_title <- length(title_list)
#' ```
#' The final step is to run `generate_report()`. This can all be wrapped within
#' a function such that the function can be used to generate a HTML report.
#' ```
#' # Step 3: Generate Report
#' generate_report(title = "My First Report",
#'                 filename = "My First Report",
#'                 outputs = output_list,
#'                 titles = title_list,
#'                 subheaders = rep("", n_title),
#'                 echos = rep(FALSE, n_title
#' ```
#' @return
#' An HTML report with the same file name as specified in the arguments is
#' generated in the working directory. No outputs are directly returned by the
#' function.
#'
#' @export
generate_report <- function(title = "My minimal HTML generator",
                            filename = "minimal_html",
                            outputs = output_list,
                            titles,
                            subheaders,
                            echos,
                            levels,
                            theme = "united",
                            preamble = ""){



  ## Title of document
  title_chr <- paste0('title: \"', title, '\"')


  ## chunk loopage
  ## merged to create `chunk_merged`
  chunk_merged <-
    list(output = outputs,
         title = titles,
         subheader = subheaders,
         echo = echos,
         level = levels,
         id = seq(1, length(outputs))) %>%
    purrr::pmap(function(output, title, subheader, echo, level, id){

      generate_chunks(level = level,
                      title = title,
                      subheader = subheader,
                      echo = echo,
                      object = paste0("outputs[[", id, "]]"))

    }) %>%
    purrr::reduce(c)

  # wpa_logo <- system.file("logos/logo.PNG", package = "wpa")

  ## markdown object
  markobj <- c('---',
               title_chr <- paste0('title: \"', title, '\"'),
               'output: ',
               '  html_document:',
               paste0('    theme: ', theme),
               # '    theme: united',
               '    toc: true',
               '    toc_float:',
               '      collapsed: false',
               '      smooth_scroll: true',
               '---',
               # paste0('![]("', wpa_logo, '")'),
               '',
               preamble,
               '',
               chunk_merged)

  writeLines(markobj, paste0(filename, ".Rmd"))
  rmarkdown::render(paste0(filename, ".Rmd"))

  ## Load in browser
  utils::browseURL(paste0(filename, ".html"))

  ## Deletes specified files
  unlink(c(paste0(filename, ".Rmd"),
           paste0(filename, ".md")))


}


#' @title Generate chunk strings
#'
#' @description This is used as a supporting function for `generate_report()`
#' and not directly used. `generate_report()`` works by creating a
#' loop structure around generate_chunks(), and binds them together
#' to create a report.
#'
#' @details
#' `generate_chunks()` is primarily a wrapper around paste() functions,
#'  to create a structured character vector that will form the individual
#'  chunks. No plots 'exist' within the environment of `generate_chunks()`.
#'
#' @param level Numeric value to specify the header level of the chunk.
#' @param title Character string to specify the title of the chunk.
#' @param subheader Character string to specify the subheader of the chunk.
#' @param echo Logical value to specify whether to display code.
#' @param object Character string to specify name of the object to show.
#'
#' @noRd
generate_chunks <- function(level = 3,
                            title,
                            subheader = "",
                            echo = FALSE,
                            object){

  level_hash <- paste(rep('#', level), collapse = "")

  obj <- c(paste(level_hash, title),
           subheader,
           paste0('```{r, echo=',
                  echo,
                  ', fig.height=9, fig.width=12}'),
           object,
           '```',
           ' ')

  return(obj)
}

#' @title Read preamble
#'
#' @description
#' Read in a preamble to be used within each individual reporting function.
#' Reads from the Markdown file installed with the package.
#'
#' @param path Text string containing the path for the appropriate Markdown file.
#'
#' @return
#' String containing the text read in from the specified Markdown file.
#'
#' @family Support
#' @family Reports
#'
#' @export
read_preamble <- function(path){

  full_path <- paste0("/preamble/", path)

  complete_path <- paste0(path.package("vivainsights"), full_path)

  text <- suppressWarnings(readLines(complete_path))

  return(text)
}

#' Display HTML fragment in RMarkdown chunk, from Markdown text
#'
#' @description
#' This is a wrapper around `markdown::markdownToHTML()`, where
#' the default behaviour is to produce a HTML fragment.
#' `htmltools::HTML()` is then used to evaluate the HTML code
#' within a RMarkdown chunk.
#'
#' @importFrom htmltools HTML
#' @importFrom markdown markdownToHTML
#'
#' @param text Character vector containing Markdown text
#'
#' @family Support
#'
#' @noRd
#'
md2html <- function(text){

  html_chunk <- markdown::markdownToHTML(text = text,
                                         fragment.only = TRUE)

  htmltools::HTML(html_chunk)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of External Collaboration Hours as a 100% stacked bar
#'
#' @description
#' Analyze the distribution of External Collaboration Hours.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @details
#' Uses the metric `External_collaboration_hours`.
#' See `create_dist()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @family Visualization
#' @family External Collaboration
#'
#' @examples
#' # Return plot
#' external_dist(pq_data, hrvar = "Organization")
#'
#' # Return summary table
#' external_dist(pq_data, hrvar = "Organization", return = "table")
#'
#' # Return result with a custom specified breaks
#' external_dist(pq_data, hrvar = "LevelDesignation", cut = c(2, 4, 6))
#'
#' @export

external_dist <- function(data,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot",
                       cut = c(5, 10, 15)) {

  data  %>%
    create_dist(
      metric = "External_collaboration_hours",
      hrvar = hrvar,
      mingroup = mingroup,
      return = return,
      cut = cut,
      dist_colours = c("#3F7066", "#64B4A4", "#B1EDE1","#CBF3EB")
      )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Frequency of Manager 1:1 Meetings as bar or 100% stacked bar chart
#'
#' @description `r lifecycle::badge('experimental')`
#'
#' This function calculates the average number of weeks (cadence) between of 1:1
#' meetings between an employee and their manager. Returns a  distribution plot
#' for typical cadence of 1:1 meetings. Additional options available to return a
#' bar plot, tables, or a data frame with a cadence of 1 on 1 meetings metric.
#'
#' @template spq-params
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#' @param mode String specifying what method to use. This must be one of the
#'   following strings:
#'   - `"dist"`
#'   - `"sum"`
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @section Distribution view:
#' For this view, there are four categories of cadence:
#'   - Weekly (once per week)
#'   - Twice monthly or more (up to 3 weeks)
#'   - Monthly (3 - 6 weeks)
#'   - Every two months (6 - 10 weeks)
#'   - Quarterly or less (> 10 weeks)
#'
#' In the occasion there are zero 1:1 meetings with managers, this is included
#' into the last category, i.e. 'Quarterly or less'. Note that when `mode` is
#' set to `"sum"`, these rows are simply excluded from the calculation.
#'
#'
#' @family Visualization
#' @family Managerial Relations
#'
#' @examples
#' # Return plot, mode dist
#' one2one_freq(pq_data, hrvar = "Organization", return = "plot", mode = "dist")
#'
#' # Return plot, mode sum
#' one2one_freq(pq_data,
#'              hrvar = "Organization",
#'              return = "plot",
#'              mode = "sum")
#'
#' # Return summary table
#' one2one_freq(pq_data, hrvar = "Organization", return = "table")
#'
#' @export

one2one_freq <- function(data,
                         hrvar = "Organization",
                         mingroup = 5,
                         return = "plot",
                         mode = "dist",
                         sort_by = NULL) {

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  expanded_data <-
    data %>%
    mutate(
      Meetings_and_calls_with_manager_1_on_1 = Meeting_and_call_hours_with_manager_1_1 > 0
      ) %>%
    group_by(PersonId)  %>%
    mutate(
      Cadence_of_1_on_1_meetings_and_calls_with_manager =
        1 / (sum(Meetings_and_calls_with_manager_1_on_1) / n())
      )


  # Arbitrarily large constant -----------------------------------------------

  arb_const <- 99999

  # `breaks_to_labels()` -----------------------------------------------------

  breaks_to_labels <- function(x){

    lookup <-
      c(
        "Weekly\n(once per week)" = "< 1 Weeks",
        "Twice monthly or more\n(up to 3 weeks)" = "1 - 3 Weeks",
        "Monthly\n(3 - 6 weeks)" = "3 - 6 Weeks",
        "Every two months\n(6 - 10 weeks)" = "6 - 10 Weeks",
        "Quarterly or less\n(>10 weeks)" = "10+ Weeks"
      )

    ifelse(
      is.na(names(lookup[match(x, lookup)])),
      x,
      names(lookup[match(x, lookup)])
    )
  }

  # Return outputs -----------------------------------------------------------

  if(return == "data"){

   expanded_data

  }

  else if(mode == "sum" & return == "plot"){

    expanded_data %>%
      filter_all(all_vars(!is.infinite(.))) %>%
      create_bar(
        metric = "Cadence_of_1_on_1_meetings_and_calls_with_manager",
        hrvar = hrvar,
        return = "table",
        mingroup = mingroup) %>%
      ggplot(aes(x = Cadence_of_1_on_1_meetings_and_calls_with_manager, y = group)) +
      geom_point(colour = "#FE7F4F") +
      scale_x_continuous("Manager 1:1 -  Frequency in Weeks") +
      labs(
        title = "Cadence of 1:1 Meetings and Calls with manager",
        subtitle = paste("Averages values, by ", hrvar),
        caption = paste(
          "Excludes individuals with no 1:1 meetings. ",
          extract_date_range(data, return = "text")
        ),
        x = camel_clean(hrvar)
      )  +
      theme_wpa_basic() +
      scale_size(guide = "none", range = c(1, 15)) +
      theme(
        axis.line = element_blank(),
        panel.grid.major.x = element_blank(),
        panel.grid.major.y = element_line(colour = "#D9E7F7", size = 3),
        # lightblue bar
        panel.grid.minor.x = element_line(color = "gray"),
        strip.placement = "outside",
        strip.background = element_blank(),
        strip.text = element_blank(
        )
        )

  } else if(mode == "sum" & return == "table"){

    expanded_data %>%
      filter_all(all_vars(!is.infinite(.))) %>%
      create_bar(
        metric = "Cadence_of_1_on_1_meetings_and_calls_with_manager",
        hrvar = hrvar,
        return = "table",
        mingroup = mingroup
      )

  } else if(mode == "dist"){

    plot_data <-
      expanded_data %>%
      mutate(
        across(
          .cols = Cadence_of_1_on_1_meetings_and_calls_with_manager,
          .fns = ~ifelse(!is.finite(.), arb_const, .)
        )
      )

    create_dist(
      plot_data,
      metric = "Cadence_of_1_on_1_meetings_and_calls_with_manager",
      hrvar = hrvar,
      mingroup = mingroup,
      cut = c(
        1, # Once a week
        3, # Twice monthly or more
        6, # Monthly
        10 # Bi-monthly
        ),
      ubound = arb_const + 1, # Bigger than arbitrary constant
      dist_colours = c(
        "#F1B8A1", # Reddish orange
        "#facebc", # Orangeish
        "#fcf0eb", # Light orange
        # "grey90",  # Light grey
        "#bfe5ee", # Light teal
        "#b4d5dd" # Dark teal
        ),
      unit = "Weeks",
      labels = breaks_to_labels,
      return = return,
      sort_by = sort_by
    )
  } else {

    stop("Invalid value passed to `mode` or `return`")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify groups under privacy threshold
#'
#' @description
#' This function scans a standard query output for groups with of employees
#' under the privacy threshold. The method consists in reviewing each individual
#' HR attribute, and count the distinct people within each group.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param hrvar A list of HR Variables to consider in the scan.
#' Defaults to all HR attributes identified.
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"table"`
#'   - `"text"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"table"`: data frame. A summary table of groups that fall below the
#'   privacy threshold.
#'   - `"text"`: string. A diagnostic message.
#'
#' @examples
#' \dontrun{
#' # Return a summary table
#' pq_data %>% identify_privacythreshold(return = "table")
#'
#' # Return a diagnostic message
#' pq_data %>% identify_privacythreshold(return = "text")
#' }
#' 
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats reorder
#'
#' @family Data Validation
#'
#' @return
#' Returns a ggplot object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @export

identify_privacythreshold <- function(data,
                        hrvar = extract_hr(data),
                        mingroup = 5,
                        return = "table"){

  results <-
    data %>% hrvar_count(
             hrvar = hrvar[1],
             return = "table")

  results$hrvar <- ""

  results <- results[0,]

  	for (p in hrvar) {
  	table1 <-
  	  data %>%
	  hrvar_count(hrvar = p,
             return = "table")

  	table1$hrvar <- p
	colnames(table1)[1] <- "group"

  	results <- rbind(results,table1)
  	}

 output <-  results %>% arrange(n) %>% select(hrvar, everything())

 groups_under <-  results %>% filter(n<mingroup) %>% nrow()

 MinGroupFlagMessage_Warning <- paste0("[Warning]  There are ", groups_under, " groups under the minimum group size privacy threshold of ", mingroup, ".")
 MinGroupFlagMessage_Low <- paste0("[Pass] There is only ", groups_under, " group under the minimum group size privacy threshold of ", mingroup, ".")
 MinGroupFlagMessage_Zero <- paste0("[Pass] There are no groups under the minimum group size privacy threshold of ", mingroup, ".")


  if(groups_under > 1){
    MinGroupFlagMessage <- MinGroupFlagMessage_Warning
  } else if(groups_under == 1 ){
    MinGroupFlagMessage <- MinGroupFlagMessage_Low
  } else if(groups_under ==0){
    MinGroupFlagMessage <- MinGroupFlagMessage_Zero
  }

  if(return == "table"){
    return(output)
  } else if(return == "message"){
    message(MinGroupFlagMessage)
  } else if(return == "text"){
    MinGroupFlagMessage
  } else {
    stop("Invalid `return` argument.")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Perform network analysis with the person-to-person query
#'
#' @description
#' `r lifecycle::badge('experimental')`
#'
#' Analyse a person-to-person (P2P) network query, with multiple visualisation
#' and analysis output options. Pass a data frame containing a person-to-person
#' query and return a network visualization. Options are available for community
#' detection using either the Louvain or the Leiden algorithms.
#' 
#' Note: The data frame must only contain a single `MetricDate` value, as the network
#' represents a snapshot at a specific point in time. If multiple date values are present,
#' filter the data frame to a specific date before using this function.
#'
#' @param data Data frame containing a person-to-person query.
#' @param hrvar String containing the label for the HR attribute.
#' @param return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `'plot'` (default)
#'   - `'plot-pdf'`
#'   - `'sankey'`
#'   - `'table'`
#'   - `'data'`
#'   - `'network'`
#' @param centrality string to determines which centrality measure is used to
#'   scale the size of the nodes. All centrality measures are automatically
#'   calculated when it is set to one of the below values, and reflected in the
#'   `'network'` and `'data'` outputs.
#' Measures include:
#'   - `betweenness`
#'   - `closeness`
#'   - `degree`
#'   - `eigenvector`
#'   - `pagerank`
#'
#' When `centrality` is set to NULL, no centrality is calculated in the outputs
#' and all the nodes would have the same size.
#'
#' @param community String determining which community detection algorithms to
#'   apply. Valid values include:
#'   - `NULL` (default): compute analysis or visuals without computing
#'   communities.
#'   - `"louvain"`
#'   - `"leiden"`
#'   - `"edge_betweenness"`
#'   - `"fast_greedy"`
#'   - `"fluid_communities"`
#'   - `"infomap"`
#'   - `"label_prop"`
#'   - `"leading_eigen"`
#'   - `"optimal"`
#'   - `"spinglass"`
#'   - `"walk_trap"`
#'
#'  These values map to the community detection algorithms offered by `igraph`.
#'  For instance, `"leiden"` is based on `igraph::cluster_leiden()`. Please see
#'  the bottom of <https://igraph.org/r/html/1.3.0/cluster_leiden.html> on all
#'  applications and parameters of these algorithms.
#'   .
#' @param weight String to specify which column to use as weights for the
#'   network. To create a graph without weights, supply `NULL` to this argument.
#' @param comm_args list containing the arguments to be passed through to
#'   igraph's clustering algorithms. Arguments must be named. See examples
#'   section on how to supply arguments in a named list.
#' @param layout String to specify the node placement algorithm to be used.
#'   Defaults to `"mds"` for the deterministic multi-dimensional scaling of
#'   nodes. See
#'   <https://rdrr.io/cran/ggraph/man/layout_tbl_graph_igraph.html> for a full
#'   list of options.
#' @param path File path for saving the PDF output. Defaults to a timestamped
#'   path based on current parameters.
#' @param style String to specify which plotting style to use for the network
#' plot. Valid values include:
#'   - `"igraph"`
#'   - `"ggraph"`
#' @param bg_fill String to specify background fill colour.
#' @param font_col String to specify font colour.
#' @param legend_pos String to specify position of legend. Defaults to
#'   `"right"`. See `ggplot2::theme()`. This is applicable for both the
#'   'ggraph' and the fast plotting method. Valid inputs include:
#'   - `"bottom"`
#'   - `"top"`
#'   - `"left"`
#'   -`"right"`
#'
#' @param palette String specifying the function to generate a colour palette
#'   with a single argument `n`. Uses `"rainbow"` by default.
#' @param node_alpha A numeric value between 0 and 1 to specify the transparency
#'   of the nodes. Defaults to 0.7.
#' @param edge_alpha A numeric value between 0 and 1 to specify the transparency
#'   of the edges (only for 'ggraph' mode). Defaults to 1.
#' @param edge_col String to specify edge link colour.
#' @param node_sizes Numeric vector of length two to specify the range of node
#' sizes to rescale to, when `centrality` is set to a non-null value.
#' @param seed Seed for the random number generator passed to either
#'   `set.seed()` when the louvain or leiden community detection algorithm is
#'   used, to ensure consistency. Only applicable when `community` is set to
#'   one of the valid non-null values.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `'plot'`: return a network plot, interactively within R.
#'   - `'plot-pdf'`: save a network plot as PDF. This option is recommended when
#'   the graph is large, which make take a long time to run if `return = 'plot'`
#'   is selected. Use this together with `path` to control the save location.
#'   - `'sankey'`: return a sankey plot combining communities and HR attribute.
#'   This is only valid if a community detection method is selected at
#'   `community`.
#'   - `'table'`: return a vertex summary table with counts in communities and
#'   HR attribute. When `centrality` is non-NULL, the average centrality values
#'   are calculated per group.
#'   - `'data'`: return a vertex data file that matches vertices with
#'   communities and HR attributes.
#'   - `'network'`: return 'igraph' object.
#'
#' @family Network
#'
#' @examples
#' p2p_df <- p2p_data_sim(dim = 1, size = 100)
#'
#' # default - ggraph visual
#' network_p2p(data = p2p_df, style = "ggraph")
#'
#' # return vertex table
#' network_p2p(data = p2p_df, return = "table")
#'
#' \donttest{
#' # return vertex table with community detection
#' network_p2p(data = p2p_df, community = "leiden", return = "table")
#'
#' # leiden - igraph style with custom resolution parameters
#' network_p2p(data = p2p_df, community = "leiden", comm_args = list("resolution" = 0.1))
#'
#' # louvain - ggraph style, using custom palette
#' network_p2p(
#'   data = p2p_df,
#'   style = "ggraph",
#'   community = "louvain",
#'   palette = "heat_colors"
#' )
#'
#' # leiden - return a sankey visual with custom resolution parameters
#' network_p2p(
#'   data = p2p_df,
#'   community = "leiden",
#'   return = "sankey",
#'   comm_args = list("resolution" = 0.1)
#' )
#'
#' # using `fluid_communities` algorithm with custom parameters
#' network_p2p(
#'   data = p2p_df,
#'   community = "fluid_communities",
#'   comm_args = list("no.of.communities" = 5)
#' )
#'
#' # Calculate centrality measures and leiden communities, return at node level
#' network_p2p(
#'   data = p2p_df,
#'   centrality = "betweenness",
#'   community = "leiden",
#'   return = "data"
#' ) %>%
#'   dplyr::glimpse()
#' }
#'
#' @import ggplot2
#' @import dplyr
#'
#' @export

network_p2p <-
  function(
    data,
    hrvar = "Organization",
    return = "plot",
    centrality = NULL,
    community = NULL,
    weight = NULL,
    comm_args = NULL,
    layout = "mds",
    path = paste("p2p", community, sep = "_"),
    style = "igraph",
    bg_fill = "#FFFFFF",
    font_col = "grey20",
    legend_pos = "right",
    palette = "rainbow",
    node_alpha = 0.7,
    edge_alpha = 1,
    edge_col = "#777777",
    node_sizes = c(1, 20),
    seed = 1
    ){

    if(length(node_sizes) != 2){
      stop("`node_sizes` must be of length 2")
    }
    
    ## Check if there are multiple MetricDate values
    if("MetricDate" %in% names(data) && length(unique(data$MetricDate)) > 1){
      stop("Multiple `MetricDate` values detected. The network_p2p() function requires a single date as it represents a snapshot. Please filter your data to a single `MetricDate` value.")
    }

    ## Set data frame for edges
    if(is.null(weight)){

      edges <-
        data %>%
        mutate(NoWeight = 1) %>% # No weight
        select(from = "PrimaryCollaborator_PersonId",
               to = "SecondaryCollaborator_PersonId",
               weight = "NoWeight")

    } else {

      edges <-
        data %>%
        select(from = "PrimaryCollaborator_PersonId",
               to = "SecondaryCollaborator_PersonId",
               weight = weight)

    }

    ## Set variables
    # TieOrigin = PrimaryCollaborator
    # TieDestination = SecondaryCollaborator
    pc_hrvar <- paste0("PrimaryCollaborator_", hrvar)
    sc_hrvar <- paste0("SecondaryCollaborator_", hrvar)

    ## Vertices data frame to provide meta-data
    vert_ft <-
      rbind(
        # TieOrigin
        edges %>%
          select(from) %>% # Single column
          unique() %>% # Remove duplications
          left_join(select(data, PrimaryCollaborator_PersonId, all_of(pc_hrvar)),
                    by = c("from"  = "PrimaryCollaborator_PersonId")) %>%
          select(node = "from", !!sym(hrvar) := all_of(pc_hrvar)),

        # TieDestination
        edges %>%
          select(to) %>% # Single column
          unique() %>% # Remove duplications
          left_join(select(data, SecondaryCollaborator_PersonId, all_of(sc_hrvar)),
                    by = c("to"  = "SecondaryCollaborator_PersonId")) %>%
          select(node = "to", !!sym(hrvar) := all_of(sc_hrvar))
      )



    ## Create 'igraph' object
    g_raw <-
      igraph::graph_from_data_frame(edges,
                                    directed = TRUE, # Directed, but FALSE for visualization
                                    vertices = unique(vert_ft)) # remove duplicates

    ## Assign weights
    g_raw$weight <- edges$weight

    ## allowed `community` values
    valid_comm <- c(
      "leiden",
      "louvain",
      "edge_betweenness",
      "fast_greedy",
      "fluid_communities",
      "infomap",
      "label_prop",
      "leading_eigen",
      "optimal",
      "spinglass",
      "walk_trap"
    )

    ## Finalise `g` object
    ## If community detection is selected, this is where the communities are appended
    if(is.null(community)){ # no community detection

      g <- igraph::simplify(g_raw)
      v_attr <- hrvar # Name of vertex attribute

    } else if(community %in% valid_comm){

      set.seed(seed = seed)
      g_ud <- igraph::as.undirected(g_raw) # Convert to undirected

      alg_label <- paste0("igraph::cluster_", community)

      # combine arguments to clustering algorithm
      c_comm_args <- c(list("graph" = g_ud), comm_args)

      # output `communities` object
      comm_out <- do.call(eval(parse(text = alg_label)), c_comm_args)

      ## Add cluster
      g <-
        g_ud %>%
        # Add partitions to graph object
        # Return membership
        igraph::set_vertex_attr(
          "cluster",
          value = as.character(igraph::membership(comm_out))) %>%
        igraph::simplify()

      ## Name of vertex attribute
      v_attr <- "cluster"

    } else {

      stop("Please enter a valid input for `community`.")

    }


    # centrality calculations -------------------------------------------------
    # attach centrality calculations if `centrality` is not NULL

    if(!is.null(centrality)){

      g <- network_summary(g, return = "network")

      igraph::V(g)$node_size <-
        igraph::get.vertex.attribute(
          g,
          name = centrality # from argument
          ) %>%
        scales::rescale(to = node_sizes) # min and max value

    } else {

      # all nodes with the same size if centrality is not calculated
      # adjust for plotting formats
      if(style == "igraph"){
        igraph::V(g)$node_size <- rep(3, igraph::vcount(g))
      } else if(style == "ggraph"){
        igraph::V(g)$node_size <- rep(2.5, igraph::vcount(g))
        node_sizes <- c(3, 3) # arbitrarily fix the node size
      }
    }

    # Common area -------------------------------------------------------------

    ## Create vertex table
    vertex_tb <-
      g %>%
      igraph::get.vertex.attribute() %>%
      as_tibble() %>%
      select(-node_size) # never show `node_size` in data output

    ## Set layout for graph
    g_layout <-
      g %>%
      ggraph::ggraph(layout = "igraph", algorithm = layout)

    ## Timestamped File Path
    out_path <- paste0(path, "_", tstamp(), ".pdf")

    # Return outputs ----------------------------------------------------------

    ## Use fast plotting method
    if(return %in% c("plot", "plot-pdf")){

      ## Set colours
      colour_tb <-
        tibble(!!sym(v_attr) := unique(igraph::get.vertex.attribute(g, name = v_attr))) %>%
        mutate(colour = eval(parse(text = paste0(palette,"(nrow(.))")))) # palette choice

      ## Colour vector
      colour_v <-
        tibble(!!sym(v_attr) := igraph::get.vertex.attribute(g, name = v_attr)) %>%
        left_join(colour_tb, by = v_attr) %>%
        pull(colour)

      if(style == "igraph"){

        # message("Using fast plot method due to large network size...")

        ## Set graph plot colours
        igraph::V(g)$color <- grDevices::adjustcolor(colour_v, alpha.f = node_alpha)
        igraph::V(g)$frame.color <- NA
        igraph::E(g)$width <- 1

        ## Internal basic plotting function used inside `network_p2p()`
        plot_basic_graph <- function(lpos = legend_pos){

          old_par <- graphics::par(no.readonly = TRUE)
          on.exit(graphics::par(old_par))

          graphics::par(bg = bg_fill)

          layout_text <- paste0("igraph::layout_with_", layout)

          ## Legend position

          if(lpos == "left"){

            leg_x <- -1.5
            leg_y <- 0.5

          } else if(lpos == "right"){

            leg_x <- 1.5
            leg_y <- 0.5

          } else if(lpos == "top"){

            leg_x <- 0
            leg_y <- 1.5

          } else if(lpos == "bottom"){

            leg_x <- 0
            leg_y <- -1.0

          } else {

            stop("Invalid `legend_pos` input.")

          }

          graphics::plot(
            g,
            layout = eval(parse(text = layout_text)),
            vertex.label = NA,
            # vertex.size = 3,
            vertex.size = igraph::V(g)$node_size,
            edge.arrow.mode = "-",
            edge.color = "#adadad"
          )

          graphics::legend(x = leg_x,
                           y = leg_y,
                           legend = colour_tb[[v_attr]], # vertex attribute
                           pch = 21,
                           text.col = font_col,
                           col = edge_col,
                           pt.bg = colour_tb$colour,
                           pt.cex = 2,
                           cex = .8,
                           bty = "n",
                           ncol = 1)
        }

        ## Default PDF output unless NULL supplied to path
        if(return == "plot"){

          plot_basic_graph()

        } else if(return == "plot-pdf"){

          grDevices::pdf(out_path)

          plot_basic_graph()

          grDevices::dev.off()

          message(paste0("Saved to ", out_path, "."))

        }

      } else if(style == "ggraph"){

        plot_output <-
          g_layout +
          ggraph::geom_edge_link(colour = edge_col,
                                 edge_width = 0.05,
                                 alpha = edge_alpha)+
          ggraph::geom_node_point(aes(colour = !!sym(v_attr),
                                      size = node_size),
                                  alpha = node_alpha,
                                  pch = 16) +
          scale_size_continuous(range = node_sizes) +
          scale_color_manual(values = unique(colour_v)) +
          theme_void() +
          theme(
            legend.position = legend_pos,
            legend.background = element_rect(fill = bg_fill, colour = bg_fill),

            text = element_text(colour = font_col),
            axis.line = element_blank(),
            panel.grid = element_blank()
          ) +
          labs(caption = paste0("Person to person collaboration showing ", v_attr, ".  "), # spaces intentional
               y = "",
               x = "") +
          guides(size = "none")

        # Default PDF output unless NULL supplied to path
        if(return == "plot"){

          plot_output

        } else if(return == "plot-pdf"){

          ggsave(out_path,
                 plot = plot_output,
                 width = 16,
                 height = 9)

          message(paste0("Saved to ", out_path, "."))

        }

      } else {

        stop("invalid input for `style`")

      }

    } else if (return == "data"){

      vertex_tb

    } else if(return == "network"){

      g

    } else if(return == "sankey"){

      if(is.null(community)){

        message("Note: no sankey return option is available if `NULL` is selected at `community`.
      Please specify a valid community detection algorithm.")

      } else if(community %in% valid_comm){

        create_sankey(
          data = vertex_tb %>% count(!!sym(hrvar), cluster),
          var1 = hrvar,
          var2 = "cluster",
          count = "n"
        )

      }

    } else if(return == "table"){

      if(is.null(community)){

        if(is.null(centrality)){

          vertex_tb %>% count(!!sym(hrvar))

        } else {

          # average centrality by group
          vertex_tb %>%
            group_by(!!sym(hrvar)) %>%
            summarise(
              n = n(),
              betweenness = mean(betweenness, na.rm = TRUE),
              closeness = mean(closeness, na.rm = TRUE),
              degree = mean(degree, na.rm = TRUE),
              eigenvector = mean(eigenvector, na.rm = TRUE),
              pagerank = mean(pagerank, na.rm = TRUE)
            )
        }

      } else if(community %in% valid_comm){

        if(is.null(centrality)){

          vertex_tb %>% count(!!sym(hrvar), cluster)

        } else {

          # average centrality by group
          vertex_tb %>%
            group_by(!!sym(hrvar), cluster) %>%
            summarise(
              n = n(),
              betweenness = mean(betweenness, na.rm = TRUE),
              closeness = mean(closeness, na.rm = TRUE),
              degree = mean(degree, na.rm = TRUE),
              eigenvector = mean(eigenvector, na.rm = TRUE),
              pagerank = mean(pagerank, na.rm = TRUE)
            )
        }

      }

    } else {

      stop("invalid input for `return`")

    }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
#' @title Summarise node centrality statistics with an igraph object
#'
#' @description
#' Pass an igraph object to the function and obtain centrality statistics for
#' each node in the object as a data frame. This function works as a wrapper of
#' the centralization functions in 'igraph'.
#'
#' @param graph 'igraph' object that can be returned from `network_g2g()` or
#'   `network_p2p()`when the `return` argument is set to `"network"`.
#'
#' @param hrvar String containing the name of the HR Variable by which to split
#'   metrics. Defaults to `NULL`.
#'
#' @param return String specifying what output to return. Valid inputs include:
#'   - `"table"`
#'   - `"network"`
#'   - `"plot"`
#'
#' See `Value` for more information.
#'
#' @return
#' By default, a data frame containing centrality statistics. Available
#' statistics include:
#'   - betweenness: number of shortest paths going through a node.
#'   - closeness: number of steps required to access every other node from a
#'   given node.
#'   - degree: number of connections linked to a node.
#'   - eigenvector: a measure of the influence a node has on a network.
#'   - pagerank: calculates the PageRank for the specified vertices.
#' Please refer to the igraph package documentation for the detailed technical
#' definition.
#'
#' When `"network"` is passed to `"return"`, an 'igraph' object is returned with
#' additional node attributes containing centrality scores.
#'
#' When `"plot"` is passed to `"return"`, a summary table is returned showing
#' the average centrality scores by HR attribute. This is currently available if
#' there is a valid HR attribute.
#'
#' @family Network
#'
#' @examples
#' # Simulate a p2p network
#' p2p_data <- p2p_data_sim(size = 100)
#' g <- network_p2p(data = p2p_data, return = "network")
#'
#' # Return summary table
#' network_summary(graph = g, return = "table")
#'
#' # Return network with node centrality statistics
#' network_summary(graph = g, return = "network")
#'
#' # Return summary plot
#' network_summary(graph = g, return = "plot", hrvar = "Organization")
#'
#' # Simulate a g2g network and return table
#' g2 <- g2g_data %>% network_g2g(return = "network")
#' network_summary(graph = g2, return = "table")
#'
#' @export

network_summary <- function(graph, hrvar = NULL, return = "table"){

  ## NULL variables
  node_id <- NULL

  ## Calculate summary table
  sum_tb <-
    dplyr::tibble(
      node_id = igraph::vertex.attributes(graph = graph)$name,
      betweenness = igraph::centralization.betweenness(graph = graph)$res,
      closeness = igraph::centralization.closeness(graph = graph)$res,
      degree = igraph::centralization.degree(graph = graph)$res,
      eigenvector = igraph::centralization.evcent(graph = graph)$vector,
      pagerank = igraph::page_rank(graph)$vector
    )

  if(!is.null(hrvar)){

    sum_tb <-
      cbind(
        sum_tb,
        hrvar = igraph::get.vertex.attribute(graph = graph, name = hrvar)
      )

    sum_tb <- dplyr::rename(sum_tb, !!sym(hrvar) := "hrvar")
  }

  if(return == "table"){

    sum_tb

  } else if(return == "network"){

    graph <- igraph::set_vertex_attr(
      graph = graph,
      name = "betweenness",
      value = sum_tb$betweenness
    ) %>%
      igraph::set_vertex_attr(
        name = "closeness",
        value = sum_tb$closeness
      ) %>%
      igraph::set_vertex_attr(
        name = "degree",
        value = sum_tb$degree
      ) %>%
      igraph::set_vertex_attr(
        name = "eigenvector",
        value = sum_tb$eigenvector
      ) %>%
      igraph::set_vertex_attr(
        name = "pagerank",
        value = sum_tb$pagerank
      )

    graph

  } else if(return == "plot"){

    if(is.null(hrvar)){

      message("Visualisation options currently only available when a valid
              HR attribute is supplied.")

    } else {

      plot_obj <-
        sum_tb %>%
        mutate(PersonId = node_id) %>%
        mutate(MetricDate = Sys.Date()) %>%
        keymetrics_scan(
          hrvar = hrvar,
          metrics = c(
            "betweenness",
            "closeness",
            "degree",
            "eigenvector",
            "pagerank"
          )
        )
    }

    plot_obj +
      labs(
        title = "Network centrality statistics",
        subtitle = paste("By", hrvar),
        caption = paste(
          c(
            "betweenness: number of shortest paths going through a node.",
            "closeness: number of steps required to access every other node from a given node.",
            "degree: number of connections linked to a node.",
            "eigenvector: a measure of the influence a node has on a network.",
            "pagerank: a measure of the relative importance of nodes based on linked nodes."
          ),
          collapse = "\n"
        )
      )

  } else {

    stop("Invalid input to `return`")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Rank groups with high After-Hours Collaboration Hours
#'
#' @description
#' This function scans a Standard Person Query for groups with high levels of
#' After-Hours Collaboration. Returns a plot by default, with an option to
#' return a table with all groups (across multiple HR attributes) ranked by
#' hours of After-Hours Collaboration Hours.
#'
#' @details
#' Uses the metric \code{After_hours_collaboration_hours}.
#' See `create_rank()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_rank
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats reorder
#'
#' @family Visualization
#' @family After-hours Collaboration
#'
#' @return
#' When 'table' is passed in `return`, a summary table is returned as a data frame.
#'
#' @examples
#' # Return plot
#' afterhours_rank(pq_data, return = "plot")
#'
#' # Return summary table
#' afterhours_rank(pq_data, return = "table")
#' @export


afterhours_rank <- function(data,
                            hrvar = extract_hr(data),
                            mingroup = 5,
                            mode = "simple",
                            plot_mode = 1,
                            return = "plot"){

  data %>%
    create_rank(metric = "After_hours_collaboration_hours",
                hrvar = hrvar,
                mingroup = mingroup,
                mode = mode,
                plot_mode = plot_mode,
                return = return)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create interactive tables in HTML with 'download' buttons.
#'
#' @description
#' See
#' <https://martinctc.github.io/blog/vignette-downloadable-tables-in-rmarkdown-with-the-dt-package/>
#' for more.
#'
#' @details
#' This is exported from `wpa::create_dt()`.
#'
#' @param x Data frame to be passed through.
#' @param rounding Numeric vector to specify the number of decimal points to display
#' @param freeze Number of columns from the left to 'freeze'. Defaults to 2,
#' which includes the row number column.
#' @param percent Logical value specifying whether to display numeric columns
#' as percentages.
#'
#' @importFrom dplyr mutate_if
#'
#' @family Import and Export
#'
#' @examples
#' output <- hrvar_count(pq_data, return = "table")
#' create_dt(output)
#'
#' @return
#' Returns an HTML widget displaying rectangular data.
#'
#' @export
create_dt <- function(x, rounding = 1, freeze = 2, percent = FALSE){

  wpa::create_dt(
    x = x,
    rounding = rounding,
    freeze = freeze,
    percent = percent
  )

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Collaboration Hours (Fizzy Drink plot)
#'
#' @description
#' Analyze weekly collaboration hours distribution, and returns
#' a 'fizzy' scatter plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @template ch
#'
#' @inheritParams create_fizz
#' @inherit create_fizz return
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' # Return plot
#' collaboration_fizz(pq_data, hrvar = "Organization", return = "plot")
#'
#' # Return summary table
#' collaboration_fizz(pq_data, hrvar = "Organization", return = "table")
#'
#' @export

collaboration_fizz <- function(data,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot"){

  create_fizz(data = data,
              metric = "Collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return)

}

#' @rdname collaboration_fizz
#' @export
collab_fizz <- collaboration_fizz

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Analyse word co-occurrence in subject lines and return a network plot
#'
#' @description
#' This function generates a word co-occurrence network plot, with options to
#' return a table. This function is used within `meeting_tm_report()`.
#'
#' @author Carlos Morales <carlos.morales@@microsoft.com>
#'
#' @details
#' This function uses `tm_clean()` as the underlying data wrangling function.
#' There is an option to remove stopwords by passing a data frame into the
#' `stopwords` argument.
#'
#' @param data A Meeting Query dataset in the form of a data frame.
#' @param stopwords A character vector OR a single-column data frame labelled
#'   `'word'` containing custom stopwords to remove.
#' @param seed A numeric vector to set seed for random generation.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @param lmult A multiplier to adjust the line width in the output plot.
#'   Defaults to 0.05.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' and 'ggraph' object. A network plot.
#'   - `"table"`: data frame. A summary table.
#'
#' @import dplyr
#' @import ggplot2
#' @import ggraph
#' @importFrom igraph graph_from_data_frame
#' @importFrom tidytext unnest_tokens
#'
#' @family Text-mining
#'
#' @examples
#' # Demo using a subset of `mt_data`
#' @section Example:
#' The function can be run with subject lines from `mt_data`, as per below.
#' ```
#' mt_data %>%
#'   tm_cooc(lmult = 0.01)
#' ```
#'
#' @export
tm_cooc <- function(data,
                    stopwords = NULL,
                    seed = 100,
                    return = "plot",
                    lmult = 0.05){

  # Clean data
  text_df <- suppressMessages(tm_clean(data = data,
                                       token = "words",
                                       stopwords = stopwords))



  # Calculate frequency of pairs
  title_word_pairs <-
    text_df %>%
    pairwise_count(id = "line", word = "word")

  # Graph networks
  set.seed(seed)

  p <-
    title_word_pairs %>%
    dplyr::top_n(500) %>%
    igraph::graph_from_data_frame() %>%
    ggraph::ggraph(layout = "fr") +
    ggraph::geom_edge_link(aes(edge_alpha = 0.5, edge_width = n * lmult), edge_colour = "cyan4") +
    ggraph::geom_node_point(size = 2) +
    ggraph::geom_node_text(aes(label = name),
                           repel = TRUE,
                           point.padding = unit(0.2, "lines")) +
    ggplot2::theme(panel.background = ggplot2::element_rect(fill = 'white'), legend.position = "none")

  if(return == "table"){

    title_word_pairs %>%
      dplyr::top_n(500) %>%
      as_tibble() %>%
      return()

  } else if(return == "plot"){

    return(p)

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Prepare variable names and types in query data frame for analysis 
#'
#' @description For applying to data frames that are read into R using _any
#'   other method_ other than `import_query()`, this function cleans variable
#'   names by replacing special characters and converting the relevant variable
#'   types so that they are compatible with the rest of the functions in
#'   **vivainsights**.
#'   
#' @param data A Standard Person Query dataset in the form of a data frame. You
#'   should pass the data frame that is read into R using _any other method_
#'   other than `import_query()`, as `import_query()` automatically performs the
#'   same variable operations.
#' @param date_format String specifying the date format for converting any
#' variable that may be a date to a Date variable. Defaults to `"%m/%d/%Y"`.
#' @param convert_date Logical. Defaults to `TRUE`. When set to `TRUE`, any
#' variable that matches true with `is_date_format()` gets converted to a Date
#' variable. When set to `FALSE`, this step is skipped.
#' 
#' @section Examples:
#' 
#' The following shows when and how to use `prep_query()`:
#' ```r
#'  pq_df <- read.csv("path_to_query.csv")
#'  cleaned_df <- pq_df |> prep_query()
#' ```
#' You can then run checks to see that the variables are of the correct type:
#' ```r
#' dplyr::glimpse(cleaned_df)
#' ```
#' 
#' @return A `tibble` with the cleaned data frame is returned.
#' 
#' @family Import and Export
#' 
#' @export
prep_query <- function(data, convert_date = TRUE, date_format = "%m/%d/%Y"){
  
  return_data <- data
  
  if(convert_date == TRUE){
    
    # Columns which are Dates
    dateCols <- sapply(return_data, function(x) all(is_date_format(x) | any_idate(x)))
    
    dateCols <- names(return_data)[dateCols == TRUE]
    
    # Format any date columns
    return_data <-
      return_data %>%
      dplyr::mutate(dplyr::across(dplyr::all_of(dateCols), ~as.Date(., format = date_format)))
    
    if(length(dateCols) >= 1){
      message("Converted the following Date variables:\n",
              paste(dateCols, collapse = ", "))
    }
  }
  
  # clean names
  names(return_data) <-
    names(return_data) %>%
    gsub(pattern = " ", replacement = "_", x = .) %>% # replace spaces
    gsub(pattern = "-", replacement = "_", x = .) %>% # replace hyphens
    gsub(pattern = "[:|,]", replacement = "_", x = .) %>% # replace : and ,
    gsub(pattern = "[(|)]", replacement = "_", x = .) %>% # replace brackets
    gsub(pattern = "\\.", replacement = "_", x = .)
  
  # Warn about missing values in `MetricDate`
  if(sum(is.na(return_data$MetricDate)) > 0){
    message(
    "Warning: Missing values found in `MetricDate` column.\n
    Date format conversion may not have been successful.\n
    Please check input to `date_format`"
    )
  }
  
  
  
  
  dplyr::as_tibble(return_data)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify Holiday Weeks based on outliers
#'
#' @description
#' This function scans a standard query output for weeks where collaboration
#' hours is far outside the mean. Returns a list of weeks that appear to be
#' holiday weeks and optionally an edited dataframe with outliers removed. By
#' default, missing values are excluded.
#'
#' As best practice, run this function prior to any analysis to remove atypical
#' collaboration weeks from your dataset.
#'
#' @template ch
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param sd The standard deviation below the mean for collaboration hours that
#'   should define an outlier week. Enter a positive number. Default is 1
#'   standard deviation.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"message"` (default)
#'   - `"data"`
#'   - `"data_cleaned"`
#'   - `"data_dirty"`
#'   - `"plot"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"message"`: message on console. a message is printed identifying holiday
#'   weeks.
#'   - `"data"`: data frame. A dataset with outlier weeks flagged in a new
#'   column is returned as a dataframe.
#'   - `"data_cleaned"`: data frame. A dataset with outlier weeks removed is
#'   returned.
#'   - `"data_dirty"`: data frame. A dataset with only outlier weeks is
#'   returned.
#'   - `"plot"`: ggplot object. A line plot of Collaboration Hours with holiday
#'   weeks highlighted.
#'
#'
#' @import dplyr
#' @import ggplot2
#' @importFrom methods is
#'
#' @family Data Validation
#'
#' @examples
#' # Return a message by default
#' identify_holidayweeks(pq_data)
#'
#' # Return plot
#' identify_holidayweeks(pq_data, return = "plot")
#'
#' @export
identify_holidayweeks <- function(data, sd = 1, return = "message"){

  ## Ensure date is formatted
  if(all(is_date_format(data$MetricDate))){
    data$MetricDate <- as.Date(data$MetricDate, format = "%m/%d/%Y")
  } else if(is(data$MetricDate, "Date")){
  # Do nothing
  } else {
    stop("`MetricDate` appears not to be properly formatted.\n
         It needs to be in the format MM/DD/YYYY.\n
         Also check for missing values or stray values with inconsistent formats.")
  }

  Calc <-
    data %>%
    group_by(MetricDate) %>%
    summarize(mean_collab = mean(Collaboration_hours, na.rm = TRUE),.groups = 'drop') %>%
    mutate(z_score = (mean_collab - mean(mean_collab, na.rm = TRUE))/ sd(mean_collab, na.rm = TRUE))

  Outliers <- (Calc$MetricDate[Calc$z_score < -sd])

  mean_collab_hrs <- mean(Calc$mean_collab, na.rm = TRUE)

  Message <- paste0("The weeks where collaboration was ",
                   sd,
                   " standard deviations below the mean (",
                   round(mean_collab_hrs, 1),
                   ") are: \n",
                   paste(wrap(Outliers, wrapper = "`"),collapse = ", "))

  myTable_plot <-
    data %>%
    mutate(holidayweek = (MetricDate %in% Outliers)) %>%
    select("MetricDate", "holidayweek", "Collaboration_hours") %>%
    group_by(MetricDate) %>%
    summarise(
      Collaboration_hours = mean(Collaboration_hours),
      holidayweek = first(holidayweek)) %>%
    mutate(MetricDate = as.Date(MetricDate, format = "%m/%d/%Y"))

  myTable_plot_shade <-
    myTable_plot %>%
    filter(holidayweek == TRUE) %>%
    mutate(min = MetricDate - 3 , max = MetricDate + 3 , ymin = -Inf, ymax = +Inf)

  plot <-
    myTable_plot %>%
    ggplot(aes(x = MetricDate, y = Collaboration_hours, group = 1)) +
    geom_line(colour = "grey40") +
    theme_wpa_basic() +
    geom_rect(data = myTable_plot_shade,
              aes(xmin = min,
                  xmax = max,
                  ymin = ymin,
                  ymax = ymax),
              color = "transparent",
              fill = "steelblue",
              alpha = 0.3) +
    labs(title = "Holiday Weeks",
         subtitle = "Showing average collaboration hours over time")+
    ylab("Collaboration Hours") +
    xlab("Date") +
    ylim(0, NA) # Set origin to zero

  if(return == "text"){

    return(Message)

  } else if(return == "message"){

    message(Message)

  } else if(return %in% c("data_clean", "data_cleaned")){
    
    # Create diagnostic message for removed holiday weeks
    if(length(Outliers) > 0) {
      diagnostic_msg <- paste0("The weeks ", paste(format(Outliers, "%Y-%m-%d"), collapse = ", "), 
                              " have been flagged as holiday weeks and removed from the data. ",
                              "This is based on a standard deviation of ", sd, 
                              " below the mean collaboration hours.")
    } else {
      diagnostic_msg <- paste0("No holiday weeks were detected based on a standard deviation of ", 
                              sd, " below the mean collaboration hours.")
    }
    
    # Print the diagnostic message
    message(diagnostic_msg)
    
    # Return the cleaned data
    data %>% filter(!(MetricDate %in% Outliers))

  } else if(return == "data_dirty"){

    data %>% filter((MetricDate %in% Outliers))

  } else if(return == "data"){

    data %>% mutate(holidayweek = (MetricDate %in% Outliers))

  } else if(return == "plot"){

    return(plot)

  } else {

    stop("Invalid input for `return`.")

  }
}

context("Test identify functions")

test_that("identify_holidayweeks accepts both data_clean and data_cleaned", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Suppress messages during testing
  suppressMessages({
    result_clean <- identify_holidayweeks(pq_data, return = "data_clean")
    result_cleaned <- identify_holidayweeks(pq_data, return = "data_cleaned")
  })
  
  expect_true(is.data.frame(result_clean))
  expect_true(is.data.frame(result_cleaned))
  expect_equal(nrow(result_clean), nrow(result_cleaned))
})

test_that("identify_inactiveweeks accepts both data_clean and data_cleaned", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Suppress messages during testing
  suppressMessages({
    result_clean <- identify_inactiveweeks(pq_data, return = "data_clean")
    result_cleaned <- identify_inactiveweeks(pq_data, return = "data_cleaned")
  })
  
  expect_true(is.data.frame(result_clean))
  expect_true(is.data.frame(result_cleaned))
  expect_equal(nrow(result_clean), nrow(result_cleaned))
})

test_that("identify_nkw accepts both data_clean and data_cleaned", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Suppress messages during testing
  suppressMessages({
    result_clean <- identify_nkw(pq_data, return = "data_clean")
    result_cleaned <- identify_nkw(pq_data, return = "data_cleaned")
  })
  
  expect_true(is.data.frame(result_clean))
  expect_true(is.data.frame(result_cleaned))
  expect_equal(nrow(result_clean), nrow(result_cleaned))
})

test_that("identify_holidayweeks prints message with data_clean", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Set up message capture
  messages <- capture.output(
    result <- identify_holidayweeks(pq_data, return = "data_clean"),
    type = "message"
  )
  
  expect_true(is.data.frame(result))
  expect_true(any(grepl("flagged as holiday weeks", messages)) || 
              any(grepl("No holiday weeks were detected", messages)))
})

test_that("identify_inactiveweeks prints message with data_clean", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Set up message capture
  messages <- capture.output(
    result <- identify_inactiveweeks(pq_data, return = "data_clean"),
    type = "message"
  )
  
  expect_true(is.data.frame(result))
  expect_true(any(grepl("flagged as inactive weeks", messages)) || 
              any(grepl("No inactive weeks were detected", messages)))
})

test_that("identify_nkw prints message with data_clean", {
  # Skip if pq_data not available
  skip_if_not_installed("vivainsights")
  skip_if_not(exists("pq_data"))
  
  # Set up message capture
  messages <- capture.output(
    result <- identify_nkw(pq_data, return = "data_clean"),
    type = "message"
  )
  
  expect_true(is.data.frame(result))
  expect_true(any(grepl("flagged as non-knowledge workers", messages)) || 
              any(grepl("No employees were identified as non-knowledge workers", messages)))
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Box Plot for any metric
#'
#' @description
#' Analyzes a selected metric and returns a box plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @details
#' This is a general purpose function that powers all the functions
#' in the package that produce box plots.
#'
#' @template spq-params
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'   - `"data"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A box plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric, containing the 
#'   following columns:
#'     - `group`: The HR variable by which the metric is split.
#'     - `mean`: The mean of the metric.
#'     - `min`: The minimum value of the metric.
#'     - `p10`: The 10th percentile of the metric.
#'     - `p25`: The 25th percentile of the metric.
#'     - `p50`: The 50th percentile of the metric.
#'     - `p75`: The 75th percentile of the metric.
#'     - `p90`: The 90th percentile of the metric.
#'     - `max`: The maximum value of the metric.
#'     - `sd`: The standard deviation of the metric.
#'     - `range`: The range of the metric.
#'     - `n`: The number of observations.
#'  - `"data"`: data frame. A data frame containing the metric and group.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats sd
#' @importFrom stats quantile
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' # Create a box plot for Collaboration_hours by Level Designation
#' create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation", return = "plot")
#'
#' # Create a box plot for Collaboration_hours by Organization
#' create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "plot")
#'
#' # Create a summary statistics table for Collaboration_hoursby Organization
#' create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")
#'
#' @export

create_boxplot <- function(data,
                           metric,
                           hrvar = "Organization",
                           mingroup = 5,
                           return = "plot") {

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Clean metric name
  clean_nm <- us_to_space(metric)

  plot_data <-
    data %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    group_by(PersonId, group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric))) %>%
    ungroup() %>%
    left_join(data %>%
                rename(group = !!sym(hrvar)) %>%
                group_by(group) %>%
                summarise(Employee_Count = n_distinct(PersonId)),
              by = "group") %>%
    filter(Employee_Count >= mingroup)

  ## Get max value
  max_point <- max(plot_data[[metric]]) * 1.2

  plot_legend <-
    plot_data %>%
    group_by(group) %>%
    summarize(Employee_Count = first(Employee_Count)) %>%
    mutate(Employee_Count = paste("n=",Employee_Count))

  ## summary table
  summary_table <- calculate_distribution_summary(plot_data, metric)

  ## group order
  group_ord <-
    summary_table %>%
    arrange(desc(mean)) %>%
    pull(group)

  ## x axis label handling
  if(hrvar == "Total"){
    xlabel<-""
  }
  else{
    xlabel<-hrvar
  }

  plot_object <-
    plot_data %>%
    mutate(group = factor(group, levels = group_ord)) %>%
    ggplot(aes(x = group, y = !!sym(metric))) +
    geom_boxplot(color = "#578DB8") +
    ylim(0, max_point) +
    annotate("text", x = plot_legend$group, y = 0, label = plot_legend$Employee_Count) +
    scale_x_discrete(labels = scales::wrap_format(10)) +
    theme_wpa_basic() +
    theme(axis.text=element_text(size=12),
          axis.text.x = element_text(angle = 30, hjust = 1),
          plot.title = element_text(color="grey40", face="bold", size=18),
          plot.subtitle = element_text(size=14),
          legend.position = "top",
          legend.justification = "right",
          legend.title=element_text(size=14),
          legend.text=element_text(size=14)) +
    labs(title = clean_nm,
         subtitle = paste("Distribution of",
                          tolower(clean_nm),
                          "by",
                          tolower(camel_clean(hrvar)))) +
    xlab(xlabel) +
    ylab(paste("Average", clean_nm)) +
    labs(caption = extract_date_range(data, return = "text"))



  if(return == "table"){

    summary_table %>%
      as_tibble() %>%
      return()

  } else if(return == "plot"){

    return(plot_object)

  } else if(return == "data"){

    plot_data %>%
      mutate(group = factor(group, levels = group_ord)) %>%
      arrange(desc(group))

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify whether string is a date format
#'
#' @description
#' This function uses regular expression to determine whether a string is of the
#' format `"mdy"`, separated by `"-"`, `"/"`, or `"."`, returning a logical
#' vector.
#'
#' @param string Character string to test whether is a date format.
#'
#' @return logical value indicating whether the string is a date format.
#'
#' @examples
#' is_date_format("1/5/2020")
#'
#' @family Support
#'
#' @export
is_date_format <- function(string){

  grepl("^\\d{1,2}[- /.]\\d{1,2}[- /.]\\d{1,4}$", string)
}

#' @title Identify whether variable is an IDate class.
#'
#' @description
#' This function checks whether the variable is an IDate class.
#'
#' @param x Variable to test whether an IDate class.
#'
#' @return logical value indicating whether the string is of an IDate class.
#'
#' @examples
#' any_idate("2023-12-15")
#'
#' @family Support
#'
#' @export

any_idate <- function(x){
  any(class(x) %in% "IDate")
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Sample person-to-person dataset
#'
#' @description
#' A demo dataset representing a person-to-person query, structured as an
#' edgelist. The identifier variable for each person is `PersonId`, where the
#' variables have been prefixed with `PrimaryCollaborator_` and
#' `SecondaryCollaborator_` to represent the direction of collaboration.
#'
#' @family Data
#' @family Network
#'
#' @return data frame.
#'
#' @format A data frame with 11550 rows and 13 variables:
#' \describe{
#'   \item{PrimaryCollaborator_PersonId}{ }
#'   \item{SecondaryCollaborator_PersonId}{ }
#'   \item{MetricDate}{ }
#'   \item{Diverse_tie_score}{ }
#'   \item{Diverse_tie_type}{ }
#'   \item{Strong_tie_score}{ }
#'   \item{Strong_tie_type}{ }
#'   \item{PrimaryCollaborator_Organization}{ }
#'   \item{SecondaryCollaborator_Organization}{ }
#'   \item{PrimaryCollaborator_LevelDesignation}{ }
#'   \item{SecondaryCollaborator_LevelDesignation}{ }
#'   \item{PrimaryCollaborator_FunctionType}{ }
#'   \item{SecondaryCollaborator_FunctionType}{ }
#'
#'   ...
#' }
#' @source \url{https://analysis.insights.cloud.microsoft/analyst/analysis/}
"p2p_data"

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Manager 1:1 Time Trend - Line Chart
#'
#' @description
#' Provides a week by week view of 1:1 time with managers, visualised as line charts.
#' By default returns a line chart for 1:1 meeting hours,
#' with a separate panel per value in the HR attribute.
#' Additional options available to return a summary table.
#'
#' @details
#' Uses the metric `Meeting_and_call_hours_with_manager_1_1`.
#'
#' @inheritParams create_line
#' @inherit create_line return
#'
#' @family Visualization
#' @family Managerial Relations
#'
#' @examples
#' # Return a line plot
#' one2one_line(pq_data, hrvar = "LevelDesignation")
#'
#' # Return summary table
#' one2one_line(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export
one2one_line <- function(data,
                         hrvar = "Organization",
                         mingroup = 5,
                         return = "plot",
                         label = FALSE){
  ## Inherit arguments
  create_line(data = data,
              metric = "Meeting_and_call_hours_with_manager_1_1",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              label = label)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Anonymise a categorical variable by replacing values
#'
#' @description
#' Anonymize categorical variables such as HR variables by replacing values with
#' dummy team names such as 'Team A'. The behaviour is to make 1 to 1
#' replacements by default, but there is an option to completely randomise
#' values in the categorical variable.
#'
#' @param x Character vector to be passed through.
#' @param scramble Logical value determining whether to randomise values in the
#' categorical variable.
#' @param replacement Character vector containing the values to replace original
#'   values in the categorical variable. The length of the vector must be at
#'   least as great as the number of unique values in the original variable.
#'   Defaults to `NULL`, where the replacement would consist of `"Team A"`,
#'   `"Team B"`, etc.
#'
#' @examples
#' unique(anonymise(pq_data$Organization))
#'
#' rep <- c("Manager+", "Manager", "IC")
#' unique(anonymise(pq_data$Layer), replacement = rep)
#'
#' @seealso jitter
#'
#' @return
#' Character vector with the same length as input `x`, replaced with values
#' provided in `replacement`.
#'
#' @export

anonymise <- function(x,
                      scramble = FALSE,
                      replacement = NULL){

  n_to_rep <- length(x)
  v_to_rep <- unique(x)
  nd_to_rep <- length(v_to_rep)

  if(is.null(replacement)){

    replacement <- paste("Team", LETTERS[1:nd_to_rep])

  } else {

    replacement <- replacement[1:nd_to_rep]

  }

  if(scramble == TRUE){

    sample(x = replacement,
           size = n_to_rep,
           replace = TRUE)

  } else if(scramble == FALSE){

    replacement[match(x, v_to_rep)]

  }
}

#' @rdname anonymise
#' @export
anonymize <- anonymise

#' @title Jitter metrics in a data frame
#'
#' @description Convenience wrapper around `jitter()` to add a layer of
#'   anonymity to a query. This can be used in combination with `anonymise()` to
#'   produce a demo dataset from real data.
#'
#' @param data Data frame containing a query.
#' @param cols Character vector containing the metrics to jitter. When set to
#' `NULL` (default), all numeric columns in the data frame are jittered.
#' @param ... Additional arguments to pass to `jitter()`.
#'
#' @importFrom dplyr mutate
#' @importFrom dplyr across
#' @import tidyselect
#'
#' @examples
#' jittered <- jitter_metrics(pq_data, cols = "Collaboration_hours")
#'
#' # compare jittered vs original results of top rows
#' head(
#'   data.frame(
#'     original = pq_data$Collaboration_hours,
#'     jittered = jittered$Collaboration_hours
#'   )
#' )
#'
#' @seealso anonymise
#'
#' @return
#' data frame where numeric columns specified by `cols` are jittered using the
#' function `jitter()`.
#'
#' @export

jitter_metrics <- function(data, cols = NULL, ...){

  if(!is.null(cols)){

    data %>%
      mutate(
        across(
          .cols = cols,
          .fns = ~abs(jitter(., ...))
        )
      )

  } else {

    data %>%
      mutate(
        across(
          .cols = where(~is.numeric(.)),
          .fns = ~abs(jitter(., ...))
        )
      )

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Collaboration Time Trend
#'
#' @description
#' Provides a week by week view of collaboration time.
#' By default returns a week by week heatmap, highlighting the points in time with most activity.
#' Additional options available to return a summary table.
#'
#' @template ch
#'
#' @inheritParams create_trend
#'
#' @family Visualization
#' @family Collaboration
#'
#' @return
#' Returns a 'ggplot' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @examples
#' # Run plot
#' collaboration_trend(pq_data)
#'
#' # Run table
#' collaboration_trend(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

collaboration_trend <- function(data,
                                hrvar = "Organization",
                                mingroup = 5,
                                return = "plot"){

  create_trend(data,
               metric = "Collaboration_hours",
               hrvar = hrvar,
               mingroup = mingroup,
               return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Meeting Hours Ranking
#'
#' @description
#' This function scans a standard query output for groups with high levels of
#' Weekly Meeting Collaboration. Returns a plot by default, with an option to
#' return a table with a all of groups (across multiple HR attributes) ranked by
#' hours of digital collaboration.
#'
#' @details
#' Uses the metric `Meeting_hours`.
#' See `create_rank()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_rank
#' @inherit create_rank return
#'
#' @family Visualization
#' @family Meetings
#'
#' @examples
#' # Return rank table
#' meeting_rank(data = pq_data, return = "table")
#'
#' # Return plot
#' meeting_rank(data = pq_data, return = "plot")
#'
#' @export

meeting_rank <- function(data,
                         hrvar = extract_hr(data),
                         mingroup = 5,
                         mode = "simple",
                         plot_mode = 1,
                         return = "plot"){
  data %>%
    create_rank(metric = "Meeting_hours",
                hrvar = hrvar,
                mingroup = mingroup,
                mode = mode,
                plot_mode = plot_mode,
                return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Tenure calculation based on different input dates, returns data
#'   summary table or histogram
#'
#' @description
#' This function calculates employee tenure based on different input dates.
#' `identify_tenure` uses the latest Date available if user selects "MetricDate",
#'  but also have flexibility to select a specific date, e.g. "1/1/2020".
#'
#' @family Data Validation
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param end_date A string specifying the name of the date variable
#'   representing the latest date. Defaults to "MetricDate".
#' @param beg_date A string specifying the name of the date variable
#'   representing the hire date. Defaults to "HireDate".
#' @param maxten A numeric value representing the maximum tenure.
#' If the tenure exceeds this threshold, it would be accounted for in the flag message.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"message"`
#'   - `"text"`
#'   - `"plot"`
#'   - `"data_cleaned"`
#'   - `"data_dirty"`
#'   - `"data"`
#'
#' See `Value` for more information.

#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"message"`: message on console with a diagnostic message.
#'   - `"text"`: string containing a diagnostic message.
#'   - `"plot"`: 'ggplot' object. A line plot showing tenure.
#'   - `"data_cleaned"`: data frame filtered only by rows with tenure values
#'   lying within the threshold.
#'   - `"data_dirty"`: data frame filtered only by rows with tenure values
#'   lying outside the threshold.
#'   - `"data"`: data frame with the `PersonId` and a calculated variable called
#'   `TenureYear` is returned.
#'
#'
#' @examples
#' library(dplyr)
#' # Add HireDate to `pq_data`
#' pq_data2 <-
#'   pq_data %>%
#'   mutate(HireDate = as.Date("1/1/2015", format = "%m/%d/%Y"))
#'
#' identify_tenure(pq_data2)
#'
#' @export
identify_tenure <- function(data,
                            end_date = "MetricDate",
                            beg_date = "HireDate",
                            maxten = 40,
                            return = "message"){

  required_variables <- c("HireDate")
  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  data_prep <-
    data %>%
    mutate(MetricDate = as.Date(MetricDate, format = "%m/%d/%Y"), # Re-format `MetricDate`
           end_date = as.Date(!!sym(end_date), format= "%m/%d/%Y"), # Access a symbol, not a string
           beg_date = as.Date(!!sym(beg_date), format= "%m/%d/%Y")) %>% # Access a symbol, not a string
    arrange(end_date) %>%
    mutate(End = last(end_date))

  last_date <- data_prep$End

  # graphing data
  tenure_summary <-
    data_prep %>%
    filter(MetricDate == last_date) %>%
    mutate(tenure_years = (MetricDate - beg_date)/365) %>%
    group_by(tenure_years)%>%
    summarise(n = n(),.groups = 'drop')


  # off person IDs
  oddpeople <-
    data_prep %>%
    filter(MetricDate == last_date) %>%
    mutate(tenure_years = (MetricDate - beg_date)/365) %>%
    filter(tenure_years >= maxten) %>%
    select(PersonId)

  # message
  Message <- paste0("The mean tenure is ",round(mean(tenure_summary$tenure_years,na.rm = TRUE),1)," years.\nThe max tenure is ",
                   round(max(tenure_summary$tenure_years,na.rm = TRUE),1),".\nThere are ",
                   length(tenure_summary$tenure_years[tenure_summary$tenure_years>=maxten])," employees with a tenure greater than ",maxten," years.")

  if(return == "text"){
    return(Message)

  } else if(return == "message"){
    message(Message)

  } else if(return == "plot"){

    suppressWarnings(
      ggplot(data = tenure_summary,aes(x = as.numeric(tenure_years))) +
        geom_density() +
        labs(title = "Tenure - Density",
             subtitle = "Calculated with `HireDate`") +
        xlab("Tenure in Years") +
        ylab("Density - number of employees") +
        theme_wpa_basic()
    )

  } else if(return == "data_cleaned"){

    return(data %>% filter(!(PersonId %in% oddpeople$PersonId)) %>% data.frame())

  } else if(return == "data_dirty"){

    return(data %>% filter((PersonId %in% oddpeople$PersonId)) %>% data.frame())

  } else if(return == "data"){

    data_prep %>%
      filter(MetricDate == last_date) %>%
      mutate(TenureYear = as.numeric((MetricDate - beg_date)/365)) %>%
      select(PersonId, TenureYear)

  } else {

    stop("Error: please check inputs for `return`")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Mean Bar Plot for any metric
#'
#' @description
#' Provides an overview analysis of a selected metric by calculating a mean per
#' metric.
#' Returns a bar plot showing the average of a selected metric by default.
#' Additional options available to return a summary table.
#'
#' @template spq-params
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @param bar_colour String to specify colour to use for bars.
#' In-built accepted values include `"default"` (default), `"alert"` (red), and
#' `"darkblue"`. Otherwise, hex codes are also accepted. You can also supply
#' RGB values via `rgb2hex()`.
#' @param na.rm A logical value indicating whether `NA` should be stripped
#' before the computation proceeds. Defaults to `FALSE`.
#' @param percent Logical value to determine whether to show labels as
#'   percentage signs. Defaults to `FALSE`.
#' @param plot_title An option to override plot title.
#' @param plot_subtitle An option to override plot subtitle.
#' @param legend_lab String. Option to override legend title/label. Defaults to
#' `NULL`, where the metric name will be populated instead.
#' @param rank String specifying how to rank the bars. Valid inputs are:
#'   - `"descending"` - ranked highest to lowest from top to bottom (default).
#'   - `"ascending"` - ranked lowest to highest from top to bottom.
#'   - `NULL` - uses the original levels of the HR attribute.
#' @param xlim An option to set max value in x axis.
#' @param text_just `r lifecycle::badge('experimental')` A numeric value
#'   controlling for the horizontal position of the text labels. Defaults to
#'   0.5.
#' @param text_colour `r lifecycle::badge('experimental')` String to specify
#'   colour to use for the text labels. Defaults to `"#FFFFFF"`.
#'
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A bar plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @importFrom scales wrap_format
#' @importFrom stats reorder
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' # Return a ggplot bar chart
#' create_bar(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation")
#'
#' # Change bar colour
#' create_bar(pq_data,
#'            metric = "After_hours_collaboration_hours",
#'            bar_colour = "alert")
#'
#' # Custom data label positions and formatting
#' pq_data %>%
#'   create_bar(
#'     metric = "Meetings",
#'     text_just = 1.1,
#'     text_colour = "black",
#'     xlim = 20)
#'
#' # Return a summary table
#' create_bar(pq_data,
#'            metric = "Collaboration_hours",
#'            hrvar = "LevelDesignation",
#'            return = "table")
#' @export
create_bar <- function(data,
                       metric,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot",
                       bar_colour = "default",
                       na.rm = FALSE,
                       percent = FALSE,
                       plot_title = us_to_space(metric),
                       plot_subtitle = paste("Average by", tolower(camel_clean(hrvar))),
                       legend_lab = NULL,
                       rank = "descending",
                       xlim = NULL,
                       text_just = 0.5,
                       text_colour = "#FFFFFF"){

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Handle `legend_lab`
  if(is.null(legend_lab)){
    legend_lab <- gsub("_", " ", metric)
  }

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Clean metric name
  clean_nm <- us_to_space(metric)

  ## Data for bar plot
  plot_data <-
    data %>%
    rename(group = !!sym(hrvar)) %>%
    group_by(PersonId, group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric)), .groups = "drop") %>%
    group_by(group) %>%
    mutate(Employee_Count = n_distinct(PersonId)) %>%
    dplyr::filter(Employee_Count >= mingroup) %>%
    ungroup() 

  ## Colour bar override
  if(bar_colour == "default"){

    bar_colour <- "#34b1e2"

  } else if(bar_colour == "alert"){

    bar_colour <- "#FE7F4F"

  } else if(bar_colour == "darkblue"){

    bar_colour <- "#1d627e"

  }

  ## Bar plot
  plot_object <- data %>%
    create_stacked(
      metrics = metric,
      hrvar = hrvar,
      mingroup = mingroup,
      stack_colours = bar_colour,
      percent = percent,
      plot_title = plot_title,
      plot_subtitle = plot_subtitle,
      legend_lab = legend_lab,
      return = "plot",
      rank = rank,
      xlim = xlim,
      text_just = text_just,
      text_colour = text_colour
      )

  summary_table <-
    plot_data %>%
    select(group, !!sym(metric)) %>%
    group_by(group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric)),
              n = n())

  if(return == "table"){

    return(summary_table)

    } else if(return == "plot"){

    return(plot_object)

    } else {

    stop("Please enter a valid input for `return`.")

    }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)

test_that("create_bar returns a data frame when return = 'table'", {

  result <-
    pq_data %>%
    create_bar(metric = "Collaboration_hours",
               hrvar = "LevelDesignation",
               return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_bar returns a ggplot when return = 'plot'", {

  result <-
    pq_data %>%
    create_bar(metric = "Collaboration_hours",
               hrvar = "LevelDesignation",
               return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a sankey chart from a two-column count table
#'
#' @description
#' Create a 'networkD3' style sankey chart based on a long count table
#' with two variables. The input data should have three columns, where
#' each row is a unique group:
#'   1. Variable 1
#'   2. Variable 2
#'   3. Count
#'
#' @param data Data frame of the long count table.
#' @param var1 String containing the name of the variable to be shown on the
#'   left.
#' @param var2 String containing the name of the variable to be shown on the
#'   right.
#' @param count String containing the name of the count variable.
#'
#' @import dplyr
#'
#' @return A 'sankeyNetwork' and 'htmlwidget' object containing a two-tier
#'  sankey plot. The output can be saved locally with
#'  `htmlwidgets::saveWidget()`.
#'
#' @examples
#' \donttest{
#' pq_data %>%
#'   dplyr::count(Organization, FunctionType) %>%
#'   create_sankey(var1 = "Organization", var2 = "FunctionType")
#' }
#'
#' @family Visualization
#' @family Flexible
#'
#' @export
create_sankey <- function(data, var1, var2, count = "n"){

  ## Rename
  data$pre_group <- data[[var1]]
  data$group <- data[[var2]]

  ## Set up `nodes`
  group_source <- unique(data$pre_group)
  group_target <- paste0(unique(data$group), " ")

  groups <- c(group_source, group_target)

  nodes_source <- tibble(name = group_source)
  nodes_target <- tibble(name = group_target)
  nodes <- rbind(nodes_source, nodes_target) %>% mutate(node = 0:(nrow(.) - 1))

  ## Set up `links`
  links <-
    data %>%
    mutate(group = paste0(group, " ")) %>%
    select(source = "pre_group",
           target = "group",
           value = count)

  nodes_source <- nodes_source %>% select(name) # Make `nodes` a single column data frame
  nodes_target <- nodes_target %>% select(name) # Make `nodes` a single column data frame

  links <-
    links %>%
    left_join(nodes %>% rename(IDsource = "node"), by = c("source" = "name")) %>%
    left_join(nodes %>% rename(IDtarget = "node"), by = c("target" = "name"))


  networkD3::sankeyNetwork(Links = as.data.frame(links),
                           Nodes = as.data.frame(nodes),
                           Source = 'IDsource', # Change reference to IDsource
                           Target = 'IDtarget', # Change reference to IDtarget
                           Value = 'value',
                           NodeID = 'name',
                           units="count",
                           sinksRight = FALSE)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)
library(dplyr)

test_that("create_sankey returns a sankeyNetwork object.", {

  result <-pq_data %>%
		   dplyr::count(Organization, FunctionType) %>%
		   create_sankey(var1 = "Organization", var2 = "FunctionType")

  # Check if the result is a sankeyNetwork object
  expect_s3_class(result, "sankeyNetwork")
})

#' @title
#' Create an incidence analysis reflecting proportion of population scoring above
#' or below a threshold for a metric
#'
#' @description
#' An incidence analysis is generated, with each value in the table reflecting
#' the proportion of the population that is above or below a threshold for a
#' specified metric. There is an option to only provide a single `hrvar` in
#' which a bar plot is generated, or two `hrvar` values where an incidence table
#' (heatmap) is generated.
#'
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param hrvar Character vector of at most length 2 containing the name of the
#'   HR Variable by which to split metrics. Accepts `NULL`, where the total
#'   population is used for the analysis.
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#' @param threshold Numeric value specifying the threshold.
#' @param position String containing the below valid values:
#'   - `"above"`: show incidence of those equal to or above the threshold
#'   - `"below"`: show incidence of those equal to or below the threshold
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A heat map.
#'   - `"table"`: data frame. A summary table.
#'
#' @import dplyr
#' @import ggplot2
#' @importFrom scales percent
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' # Only a single HR attribute
#' create_inc(
#'   data = pq_data,
#'   metric = "After_hours_collaboration_hours",
#'   hrvar = "Organization",
#'   threshold = 4,
#'   position = "above"
#' )
#'
#' # Total population (NULL hrvar)
#' create_inc(
#'   data = pq_data,
#'   metric = "Collaboration_hours",
#'   hrvar = NULL,
#'   threshold = 20,
#'   position = "below"
#' )
#'
#' # Two HR attributes
#' create_inc(
#'   data = pq_data,
#'   metric = "Collaboration_hours",
#'   hrvar = c("LevelDesignation", "Organization"),
#'   threshold = 20,
#'   position = "below"
#' )
#'
#' @export

create_inc <- function(
  data,
  metric,
  hrvar,
  mingroup = 5,
  threshold,
  position,
  return = "plot"
){

  ## Validate position argument
  if (!position %in% c("above", "below")) {
    stop("Invalid value for `position`. Please use either \"above\" or \"below\".")
  }

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  if(length(hrvar) == 1){

    create_inc_bar(
      data = data,
      metric = metric,
      hrvar = hrvar,
      mingroup = mingroup,
      threshold = threshold,
      position = position,
      return = return
    )

  } else if(length(hrvar) == 2){

    create_inc_grid(
      data = data,
      metric = metric,
      hrvar = hrvar,
      mingroup = mingroup,
      threshold = threshold,
      position = position,
      return = return
    )


  } else {

    stop("`hrvar` can only accept a character vector of length 2.")

  }

}

#' @rdname create_inc
#' @export
create_incidence <- create_inc


#' Run `create_inc` with only single `hrvar`
#' Returning a bar chart
#'
#' @noRd
create_inc_bar <- function(
  data,
  metric,
  hrvar,
  mingroup = 5,
  threshold,
  position,
  return = "plot"
){

  # Validate position argument
  if (!position %in% c("above", "below")) {
    stop("Invalid value for `position`. Please use either \"above\" or \"below\".")
  }

  # Transform data so that metrics become proportions
  data_t <-
    data %>%
    { if (position == "above"){
      mutate(., !!sym(metric) := !!sym(metric) >= threshold)
    } else if (position == "below"){
      mutate(., !!sym(metric) := !!sym(metric) <= threshold)
    }
    }

  # Set title text
  title_text <-
    paste(
      "Incidence of",
      tolower(us_to_space(metric)),
      position,
      threshold
    )

  # Set subtitle text
  subtitle_text <-
    paste(
      "Percentage and number of employees by",
      hrvar
    )

  # Pipe result to `create_bar()`
  create_bar(
    data = data_t,
    metric = metric,
    hrvar = hrvar,
    mingroup = mingroup,
    return = return,
    plot_title = title_text,
    plot_subtitle = subtitle_text,
    legend_lab = paste("% with",
                       tolower(us_to_space(metric)),
                       position,
                       threshold),
    percent = TRUE
  )
}

#' Run `create_inc` with only two `hrvar`
#' Returning a heatmap
#'
#' @noRd
create_inc_grid <- function(
  data,
  metric,
  hrvar,
  mingroup = 5,
  threshold,
  position,
  return = "plot"
){

  # Validate position argument
  if (!position %in% c("above", "below")) {
    stop("Invalid value for `position`. Please use either \"above\" or \"below\".")
  }

  # Create table of proportions
  myTable <-
    data %>%
    { if (position == "above"){
      mutate(., !!sym(metric) := !!sym(metric) >= threshold)
    } else if (position == "below"){
      mutate(., !!sym(metric) := !!sym(metric) <= threshold)
    }
    } %>%
    group_by(!!sym(hrvar[1]), !!sym(hrvar[2]), PersonId) %>%
    summarise(
      !!sym(metric) := mean(!!sym(metric), na.rm = TRUE)
    ) %>%
    group_by(!!sym(hrvar[1]), !!sym(hrvar[2])) %>%
    summarise(
      !!sym(metric) := mean(!!sym(metric), na.rm = TRUE),
      n = n_distinct(PersonId),
      .groups = "drop"
    ) %>%
    filter(n >= mingroup) %>%
    arrange(desc(!!sym(metric)))

  if(return == "table"){

    myTable

  } else if(return == "plot"){

    # Set title text
    title_text <-
      paste(
        "Incidence of",
        tolower(us_to_space(metric)),
        position,
        threshold
      )

    # Set subtitle text
    subtitle_text <-
      paste(
        "Percentage and number of employees by",
        hrvar[1],
        "and",
        hrvar[2]
      )

    metric_text <- NULL

    myTable %>%
      mutate(metric_text = paste0(
        scales::percent(!!sym(metric), accuracy = 1),
        " (", n, ")")) %>%
      ggplot(aes(x = !!sym(hrvar[1]),
                 y = !!sym(hrvar[2]),
                 fill = !!sym(metric))) +
      geom_tile() +
      geom_text(aes(label = metric_text),
                colour = "black",
                size = 3)+
      scale_fill_gradient2(low = rgb2hex(7, 111, 161),
                           mid = rgb2hex(241, 204, 158),
                           high = rgb2hex(216, 24, 42),
                           midpoint = 0.5,
                           breaks = c(0, 0.5, 1),
                           labels = c("0%", "", "100%"),
                           limits = c(0, 1)) +
      scale_x_discrete(position = "top", labels = us_to_space) +
      scale_y_discrete(labels = us_to_space) +
      theme_wpa_basic() +
      labs(
        title = title_text,
        subtitle = subtitle_text,
        caption = paste(
          extract_date_range(data, return = "text"),
          "\n",
          "Percentages reflect incidence with respect to population in cell."),
        fill = "Incidence"
      )
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_inc returns a data frame when return = 'table'", {

  result <- create_inc(
                data = pq_data,
                metric = "Collaboration_hours",
                hrvar = c("LevelDesignation", "Organization"),
                threshold = 20,
                position = "below",
                return = "table"
              )

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_inc returns a ggplot when return = 'plot'", {

  result <- create_inc(
                data = pq_data,
                metric = "Collaboration_hours",
                hrvar = c("LevelDesignation", "Organization"),
                threshold = 20,
                position = "below",
                return = "plot"
                )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_inc works with NULL hrvar", {
  
  result <- create_inc(
                data = pq_data,
                metric = "Collaboration_hours",
                hrvar = NULL,
                threshold = 20,
                position = "below",
                return = "table"
              )
  
  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
  
  # Check if the result contains the expected "group" column from totals_col
  # The create_bar function renames the hrvar column to "group"
  expect_true("group" %in% names(result))
  
  # Check that all values in group column are "Total"
  expect_true(all(result$group == "Total"))
})

test_that("create_inc throws error for invalid position", {
  
  expect_error(
    create_inc(
      data = pq_data,
      metric = "Collaboration_hours",
      hrvar = "Organization",
      threshold = 20,
      position = "invalid",
      return = "table"
    ),
    "Invalid value for `position`. Please use either \"above\" or \"below\"."
  )
})

test_that("create_inc throws error for invalid position with NULL hrvar", {
  
  expect_error(
    create_inc(
      data = pq_data,
      metric = "Collaboration_hours",
      hrvar = NULL,
      threshold = 20,
      position = "invalid",
      return = "table"
    ),
    "Invalid value for `position`. Please use either \"above\" or \"below\"."
  )
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Calculate Distribution Summary Statistics
#'
#' @description
#' Internal helper function to calculate comprehensive distribution statistics
#' for a given metric grouped by a categorical variable. Used by create_hist(), 
#' create_density(), and create_boxplot() to ensure consistent output.
#'
#' @param plot_data A data frame containing the metric data with columns:
#'   - `group`: The grouping variable
#'   - `<metric>`: The metric column (name specified in metric parameter)
#' @param metric Character string containing the name of the metric column
#'
#' @return A data frame with distribution statistics:
#'   - `group`: The grouping variable
#'   - `mean`: Mean of the metric
#'   - `min`: Minimum value of the metric  
#'   - `p10`: 10th percentile of the metric
#'   - `p25`: 25th percentile of the metric
#'   - `p50`: 50th percentile (median) of the metric
#'   - `p75`: 75th percentile of the metric
#'   - `p90`: 90th percentile of the metric
#'   - `max`: Maximum value of the metric
#'   - `sd`: Standard deviation of the metric
#'   - `range`: Range of the metric (max - min)
#'   - `n`: Number of observations
#'
#' @import dplyr
#' @importFrom stats quantile
#' @importFrom stats sd
#'
#' @keywords internal
#'
calculate_distribution_summary <- function(plot_data, metric) {
  plot_data %>%
    group_by(group) %>%
    summarise(
      mean = mean(!!sym(metric), na.rm = TRUE),
      min = min(!!sym(metric), na.rm = TRUE),
      p10 = quantile(!!sym(metric), 0.10, na.rm = TRUE),
      p25 = quantile(!!sym(metric), 0.25, na.rm = TRUE),
      p50 = quantile(!!sym(metric), 0.50, na.rm = TRUE),
      p75 = quantile(!!sym(metric), 0.75, na.rm = TRUE),
      p90 = quantile(!!sym(metric), 0.90, na.rm = TRUE),
      max = max(!!sym(metric), na.rm = TRUE),
      sd = sd(!!sym(metric), na.rm = TRUE),
      range = max - min,
      n = n()
    ) %>%
    ungroup()
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("calculate_distribution_summary returns correct structure", {
  
  # Create simple test data
  test_data <- data.frame(
    group = c(rep("A", 3), rep("B", 3)),
    test_metric = c(1, 2, 3, 4, 5, 6)
  )
  
  result <- calculate_distribution_summary(test_data, "test_metric")
  
  # Check structure
  expect_s3_class(result, "data.frame")
  expect_equal(nrow(result), 2)
  expect_equal(ncol(result), 12)
  
  # Check column names
  expected_cols <- c("group", "mean", "min", "p10", "p25", "p50", "p75", "p90", "max", "sd", "range", "n")
  expect_true(all(expected_cols %in% names(result)))
  
  # Check that all values are numeric (except group)
  expect_true(all(sapply(result[, -1], is.numeric)))
  
  # Check basic constraints
  expect_true(all(result$n > 0))
  expect_true(all(result$min <= result$max))
  expect_true(all(result$range >= 0))
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Clean subject line text prior to analysis
#'
#' @description
#' This function processes the `Subject` column in a Meeting Query by applying
#' tokenisation using`tidytext::unnest_tokens()`, and removing any stopwords
#' supplied in a data frame (using the argument `stopwords`). This is a
#' sub-function that feeds into `tm_freq()`, `tm_cooc()`, and `tm_wordcloud()`.
#' The default is to return a data frame with tokenised counts of words or
#' ngrams.
#'
#'
#' @param data A Meeting Query dataset in the form of a data frame.
#' @param token A character vector accepting either `"words"` or `"ngrams"`,
#'   determining type of tokenisation to return.
#' @param stopwords A character vector OR a single-column data frame labelled
#'   `'word'` containing custom stopwords to remove.
#' @param ... Additional parameters to pass to `tidytext::unnest_tokens()`.
#'
#' @import dplyr
#' @import ggplot2
#' @importFrom tidytext unnest_tokens
#'
#' @family Text-mining
#'
#' @examples
#' # words
#' tm_clean(mt_data)
#'
#' # ngrams
#' tm_clean(mt_data, token = "ngrams")
#'
#' @return
#' data frame with two columns:
#' - `line`
#' - `word`
#'
#' @export
tm_clean <- function(data,
                     token = "words",
                     stopwords = NULL,
                     ...){

  # Get a dataset with only subjects and a subject line ID
  text_df <-
    data %>%
    select(Subject) %>%
    mutate(line = 1:n(),
           text = as.character(Subject)) %>%
    select(line, text)

  # If `stopwords` is passed as a character vector, convert to data frame
  if(is.character(stopwords)){
    stopwords <-
      data.frame(
        word = stopwords
      )
  }

  # Expand dataset to have each word in the subject as a different observation
  text_df <- text_df %>%
    tidytext::unnest_tokens(
      word,
      text,
      token = token,
      ...)

  # Remove common English stop words (and, or, at, etc)
  text_df <-
    text_df %>%
    dplyr::anti_join(tidytext::stop_words) %>%
    suppressMessages()

  # Remove WPI custom irrelevant words
  if(!is.data.frame(stopwords)){

    stopwords <- dplyr::tibble(word = "")

  }

  text_df %>%
    anti_join(stopwords) %>%
    suppressMessages()

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Summary of After-Hours Collaboration Hours
#'
#' @description
#' Provides an overview analysis of after-hours collaboration time.
#' Returns a bar plot showing average weekly after-hours collaboration hours by default.
#' Additional options available to return a summary table.
#'
#' @details
#' Uses the metric \code{After_hours_collaboration_hours}.
#'
#' @inheritParams create_bar
#' @inherit create_bar return
#'
#' @family Visualization
#' @family After-hours Collaboration
#'
#' @examples
#' # Return a ggplot bar chart
#' afterhours_summary(pq_data, hrvar = "LevelDesignation")
#'
#' # Return a summary table
#' afterhours_summary(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export
afterhours_summary <- function(data,
                              hrvar = "Organization",
                              mingroup = 5,
                              return = "plot"){
  create_bar(data = data,
             metric = "After_hours_collaboration_hours",
             hrvar = hrvar,
             mingroup = mingroup,
             return = return,
             bar_colour = "alert")

}


#' @rdname afterhours_summary
#' @export
afterhours_sum <- afterhours_summary

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a line chart that tracks metrics over time with a 4-week
#'   rolling average
#'
#' @description
#' `r lifecycle::badge('experimental')`
#'
#' Create a two-series line chart that visualizes a set of metric over time for
#' the selected population, with one of the series being a four-week rolling
#' average.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#'   percentage signs. Defaults to `FALSE`.
#' @param plot_title An option to override plot title.
#' @param plot_subtitle An option to override plot subtitle.
#' @param percent Logical value to determine whether to show labels as
#'   percentage signs. Defaults to `FALSE`.
#'
#' @examples
#' pq_data %>%
#'   create_tracking(
#'     metric = "Collaboration_hours",
#'     percent = FALSE
#'   )
#'
#' @family Visualization
#' @family Flexible
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A time-series plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @export

create_tracking <- function(data,
                            metric,
                            plot_title = us_to_space(metric),
                            plot_subtitle = "Measure over time",
                            percent = FALSE){

  data$Date <- as.Date(data$MetricDate, "%m/%d/%Y")

  min_date <- data %>% extract_date_range() %>% pull(Start)
  max_date <- data %>% extract_date_range() %>% pull(End)

  # Set variables
  metrics <- NULL
  `4 week rolling average` <- NULL
  `Weekly average` <- NULL

  data %>%
    group_by(MetricDate) %>%
    summarise(across(.cols = metric,
                     .fns = ~mean(., na.rm = TRUE)),
              .groups = "drop") %>%
    mutate(
      lag0 = lag(!!sym(metric), 0),
      lag1 = lag(!!sym(metric), 1),
      lag2 = lag(!!sym(metric), 2),
      lag3 = lag(!!sym(metric), 3)
    ) %>%
    mutate(`4 week rolling average` = select(., paste0("lag", 0:3)) %>%
             apply(1, function(x) mean(x, na.rm = TRUE))) %>% # Use all available data
    select(-paste0("lag", 0:3)) %>%
    rename(`Weekly average` = metric) %>%
    tidyr::pivot_longer(cols = c(`Weekly average`, `4 week rolling average`),
                 names_to = "metrics",
                 values_to = "value") %>%
    tidyr::drop_na(value) %>%
    ggplot(aes(x = MetricDate,
               y = value,
               colour = metrics)) +
    geom_line(size = 1) +
    scale_colour_manual(
      values = c(
        "Weekly average" = rgb2hex(67, 189, 211),
        "4 week rolling average" = rgb2hex(0, 82, 101)),
      labels = us_to_space,
      guide = guide_legend(reverse = TRUE)
    ) +
    { if(percent == FALSE){
      scale_y_continuous(
        limits = c(0, NA)
      )
    } else if(percent == TRUE){
      scale_y_continuous(
        limits = c(0, 1),
        labels = scales::percent
      )
    }} +
    scale_x_date(position = "top",
                 limits = c(min_date, max_date),
                 date_breaks = "2 weeks") +
    theme_wpa_basic() +
    theme(axis.line = element_blank(),
          axis.ticks = element_blank(),
          axis.title = element_blank(),
          panel.grid.major.x = element_line(color="gray"),
          panel.grid.major.y = element_line(colour = "#D9E7F7", size = 5)) +
    labs(
      title = plot_title,
      subtitle = plot_subtitle,
      caption = extract_date_range(data, return = "text")
    )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_tracking returns a ggplot.", {

  result <- pq_data %>%
            create_tracking(
             metric = "Collaboration_hours",
             percent = FALSE
            )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Sample Meeting Query dataset
#'
#' @description
#' A dataset generated from a Meeting Query from Viva Insights.
#'
#' @family Data
#'
#' @return data frame.
#'
#' @format A data frame with 612 rows and 41 variables:
#' \describe{
#' \item{MeetingId}{ }
#' \item{Attendee_meeting_hours}{ }
#' \item{Number_of_attendees}{ }
#' \item{Number_of_attendees_multitasking}{ }
#' \item{Number_of_attendees_who_didn_t_end_the_meeting_on_time}{ }
#' \item{Number_of_attendees_who_didn_t_join_the_meeting_on_time}{ }
#' \item{Number_of_attendees_who_ended_the_meeting_on_time}{ }
#' \item{Number_of_attendees_who_joined_the_meeting_on_time}{ }
#' \item{Number_of_chats_sent_during_the_meeting}{ }
#' \item{Number_of_emails_sent_during_the_meeting}{ }
#' \item{Number_of_redundant_attendees}{ }
#' \item{Subject}{ }
#' \item{All_Day_Meeting}{ }
#' \item{Cancelled}{ }
#' \item{Recurring}{ }
#' \item{Accept_count}{ }
#' \item{No_response_count}{ }
#' \item{Decline_count}{ }
#' \item{Tentatively_accepted_count}{ }
#' \item{Intended_participant_count}{ }
#' \item{Collaboration_start_time}{ }
#' \item{Organizer}{ }
#' \item{zId}{ }
#' \item{attainment}{ }
#' \item{TimeZone}{ }
#' \item{SupervisorIndicator}{ }
#' \item{Region}{ }
#' \item{Population_Type}{ }
#' \item{Organization}{ }
#' \item{OnsiteDays}{ }
#' \item{Number_of_directs}{ }
#' \item{LevelDesignation}{ }
#' \item{Layer}{ }
#' \item{HireDate}{ }
#' \item{GroupNum}{ }
#' \item{GroupName}{ }
#' \item{FunctionType}{ }
#' \item{Domain}{ }
#' \item{ADO_PersonSK}{ }
#' \item{ADO_PersonIndicator}{ }
#' \item{Duration}{ }
#'
#' }
#' @source \url{https://learn.microsoft.com/en-us/viva/insights/advanced/analyst/meeting-query/}
"mt_data"

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Main theme for 'vivainsights' visualisations
#'
#' @description
#' A theme function applied to 'ggplot' visualisations in 'vivainsights'.
#' Install and load 'extrafont' to use custom fonts for plotting.
#'
#' @param font_size Numeric value that prescribes the base font size
#' for the plot. The text elements are defined relatively to this
#' base font size. Defaults to 12.
#'
#' @param font_family Character value specifying the font family
#' to be used in the plot. The default value is `"Segoe UI"`. To ensure
#' you can use this font, install and load 'extrafont' prior to
#' plotting. There is an initialisation process that is described by:
#' <https://stackoverflow.com/questions/34522732/changing-fonts-in-ggplot2>
#'
#' @import ggplot2
#'
#' @family Themes
#'
#' @return
#' Returns a ggplot object with the applied theme.
#'
#' @export
theme_wpa <- function(font_size = 12, font_family = "Segoe UI"){

  bg_colour <- "#FFFFFF"
  bg_colour2 <- "#CCCCCC" # light grey
  text_colour <- "grey40"

  text_small_dark <- element_text(size = font_size - 2, colour = text_colour, face = "plain")
  text_small_light <- element_text(size = font_size - 2, colour = "#FFFFFF", face = "plain")
  text_normal <- element_text(size = font_size + 2, colour = text_colour, face = "plain")
  text_italic <- element_text(size = font_size + 2, colour = text_colour, face = "italic")

  text_bold <- element_text(size = font_size + 2, colour = text_colour, face = "bold")
  text_title <- element_text(size = font_size + 8, colour = text_colour, face = "bold")

  theme_minimal(base_family = font_family) +
    theme(plot.background = element_blank(),
          # plot.background = element_rect(fill = bg_colour),
          text = text_normal,
          plot.title = text_title,
          plot.subtitle = text_italic,

          axis.title = text_normal,
          axis.text = text_small_dark,

          legend.title = text_small_dark,
          legend.text = text_small_dark) +

    theme(axis.line = element_line(colour = "grey20"),
          axis.ticks = element_blank(),

          legend.position = "bottom",
          legend.title = element_blank(),

          panel.grid = element_blank(),
          strip.background = element_rect(fill = bg_colour2, colour = bg_colour2),
          strip.text = text_small_dark)
}

#' @title Basic theme for 'vivainsights' visualisations
#'
#' @description
#' A theme function applied to 'ggplot' visualisations in 'vivainsights'.
#' Based on `theme_wpa()` but has no font requirements.
#'
#' @param font_size Numeric value that prescribes the base font size
#' for the plot. The text elements are defined relatively to this
#' base font size. Defaults to 12.
#'
#' @import ggplot2
#'
#' @family Themes
#'
#' @return
#' Returns a ggplot object with the applied theme.
#'
#' @export
theme_wpa_basic <- function(font_size = 12){

  bg_colour <- "#FFFFFF"
  bg_colour2 <- "#CCCCCC" # light grey
  text_colour <- "grey40"

  text_tiny_dark <- element_text(size = font_size - 4, colour = text_colour, face = "plain")
  text_small_dark <- element_text(size = font_size - 2, colour = text_colour, face = "plain")
  text_small_light <- element_text(size = font_size - 2, colour = "#FFFFFF", face = "plain")
  text_normal <- element_text(size = font_size + 0, colour = text_colour, face = "plain")
  text_italic <- element_text(size = font_size + 0, colour = text_colour, face = "italic")

  text_bold <- element_text(size = font_size + 0, colour = text_colour, face = "bold")
  text_title <- element_text(size = font_size + 2, colour = text_colour, face = "bold")

  theme_minimal() +
    theme(plot.background = element_blank(),
          # plot.background = element_rect(fill = bg_colour),
          text = text_normal,
          plot.title = text_title,
          plot.subtitle = text_normal,
          plot.caption = text_tiny_dark,

          axis.title = text_normal,
          axis.text = text_small_dark,

          legend.title = text_small_dark,
          legend.text = text_small_dark) +

    theme(axis.line = element_line(colour = "grey20"),
          axis.ticks = element_blank(),

          legend.position = "bottom",
          # legend.title = element_blank(),

          panel.grid = element_blank(),
          strip.background = element_rect(fill = bg_colour2, colour = bg_colour2),
          strip.text = text_small_dark)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Flag unusual outlook time settings for work day start and end time
#'
#' @description This function flags unusual outlook calendar settings for
#' start and end time of work day.
#'
#' @import dplyr
#'
#' @param data A data frame containing a Person Query.
#' @param threshold A numeric vector of length two, specifying the hour
#'   threshold for flagging. Defaults to c(4, 15).
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"text"` (default)
#'   - `"message"`
#'   - `"data"`
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"text"`: string. A diagnostic message.
#'   - `"message"`: message on console. A diagnostic message.
#'   - `"data"`: data frame. Data where flag is present.
#'
#' See `Value` for more information.
#'
#' @family Data Validation
#'
#' @examples
#' # Demo with `pq_data` example where Outlook Start and End times are imputed
#' spq_df <- pq_data
#'
#' spq_df$WorkingStartTimeSetInOutlook <- "6:30"
#'
#' spq_df$WorkingEndTimeSetInOutlook <- "23:30"
#'
#' # Return a message
#' flag_outlooktime(spq_df, threshold = c(5, 13))
#'
#' # Return data
#' flag_outlooktime(spq_df, threshold = c(5, 13), return = "data")
#'
#' @export
flag_outlooktime <- function(data, threshold = c(4, 15), return = "message"){

  # pad_times <- function(x){
  #   if(nchar(x) == 1){
  #     x <- paste0("0", x, "00")
  #   } else if(nchar(x) == 2){
  #     x <- paste0(x, "00")
  #   } else if(nchar(x) == 3){
  #     x <- paste0("0", x)
  #   } else {
  #     x
  #   }
  # }
  #
  # pad_times <- Vectorize(pad_times)

  ## Clean `WorkingStartTimeSetInOutlook`

  if(any(grepl(pattern = "\\d{1}:\\d{1,2}", x = data$WorkingStartTimeSetInOutlook))){

    # Pad two zeros and keep last five characters
    data$WorkingStartTimeSetInOutlook <-
      paste0("00", data$WorkingStartTimeSetInOutlook) %>%
      substr(start = nchar(.) - 4, stop = nchar(.))

  }

  ## Clean `WorkingEndTimeSetInOutlook`

  if(any(grepl(pattern = "\\d{1}:\\d{1,2}", x = data$WorkingEndTimeSetInOutlook))){

    # Pad two zeros and keep last five characters
    data$WorkingEndTimeSetInOutlook <-
      paste0("00", data$WorkingEndTimeSetInOutlook) %>%
      substr(start = nchar(.) - 4, stop = nchar(.))


  }

  if(
      any(
        !grepl(pattern = "\\d{1,2}:\\d{1,2}", x = data$WorkingStartTimeSetInOutlook) |
        !grepl(pattern = "\\d{1,2}:\\d{1,2}", x = data$WorkingEndTimeSetInOutlook)
      )
    ){

    stop("Please check data format for `WorkingStartTimeSetInOutlook` or `WorkingEndTimeSetInOutlook.\n
         These variables must be character vectors, and have the format `%H:%M`, such as `07:30` or `23:00`.")

  }

  clean_times <- function(x){
    out <- gsub(pattern = ":", replacement = "", x = x)
    # out <- pad_times(out)
    strptime(out, format = "%H%M")
  }

  flagged_data <-
    data %>%
    # mutate_at(vars(WorkingStartTimeSetInOutlook, WorkingEndTimeSetInOutlook), ~clean_times(.)) %>%
    mutate(across(c(WorkingStartTimeSetInOutlook, WorkingEndTimeSetInOutlook), ~gsub(pattern = ":", replacement = "", x = .))) %>%
    mutate(across(c(WorkingStartTimeSetInOutlook, WorkingEndTimeSetInOutlook), ~strptime(., format = "%H%M"))) %>%
    mutate(WorkdayRange = as.numeric(WorkingEndTimeSetInOutlook - WorkingStartTimeSetInOutlook, units = "hours"),
           WorkdayFlag1 = WorkdayRange < threshold[[1]],
           WorkdayFlag2 = WorkdayRange > threshold[[2]],
           WorkdayFlag = WorkdayRange < threshold[[1]] | WorkdayRange > threshold[[2]]) %>%
    select(PersonId, WorkdayRange, WorkdayFlag, WorkdayFlag1, WorkdayFlag2)

  ## Short working hour settings
  FlagN1 <- sum(flagged_data$WorkdayFlag1, na.rm = TRUE)
  FlagProp1 <- mean(flagged_data$WorkdayFlag1, na.rm = TRUE)
  FlagProp1F <- paste0(round(FlagProp1 * 100, 1), "%") # Formatted

  ## Long working hour settings
  FlagN2 <- sum(flagged_data$WorkdayFlag2, na.rm = TRUE)
  FlagProp2 <- mean(flagged_data$WorkdayFlag2, na.rm = TRUE)
  FlagProp2F <- paste0(round(FlagProp2 * 100, 1), "%") # Formatted

  ## Short or long working hoursettings
  FlagN <- sum(flagged_data$WorkdayFlag, na.rm = TRUE)
  FlagProp <- mean(flagged_data$WorkdayFlag, na.rm = TRUE)
  FlagPropF <- paste0(round(FlagProp * 100, 1), "%") # Formatted

  ## Flag Messages
  Warning_Message <- paste0("[Warning]  ", FlagPropF, " (", FlagN, ") ", "of the person-date rows in the data have extreme Outlook settings.")
  Pass_Message1 <- paste0("[Pass] Only ", FlagPropF, " (", FlagN, ") ", "of the person-date rows in the data have extreme Outlook settings.")
  Pass_Message2 <- paste0("There are no extreme Outlook settings in this dataset (Working hours shorter than  ", threshold[[1]], " hours, or longer than ", threshold[[2]], " hours.")
  Detail_Message <-  paste0(FlagProp1F, " (", FlagN1, ") ", " have an Outlook workday shorter than ", threshold[[1]], " hours, while ",
                        FlagProp2F, " (", FlagN2, ") ", "have a workday longer than ", threshold[[2]], " hours.")


  if(FlagProp >= .05){
    FlagMessage <- paste(Warning_Message, Detail_Message, sep = "\n")

  } else if(FlagProp < .05 & FlagProp > 0){
    FlagMessage <- paste(Pass_Message1, Detail_Message, sep = "\n")

  } else if(FlagProp==0){
    FlagMessage <- Pass_Message2
  }

  ## Print diagnosis
  ## Should implement options to return the PersonIds or a full data frame
  if(return == "text"){

    FlagMessage

  } else if(return == "message"){

    message(FlagMessage)

  } else if(return == "data"){

    flagged_data[flagged_data$WorkdayFlag == TRUE,]

  } else {

    stop("Error: please check inputs for `return`")

  }
}

#' @title Distribution of Email Hours (Fizzy Drink plot)
#'
#' @description
#' Analyze weekly email hours distribution, and returns
#' a 'fizzy' scatter plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @inheritParams create_fizz
#' @inherit create_fizz return
#'
#' @family Visualization
#' @family Emails
#'
#' @examples
#'
#' # Return plot
#' email_fizz(pq_data, hrvar = "Organization", return = "plot")
#'
#' # Return summary table
#' email_fizz(pq_data, hrvar = "Organization", return = "table")
#'
#' @export

email_fizz <- function(data,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot"){

  create_fizz(data = data,
              metric = "Email_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify employees who have churned from the dataset
#'
#' @description
#' This function identifies and counts the number of employees who have churned
#' from the dataset by measuring whether an employee who is present in the first
#' `n` (n1) weeks of the data is present in the last `n` (n2) weeks of the data.
#'
#' @details
#' An additional use case of this function is the ability to identify
#' "new-joiners" by using the argument `flip`.
#'
#' @param data A Person Query as a data frame. Must contain a `PersonId`.
#' @param n1 A numeric value specifying the number of weeks at the beginning of
#'   the period that defines the measured employee set. Defaults to 6.
#' @param n2 A numeric value specifying the number of weeks at the end of the
#'   period to calculate whether employees have churned from the data. Defaults
#'   to 6.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"message"` (default)
#'   - `"text"`
#'   - `"data"`
#'
#' See `Value` for more information.
#'
#' @param flip Logical, defaults to FALSE. This determines whether to reverse
#'   the logic of identifying the non-overlapping set. If set to `TRUE`, this
#'   effectively identifies new-joiners, or those who were not present in the
#'   first n weeks of the data but were present in the final n weeks.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"message"`: Message on console. A diagnostic message.
#'   - `"text"`: String. A diagnostic message.
#'   - `"data"`: Character vector containing the the `PersonId` of
#'   employees who have been identified as churned.
#'
#' @details
#' If an employee is present in the first `n` weeks of the data but not present
#' in the last `n` weeks of the data, the function considers the employee as
#' churned. As the measurement period is defined by the number of weeks from the
#' start and the end of the passed data frame, you may consider filtering the
#' dates accordingly before running this function.
#'
#' Another assumption that is in place is that any employee whose `PersonId` is
#' not available in the data has churned. Note that there may be other reasons
#' why an employee's `PersonId` may not be present, e.g. maternity/paternity
#' leave, Viva Insights license has been removed, shift to a
#' low-collaboration role (to the extent that he/she becomes inactive).
#'
#' @family Data Validation
#'
#' @examples
#' pq_data %>% identify_churn(n1 = 3, n2 = 3, return = "message")
#'
#' @export
identify_churn <- function(data,
                           n1 = 6,
                           n2 = 6,
                           return = "message",
                           flip = FALSE){

  data$Date <- as.Date(data$MetricDate, format = "%m/%d/%Y") # Ensure correct format

  unique_dates <- unique(data$MetricDate) # Vector of unique dates

  nlen <- length(unique_dates) # Total number of unique dates

  # First and last n weeks
  firstnweeks <- sort(unique_dates)[1:n1]
  lastnweeks <- sort(unique_dates, decreasing = TRUE)[1:n2]

  ## People in the first week
  first_peeps <-
    data %>%
    dplyr::filter(MetricDate %in% firstnweeks) %>%
    dplyr::pull(PersonId) %>%
    unique()

  ## People in the last week
  final_peeps <-
    data %>%
    dplyr::filter(MetricDate %in% lastnweeks) %>%
    dplyr::pull(PersonId) %>%
    unique()

  if(flip == FALSE){

    ## In first, not in last
    churner_id <- setdiff(first_peeps, final_peeps)

    ## Message
    printMessage <-
      paste0("Churn:\nThere are ", length(churner_id),
             " employees from ", min(firstnweeks), " to ",
             max(firstnweeks), " (", n1, " weeks)",
             " who are no longer present in ",
             min(lastnweeks), " to ", max(lastnweeks),
             " (", n2, " weeks).")

  } else if(flip == TRUE){

    ## In last, not in first
    ## new joiners
    churner_id <- dplyr::setdiff(final_peeps, first_peeps)

    ## Message
    printMessage <-
      paste0("New joiners:\nThere are ", length(churner_id),
             " employees from ", min(lastnweeks), " to ",
             max(lastnweeks), " (", n2, " weeks)",
             " who were not present in ",
             min(firstnweeks), " to ", max(firstnweeks),
             " (", n1, " weeks).")

  } else {

    stop("Invalid argument for `flip`")

  }



  if(return == "message"){

    message(printMessage)

  } else if(return == "text"){

    printMessage

  } else if(return == "data"){

    churner_id

  } else {

    stop("Invalid `return`")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Email Summary
#'
#' @description
#' Provides an overview analysis of weekly email hours.
#' Returns a bar plot showing average weekly email hours by default.
#' Additional options available to return a summary table.
#'
#' @inheritParams create_bar
#' @inherit create_bar return
#'
#' @family Visualization
#' @family Emails
#'
#' @examples
#' # Return a ggplot bar chart
#' email_summary(pq_data, hrvar = "LevelDesignation")
#'
#' # Return a summary table
#' email_summary(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

email_summary <- function(data,
                          hrvar = "Organization",
                          mingroup = 5,
                          return = "plot"){

  create_bar(data = data,
             metric = "Email_hours",
             hrvar = hrvar,
             mingroup = mingroup,
             return = return,
             bar_colour = "darkblue")


}

#' @rdname email_summary
#' @export
email_sum <- email_summary

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Heat mapped horizontal bar plot over time for any metric
#'
#' @description
#' Provides a week by week view of a selected Viva Insights metric. By
#' default returns a week by week heatmap bar plot, highlighting the points in
#' time with most activity. Additional options available to return a summary
#' table.
#'
#' @template spq-params
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#' @param palette Character vector containing colour codes, ranked from the
#' lowest value to the highest value. This is passed directly to
#' `ggplot2::scale_fill_gradientn()`.
#' @param return Character vector specifying what to return, defaults to
#' `"plot"`.
#' Valid inputs are "plot" and "table".
#' @param legend_title String to be used as the title of the legend. Defaults to
#' `"Hours"`.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#'
#' @family Visualization
#' @family Flexible
#' @family Time-series
#'
#' @examples
#' create_trend(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation")
#'
#' # custom colours
#' create_trend(
#'   pq_data,
#'   metric = "Collaboration_hours",
#'   hrvar = "LevelDesignation",
#'   palette = c(
#'     "#FB6107",
#'     "#F3DE2C",
#'     "#7CB518",
#'     "#5C8001"
#'   )
#'   )
#'
#' @return
#' Returns a 'ggplot' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @export

create_trend <- function(data,
                         metric,
                         hrvar = "Organization",
                         mingroup = 5,
                         palette = c("steelblue4",
                                    "aliceblue",
                                    "white",
                                    "mistyrose1",
                                    "tomato1"),
                         return = "plot",
                         legend_title = "Hours"){

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Clean metric name
  clean_nm <- us_to_space(metric)

  myTable <-
    data %>%
    mutate(MetricDate = as.Date(MetricDate, "%m/%d/%Y")) %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    select(PersonId, MetricDate, group, !!sym(metric)) %>%
    group_by(group) %>%
    mutate(Employee_Count = n_distinct(PersonId)) %>%
    filter(Employee_Count >= mingroup)  # Keep only groups above privacy threshold

  myTable <-
    myTable %>%
    group_by(MetricDate, group) %>%
    summarize(Employee_Count = mean(Employee_Count, na.rm = TRUE),
              !!sym(metric) := mean(!!sym(metric), na.rm = TRUE))

  myTable_plot <- myTable %>% select(MetricDate, group, !!sym(metric))

  myTable_return <-  myTable_plot %>% tidyr::spread(MetricDate, !!sym(metric))

  plot_object <-
    myTable_plot %>%
    ggplot(aes(x = MetricDate , y = group , fill = !!sym(metric))) +
    geom_tile(height=.5) +
    scale_x_date(position = "top") +
    scale_fill_gradientn(name = legend_title,
                         colours = palette) +
    theme_wpa_basic() +
    theme(axis.line.y = element_blank(), axis.title.y = element_blank()) +
    labs(title = clean_nm,
         subtitle = paste("Hotspots by", tolower(camel_clean(hrvar)))) +
    xlab("Date") +
    ylab(hrvar) +
    labs(caption = extract_date_range(data, return = "text"))

  if(return == "table"){

    myTable_return

  } else if(return == "plot"){

    plot_object

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Flag unusual high collaboration hours to after-hours collaboration
#'   hours ratio
#'
#' @description This function flags persons who have an unusual ratio
#' of collaboration hours to after-hours collaboration hours.
#' Returns a character string by default.
#'
#' @template ch
#'
#' @import dplyr
#'
#' @param data A data frame containing a Person Query.
#' @param threshold Numeric value specifying the threshold for flagging.
#'   Defaults to 30.
#' @param return String to specify what to return. Options include:
#'   - `"message"`
#'   - `"text"`
#'   - `"data"`
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"message"`: message in the console containing diagnostic summary
#'   - `"text"`: string containing diagnostic summary
#'   - `"data"`: data frame. Person-level data with flags on unusually high or
#'   low ratios
#'
#' @family Data Validation
#'
#' @examples
#' flag_ch_ratio(pq_data)
#'
#'
#' data.frame(PersonId = c("Alice", "Bob"),
#'            Collaboration_hours = c(30, 0.5),
#'            After_hours_collaboration_hours = c(0.5, 30)) %>%
#'   flag_ch_ratio()
#'
#' @export
flag_ch_ratio <- function(data, threshold = c(1, 30), return = "message"){

  min_thres <- min(threshold, na.rm = TRUE)
  max_thres <- max(threshold, na.rm = TRUE)

  ## Check for high collab hours but lower afterhour collab hours
  ## Because of faulty outlook settings
  ch_summary <-
    data %>%
    group_by(PersonId) %>%
    summarise(across(c(Collaboration_hours, After_hours_collaboration_hours), ~mean(.))) %>%
    mutate(CH_ratio = Collaboration_hours / After_hours_collaboration_hours) %>%
    arrange(desc(CH_ratio)) %>%
    mutate(CH_FlagLow = ifelse(CH_ratio < min_thres, TRUE, FALSE),
           CH_FlagHigh = ifelse(CH_ratio > max_thres, TRUE, FALSE),
           CH_Flag = ifelse(CH_ratio > max_thres | CH_ratio < min_thres, TRUE, FALSE))

  ## Percent of people with high collab hours + low afterhour collab hours
  CHFlagN <- sum(ch_summary$CH_Flag, na.rm = TRUE)
  CHFlagProp <- mean(ch_summary$CH_Flag, na.rm = TRUE)
  CHFlagProp2 <- paste(round(CHFlagProp * 100), "%") # Formatted

  CHFlagMessage_Warning <- paste0("[Warning]  The ratio of after-hours collaboration to total collaboration hours is outside the expected threshold for ", CHFlagN, " employees (", CHFlagProp2, " of the total).")
  CHFlagMessage_Pass_Low <- paste0("[Pass] The ratio of after-hours collaboration to total collaboration hours is outside the expected threshold for only ", CHFlagN, " employees (", CHFlagProp2, " of the total).")
  CHFlagMessage_Pass_Zero <- paste0("[Pass] The ratio of after-hours collaboration to total collaboration hours falls within the expected threshold for all employees.")


  CHFlagLowN <- sum(ch_summary$CH_FlagLow, na.rm = TRUE)
  CHFlagLowProp <- mean(ch_summary$CH_FlagLow, na.rm = TRUE)
  CHFlagLowProp2 <- paste(round(CHFlagLowProp * 100), "%") # Formatted
  CHFlagLowMessage <- paste0("- ", CHFlagLowN, " employees (", CHFlagLowProp2,
                          ") have an unusually low after-hours collaboration")

  CHFlagHighN <- sum(ch_summary$CH_FlagHigh, na.rm = TRUE)
  CHFlagHighProp <- mean(ch_summary$CH_FlagHigh, na.rm = TRUE)
  CHFlagHighProp2 <- paste(round(CHFlagHighProp * 100), "%") # Formatted
  CHFlagHighMessage <- paste0("- ", CHFlagHighN, " employees (", CHFlagHighProp2 , ") have an unusually high after-hours collaboration (relative to weekly collaboration hours)")

  if(CHFlagProp >= .05){
    CHFlagMessage <- paste(CHFlagMessage_Warning, CHFlagHighMessage, CHFlagLowMessage, sep = "\n")
  } else if(CHFlagProp < .05 & CHFlagProp2 > 0){
    CHFlagMessage <- paste(CHFlagMessage_Pass_Low, CHFlagHighMessage, CHFlagLowMessage, sep = "\n")
  } else if(CHFlagProp==0){
    CHFlagMessage <- CHFlagMessage_Pass_Zero
  }

  ## Print diagnosis
  ## Should implement options to return the PersonIds or a full data frame
  if(return == "message"){

    message(CHFlagMessage)

  } else if(return == "text"){

    CHFlagMessage

  } else if(return == "data") {

    ch_summary

  } else {

    stop("Invalid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Extract HR attribute variables
#'
#' @description
#' This function uses a combination of variable class,
#' number of unique values, and regular expression matching
#' to extract HR / organisational attributes from a data frame.
#'
#' @param data A data frame to be passed through.
#' @param max_unique A numeric value representing the maximum
#' number of unique values to accept for an HR attribute. Defaults to 50.
#' @param exclude_constants Logical value to specify whether single-value HR
#' attributes are to be excluded. Defaults to `TRUE`.
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"names"`
#'   - `"vars"`
#'
#' See `Value` for more information.

#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"names"`: character vector identifying all the names of HR variables
#'   present in the data.
#'   - `"vars"`: data frame containing all the columns of HR variables present
#'    in the data.
#'
#' @family Support
#' @family Data Validation
#'
#' @examples
#' pq_data %>% extract_hr(return = "names")
#'
#' pq_data %>% extract_hr(return = "vars")
#'
#' @export
extract_hr <- function(data,
                       max_unique = 50,
                       exclude_constants = TRUE,
                       return = "names"){


  if(exclude_constants == TRUE){

    min_unique = 1

  } else if (exclude_constants == FALSE){

    min_unique = 0

  }


  hr_var <-
    data %>%
    dplyr::select(where(~(is.character(.) | is.logical(.) | is.factor(.)))) %>%
    dplyr::select(where(~(dplyr::n_distinct(.) < max_unique))) %>%
    dplyr::select(where(~(dplyr::n_distinct(.) > min_unique))) %>% # Exc constants
    dplyr::select(where(~!all(is_date_format(.)))) %>%
    names() %>%
    .[.!= "WorkingStartTimeSetInOutlook"] %>%
    .[.!= "WorkingEndTimeSetInOutlook"] %>%
    .[.!= "WorkingDaysSetInOutlook"]

  if(return == "names"){
    return(hr_var)
  } else if(return == "vars"){
    return(dplyr::select(data, tidyselect::all_of(hr_var)))
  } else {
   stop("Invalid input for return")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)

test_that("extract_hr returns a character vector when return = 'names'", {

  result <- pq_data %>% extract_hr(return = "names")

  expect_type(result, "character")
  expect_true(length(result) > 0)
})

test_that("extract_hr returns a data frame when return = 'vars'", {

  result <- pq_data %>% extract_hr(return = "vars")

  expect_s3_class(result, "data.frame")
  expect_true(ncol(result) > 0)
})

test_that("extract_hr emits message when columns exceed max_unique", {

  # Use a low threshold so some columns are excluded
  expect_message(
    pq_data %>% extract_hr(max_unique = 3, return = "names"),
    "column\\(s\\) excluded due to max_unique"
  )
})

test_that("extract_hr emits no message when no columns exceed max_unique", {

  # Use a very high threshold so nothing is excluded
  expect_no_message(
    pq_data %>% extract_hr(max_unique = 10000, return = "names")
  )
})

test_that("extract_hr errors on invalid return argument", {

  expect_error(
    pq_data %>% extract_hr(return = "invalid"),
    "Invalid input for return"
  )
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Perform a Word or Ngram Frequency Analysis and return a Circular Bar
#'   Plot
#'
#' @description
#' Generate a circular bar plot with frequency of words / ngrams.
#' This function is used within `meeting_tm_report()`.
#'
#' @details
#' This function uses `tm_clean()` as the underlying data wrangling function.
#' There is an option to remove stopwords by passing a data frame into the
#' `stopwords` argument.
#'
#' @param data A Meeting Query dataset in the form of a data frame.
#' @param token A character vector accepting either `"words"` or `"ngram"`,
#'   determining type of tokenisation to return.
#' @param stopwords A character vector OR a single-column data frame labelled
#'   `'word'` containing custom stopwords to remove.
#' @param keep A numeric vector specifying maximum number of words to keep.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A circular bar plot.
#'   - `"table"`: data frame. A summary table.
#'
#' @import dplyr
#' @import ggplot2
#' @importFrom tidytext unnest_tokens
#' @importFrom stats na.omit
#'
#'
#' @examples
#' # circular network plot with words
#' tm_freq(mt_data, token = "words")
#'
#' # circular network plot with ngrams
#' tm_freq(mt_data, token = "ngrams")
#'
#' # summary table of text frequency
#' tm_freq(mt_data, token = "words", return = "table")
#'
#' @family Text-mining
#'
#' @export
tm_freq <- function(data,
                    token = "words",
                    stopwords = NULL,
                    keep = 100,
                    return = "plot"){
  # Clean data
  text_df <- suppressMessages(tm_clean(data = data,
                                       token = token,
                                       stopwords = stopwords))

  # Calculate frequency of word sand keep top 100 terms
  text_count <-
    text_df %>%
    count(word, sort = TRUE) %>%
    stats::na.omit() %>%
    top_n(keep)

  # Plot as a circular bar chart
  # Note that id is a factor. If x is numeric, there is some space between the first bar
  # `fill` in `geom_bar` add the bars with a blue color
  # Limits of the plot = very important.
  # The negative value controls the size of the inner circle,
  # the positive one is useful to add size over each bar
  # Custom the theme: no axis title and no cartesian grid
  # `coord_polar` makes the coordinate polar instead of cartesian.
  # `geom_text` adds the labels, using the label_data dataframe that we have created before

  p <-
    ggplot(text_count, aes(x=as.factor(word), y=n)) +
    geom_bar(stat="identity", fill=alpha("skyblue", 0.7)) +
    ylim(-100,max(text_count$n) + 10) +
    theme_minimal() +
    theme(
      axis.text = element_blank(),
      axis.title = element_blank(),
      panel.grid = element_blank(),
      plot.margin = unit(rep(-1,4), "cm") # Adjust the margin to make in sort labels are not truncated!
    ) +
    coord_polar(start = 0) +
    ggrepel::geom_text_repel(
      data = text_count,
      aes(x=word, y=n+10, label=word),
      color = "black",
      fontface = "bold",
      alpha = 0.6,
      size = 2.5,
      inherit.aes = FALSE,
      max.overlaps = getOption("ggrepel.max.overlaps", default = 50)
      )

  if(return == "table"){

    text_count %>%
      as_tibble() %>%
      return()

  } else if(return == "plot"){

    return(p)

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Manager 1:1 Time as a 100% stacked bar
#'
#' @description
#' Analyze Manager 1:1 Time distribution.
#' Returns a stacked bar plot of different buckets of 1:1 time.
#' Additional options available to return a table with distribution elements.
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @family Visualization
#' @family Managerial Relations
#'
#' @examples
#' # Return plot
#' one2one_dist(pq_data, hrvar = "Organization", return = "plot")
#'
#' # Return summary table
#' one2one_dist(pq_data, hrvar = "Organization", return = "table")
#' @export

one2one_dist <- function(data,
                         hrvar = "Organization",
                         mingroup = 5,
                         dist_colours = c("#facebc",
                                          "#fcf0eb",
                                          "#b4d5dd",
                                          "#bfe5ee"),
                         return = "plot",
                         cut = c(5, 15, 30)) {

  cleaned_data <-
    data %>%
    mutate(`Scheduled 1:1 meeting and call minutes with manager` =
             Meeting_and_call_hours_with_manager_1_1 * 60)

  create_dist(data = cleaned_data,
              metric = "Scheduled 1:1 meeting and call minutes with manager",
              hrvar = hrvar,
              mingroup = mingroup,
              dist_colours = dist_colours,
              return = return,
              cut = cut,
              unit = "minutes")

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

###################################################################

## Global Variables

## This file is added to minimize the false positives flagged during R CMD check.
## Example: afterhours_trend: no visible binding for global variable 'Date'

###################################################################

utils::globalVariables(
  c(
    "PersonId",
    ".",
    "group",
    "Employee_Count",
    "PANEL",
    "y",
    "x",
    "bucket_hours",
    "Employees",
    "heat_colours",
    "xmin",
    "xmax",
    "Date",
    "MetricDate", # New `Date`
    "top_group",
    "OrgGroup",
    "var1",
    "var2",
    "Total",
    "Metric",
    "Value",
    "Start",
    "End",
    "Group",
    "value",
    "where", # in `jitter_metrics()` for tidyselect
    "Hours",
    "Collaboration_hours",
    "External_collaboration_hours",
    "attribute",
    "values",
    "calculation",
    "variable",
    "value_rescaled",
    "Meeting_and_call_hours_with_manager_1_1",
    "Meetings_and_calls_with_manager_1_on_1",
    "Cadence_of_1_on_1_meetings_and_calls_with_manager",
    "Organization",
    "flag_nkw",
    "holidayweek",
    "mean_collab",
    "perc",
    "perc_nkw",
    "pct",
    "total",
    "ymax",
    "ymin",
    "z_score",
    ".N",
    "After_hours_collaboration_hours",
    "Attributes",
    "CH_ratio",
    "Collaboration_hrs",
    "HRAttribute",
    "Unique values",
    "WorkingEndTimeSetInOutlook",
    "name",
    "Email_hours",
    "Instant_message_hours",
    "values",
    "WorkingStartTimeSetInOutlook",
    "output_list",
    "Email_ratio",
    "PersonCount",
    "WorkdayFlag",
    "WorkdayRange",
    "identifier",
    "pre_group",
    "Emails_sent",
    "Shifts",
    "WorkdayFlag1",
    "subject_validate",
    "FirstValue",
    "TenureYear",
    "WorkdayFlag2",
    "tenure_years",
    "N",
    "V1",
    "V2",
    "Subject",
    "line",
    "text",
    "word",
    "freq",
    "PrimaryCollaborator_PersonId",
    "PrimaryOrg",
    "SecondaryCollaborator_PersonId",
    "SecondaryOrg",
    "betweenness",
    "closeness",
    "cluster",
    "colour",
    "degree",
    "eigenvector",
    "from",
    "metric_prop",
    "node_size",
    "org_size",
    "pagerank",
    "to",
    "Variable",
    "pval",
    "WOE",
    "ODDS",
    "labelpos",
    "cum_population",
    "cum_values",
    "cum_values_prop",
    "GainedHabit",
    "HabitCurve",
    "IsHabit",
    "LostHabit",
    "Most recent week - Total persons with habit",
    "Total Person-weeks",
    "Total Person-weeks with habit",
    "cumsum_value",
    "lagged_cumsum",
    "sum_last_w",
     "Period",
     "Y",
     "label",
     "IsHabit12w",
     "IsHabit4w",
     "prop",
     "target_metric",
     "adoption_week",
     "cumulative_adopters",
     "cumulative_percent",
     "new_adopters",
     "moving_avg",
     "enable_week",
     "weeks_to_adopt",
     "adoption_delay_percent",
     "RogersSegment_delay",
     "RogersSegment",
     "cumulative",
     "earliest_adoption",
     "latest_adoption",
     "median_adoption_week",
     "total_adopters",
     "id",
     "segment_count"
    )
)

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Collaboration Hours as a 100% stacked bar
#'
#' @description
#' Analyze the distribution of Collaboration Hours.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @template ch
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' # Return plot
#' collaboration_dist(pq_data, hrvar = "Organization")
#'
#' # Return summary table
#' collaboration_dist(pq_data, hrvar = "Organization", return = "table")
#' @export

collaboration_dist <- function(data,
                               hrvar = "Organization",
                               mingroup = 5,
                               return = "plot",
                               cut = c(15, 20, 25)) {

  create_dist(data = data,
              metric = "Collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              cut = cut)


}

#' @rdname collaboration_dist
#' @export
collab_dist <- collaboration_dist

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Horizontal stacked bar plot for any metric
#'
#' @description
#' Creates either a single bar plot, of a stacked bar using selected metrics 
#' (where the typical use case is to create different definitions of
#' collaboration hours).
#' Returns a plot by default.
#' Additional options available to return a summary table.
#'
#' @template spq-params
#' @param metrics A character vector to specify variables to be used
#' in calculating the "Total" value, e.g. c("Meeting_hours", "Email_hours").
#' The order of the variable names supplied determine the order in which they
#' appear on the stacked plot.
#' @param return Character vector specifying what to return, defaults to "plot".
#' Valid inputs are "plot" and "table".
#' @param stack_colours
#' A character vector to specify the colour codes for the stacked bar charts.
#' @param percent Logical value to determine whether to show labels as
#'   percentage signs. Defaults to `FALSE`.
#' @param plot_title String. Option to override plot title.
#' @param plot_subtitle String. Option to override plot subtitle.
#' @param legend_lab String. Option to override legend title/label. Defaults to
#' `NULL`, where the metric name will be populated instead.
#' @param rank String specifying how to rank the bars. Valid inputs are:
#'   - `"descending"` - ranked highest to lowest from top to bottom (default).
#'   - `"ascending"` - ranked lowest to highest from top to bottom.
#'   - `NULL` - uses the original levels of the HR attribute.
#' @param xlim An option to set max value in x axis.
#' @param text_just `r lifecycle::badge('experimental')` A numeric value
#'   controlling for the horizontal position of the text labels. Defaults to
#'   0.5.
#' @param text_colour `r lifecycle::badge('experimental')` String to specify
#'   colour to use for the text labels. Defaults to `"#FFFFFF"`.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats reorder
#'
#' @family Visualization
#' @family Flexible
#'
#' @return
#' Returns a 'ggplot' object by default, where 'plot' is passed in `return`.
#' When 'table' is passed, a summary table is returned as a data frame.
#'
#' @examples
#' pq_data %>%
#'   create_stacked(hrvar = "LevelDesignation",
#'                  metrics = c("Meeting_hours", "Email_hours"),
#'                  return = "plot")
#'
#' pq_data %>%
#'   create_stacked(hrvar = "FunctionType",
#'                  metrics = c("Meeting_hours",
#'                              "Email_hours",
#'                              "Call_hours",
#'                              "Chat_hours"),
#'                  return = "plot",
#'                  rank = "ascending")
#'
#' pq_data %>%
#'   create_stacked(hrvar = "FunctionType",
#'                  metrics = c("Meeting_hours",
#'                              "Email_hours",
#'                              "Call_hours",
#'                              "Chat_hours"),
#'                  return = "table")
#'
#' @export
create_stacked <- function(data,
                           hrvar = "Organization",
                           metrics = c("Meeting_hours",
                                       "Email_hours"),
                           mingroup = 5,
                           return = "plot",
                           stack_colours = c("#1d627e",
                                             "#34b1e2",
                                             "#b4d5dd",
                                             "#adc0cb"),
                           percent = FALSE,
                           plot_title = "Collaboration Hours",
                           plot_subtitle = paste("Average by", tolower(camel_clean(hrvar))),
                           legend_lab = NULL,
                           rank = "descending",
                           xlim = NULL,
                           text_just = 0.5,
                           text_colour = "#FFFFFF"
                           ){

  ## Check inputs
  required_variables <- c("MetricDate",
                          metrics,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Plot Title Handling
  if(is(object = metrics, class2 = "character") & length(metrics) == 1){
    plot_title <- us_to_space(metrics)
  }
  else{   #vector of strings
    plot_title <- paste(plot_title, collapse = ", ")
  }

  ## Handle `legend_lab`
  if(is.null(legend_lab)){
    legend_lab <- gsub("_", " ", metrics)
  }

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  n_count <-
    data %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    group_by(group) %>%
    summarise(Employee_Count = n_distinct(PersonId))

  ## Person level table
  myTable <-
    data %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    select(PersonId, group, tidyselect::all_of(metrics)) %>%
    group_by(PersonId, group) %>%
    summarise(across(.cols = all_of(metrics), .fns = ~mean(.)),
      .groups = "drop") %>%
    mutate(Total = select(., metrics) %>% apply(1, sum)) %>%
    left_join(n_count, by = "group") %>%
    # Keep only groups above privacy threshold
    dplyr::filter(Employee_Count >= mingroup)

  myTableReturn <-
    myTable %>%
    group_by(group) %>%
    summarise(across(c(metrics, Total), ~mean(.))) %>%
    left_join(n_count, by = "group")

  plot_table <-
    myTable %>%
    select(PersonId, group, metrics, Total) %>%
    tidyr::gather(Metric, Value, -PersonId, -group)

  totalTable <-
    plot_table %>%
    dplyr::filter(Metric == "Total") %>%
    group_by(group) %>%
    summarise(Total = mean(Value))

  myTable_legends <-
    n_count %>%
    filter(Employee_Count >= mingroup) %>%
    mutate(Employee_Count = paste("n=",Employee_Count)) %>%
    left_join(totalTable, by = "group")

  ## Get maximum value
  if (is.null(xlim)) {
  location <- max(myTable_legends$Total)
  }
  else if(is.numeric(xlim)) {
  location <- xlim
  }
  else {
     stop("Invalid return to `xlim`")
   }

  ## Remove max from axis labels ------------------------------------------
 max_blank <- function(x){
   as.character(
     c(
       x[1:length(x) - 1],
       "")
   )
 }

 ## Remove max from axis labels, but with percentages ---------------------
 max_blank_percent <- function(x){

   x <- scales::percent(x)

   as.character(
     c(
       x[1:length(x) - 1],
       "")
   )
 }

 invert_mean <- function(x){
   mean(x) * -1
 }

  ## Create plot -----------------------------------------------------------

 plot_object <-
   plot_table %>%
   filter(Metric != "Total") %>%
   mutate(Metric = factor(Metric, levels = rev(metrics))) %>%
   group_by(group, Metric) %>%
   summarise(across(Value, ~mean(.))) %>%
   # Conditional ranking based on `rank` argument
   { if(is.null(rank)){
     ggplot(., aes(x = group, y = Value, fill = Metric))
   } else if(rank == "descending"){
     ggplot(., aes(x = stats::reorder(group, Value, mean), y = Value, fill = Metric))
   } else if(rank == "ascending"){
     ggplot(., aes(x = stats::reorder(group, Value, invert_mean), y = Value, fill = Metric))
   } else {
     stop("Invalid return to `rank`")
   }
   } +
   geom_bar(position = "stack", stat = "identity") +
   { if(percent == FALSE){
     geom_text(aes(label = round(Value, 1)),
               position = position_stack(vjust = text_just),
               color = text_colour,
               fontface = "bold")
   } else if(percent == TRUE){
     geom_text(aes(label = scales::percent(Value, accuracy = 0.1)),
               position = position_stack(vjust = text_just),
               color = text_colour,
               fontface = "bold")
   }
   } +
   { if(percent == FALSE){
     scale_y_continuous(expand = c(.01, 0),
                        limits = c(0, location * 1.3),
                        labels = max_blank,
                        position = "right")
   } else if(percent == TRUE){
     scale_y_continuous(expand = c(.01, 0),
                        limits = c(0, location * 1.3),
                        labels = max_blank_percent,
                        position = "right")
   }
   } +
   annotate("text",
            x = myTable_legends$group,
            y = location * 1.15,
            label = myTable_legends$Employee_Count,
            size = 3) +
   annotate("rect",
            xmin = 0.5,
            xmax = length(myTable_legends$group) + 0.5,
            ymin = location * 1.05,
            ymax = location * 1.25,
            alpha = .2) +
   annotate(x=length(myTable_legends$group) + 0.8,
            xend=length(myTable_legends$group) + 0.8,
            y = 0,
            yend = location* 1.04,
            colour = "black",
            lwd = 0.75,
            geom = "segment") +
   scale_fill_manual(name="",
                     values = stack_colours,
                     breaks = metrics,
                     labels = legend_lab) +
   coord_flip() +
   theme_wpa_basic() +
   theme(axis.line = element_blank(),
         axis.ticks = element_blank(),
         axis.title = element_blank()) +
   labs(title = plot_title,
        subtitle = plot_subtitle,
        x = hrvar,
        y = "Average weekly hours",
        caption = extract_date_range(data, return = "text"))

  # Return options ---------------------------------------------------------

  if(return == "table"){

    myTableReturn

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_stacked returns a data frame when return = 'table'", {

  result <- pq_data %>%
			create_stacked(hrvar = "FunctionType",
							metrics = c("Meeting_hours",
										"Email_hours",
										"Call_hours",
										"Chat_hours"),
							return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_stacked returns a ggplot when return = 'plot'", {

  result <- pq_data %>%
			create_stacked(hrvar = "LevelDesignation",
						   metrics = c("Meeting_hours", "Email_hours"),
						   return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify Retention Rate Between Two Time Periods
#'
#' @description `r lifecycle::badge('experimental')`
#'
#' This function calculates the retention rate of individuals who meet a
#' specific category condition in one time period and checks whether they still
#' meet that condition in a subsequent time period. This function complements
#' `identify_usage_segments()`.
#'
#' @param data A data frame containing person-level time series data with at
#'   minimum `PersonId`, `MetricDate`, and the column specified in `category`.
#' @param start_x Start date for the first time period (Date or character in
#'   `"YYYY-MM-DD"` format).
#' @param end_x End date for the first time period (exclusive).
#' @param start_y Start date for the second time period.
#' @param end_y End date for the second time period (exclusive). If `NULL`,
#'   uses all data from `start_y` onwards.
#' @param category A string specifying the column name containing the
#'   binary/categorical variable to evaluate (e.g. `"IsHabitualUser"`).
#' @param category_values A character vector of values in `category` that
#'   define the "positive" condition (e.g. `c("Power User", "Habitual User")`).
#'   Defaults to `TRUE` for binary columns.
#' @param return A string specifying the return type. Valid options are:
#'   - `"summary"` (default): A tibble with retention statistics.
#'   - `"data"`: A list with person-level retention status and breakdown.
#'   - `"message"`: Prints a formatted message and returns the summary tibble
#'     invisibly.
#'
#' @return Depending on `return`:
#'   - `"summary"`: A tibble with the following columns:
#'     - `PeriodX_Start`, `PeriodX_End`: Start and end dates of period X.
#'     - `PeriodY_Start`, `PeriodY_End`: Start and end dates of period Y.
#'     - `Category`: The category column name.
#'     - `CategoryValues`: The category values used.
#'     - `N_Original`: Number of individuals meeting the condition in period X.
#'     - `N_Tracked`: Number of those individuals found in period Y.
#'     - `N_Lost`: Number of individuals not found in period Y.
#'     - `N_Retained`: Number still meeting the condition in period Y.
#'     - `RetentionPct`: Retention percentage.
#'   - `"data"`: A list containing `summary`, `person_status`, and `breakdown`.
#'   - `"message"`: Prints a formatted message; returns the summary tibble
#'     invisibly.
#'
#' @examples
#' \dontrun{
#' # Retention of Power/Habitual users from Nov 2025 to Jan 2026
#' identify_retention(
#'   data = pq_week_df,
#'   start_x = "2025-11-01",
#'   end_x = "2025-12-01",
#'   start_y = "2026-01-01",
#'   end_y = "2026-02-01",
#'   category = "UsageSegments_12w",
#'   category_values = c("Power User", "Habitual User")
#' )
#' }
#'
#' @author Martin Chan
#' @export
identify_retention <- function(
    data,
    start_x,
    end_x,
    start_y,
    end_y = NULL,
    category,
    category_values = TRUE,
    return = "summary"
) {

  # Input validation
  if (!inherits(data, "data.frame")) {
    stop("`data` must be a data frame.")
  }

  required_cols <- c("PersonId", "MetricDate", category)
  missing_cols <- setdiff(required_cols, names(data))
  if (length(missing_cols) > 0) {
    stop("Missing required columns: ", paste(missing_cols, collapse = ", "))
  }

  if (!return %in% c("summary", "data", "message")) {
    stop("`return` must be one of: 'summary', 'data', 'message'")
  }

  # Convert dates if character
  start_x <- as.Date(start_x)
  end_x   <- as.Date(end_x)
  start_y <- as.Date(start_y)
  if (!is.null(end_y)) {
    end_y <- as.Date(end_y)
  }

  # Step 1: Identify people meeting category condition in period X
  period_x_data <- data %>%
    dplyr::filter(
      MetricDate >= start_x,
      MetricDate < end_x
    )

  # Filter for those meeting the category condition
  if (is.logical(category_values) && isTRUE(category_values)) {
    period_x_positive <- period_x_data %>%
      dplyr::filter(
        !!rlang::sym(category) == TRUE | !!rlang::sym(category) == 1
      )
  } else {
    period_x_positive <- period_x_data %>%
      dplyr::filter(!!rlang::sym(category) %in% category_values)
  }

  # Get unique PersonIds from period X
  persons_in_x <- period_x_positive %>%
    dplyr::distinct(PersonId) %>%
    dplyr::pull(PersonId)

  if (length(persons_in_x) == 0) {
    warning("No individuals found meeting the category condition in period X.")
    return(NULL)
  }

  # Step 2: Check their status in period Y
  period_y_data <- data %>%
    dplyr::filter(
      MetricDate >= start_y,
      PersonId %in% persons_in_x
    )

  if (!is.null(end_y)) {
    period_y_data <- period_y_data %>%
      dplyr::filter(MetricDate < end_y)
  }

  # Get the latest status for each person in period Y
  period_y_status <- period_y_data %>%
    dplyr::arrange(PersonId, MetricDate) %>%
    dplyr::group_by(PersonId) %>%
    dplyr::summarise(
      LatestCategory = dplyr::last(!!rlang::sym(category)),
      LatestDate     = max(MetricDate),
      .groups = "drop"
    )

  # Determine if still in positive category
  if (is.logical(category_values) && isTRUE(category_values)) {
    period_y_status <- period_y_status %>%
      dplyr::mutate(
        StillPositive = .data[["LatestCategory"]] == TRUE |
          .data[["LatestCategory"]] == 1
      )
  } else {
    period_y_status <- period_y_status %>%
      dplyr::mutate(
        StillPositive = .data[["LatestCategory"]] %in% category_values
      )
  }

  # Step 3: Calculate retention statistics
  n_original     <- length(persons_in_x)
  n_tracked      <- nrow(period_y_status)
  n_retained     <- sum(period_y_status$StillPositive, na.rm = TRUE)
  n_lost         <- n_original - n_tracked
  retention_pct  <- if (n_tracked > 0) n_retained / n_tracked * 100 else NA

  period_y_end_val <- if (!is.null(end_y)) {
    end_y
  } else if (nrow(period_y_data) > 0) {
    max(period_y_data$MetricDate, na.rm = TRUE)
  } else {
    NA
  }

  # Create summary tibble
  summary_df <- tibble::tibble(
    PeriodX_Start   = start_x,
    PeriodX_End     = end_x,
    PeriodY_Start   = start_y,
    PeriodY_End     = period_y_end_val,
    Category        = category,
    CategoryValues  = paste(category_values, collapse = ", "),
    N_Original      = n_original,
    N_Tracked       = n_tracked,
    N_Lost          = n_lost,
    N_Retained      = n_retained,
    RetentionPct    = round(retention_pct, 1)
  )

  # Breakdown by latest category
  breakdown <- period_y_status %>%
    dplyr::count(!!rlang::sym("LatestCategory")) %>%
    dplyr::mutate(Pct = round(n / sum(n) * 100, 1)) %>%
    dplyr::arrange(dplyr::desc(n))

  # Return based on parameter
  if (return == "summary") {

    summary_df

  } else if (return == "data") {

    list(
      summary       = summary_df,
      person_status = period_y_status,
      breakdown     = breakdown
    )

  } else if (return == "message") {

    period_x_label <- paste0(
      format(start_x, "%b %Y"), " - ", format(end_x - 1, "%b %Y")
    )
    period_y_end_label <- if (!is.null(end_y)) {
      format(end_y - 1, "%b %Y")
    } else {
      "latest"
    }
    period_y_label <- paste0(
      format(start_y, "%b %Y"), " - ", period_y_end_label
    )

    message("\n=== RETENTION ANALYSIS ===")
    message("Category: ", category, " = ", paste(category_values, collapse = " / "))
    message("Period X: ", period_x_label)
    message("Period Y: ", period_y_label)
    message("---")
    message("Original in Period X: ", n_original)
    message("Tracked in Period Y: ", n_tracked)
    if (n_lost > 0) message("Lost (not in Period Y): ", n_lost)
    message("Still in category: ", n_retained)
    message("Retention rate: ", round(retention_pct, 1), "%")
    message("\nBreakdown in Period Y:")
    print(breakdown)
    message("===========================\n")

    invisible(summary_df)
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)

skip_if_not_installed("dplyr")

library(dplyr)

# Helper: create simple person-level time series data with a categorical column
make_retention_data <- function() {
  data.frame(
    PersonId = c(
      "A", "A", "A",
      "B", "B", "B",
      "C", "C", "C"
    ),
    MetricDate = as.Date(c(
      "2024-01-01", "2024-02-01", "2024-03-01",
      "2024-01-01", "2024-02-01", "2024-03-01",
      "2024-01-01", "2024-02-01", "2024-03-01"
    )),
    Segment = c(
      "Power User", "Power User", "Power User",   # A stays Power User
      "Power User", "Low User",   "Low User",     # B drops out
      "Low User",   "Low User",   "Power User"    # C is not in X set
    ),
    stringsAsFactors = FALSE
  )
}

test_that("identify_retention returns summary tibble by default", {
  df <- make_retention_data()
  result <- identify_retention(
    data             = df,
    start_x          = "2024-01-01",
    end_x            = "2024-02-01",
    start_y          = "2024-02-01",
    end_y            = "2024-04-01",
    category         = "Segment",
    category_values  = c("Power User")
  )

  expect_s3_class(result, "data.frame")
  expect_true("RetentionPct" %in% names(result))
  expect_equal(result$N_Original, 2L)  # A and B are Power Users in Jan
  expect_equal(result$N_Tracked,  2L)  # Both appear in period Y
  expect_equal(result$N_Retained, 1L)  # Only A stays Power User
  expect_equal(result$RetentionPct, 50)
})

test_that("identify_retention return = 'data' gives a list with three elements", {
  df <- make_retention_data()
  result <- identify_retention(
    data             = df,
    start_x          = "2024-01-01",
    end_x            = "2024-02-01",
    start_y          = "2024-02-01",
    end_y            = "2024-04-01",
    category         = "Segment",
    category_values  = c("Power User"),
    return           = "data"
  )

  expect_type(result, "list")
  expect_named(result, c("summary", "person_status", "breakdown"))
  expect_s3_class(result$summary, "data.frame")
  expect_s3_class(result$person_status, "data.frame")
  expect_s3_class(result$breakdown, "data.frame")
  expect_true("StillPositive" %in% names(result$person_status))
})

test_that("identify_retention return = 'message' prints and returns invisibly", {
  df <- make_retention_data()
  expect_message(
    result <- identify_retention(
      data             = df,
      start_x          = "2024-01-01",
      end_x            = "2024-02-01",
      start_y          = "2024-02-01",
      end_y            = "2024-04-01",
      category         = "Segment",
      category_values  = c("Power User"),
      return           = "message"
    ),
    "RETENTION ANALYSIS"
  )
  # The returned object should still be the summary tibble
  expect_s3_class(result, "data.frame")
  expect_true("RetentionPct" %in% names(result))
})

test_that("identify_retention errors on invalid return value", {
  df <- make_retention_data()
  expect_error(
    identify_retention(
      data             = df,
      start_x          = "2024-01-01",
      end_x            = "2024-02-01",
      start_y          = "2024-02-01",
      end_y            = "2024-04-01",
      category         = "Segment",
      category_values  = c("Power User"),
      return           = "invalid"
    ),
    "`return` must be one of"
  )
})

test_that("identify_retention errors when required columns are missing", {
  df <- make_retention_data()
  df$PersonId <- NULL
  expect_error(
    identify_retention(
      data             = df,
      start_x          = "2024-01-01",
      end_x            = "2024-02-01",
      start_y          = "2024-02-01",
      category         = "Segment",
      category_values  = c("Power User")
    ),
    "Missing required columns"
  )
})

test_that("identify_retention errors when data is not a data frame", {
  expect_error(
    identify_retention(
      data             = list(a = 1),
      start_x          = "2024-01-01",
      end_x            = "2024-02-01",
      start_y          = "2024-02-01",
      category         = "Segment",
      category_values  = c("Power User")
    ),
    "`data` must be a data frame"
  )
})

test_that("identify_retention warns and returns NULL when no individuals in period X", {
  df <- make_retention_data()
  expect_warning(
    result <- identify_retention(
      data             = df,
      start_x          = "2024-01-01",
      end_x            = "2024-02-01",
      start_y          = "2024-02-01",
      end_y            = "2024-04-01",
      category         = "Segment",
      category_values  = c("Non-existent Segment")
    ),
    "No individuals found"
  )
  expect_null(result)
})

test_that("identify_retention works with NULL end_y (open-ended period Y)", {
  df <- make_retention_data()
  result <- identify_retention(
    data             = df,
    start_x          = "2024-01-01",
    end_x            = "2024-02-01",
    start_y          = "2024-02-01",
    end_y            = NULL,
    category         = "Segment",
    category_values  = c("Power User")
  )

  expect_s3_class(result, "data.frame")
  expect_true(!is.na(result$PeriodY_End))
})

test_that("identify_retention handles binary category_values = TRUE", {
  df <- data.frame(
    PersonId   = c("A", "A", "B", "B"),
    MetricDate = as.Date(c("2024-01-01", "2024-03-01",
                           "2024-01-01", "2024-03-01")),
    IsActive   = c(TRUE, TRUE, TRUE, FALSE),
    stringsAsFactors = FALSE
  )
  result <- identify_retention(
    data            = df,
    start_x         = "2024-01-01",
    end_x           = "2024-02-01",
    start_y         = "2024-02-01",
    end_y           = "2024-04-01",
    category        = "IsActive",
    category_values = TRUE
  )

  expect_s3_class(result, "data.frame")
  expect_equal(result$N_Original, 2L)
  expect_equal(result$N_Retained, 1L)
})

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title
#' Rank all groups across HR attributes on a selected Viva Insights metric
#'
#' @description
#' This function scans a standard Person query output for groups with high
#' levels of a given Viva Insights Metric. Returns a plot by default, with an
#' option to return a table with all groups (across multiple HR attributes)
#' ranked by the specified metric.
#'
#' @author Carlos Morales Torrado <carlos.morales@@microsoft.com>
#' @author Martin Chan <martin.chan@@microsoft.com>
#'
#' @template spq-params
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"` (default)
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @param mode String to specify calculation mode. Must be either:
#'   - `"simple"`
#'   - `"combine"`
#'
#' @param plot_mode Numeric vector to determine which plot mode to return. Must
#' be either `1` or `2`, and is only used when `return = "plot"`.
#'   - `1`: Top and bottom five groups across the data population are highlighted
#'   - `2`: Top and bottom groups _per_ organizational attribute are highlighted
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats reorder
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
# Use a small sample for faster runtime
#' pq_data_small <- dplyr::slice_sample(pq_data, prop = 0.1)
#'
#' # Plot mode 1 - show top and bottom five groups
#' create_rank(
#'   data = pq_data_small,
#'   hrvar = c("FunctionType", "LevelDesignation"),
#'   metric = "Emails_sent",
#'   return = "plot",
#'   plot_mode = 1
#' )
#'
#' # Plot mode 2 - show top and bottom groups per HR variable
#' create_rank(
#'   data = pq_data_small,
#'   hrvar = c("FunctionType", "LevelDesignation"),
#'   metric = "Emails_sent",
#'   return = "plot",
#'   plot_mode = 2
#' )
#'
#' # Return a table
#' create_rank(
#'   data = pq_data_small,
#'   metric = "Emails_sent",
#'   return = "table"
#' )
#'
#' \donttest{
#' # Return a table - combination mode
#' create_rank(
#'   data = pq_data_small,
#'   metric = "Emails_sent",
#'   mode = "combine",
#'   return = "table"
#' )
#' }
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A bubble plot where the x-axis represents the
#'   metric, the y-axis represents the HR attributes, and the size of the
#'   bubbles represent the size of the organizations. Note that there is no
#'   plot output if `mode` is set to `"combine"`.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @export

create_rank <- function(data,
                        metric,
                        hrvar = extract_hr(data, exclude_constants = TRUE),
                        mingroup = 5,
                        return = "table",
                        mode = "simple",
                        plot_mode = 1){


  if(mode == "simple"){

    results <-
      create_bar(data,
                 metric = metric,
                 hrvar = hrvar[1],
                 mingroup = mingroup,
                 return = "table")

    ## Create a blank column
    results$hrvar <- ""

    ## Empty table
    results <- results[0,]

    ## Loop through each HR attribute supplied in argument
    for (p in hrvar) {
      table1 <-
        data %>%
        create_bar(metric = metric,
                   hrvar = p,
                   mingroup = mingroup,
                   return = "table")

      table1$hrvar <- p

      results <- rbind(results,table1)
    }

    output <-
      results %>%
      arrange(desc(get(metric))) %>%
      select(hrvar, everything()) %>%
      mutate(group = as.character(group)) # text fails when not string

    if(return == "table"){

      output

    } else if(return == "plot"){

      # Company average
      avg_ch <-
        data %>%
        create_bar(hrvar = NULL, metric = metric, return = "table") %>%
        pull(metric)

      if(plot_mode == 1){

        # Main plot
        output %>%
          mutate(Rank = rev(rank(!!sym(metric), ties.method = "max"))) %>%
          mutate(Group =
                   case_when(Rank %in% 1:5 ~ "Top 5",
                             Rank %in% nrow(.):(nrow(.) - 5) ~ "Bottom 5",
                             TRUE ~ "Middle")) %>%
          group_by(hrvar) %>%
          mutate(OrgGroup =
                   case_when(!!sym(metric) == max(!!sym(metric), na.rm = TRUE) ~ "Top",
                             !!sym(metric) == min(!!sym(metric), na.rm = TRUE) ~ "Bottom",
                             TRUE ~ "Middle")) %>%
          mutate(top_group = max(!!sym(metric), na.rm = TRUE)) %>%
          ungroup() %>%
          ggplot(aes(x = !!sym(metric),
                     y = reorder(hrvar, top_group))) + # Sort by top group
          geom_point(aes(fill = Group,
                         size = n),
                     colour = "black",
                     pch = 21,
                     alpha = 0.8) +
          labs(title = us_to_space(metric),
               subtitle = "Lowest and highest group averages, by org. attribute",
               y = "",
               x = "") +
          ggrepel::geom_text_repel(
            aes(x = !!sym(metric),
                y = hrvar,
                label = ifelse(Group %in% c("Top 5", "Bottom 5"), group, "")),
            size = 3) +
          scale_x_continuous(position = "top") +
          scale_fill_manual(name = "Group",
                            values = c(rgb2hex(68,151,169),
                                       "white",
                                       "#FE7F4F"),
                            guide = "legend") +
          theme_wpa_basic() +
          scale_size(guide = "none", range = c(1, 15)) +
          theme(
            axis.line=element_blank(),
            panel.grid.major.x = element_blank(),
            panel.grid.major.y = element_line(colour = "#D9E7F7", size = 3), # lightblue bar
            panel.grid.minor.x = element_line(color="gray"),
            strip.placement = "outside",
            strip.background = element_blank(),
            strip.text = element_blank()
          ) +
          geom_vline(xintercept = avg_ch, colour = "red")

      } else if(plot_mode == 2){

        output %>%
          group_by(hrvar) %>%
          mutate(OrgGroup =
                   case_when(!!sym(metric) == max(!!sym(metric), na.rm = TRUE) ~ "Top",
                             !!sym(metric) == min(!!sym(metric), na.rm = TRUE) ~ "Bottom",
                             TRUE ~ "Middle")) %>%
          mutate(top_group = max(!!sym(metric), na.rm = TRUE)) %>%
          ungroup() %>%
          ggplot(aes(x = !!sym(metric),
                     y = reorder(hrvar, top_group))) + # Sort by top group
          geom_point(aes(fill = OrgGroup,
                         size = n),
                     colour = "black",
                     pch = 21,
                     alpha = 0.8) +
          labs(title = us_to_space(metric),
               subtitle = "Group averages by organizational attribute",
               y = "Organizational attributes",
               x = us_to_space(metric)) +
          ggrepel::geom_text_repel(aes(x = !!sym(metric),
                                       y = hrvar,
                                       label = ifelse(OrgGroup %in% c("Top", "Bottom"), group, "")),
                                   size = 3) +
          scale_x_continuous(position = "top") +
          scale_fill_manual(name = "Group",
                            values = c(rgb2hex(68,151,169),
                                       "white",
                                       "#FE7F4F"),
                            guide = "legend") +
          theme_wpa_basic() +
          scale_size(guide = "none", range = c(1, 8)) +
          theme(
            panel.grid.major.x = element_blank(),
            panel.grid.major.y = element_line(colour = "#D9E7F7", size = 3), # lightblue bar
            strip.placement = "outside",
            strip.background = element_blank(),
            strip.text = element_blank()
          ) +
          geom_vline(xintercept = avg_ch, colour = "red")

      } else {

        stop("Invalid plot_mode argument.")

      }

    } else {

      stop("Invalid `return` argument.")

    }

  } else if(mode == "combine"){

    create_rank_combine(
      data = data,
      hrvar = hrvar,
      metric = metric,
      mingroup = mingroup
    )

  } else {

    stop("Invalid `mode` argument.")

  }
}

#' @title Create combination pairs of HR variables and run 'create_rank()'
#'
#' @description Create pairwise combinations of HR variables and compute an
#' average of a specified advanced insights metric.
#'
#' @details
#' This function is called when the `mode` argument in `create_rank()` is
#' specified as `"combine"`.
#'
#' @inheritParams create_rank
#'
#' @examples
#' # Use a small sample for faster runtime
#' pq_data_small <- dplyr::slice_sample(pq_data, prop = 0.1)
#'
#' create_rank_combine(
#'   data = pq_data_small,
#'   metric = "Email_hours",
#'   hrvar = c("Organization", "FunctionType", "LevelDesignation")
#' )
#'
#' @return Data frame containing the following variables:
#'   - `hrvar`: placeholder column that denotes the output as `"Combined"`.
#'   - `group`: pairwise combinations of HR attributes with the HR attribute
#'   in square brackets followed by the value of the HR attribute.
#'   - Name of the metric (as passed to `metric`)
#'   - `n`
#'
#' @export
create_rank_combine <- function(data,
                                hrvar = extract_hr(data),
                                metric,
                                mingroup = 5){

  hrvar_iter_grid <-
    tidyr::expand_grid(var1 = hrvar,
                var2 = hrvar) %>%
    dplyr::filter(var1 != var2)

  hrvar_iter_grid %>%
    purrr::pmap(function(var1, var2){

      data %>%
        dplyr::mutate(Combined =
                 paste0(
                   "[",var1, "] ",
                   !!sym(var1),
                   " [",var2, "] ",
                   !!sym(var2))) %>%
        create_rank(
          metric = metric,
          hrvar = "Combined",
          mode = "simple",
          mingroup = mingroup
        )
    }) %>%
    dplyr::bind_rows()
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------
library(testthat)
library(vivainsights)

test_that("create_rank returns a data frame when return = 'table'", {

  result <-create_rank(
		   data = pq_data,
		   metric = "Emails_sent",
		   return = "table"
		   )

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_rank returns a ggplot when return = 'plot' and plot_mode = 1", {

  result <- create_rank(
                data = pq_data,
                hrvar = c("FunctionType", "LevelDesignation"),
                metric = "Emails_sent",
                return = "plot",
                plot_mode = 1
                )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_rank returns a ggplot when return = 'plot' and plot_mode = 2", {

  result <- create_rank(
                data = pq_data,
                hrvar = c("FunctionType", "LevelDesignation"),
                metric = "Emails_sent",
                return = "plot",
                plot_mode = 2
                )

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

test_that("create_rank returns a data frame when mode = 'combine'. In this case return type doesnt matter.", {

  result <-create_rank(
            data = pq_data,
            hrvar = c("FunctionType", "LevelDesignation"),
            metric = "Emails_sent",
            mode = "combine"
            )

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
  })

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Calculate Chatterjee's Rank Correlation Coefficient
#'
#' @description
#' This function calculates Chatterjee's rank correlation coefficient, which
#' measures the association between two variables. It is particularly useful for
#' identifying monotonic relationships between variables, even if they are not
#' linear.
#'
#' @param x A numeric vector representing the independent variable.
#' @param y A numeric vector representing the dependent variable.
#' @param ties A logical value indicating whether to handle ties in the data.
#'   Default is FALSE.
#' 
#' If `ties = TRUE`, the function adjusts for tied ranks (repeated values in the
#' data). This is important when there are many tied values in either `x` or
#' `y`, as it ensures accurate calculation by considering the maximum rank for
#' tied observations.
#' 
#' If `ties = FALSE`, the function assumes that there are no ties, or that ties
#' can be handled without additional computational effort. This option can offer
#' better performance when ties are rare or absent.
#' 
#' @details
#' Unlike Pearson's correlation (which measures linear relationships),
#' Chatterjee's coefficient can handle non-linear monotonic relationships. It is
#' robust to outliers and can handle tied ranks, making it versatile for
#' datasets with ordinal data or tied ranks. This makes it a valuable
#' alternative to Spearman's and Kendall's correlations, especially when the
#' data may not meet the assumptions required by these methods.
#' 
#' By default, `ties = FALSE` is set to prioritize computational efficiency, as
#' handling ties requires additional processing. In cases where ties are present
#' or likely (such as when working with ordinal or categorical data), it is
#' recommended to set `ties = TRUE`.
#'
#' @return A numeric value representing Chatterjee's rank correlation coefficient.
#'
#' @examples
#' xicor(x = pq_data$Collaboration_hours, y = pq_data$Internal_network_size, ties = TRUE)
#' xicor(x = pq_data$Collaboration_hours, y = pq_data$Internal_network_size, ties = FALSE)
#'
#' 
#' @export

xicor <- function(x, y, ties = FALSE){  # Default is now FALSE
  n <- length(x)
  
  # Sort Y based on the order of X
  ordered_y <- y[order(x)]
  
  # Get the ranks of Y after sorting by X
  r <- rank(ordered_y, ties.method = ifelse(ties, "max", "first"))
  
  if(ties){
    # Handling ties: Use maximum rank for tied values
    l <- rank(ordered_y, ties.method = "max")
    
    # Calculate Chatterjee's coefficient with ties
    return( 1 - n * sum(abs(r[-1] - r[-n])) / (2 * sum(l * (n - l))) )
  } else {
    # No ties: Simplified formula for the Chatterjee coefficient
    return( 1 - 3 * sum(abs(r[-1] - r[-n])) / (n^2 - 1) )
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Create a network plot with the group-to-group query
#'
#' @description
#' Pass a data frame containing a group-to-group query and return a network
#' plot. Automatically handles `"Within Group"` and `"Other_collaborators"`
#' values within query data.
#'
#' @param data Data frame containing a group-to-group query.
#' @param primary String containing the variable name for the Primary
#'   Collaborator column.
#' @param secondary String containing the variable name for the Secondary
#'   Collaborator column.
#' @param metric String containing the variable name for metric. Defaults to
#'   `Group_collaboration_time_invested`.
#' @param algorithm String to specify the node placement algorithm to be used.
#'   Defaults to `"fr"` for the force-directed algorithm of Fruchterman and
#'   Reingold. See
#'   <https://rdrr.io/cran/ggraph/man/layout_tbl_graph_igraph.html> for a full
#'   list of options.
#' @param node_colour String or named vector to specify the colour to be used
#'   for displaying nodes. Defaults to `"lightblue"`.
#'   - If `"vary"` is supplied, a different colour is shown for each node at
#' random.
#'   - If a named vector is supplied, the names must match the values of the
#'   variable provided for the `primary` and `secondary` columns. See
#'   example section for details.
#' @param exc_threshold Numeric value between 0 and 1 specifying the exclusion
#'   threshold to apply. Defaults to 0.1, which means that the plot will only
#'   display collaboration above 10% of a node's total collaboration. This
#'   argument has no impact on `"data"` or `"table"` return.
#' @param org_count Optional data frame to provide the size of each organization
#' in the `secondary` attribute. The data frame should contain only two
#' columns:
#'   - Name of the `secondary` attribute excluding any prefixes, e.g.
#'   `"Organization"`. Must be of character or factor type.
#'   - `"n"`. Must be of numeric type.
#' Defaults to `NULL`, where node sizes will be fixed.
#'
#' @param subtitle String to override default plot subtitle.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'   - `"network"`
#'   - `"data"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"plot"`: 'ggplot' object. A group-to-group network plot.
#'   - `"table"`: data frame. An interactive matrix of the network.
#'   - `"network`: 'igraph' object used for creating the network plot.
#'   - `"data"`: data frame. A long table of the underlying data.
#'
#' @examples
#' # Return a network plot
#' g2g_data %>% network_g2g()
#'
#' # Return a network plot - Meeting hours and 5% threshold
#' network_g2g(
#'   data = g2g_data,
#'   primary = "PrimaryCollaborator_Organization",
#'   secondary = "SecondaryCollaborator_Organization",
#'   exc_threshold = 0.05
#' )
#'
#' # Return a network plot - custom-specific colours
#' # Get labels of orgs and assign random colours
#' org_str <- unique(g2g_data$PrimaryCollaborator_Organization)
#'
#' col_str <-
#'   sample(
#'     x = heat_colours(n = length(org_str)), # generate colour codes for each one
#'     size = length(org_str),
#'     replace = TRUE
#'   )
#'
#' # Create and supply a named vector to `node_colour`
#' names(col_str) <- org_str
#'
#' g2g_data %>%
#'   network_g2g(node_colour = col_str)
#'
#'
#' # Return a network plot with circle layout
#' # Vary node colours and add org sizes
#' org_tb <-
#'   data.frame(
#'     Organization = c(
#'       "G&A East",
#'       "G&A West",
#'       "G&A North",
#'       "South Sales",
#'       "North Sales",
#'       "G&A South"
#'     ),
#'     n = sample(30:1000, size = 6)
#'   )
#'
#' g2g_data %>%
#'   network_g2g(algorithm = "circle",
#'               node_colour = "vary",
#'               org_count = org_tb)
#'
#' # Return an interaction matrix
#' # Minimum arguments specified
#' g2g_data %>%
#'   network_g2g(return = "table")
#'
#' @import ggplot2
#' @import dplyr
#'
#' @family Network
#'
#'
#' @export
network_g2g <- function(data,
                        primary = NULL,
                        secondary = NULL,
                        metric = "Group_collaboration_time_invested",
                        algorithm = "fr",
                        node_colour = "lightblue",
                        exc_threshold = 0.1,
                        org_count = NULL,
                        subtitle = "Collaboration Across Organizations",
                        return = "plot"){

  if(is.null(primary)){

    # Only return first match
    primary <-
      names(data)[grepl(pattern = "^PrimaryCollaborator_", names(data))][1]

    message(
      paste("`primary` field not provided.",
            "Assuming", wrap(primary, wrapper = "`"),
            "as the `primary` variable.")
    )

  }

  if(is.null(secondary)){

    # Only return first match
    secondary <-
      names(data)[grepl(pattern = "^SecondaryCollaborator_", names(data))][1]

    message(
      paste("`secondary` field not provided.",
            "Assuming", wrap(secondary, wrapper = "`"),
            "as the `secondary` variable.")
    )
  }

  ## Get string of HR variable
  hrvar_string <- gsub(pattern = "SecondaryCollaborator_",
                       replacement = "",
                       x = secondary)

  ## Warn if 'Within Group' is not present in data
  if(! "Within Group" %in% unique(data[[secondary]])){

    warning(
      "`Within Group` is not found in the `secondary` variable.
      The analysis may be excluding in-group collaboration."
    )
  }


  ## Run plot_data
  plot_data <-
    data %>%
    rename(PrimaryOrg = primary,
           SecondaryOrg = secondary,
           Metric = metric) %>%
    mutate(SecondaryOrg = case_when(SecondaryOrg == "Within Group" ~ PrimaryOrg,
                                       TRUE ~ SecondaryOrg)) %>%
    group_by(PrimaryOrg, SecondaryOrg) %>%
    filter(PrimaryOrg != "Other_Collaborators" &
             SecondaryOrg!="Other_Collaborators") %>%
    summarise(across(all_of("Metric"), ~mean(.))) %>%
    group_by(PrimaryOrg) %>%
    mutate(metric_prop = Metric / sum(Metric, na.rm = TRUE)) %>%
    select(PrimaryOrg, SecondaryOrg, metric_prop) %>%
    ungroup()

  if(return == "table"){

    ## Return a 'tidy' matrix
    plot_data %>%
      tidyr::pivot_wider(names_from = SecondaryOrg,
                         values_from = metric_prop)

  } else if(return == "data"){

    ## Return long table
    plot_data

  } else if(return %in% c("plot", "network")){

    ## Network object
    mynet_em <-
      plot_data %>%
      filter(metric_prop > exc_threshold) %>%
      mutate(
        across(
          .cols = c(PrimaryOrg, SecondaryOrg),
          .fns = ~sub(pattern = " ", replacement = "\n", x = .)
        )) %>%
      mutate(metric_prop = metric_prop * 10) %>%
      igraph::graph_from_data_frame(directed = FALSE)

    # Org count vary by size -------------------------------------------

    if(!is.null(org_count)){

      igraph::V(mynet_em)$org_size <-
        tibble(id = igraph::get.vertex.attribute(mynet_em)$name) %>%
        mutate(id = gsub(pattern = "\n", replacement = " ", x = id)) %>%
        left_join(org_count, by = c("id" = hrvar_string)) %>%
        pull(n)

    } else {

      # Imputed size if not specified
      igraph::V(mynet_em)$org_size <-
        tibble(id = igraph::get.vertex.attribute(mynet_em)$name) %>%
        mutate(id = gsub(pattern = "\n", replacement = " ", x = id)) %>%
        mutate(n = 20) %>%
        pull(n)
    }

    ## Plot object
    plot_obj <-
      mynet_em %>%
      ggraph::ggraph(layout = algorithm) +
      ggraph::geom_edge_link(aes(edge_width = metric_prop * 1),
                             edge_alpha = 0.5,
                             edge_colour = "grey")

    if(return == "network"){

      mynet_em # Return 'igraph' object

    } else {

      # Custom node colours ----------------------------------------------

      # String vector with length greater than 1
      if(is.character(node_colour) & length(node_colour) > 1){

        names(node_colour) <-
          gsub(
            pattern = " ",
            replacement = "\n",
            x = names(node_colour))

        plot_obj <-
          plot_obj +
          ggraph::geom_node_point(
            aes(color = name,
                size = org_size),
            alpha = 0.9
          ) +
          scale_colour_manual(
            # Enable matching
            values = node_colour
          )

        # Auto assign colours

      } else if(node_colour == "vary"){

        plot_obj <-
          plot_obj +
          ggraph::geom_node_point(
            aes(color = name,
                size = org_size),
            alpha = 0.9
          )

      } else {

        plot_obj <-
          plot_obj +
          ggraph::geom_node_point(
            aes(size = org_size),
            colour = node_colour,
            alpha = 0.9
          )

      }

      plot_obj +
        ggraph::geom_node_text(aes(label = name), size = 3, repel = FALSE) +
        ggplot2::theme(
          panel.background = ggplot2::element_rect(fill = 'white'),
          legend.position = "none") +
        theme_wpa_basic() +
        scale_size(range = c(1, 30)) +
        labs(title = "Group to Group Collaboration",
             subtitle = subtitle,
             x = "",
             y = "",
             caption = paste("Displays only collaboration above ", exc_threshold * 100, "% of node's total collaboration", sep = "")) +
        theme(axis.line = element_blank(),
              axis.text = element_blank(),
              legend.position = "none")

    }

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate a time stamp
#'
#' @description
#' This function generates a time stamp of the format `'yymmdd_hhmmss'`.
#' This is a support function and is not intended for direct use.
#'
#' @family Support
#'
#' @return
#' String containing the timestamp in the format `'yymmdd_hhmmss'`.
#'
#' @export
tstamp <- function(){
  stamp <- Sys.time()
  stamp <- gsub(pattern = "[[:punct:]]", replacement = "", x = stamp)
  stamp <- gsub(pattern = " ", replacement = "_", x = stamp)

  return(stamp)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify Inactive Weeks
#'
#' @description
#' This function scans a standard query output for weeks where collaboration
#' hours is far outside the mean for any individual person in the dataset.
#' Returns a list of weeks that appear to be inactive weeks and optionally an
#' edited dataframe with outliers removed.
#'
#' As best practice, run this function prior to any analysis to remove atypical
#' collaboration weeks from your dataset.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param sd The standard deviation below the mean for collaboration hours that
#'   should define an outlier week. Enter a positive number. Default is 1
#'   standard deviation.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"text"`
#'   - `"data_cleaned"`
#'   - `"data_clean"`
#'   - `"data_dirty"`
#'
#' See `Value` for more information.
#'
#' @import dplyr
#' @importFrom methods is
#'
#' @family Data Validation
#'
#' @return
#' Returns an error message by default, where `'text'` is returned. When
#' `'data_cleaned'` or `'data_clean'` is passed, a dataset with outlier weeks removed is returned
#' as a dataframe. When `'data_dirty'` is passed, a dataset with outlier weeks
#' is returned as a dataframe.
#'
#' @export
identify_inactiveweeks <- function(data, sd = 2, return = "text"){

  init_data <-
    data %>%
    group_by(PersonId) %>%
    mutate(z_score = (Collaboration_hours - mean(Collaboration_hours))/sd(Collaboration_hours))


  Calc <-
    init_data %>%
    filter(z_score <= -sd) %>%
    select(PersonId, MetricDate, z_score) %>%
    data.frame()

  pop_mean <-
    data %>%
    dplyr::mutate(Total = "Total") %>%
    create_bar(metric = "Collaboration_hours",
               hrvar = "Total",
               return = "table") %>%
    dplyr::pull(Collaboration_hours) %>%
    round(digits = 1)


  Message <- paste0("There are ", nrow(Calc), " rows of data with weekly collaboration hours more than ",
                    sd," standard deviations below the mean (", pop_mean, ").")

  if(return == "text"){

    return(Message)

  } else if(return == "data_dirty"){

    init_data %>%
      filter(z_score <= -sd) %>%
      select(-z_score) %>%
      data.frame()

  } else if(return %in% c("data_clean", "data_cleaned")){
    
    # Create diagnostic message for removed inactive weeks
    inactive_dates <- init_data %>%
      filter(z_score <= -sd) %>%
      pull(MetricDate) %>% 
      unique()
    
    if(length(inactive_dates) > 0) {
      # Format the dates to ISO format
      if(methods::is(inactive_dates, "Date")) {
        formatted_dates <- format(inactive_dates, "%Y-%m-%d")
      } else {
        # Attempt to convert to date if possible
        tryCatch({
          formatted_dates <- format(as.Date(inactive_dates), "%Y-%m-%d")
        }, error = function(e) {
          # If conversion fails, use as is
          formatted_dates <- as.character(inactive_dates)
        })
      }
      
      diagnostic_msg <- paste0("The weeks ", paste(formatted_dates, collapse = ", "), 
                              " have been flagged as inactive weeks and removed from the data. ",
                              "This is based on a standard deviation of ", sd, 
                              " below the mean collaboration hours.")
    } else {
      diagnostic_msg <- paste0("No inactive weeks were detected based on a standard deviation of ", 
                              sd, " below the mean collaboration hours.")
    }
    
    # Print the diagnostic message
    message(diagnostic_msg)
    
    # Return the cleaned data
    init_data %>%
      filter(z_score > -sd) %>%
      select(-z_score) %>%
      data.frame()

  } else if(return == "data"){

    init_data %>%
      mutate(inactiveweek = (z_score<= -sd)) %>%
      select(-z_score) %>%
      data.frame()

  } else {

    stop("Error: please check inputs for `return`")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Email Hours Time Trend
#'
#' @description Provides a week by week view of email time.
#' By default returns a week by week heatmap, highlighting the points in time with most activity.
#' Additional options available to return a summary table.
#'
#' @details
#' Uses the metric `Email_hours`.
#'
#' @inheritParams create_trend
#' @inherit create_trend return
#'
#' @family Visualization
#' @family Emails
#'
#'
#' @examples
#' # Run plot
#' email_trend(pq_data)
#'
#' # Run table
#' email_trend(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export


email_trend <- function(data,
                        hrvar = "Organization",
                        mingroup = 5,
                        return = "plot"){

  create_trend(data,
               metric = "Email_hours",
               hrvar = hrvar,
               mingroup = mingroup,
               return = return)

}

#' @title
#' Generate a vector of `n` contiguous colours, as a red-yellow-green palette.
#'
#' @description
#' Takes a numeric value `n` and returns a character vector of colour HEX codes
#' corresponding to the heat map palette.
#'
#' @param n the number of colors (>= 1) to be in the palette.
#' @param alpha an alpha-transparency level in the range of 0 to 1
#' (0 means transparent and 1 means opaque)
#' @param rev logical indicating whether the ordering of the colors should be
#'   reversed.
#'
#' @examples
#' barplot(rep(10, 50), col = heat_colours(n = 50), border = NA)
#'
#' barplot(rep(10, 50), col = heat_colours(n = 50, alpha = 0.5, rev = TRUE),
#' border = NA)
#'
#' @family Support
#'
#' @return
#' A character vector containing the HEX codes and the same length as `n` is
#' returned.
#'
#' @export
heat_colours <- function (n, alpha, rev = FALSE) {

  ## Move from red to green
  h <- seq(from = 0, to = 0.3, length.out = n)
  #h <- c(1, pre_h)

  ## Less bright
  s <- rep(0.69, length(h))

  ## Increasingly low value (darker)
  v <- seq(from = 1, to = 0.8, length.out = n)

  cols <- grDevices::hsv(h = h, s = s, v = v, alpha = alpha)

  if(rev){

    rev(cols)

  } else if(rev == FALSE) {

    cols
  }
}

#' @rdname heat_colours
#' @export
heat_colors <- heat_colours

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title External Collaboration Hours Time Trend - Line Chart
#'
#' @description
#' Provides a week by week view of External collaboration time, visualized as
#' line chart. By default returns a separate panel per value in the HR attribute. Additional
#' options available to return a summary table.
#'
#' @details
#' Uses the metric `Collaboration_hours_external`.
#'
#' @seealso [create_line()] for applying the same analysis to a different metric.
#'
#' @inheritParams create_line
#' @inherit create_line return
#'
#' @family Visualization
#' @family External Collaboration
#'
#' @examples
#' # Return a line plot
#' external_line(pq_data, hrvar = "LevelDesignation")
#'
#' # Return summary table
#' external_line(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

external_line <- function(data,
                            hrvar = "Organization",
                            mingroup=5,
                            return = "plot",
                            label = FALSE){


  ## Inherit arguments
  create_line(data = data,
              metric = "External_collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              label = label)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Fizzy Drink / Jittered Scatter Plot for any metric
#'
#' @description
#' Analyzes a selected metric and returns a 'fizzy' scatter plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @details
#' This is a general purpose function that powers all the functions
#' in the package that produce 'fizzy drink' / jittered scatter plots.
#'
#' @template spq-params
#' @param metric Character string containing the name of the metric,
#' e.g. `"Collaboration_hours"`
#' @param return String specifying what to return. This must be one of the following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A jittered scatter plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom stats median
#' @importFrom stats sd
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' # Create a fizzy plot for Collaboration hours by Level Designation
#' create_fizz(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation", return = "plot")
#'
#' # Create a summary statistics table for Collaboration hours by Organization
#' create_fizz(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")
#'

#' @export

create_fizz <- function(data,
                        metric,
                        hrvar = "Organization",
                        mingroup = 5,
                        return = "plot") {

  ## Check inputs
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Clean metric name
  clean_nm <- us_to_space(metric)

  ## Plot data
  plot_data <-
    data %>%
    rename(group = !!sym(hrvar)) %>%
    group_by(PersonId, group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric)), .groups = "drop") %>%
    group_by(group) %>%
    mutate(Employee_Count = n_distinct(PersonId)) %>%
    dplyr::filter(Employee_Count >= mingroup) %>%
    ungroup() 

  ## Get max value
  max_point <- max(plot_data[[metric]]) * 1.2

  plot_legend <-
    plot_data %>%
    group_by(group) %>%
    summarize(Employee_Count = first(Employee_Count)) %>%
    mutate(Employee_Count = paste("n=",Employee_Count))

  plot_object <-
    plot_data %>%
    ggplot(aes(x = group, y = !!sym(metric))) +
    geom_point(size = 1,
               alpha = 1/5,
               color = "#578DB8",
               position = position_jitter(width = 0.1, height = 0.1)) +
    theme_wpa_basic() +
    theme(
      axis.line = element_blank(),
      panel.grid.major.x = element_line(colour = "grey80"),
      axis.ticks = element_blank(),
      axis.title = element_blank()
    ) +
    annotate("text",
             x = plot_legend$group,
             y = max_point,
             label = plot_legend$Employee_Count,
             size = 3) +
    annotate("rect",
             xmin = 0.5,
             xmax = length(plot_legend$group) + 0.5,
             ymin = max_point*0.95,
             ymax = max_point*1.05,
             alpha = .2) +
    scale_y_continuous(
      position = "right",
      limits = c(0, max_point * 1.1)) +
    coord_flip() +
    labs(title = clean_nm,
         subtitle = paste("Distribution of",
                          tolower(clean_nm),
                          "by",
                          tolower(camel_clean(hrvar))),
         caption = extract_date_range(data, return = "text"),
         x = hrvar,
         y = paste("Average", clean_nm))

  summary_table <-
    plot_data %>%
    select(group, tidyselect::all_of(metric)) %>%
    group_by(group) %>%
    summarise(mean = mean(!!sym(metric)),
              median = median(!!sym(metric)),
              sd = sd(!!sym(metric)),
              min = min(!!sym(metric)),
              max = max(!!sym(metric)),
              range = max - min,
              n = n())

  if(return == "table"){

    summary_table %>%
      as_tibble() %>%
      return()

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify metric outliers over a date interval
#'
#' @description This function takes in a selected metric and uses
#' z-score (number of standard deviations) to identify outliers
#' across time. There are applications in this for identifying
#' weeks with abnormally low collaboration activity, e.g. holidays.
#' Time as a grouping variable can be overridden with the `group_var`
#' argument.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param group_var A string with the name of the grouping variable.
#' Defaults to `Date`.
#' @param metric Character string containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @import dplyr
#'
#' @examples
#' identify_outlier(pq_data, metric = "Collaboration_hours")
#'
#' @return
#' Returns a data frame with `MetricDate` (if grouping variable is not set),
#' the metric, and the corresponding z-score.
#'
#' @family Data Validation
#'
#' @export
identify_outlier <- function(data,
                             group_var = "MetricDate",
                             metric = "Collaboration_hours"){

  ## Check inputs
  required_variables <- c(group_var,
                          "PersonId",
                          metric)

  ## Error message if variables are not present
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  main_table <-
    data %>%
    group_by(!!sym(group_var)) %>%
    summarise(across(!!sym(metric), ~mean(.))) %>%
    mutate(zscore = (!!sym(metric) - mean(!!sym(metric)))/sd(!!sym(metric)))

  return(main_table)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Warn for extreme values by checking against a threshold
#'
#' @description
#' This is used as part of data validation to check if there are extreme values
#' in the dataset.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param metric A character string specifying the metric to test.
#' @param person A logical value to specify whether to calculate
#'   person-averages. Defaults to `TRUE` (person-averages calculated).
#' @param threshold Numeric value specifying the threshold for flagging.
#' @param mode String determining mode to use for identifying extreme values.
#'   - `"above"`: checks whether value is great than the threshold (default)
#'   - `"equal"`: checks whether value is equal to the threshold
#'   - `"below"`: checks whether value is below the threshold
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"text"`
#'   - `"message"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"text"`: string. A diagnostic message.
#'   - `"message"`: message on console. A diagnostic message.
#'   - `"table"`: data frame. A person-level table with `PersonId` and the
#'   extreme values of the selected metric.
#'
#' @family Data Validation
#'
#' @import dplyr
#'
#' @examples
#' # The threshold values are intentionally set low to trigger messages.
#' flag_extreme(pq_data, "Email_hours", threshold = 15)
#'
#' # Return a summary table
#' flag_extreme(pq_data, "Email_hours", threshold = 15, return = "table")
#'
#' # Person-week level
#' flag_extreme(pq_data, "Email_hours", person = FALSE, threshold = 15)
#'
#' # Check for values equal to threshold
#' flag_extreme(pq_data, "Email_hours", person = TRUE, mode = "equal", threshold = 0)
#'
#' # Check for values below threshold
#' flag_extreme(pq_data, "Email_hours", person = TRUE, mode = "below", threshold = 5)
#'
#' @export
flag_extreme <- function(data,
                         metric,
                         person = TRUE,
                         threshold,
                         mode = "above",
                         return = "message"){

  ## Define relational term/string and input checks

  if(mode == "above"){

    rel_str <- " exceeds "

  } else if(mode == "equal"){

    rel_str <- " are equal to "

  } else if(mode == "below"){

    rel_str <- " are less than "

  } else {

    stop("invalid input to `mode`")

  }

  ## Data frame containing the extreme values
  if(person == TRUE){

    extreme_df <-
      data %>%
      rename(metric = !!sym(metric)) %>%
      group_by(PersonId) %>%
      summarise(across(metric, ~mean(.))) %>%

      # Begin mode chunk
      {
        if(mode == "above"){

          filter(., metric > threshold)

        } else if(mode == "equal"){

          filter(., metric == threshold)

        } else if(mode == "below"){

          filter(., metric < threshold)

        }

      } %>%
      rename(!!sym(metric) := "metric")

  } else if(person == FALSE){

    extreme_df <-
      data %>%
      rename(metric = !!sym(metric)) %>%
      # Begin mode chunk
      {
        if(mode == "above"){

          filter(., metric > threshold)

        } else if(mode == "equal"){

          filter(., metric == threshold)

        } else if(mode == "below"){

          filter(., metric < threshold)

        }

      } %>%
      rename(!!sym(metric) := "metric")

  }


  ## Clean names for pretty printing
  metric_nm <- metric %>% us_to_space() %>% camel_clean()

  ## Define MessageLevel
  if(person == TRUE){

    MessageLevel <- " persons where their average "

  } else if(person == FALSE){

    MessageLevel <- " rows where their value of "

  }

  ## Define FlagMessage

  if(nrow(extreme_df) == 0){
    FlagMessage <-
      paste0("[Pass] There are no",
             MessageLevel,
             metric_nm,
             rel_str,
             threshold, ".")
  } else {
    FlagMessage <-
      paste0("[Warning] There are ",
             nrow(extreme_df),
             MessageLevel,
             metric_nm,
             rel_str,
             threshold, ".")
  }

  if(return == "text"){

    FlagMessage

  } else if(return == "message"){

    message(FlagMessage)

  } else if(return == "table"){

    extreme_df

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Fabricate a 'Total' HR variable
#'
#' @description Create a 'Total' column of character type comprising exactly of
#'   one unique value. This is a convenience function for returning a no-HR
#'   attribute view when `NULL` is supplied to the `hrvar` argument in
#'   functions.
#'
#' @examples
#' # Create a visual without HR attribute breaks
#' pq_data %>%
#'   totals_col() %>%
#'   create_fizz(hrvar = "Total", metric = "Email_hours")
#'
#' @param data data frame
#' @param total_value Character value defining the name and the value of the
#'   `"Total"` column. Defaults to `"Total"`. An error is returned if an
#'   existing variable has the same name as the supplied value.
#'
#' @return
#' data frame containing an additional 'Total' column on top of the input data
#' frame.
#'
#' @family Support
#'
#' @export
totals_col <- function(data, total_value = "Total"){

  if(total_value %in% names(data)){
    stop(paste("Column", wrap(total_value, wrapper = "`"), "already exists. Please supply a different
               value to `total_value`"))
  }

  data %>%
    dplyr::mutate(!!sym(total_value) := total_value)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate HTML report based on existing RMarkdown documents
#'
#' @description
#' This is a support function that accepts parameters and creates a HTML
#' document based on an RMarkdown template. This is an alternative to
#' `generate_report()` which instead creates an RMarkdown document from scratch
#' using individual code chunks.
#'
#' @note
#' The implementation of this function was inspired by the 'DataExplorer'
#' package by boxuancui, with credits due to the original author.
#'
#' @param output_format output format in `rmarkdown::render()`. Default is
#'  `rmarkdown::html_document(toc = TRUE, toc_depth = 6, theme = "cosmo")`.
#' @param output_file output file name in `rmarkdown::render()`. Default is
#'   `"report.html"`.
#' @param output_dir output directory for report in `rmarkdown::render()`.
#'   Default is user's current directory.
#' @param report_title report title. Default is `"Report"`.
#' @param rmd_dir string specifying the path to the directory containing the
#'   RMarkdown template files.
#' @param \dots other arguments to be passed to `params`. For instance, pass
#'   `hrvar` if the RMarkdown document requires a 'hrvar' parameter.
#' @export

generate_report2 <- function(output_format = rmarkdown::html_document(toc = TRUE, toc_depth = 6, theme = "cosmo"),
                             output_file = "report.html",
                             output_dir = getwd(),
                             report_title = "Report",
                             rmd_dir = system.file("rmd_template/minimal.rmd", package = "vivainsights"),
                             ...) {

  ## Render report into html
  suppressWarnings(
    rmarkdown::render(
      input = rmd_dir,
      output_format = output_format,
      output_file = output_file,
      output_dir = output_dir,
      intermediates_dir = output_dir,
      params = list(set_title = report_title, ...)
  ))

  ## Open report
  report_path <- path.expand(file.path(output_dir, output_file))
  utils::browseURL(report_path)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Horizontal 100 percent stacked bar plot for any metric
#'
#' @description
#' Provides an analysis of the distribution of a selected metric.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @template spq-params
#' @param metric String containing the name of the metric,
#' e.g. "Collaboration_hours"
#'
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @param cut A numeric vector of length three to specify the breaks for the
#'   distribution,
#' e.g. c(10, 15, 20)
#' @param dist_colours A character vector of length four to specify colour
#' codes for the stacked bars.
#' @param unit String to specify what unit to use. This defaults to `"hours"`
#'   but can accept any custom string. See `cut_hour()` for more details.
#' @inheritParams cut_hour
#' @param sort_by String to specify the bucket label to sort by. Defaults to
#'  `NULL` (no sorting).
#' @param labels Character vector to override labels for the created
#' categorical variables. Must be a named vector - see examples.
#'
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A stacked bar plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#' @importFrom tidyr spread
#' @importFrom stats median
#' @importFrom stats sd
#'
#' @family Visualization
#' @family Flexible
#'
#' @examples
#' # Return plot
#' create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization")
#'
#' # Return summary table
#' create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")
#'
#' # Use custom labels by providing a label vector
#' eh_labels <- c(
#'   "Fewer than fifteen" = "< 15 hours",
#'   "Between fifteen and twenty" = "15 - 20 hours",
#'   "Between twenty and twenty-five" = "20 - 25 hours",
#'   "More than twenty-five" = "25+ hours"
#' )
#'
#' pq_data %>% create_dist(metric = "Meeting_hours", labels = eh_labels, return = "plot")
#'
#' # Sort by a category
#' pq_data %>%  create_dist(metric = "Collaboration_hours", sort_by = "25+ hours")
#' @export

create_dist <- function(data,
                        metric,
                        hrvar = "Organization",
                        mingroup = 5,
                        return = "plot",
                        cut = c(15, 20, 25),
                        dist_colours = c("#facebc",
                                         "#fcf0eb",
                                         "#b4d5dd",
                                         "#bfe5ee"),
                        unit = "hours",
                        lbound = 0,
                        ubound = 200,
                        sort_by = NULL,
                        labels = NULL) {

  ## Check inputs -----------------------------------------------------------
  required_variables <- c("MetricDate",
                          metric,
                          "PersonId")

  ## Error message if variables are not present -----------------------------
  ## Nothing happens if all present
  data %>%
    check_inputs(requirements = required_variables)

  ## Clean metric name ------------------------------------------------------
  clean_nm <- us_to_space(metric)

  ## Replace labels ---------------------------------------------------------

  replace_labels <- function(x, labels){

    ifelse(
      is.na(names(labels[match(x, labels)])),
      x,
      names(labels[match(x, labels)])
    )
  }

  ## Handling NULL values passed to hrvar -----------------------------------

  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Basic Data for bar plot ------------------------------------------------

  plot_data <-
    data %>%
    rename(group = !!sym(hrvar)) %>%
    group_by(PersonId, group) %>%
    summarise(!!sym(metric) := mean(!!sym(metric)), .groups = "drop") %>%
    group_by(group) %>%
    mutate(Employee_Count = n_distinct(PersonId)) %>%
    dplyr::filter(Employee_Count >= mingroup) %>%
    ungroup() 

  ## Create buckets of collaboration hours ---------------------------------

  plot_data <-
    plot_data %>%
    mutate(bucket_hours = cut_hour(!!sym(metric),
                                   cuts = cut,
                                   unit = unit,
                                   lbound = lbound,
                                   ubound = ubound))

  ## Employee count / base size table --------------------------------------
  plot_legend <-
    plot_data %>%
    group_by(group) %>%
    summarize(Employee_Count = first(Employee_Count)) %>%
    mutate(Employee_Count = paste("n=",Employee_Count))

  ## Data for bar plot
  plot_table <-
    plot_data %>%
    group_by(group, bucket_hours) %>%
    summarize(Employees = n(),
              Employee_Count = first(Employee_Count),
              percent = Employees / Employee_Count ) %>%
    arrange(group, desc(bucket_hours))

  ## Table for annotation --------------------------------------------------
  annot_table <-
    plot_legend %>%
    dplyr::left_join(plot_table, by = "group")

  ## Remove max from axis labels, and add %
  max_blank <- function(x){
    as.character(
      c(
        scales::percent(
          x[1:length(x) - 1]
          ),
        "")
    )
  }

  # paste0(x*100, "%")

  ## Replace dist_colours --------------------------------------------------

  if((length(dist_colours) - length(cut)) < 1){

    dist_colours <- heat_colours(n = length(cut) + 1)
    message("Insufficient colours supplied to `dist_colours` - using default colouring palette instead.",
            "Please supply a vector of colours of length n + 1 where n is the length of vector supplied to `cut`.")
  }

  ## Table to return -------------------------------------------------------

  return_table <-
    plot_table %>%
    select(group, bucket_hours, percent) %>%
    {if(is.null(labels)){

      .

    } else if(is.function(labels)){

      mutate(., bucket_hours = do.call(what = labels, args = list(bucket_hours)))

    } else {

      mutate(., bucket_hours = replace_labels(x = bucket_hours, labels = labels))

    }} %>%
    spread(bucket_hours,  percent) %>%
    left_join(data %>%
                rename(group = !!sym(hrvar)) %>%
                group_by(group) %>%
                summarise(Employee_Count = n_distinct(PersonId)),
              by = "group") %>%
    ungroup() %>%
    { if(is.null(sort_by)){

      .

    } else {

      arrange(., desc(!!sym(sort_by)))

    }} %>%
    mutate(group = factor(group, levels = unique(group)))



  ## Bar plot -------------------------------------------------------------

  plot_object <-
    plot_table %>%
    mutate(group = factor(group, levels = levels(return_table$group))) %>%
    ggplot(aes(x = group,
               y = Employees,
               # y = stats::reorder(Employees, group),
               fill = bucket_hours)) +
    geom_bar(stat = "identity", position = position_fill(reverse = TRUE)) +
    scale_y_continuous(expand = c(.01, 0), labels = max_blank, position = "right") +
    coord_flip() +
    annotate("text", x = plot_legend$group, y = 1.15, label = plot_legend$Employee_Count, size = 3) +
    annotate("rect", xmin = 0.5, xmax = length(plot_legend$group) + 0.5, ymin = 1.05, ymax = 1.25, alpha = .2) +
    annotate(x = length(plot_legend$group) + 0.8,
             xend = length(plot_legend$group) + 0.8,
             y = 0,
             yend = 1,
             colour = "black",
             lwd = 0.75,
             geom = "segment") +

    # Option to override labels ---------------------------------------------
    {if(is.null(labels)){

      scale_fill_manual(name = "", values = rev(dist_colours))

    } else if(is.function(labels)){

      scale_fill_manual(name = "", labels = labels, values = rev(dist_colours))

    } else {

      # # Match with values, replace with names
      # # Flip names and values to be used for `scale_fill_manual()`
      flip <- function(x){ stats::setNames(object = names(x), nm = x)}

      scale_fill_manual(name = "",
                        labels = flip(labels),
                        values = rev(dist_colours))

    }} +
    theme_wpa_basic() +
    theme(axis.line = element_blank(),
          axis.ticks = element_blank(),
          axis.title = element_blank()) +
    labs(
      title = clean_nm,
      subtitle = paste("Percentage of employees by", tolower(camel_clean(hrvar))),
      x = camel_clean(hrvar),
      caption = extract_date_range(data, return = "text")
      )

  # Return options ---------------------------------------------------------


  if(return == "table"){

    return_table

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

library(testthat)
library(vivainsights)

test_that("create_dist returns a data frame when return = 'table'", {

  result <- create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")

  # Check if the result is a data frame
  expect_s3_class(result, "data.frame")
})

test_that("create_dist returns a ggplot when return = 'plot'", {

    result <- create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "plot")

  # Check if the result is a ggplot object
  expect_s3_class(result, "ggplot")
})

#' @title Generate a Meeting Text Mining report in HTML
#'
#' @description
#' Create a text mining report in HTML based on Meeting Subject Lines
#'
#' @details
#' Note that the column `Subject` must be available within the input data frame
#' in order to run.d
#'
#' @param data A Meeting Query dataset in the form of a data frame.
#' @param path Pass the file path and the desired file name, _excluding the file
#'   extension_. For example, `"meeting text mining report"`.
#' @param stopwords A character vector OR a single-column data frame labelled
#'   `'word'` containing custom stopwords to remove.
#' @param timestamp Logical vector specifying whether to include a timestamp in
#'   the file name. Defaults to TRUE.
#' @param keep A numeric vector specifying maximum number of words to keep.
#' @param seed A numeric vector to set seed for random generation.
#'
#' @family Reports
#' @family Meetings
#' @family Text-mining
#'
#' @inherit generate_report return
#'
#' @section How to run:
#'  ```
#'  meeting_tm_report(mt_data)
#'  ```
#'  This will generate a HTML report as specified in `path`.
#'
#' @export
meeting_tm_report <- function(data,
                              path = "meeting text mining report",
                              stopwords = NULL,
                              timestamp = TRUE,
                              keep = 100,
                              seed = 100){

  ## Check if dependencies are installed
  check_pkg_installed(pkgname = "flexdashboard")

  ## Add timestamp
  if(timestamp == TRUE){
    path <- paste(path, tstamp())
  }

  ## Generate report from RMarkdown
  generate_report2(
    data = data,
    stopwords = stopwords,
    keep = keep,
    seed = seed,
    output_file = paste0(path, ".html"),
    report_title = "Analysis of Meeting Subject Lines",
    rmd_dir = system.file("rmd_template/meeting_tm/meeting_tm_report.rmd", package = "vivainsights"),
    output_format =
      flexdashboard::flex_dashboard(orientation = "columns",
                                    vertical_layout = "fill",
                                    source_code = "embed"),
  )


#   ## Create timestamped path (if applicable)
#   if(timestamp == TRUE){
#     newpath <- paste(path, wpa::tstamp())
#   } else {
#     newpath <- path
#   }
#
#   # Set outputs
#   output_list <-
#     list(
#       md2html(text = read_preamble("blank.md")), # Header
#       data %>% tm_wordcloud(stopwords = stopwords, keep = keep),
#       data %>% tm_freq(token = "words", stopwords = stopwords, keep = keep),
#       data %>% tm_freq(token = "words", stopwords = stopwords, keep = keep, return = "table"),
#       data %>% tm_freq(token = "ngrams", stopwords = stopwords, keep = keep),
#       data %>% tm_freq(token = "ngrams", stopwords = stopwords, keep = keep, return = "table"),
#       data %>% tm_cooc(stopwords = stopwords, seed = seed),
#       data %>% tm_cooc(stopwords = stopwords, seed = seed, return = "table"),
#       data %>% subject_scan(mode = "days"),
#       data %>% subject_scan(mode = "hours")
#          ) %>%
#     purrr::map_if(is.data.frame, create_dt)
#
#   # Set header titles
#   title_list <-
#     c(
#       "Text Mining Report", # Section header
#       "Word cloud",
#       "Word Frequency",
# 	    "",
#       "Phrase Frequency",
# 	    "",
#       "Word Co-occurrence",
# 	    "",
#       "Top terms",
#       ""
#       )
#
#   # Set header levels
#   n_title <- length(title_list)
#   levels_list <- rep(3, n_title)
#   levels_list[c(1)] <- 2 # Section header
#
#   # Generate report
#   generate_report(title = "Analysis of Meeting Subject Lines",
#                   filename = newpath,
#                   outputs = output_list,
#                   titles = title_list,
#                   subheaders = rep("", n_title),
#                   echos = rep(FALSE, n_title),
#                   levels = levels_list,
#                   theme = "cosmo",
#                   preamble = read_preamble("meeting_tm_report.md"))

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Manager 1:1 Time Trend
#'
#' @description
#' Provides a week by week view of scheduled manager 1:1 Time. By default
#' returns a week by week heatmap, highlighting the points in time with most
#' activity. Additional options available to return a summary table.
#'
#' @details
#' Uses the metric `Meeting_and_call_hours_with_manager_1_1`.
#'
#' @inheritParams create_trend
#' @inherit create_trend return
#'
#' @family Visualization
#' @family Managerial Relations
#'
#'
#' @examples
#' # Run plot
#' one2one_trend(pq_data)
#'
#' # Run table
#' one2one_trend(pq_data, hrvar = "LevelDesignation", return = "table")
#'
#' @export

one2one_trend <- function(data,
                          hrvar = "Organization",
                          mingroup = 5,
                          return = "plot"){

  create_trend(data,
               metric = "Meeting_and_call_hours_with_manager_1_1",
               hrvar = hrvar,
               mingroup = mingroup,
               return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Manager 1:1 Time (Fizzy Drink plot)
#'
#' @description
#' Analyze weekly Manager 1:1 Time distribution, and returns
#' a 'fizzy' scatter plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @inheritParams create_fizz
#' @inherit create_fizz return
#'
#' @family Visualization
#' @family Managerial Relations
#'
#' @examples
#' # Return plot
#' one2one_fizz(pq_data, hrvar = "Organization", return = "plot")
#'
#' # Return a summary table
#' one2one_fizz(pq_data, hrvar = "Organization", return = "table")
#'
#' @export

one2one_fizz <- function(data,
                       hrvar = "Organization",
                       mingroup = 5,
                       return = "plot"){

  cleaned_data <-
    data %>%
    mutate(`Scheduled 1:1 meeting and call minutes with manager` = Meeting_and_call_hours_with_manager_1_1 * 60)

  create_fizz(data = cleaned_data,
              metric = "Scheduled 1:1 meeting and call minutes with manager",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return)

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify Non-Knowledge workers in a Person Query using Collaboration
#'   Hours
#'
#' @description
#' This function scans a standard query output to identify employees with
#' consistently low collaboration signals. Returns the % of non-knowledge
#' workers identified by Organization, and optionally an edited data frame with
#' non-knowledge workers removed, or the full data frame with the kw/nkw flag
#' added.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param collab_threshold Positive numeric value representing the collaboration
#'   hours threshold that should be exceeded as an average for the entire
#'   analysis period for the employee to be categorized as a knowledge worker
#'   ("kw"). Default is set to 5 collaboration hours. Any versions after v1.4.3,
#'   this uses a "greater than or equal to" logic (`>=`), in which case persons
#'   with exactly 5 collaboration hours will pass.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"text"`
#'   - `"data_with_flag"`
#'   - `"data_clean"`
#'   - `"data_cleaned"`
#'   - `"data_summary"`
#'
#' See `Value` for more information.
#'
#' @import dplyr
#'
#' @family Data Validation
#'
#' @return
#' A different output is returned depending on the value passed to the `return`
#' argument:
#'   - `"text"`: string. Returns a diagnostic message.
#'   - `"data_with_flag"`: data frame. Original input data with an additional
#'   column containing the `kw`/`nkw` flag.
#'   - `"data_clean"` or `"data_cleaned"`: data frame. Data frame with non-knowledge workers
#'   excluded.
#'   - `"data_summary"`: data frame. A summary table by organization listing
#'   the number and % of non-knowledge workers.
#'
#' @export
identify_nkw <- function(data, collab_threshold = 5, return = "data_summary"){

  summary_byPersonId <-
    data %>%
    group_by(PersonId, Organization) %>%
    summarize(mean_collab = mean(Collaboration_hours), .groups = "drop")%>%
    mutate(flag_nkw = case_when(mean_collab >= collab_threshold ~ "kw",
                                TRUE ~ "nkw"))

  data_with_flag <-
    left_join(data,
              summary_byPersonId %>%
                dplyr::select(PersonId,flag_nkw),
              by = 'PersonId')

  summary_byOrganization <-
    summary_byPersonId %>%
    group_by(Organization, flag_nkw)%>%
    summarise(total = n(), .groups = "drop")%>%
    group_by(Organization)%>%
    mutate(perc = total/sum(total))%>% #need to format to %
    filter(flag_nkw == "nkw")%>%
    rename(n_nkw = total, perc_nkw = perc)%>%
    select(-flag_nkw) %>%
    ungroup()

  ## Number of NKW identified
  n_nkw <- sum(summary_byPersonId$flag_nkw == "nkw")


  if(n_nkw == 0){
    flagMessage <- paste0("[Pass] There are no non-knowledge workers identified",
                          " (average collaboration hours below ",
                          collab_threshold,
                          " hours).")
  } else {
    flagMessage <-
      paste0("[Warning] Out of a population of ", n_distinct(data$PersonId),
             ", there are ", n_nkw,
             " employees who may be non-knowledge workers (average collaboration hours below ",
             collab_threshold, " hours).")
  }

   if(return == "data_with_flag"){
    return(data_with_flag)

  } else if(return %in% c("data_clean", "data_cleaned")){
    
    # Create diagnostic message for removed non-knowledge workers
    nkw_count <- sum(data_with_flag$flag_nkw == "nkw", na.rm = TRUE)
    total_persons <- n_distinct(data$PersonId)
    
    if(nkw_count > 0) {
      diagnostic_msg <- paste0(nkw_count, " employees have been flagged as non-knowledge workers and removed from the data. ",
                              "This is based on a collaboration hours threshold of ", collab_threshold, 
                              " hours (employees with less than this threshold on average).")
    } else {
      diagnostic_msg <- paste0("No employees were identified as non-knowledge workers based on a collaboration hours threshold of ", 
                              collab_threshold, " hours.")
    }
    
    # Print the diagnostic message
    message(diagnostic_msg)
    
    # Return the cleaned data
    data_with_flag %>%
      filter(flag_nkw == "kw")

  } else if(return == "text"){

    flagMessage

  } else if(return =="data_summary"){

    summary_byOrganization %>%
      mutate(perc_nkw = scales::percent(perc_nkw, accuracy = 1)) %>%
      rename(`Non-knowledge workers (count)` = "n_nkw",
             `Non-knowledge workers (%)` = "perc_nkw")

  } else {
    stop("Error: please check inputs for `return`")
  }
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Collaboration Ranking
#'
#' @description
#' This function scans a standard query output for groups with high levels of
#' 'Weekly Digital Collaboration'. Returns a plot by default, with an option to
#' return a table with a all of groups (across multiple HR attributes) ranked by
#' hours of digital collaboration.
#'
#' @details
#' Uses the metric `Collaboration_hours`.
#' See `create_rank()` for applying the same analysis to a different metric.
#'
#' @inheritParams create_rank
#' @inherit create_rank return
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' # Return rank table
#' collaboration_rank(
#'   data = pq_data,
#'   return = "table"
#' )
#'
#' # Return plot
#' collaboration_rank(
#'   data = pq_data,
#'   return = "plot"
#' )
#'
#' @export


collaboration_rank <- function(data,
                               hrvar = extract_hr(data),
                               mingroup = 5,
                               mode = "simple",
                               plot_mode = 1,
                               return = "plot"){

  create_rank(data,
              metric = "Collaboration_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              mode = mode,
              plot_mode = plot_mode,
              return = return)

}

#' @rdname collaboration_rank
#' @export
collab_rank <- collaboration_rank

#' @title Max-Min Scaling Function
#'
#' @description This function allows you to scale vectors or an entire data
#'   frame using the max-min scaling method A numeric vector is always returned.
#'
#' @details This is used within `keymetrics_scan()` to enable row-wise
#'   heatmapping. Originally implemented in
#'   <https://github.com/martinctc/surveytoolbox>.
#'
#' @param x Pass a vector or the required columns of a data frame through this
#'   argument.
#' @keywords max-min
#'
#' @family Support
#'
#' @examples
#' numbers <- c(15, 40, 10, 2)
#' maxmin(numbers)
#'
#' @return
#' Returns a numeric vector with the input rescaled.
#'
#' @export

maxmin <- function(x){
  if(any(is.na(x))){
    warning("Warning: vector contains missing values. Those values will return as NA.")
  }
  maxs <- max(x, na.rm = TRUE)
  mins <- min(x, na.rm = TRUE)
  as.numeric(scale(x,center=mins,scale=maxs-mins))
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Distribution of Meeting Hours as a 100% stacked bar
#'
#' @description
#' Analyze Meeting Hours distribution.
#' Returns a stacked bar plot by default.
#' Additional options available to return a table with distribution elements.
#'
#' @inheritParams create_dist
#' @inherit create_dist return
#'
#' @family Visualization
#' @family Meetings
#'
#' @examples
#' # Return plot
#' meeting_dist(pq_data, hrvar = "Organization")
#'
#' # Return summary table
#' meeting_dist(pq_data, hrvar = "Organization", return = "table")
#'
#' # Return result with a custom specified breaks
#' meeting_dist(pq_data, hrvar = "LevelDesignation", cut = c(4, 7, 9))
#'
#' @export

meeting_dist <- function(data,
                         hrvar = "Organization",
                         mingroup = 5,
                         return = "plot",
                         cut = c(5, 10, 15)) {

  create_dist(data = data,
              metric = "Meeting_hours",
              hrvar = hrvar,
              mingroup = mingroup,
              return = return,
              cut = cut)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

.onAttach <- function(libname, pkgname) {
  message <- c("\n Thank you for using the {vivainsights} R package!",
               "\n \n Our analysts have taken every care to ensure that this package runs smoothly and bug-free.",
               "\n \n However, if you do happen to encounter any, please report any issues at",
               "\n https://github.com/microsoft/vivainsights/issues/",
               "\n \n Happy coding!")
  packageStartupMessage(message)
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Generate a Information Value HTML Report
#'
#' @description
#' The function generates an interactive HTML report using Standard Person Query
#' data as an input. The report contains a full Information Value analysis,  a
#' data exploration technique that helps determine which columns in a data set
#' have predictive power or influence on the value of a specified dependent
#' variable.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' @param predictors A character vector specifying the columns to be used as
#'   predictors. Defaults to NULL, where all numeric vectors in the data will be
#'   used as predictors.
#' @param outcome A string specifying a binary variable, i.e. can only contain
#'   the values 1 or 0.
#' @param bins Number of bins to use in `Information::create_infotables()`,
#'   defaults to 10.
#' @param max_var Numeric value to represent the maximum number of variables to
#' show on plots.
#' @param path Pass the file path and the desired file name, _excluding the file
#'   extension_. For example, `"IV report"`.
#' @param timestamp Logical vector specifying whether to include a timestamp in
#'   the file name. Defaults to TRUE.
#'
#' @section Creating a report:
#'
#' Below is an example on how to run the report.
#'
#' ```
#' library(dplyr)
#'
#' pq_data %>%
#'   mutate(CH_binary = ifelse(Collaboration_hours > 12, 1, 0)) %>% # Simulate binary variable
#'   IV_report(outcome =  "CH_binary",
#'             predictors = c("Email_hours", "Meeting_hours"))
#' ```
#'
#' @family Reports
#' @family Variable Association
#' @family Information Value
#'
#' @inherit generate_report return
#'
#' @export
IV_report <- function(data,
                      predictors = NULL,
                      outcome,
                      bins = 5,
                      max_var = 9,
                      path = "IV report",
                      timestamp = TRUE){

  # Create timestamped path (if applicable) -----------------------------------

  if(timestamp == TRUE){
    newpath <- paste(path, vivainsights::tstamp())
  } else {
    newpath <- path
  }

  # Return IV object directly -------------------------------------------------

  # Call `calculate_IV()` only once
  IV_obj <-
    data %>%
    create_IV(outcome = outcome,
              predictors = predictors,
              bins = bins,
              return = "IV")

  # IV_names
  IV_names <- names(IV_obj$Tables)

  # List of tables -----------------------------------------------------------

  table_list <-
    IV_names %>%
    purrr::map(function(x){
      IV_obj$Tables[[x]] %>%
        mutate(ODDS = exp(WOE + IV_obj$lnodds),
               PROB = ODDS / (ODDS + 1))
    }) %>%
    purrr::set_names(IV_names)

  # List of ggplot objects ----------------------------------------------------

  plot_list <-
    IV_obj$Summary$Variable %>%
    as.character() %>%
    purrr::map(~plot_WOE(IV = IV_obj, predictor = .))

  # Restrict maximum plots to `max_var` ---------------------------------------

  if(length(plot_list) > max_var){

    plot_list <- plot_list[1:max_var]
    table_list <- table_list[1:max_var]

  }

  table_names <- gsub("_", " ", x = names(table_list))

  # Output list ---------------------------------------------------------------

  output_list <-
    list(
      data %>% check_query(return = "text"),
      data %>% create_IV(outcome = outcome, predictors=predictors, bins= bins),
      data %>% create_IV(outcome = outcome,
                         predictors = predictors,
                         bins = bins,
                         return="summary"),
      read_preamble("blank.md") # Header for WOE Analysis
    ) %>%
    c(plot_list) %>%
    c(list(read_preamble("blank.md"))) %>% # Header for Summary Tables
    c(table_list)  %>%
    purrr::map_if(is.data.frame, create_dt) %>%
    purrr::map_if(is.character, md2html)

  title_list <-
    c("Data Overview",
      "Top Predictors",
      "",
      "WOE Analysis",
      rep("", length(plot_list)),
      "Summary - Predictors",
      table_names)


  n_title <- length(title_list)

  title_levels <-
    c(
      2,
      2,
      4,
      2, # Header for WOE Analysis
      rep(4, length(plot_list)),
      2, # Header for WOE Analysis
      rep(3, length(table_list))
    )

  generate_report(title = "Information Value Report",
                  filename = newpath,
                  outputs = output_list,
                  titles = title_list,
                  subheaders = rep("", n_title),
                  echos = rep(FALSE, n_title),
                  levels = title_levels,
                  theme = "cosmo",
                  preamble = read_preamble("IV_report.md"))

}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Identify date frequency based on a series of dates
#'
#' @description
#' `r lifecycle::badge('experimental')`
#'
#' Takes a vector of dates and identify whether the frequency is 'daily',
#' 'weekly', or 'monthly'. The primary use case for this function is to provide
#' an accurate description of the query type used and for raising errors should
#' a wrong date grouping be used in the data input.
#'
#' @param x Vector containing a series of dates.
#'
#' @details
#' Date frequency detection works as follows:
#'   - If at least three days of the week are present (e.g., Monday, Wednesday,
#'   Thursday) in the series, then the series is classified as 'daily'
#'   - If the total number of months in the series is equal to the length, then
#'   the series is classified as 'monthly'
#'   - If the total number of sundays in the series is equal to the length of
#'   the series, then the series is classified as 'weekly
#'
#' @section Limitations:
#' One of the assumptions made behind the classification is that weeks are
#' denoted with Sundays, hence the count of sundays to measure the number of
#' weeks. In this case, weeks where a Sunday is missing would result in an
#' 'unable to classify' error.
#'
#' Another assumption made is that dates are evenly distributed, i.e. that the
#' gap between dates are equal. If dates are unevenly distributed, e.g. only two
#' days of the week are available for a given week, then the algorithm will fail
#' to identify the frequency as 'daily'.
#'
#' @return
#' String describing the detected date frequency, i.e.:
#'   - `'daily'`
#'   - `'weekly'`
#'   - `'monthly'`
#'
#' @examples
#' start_date <- as.Date("2022/06/26")
#' end_date <- as.Date("2022/11/27")
#'
#' # Daily
#' day_seq <-
#'   seq.Date(
#'     from = start_date,
#'     to = end_date,
#'     by = "day"
#'   )
#'
#' identify_datefreq(day_seq)
#'
#' # Weekly
#' week_seq <-
#'   seq.Date(
#'     from = start_date,
#'     to = end_date,
#'     by = "week"
#'   )
#'
#' identify_datefreq(week_seq)
#'
#' # Monthly
#' month_seq <-
#'   seq.Date(
#'     from = start_date,
#'     to = end_date,
#'     by = "month"
#'   )
#' identify_datefreq(month_seq)
#'
#' @export

identify_datefreq <- function(x){

  # Data frame for checking
  date_df <- data.frame(
    weekdays = names(table(weekdays(x))),
    n = as.numeric(table(weekdays(x)))
  )


  dweekchr <- c(
    "Sunday",
    "Saturday",
    "Monday",
    "Tuesday",
    "Wednesday",
    "Thursday",
    "Friday"
  )

  # At least 3 days of the week must be present
  check_wdays <- ifelse(
    sum(dweekchr %in% date_df$weekdays) >= 3, TRUE, FALSE)

  # Check number of Sundays - should equal number of weeks if weekly
  check_nsun <- sum(date_df$n[date_df$weekdays == "Sunday"])

  ifelse(
    length(months(x)) == length(x),
    "monthly",
    ifelse(
      check_nsun == length(x),
      "weekly",
      ifelse(
        check_wdays,
        "daily",
        "Unable to identify date frequency."
      )
    )
  )
}

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

#' @title Collaboration - Stacked Area Plot
#'
#' @description
#' Provides an overview analysis of Weekly Digital Collaboration.
#' Returns an stacked area plot of Email and Meeting Hours by default.
#' Additional options available to return a summary table.
#'
#' @details
#' Uses the metrics `Meeting_hours`, `Email_hours`, `Unscheduled_Call_hours`,
#' and `Instant_Message_hours`.
#'
#' @param data A Standard Person Query dataset in the form of a data frame.
#' A Ways of Working assessment dataset may also be provided, in which
#' Unscheduled call hours would be included in the output.
#' @param hrvar HR Variable by which to split metrics, defaults to `NULL`, but
#'   accepts any character vector, e.g. "LevelDesignation". If `NULL` is passed,
#'   the organizational attribute is automatically populated as "Total".
#' @param mingroup Numeric value setting the privacy threshold / minimum group
#'   size. Defaults to 5.
#' @param return String specifying what to return. This must be one of the
#'   following strings:
#'   - `"plot"`
#'   - `"table"`
#'
#' See `Value` for more information.
#'
#' @import dplyr
#' @import ggplot2
#' @import reshape2
#' @import scales
#'
#' @family Visualization
#' @family Collaboration
#'
#' @examples
#' \dontrun{
#' # Return plot with total (default)
#' collaboration_area(pq_data)
#'
#' # Return plot with hrvar split
#' collaboration_area(pq_data, hrvar = "Organization")
#' 
#' # Return summary table
#' collaboration_area(pq_data, return = "table")
#' }
#' 
#' @return
#' A different output is returned depending on the value passed to the `return` argument:
#'   - `"plot"`: 'ggplot' object. A stacked area plot for the metric.
#'   - `"table"`: data frame. A summary table for the metric.
#'
#' @export

collaboration_area <- function(data,
                               hrvar = NULL,
                               mingroup = 5,
                               return = "plot"){

  ## Handle date name
  data <- data %>% rename(Date = MetricDate)

  ## Handling NULL values passed to hrvar
  if(is.null(hrvar)){
    data <- totals_col(data)
    hrvar <- "Total"
  }

  ## Date cleaning
  data$Date <- as.Date(data$Date, format = "%m/%d/%Y")

  ## Lower case version of column names
  lnames <- tolower(names(data))

  if("unscheduled_call_hours" %in% lnames){

    names(data) <-
      gsub(pattern = "unscheduled_call_hours",
           replacement = "Unscheduled_Call_hours",
           x = names(data),
           ignore.case = TRUE) # Case-insensitive

  }

  ## Exclude metrics if not available as a metric

  check_chr <- c("^Meeting_hours$",
                 "^Email_hours$",
                 "^Instant_Message_hours$",
                 "^Unscheduled_Call_hours$")

  main_vars <-
    names(data)[
    grepl(pattern = paste(check_chr, collapse = "|"),
          x = lnames,
          ignore.case = TRUE)
  ]

  ## Analysis table

  myTable <-
    data %>%
    rename(group = !!sym(hrvar)) %>% # Rename HRvar to `group`
    select(PersonId,
           Date,
           group,
           main_vars) %>%
    group_by(Date, group) %>%
    summarise(across(all_of(main_vars), ~mean(.))) %>%
    left_join(hrvar_count(data, hrvar, return = "table"),
              by = c("group" = hrvar)) %>%
    rename(Employee_Count = "n") %>%
    dplyr::filter(Employee_Count >= mingroup) %>%
    ungroup()


  myTable_long <-
    myTable %>%
    select(Date, group, ends_with("_hours")) %>%
    tidyr::gather(Metric, Hours, -Date, -group) %>%
    mutate(Metric = sub(pattern = "_hours", replacement = "", x = Metric))

  ## Levels
  level_chr <- sub(pattern = "_hours", replacement = "", x = main_vars)

  ## Colour definitions
  colour_defs <-
    c("Meeting" = "#34b1e2",
      "Email" = "#1d627e",
      "Instant_Message" = "#adc0cb",
      "Unscheduled_Call" = "#b4d5dd")

  colour_defs <- colour_defs[names(colour_defs) %in% level_chr]

  plot_object <-
    myTable_long %>%
    mutate(Metric = factor(Metric, levels = level_chr)) %>%
    ggplot(aes(x = Date, y = Hours, colour = Metric)) +
    geom_area(aes(fill = Metric), alpha = 1.0, position = 'stack') +
    theme_wpa_basic() +
    scale_y_continuous(labels = round) +
    theme(axis.text.x = element_text(angle = 90, hjust = 1)) +
    scale_colour_manual(values = colour_defs) +
    scale_fill_manual(values = colour_defs) +
    facet_wrap(.~group) +
    labs(title = "Total Collaboration Hours",
         subtitle = paste("Weekly collaboration hours by",  camel_clean(hrvar))) +
    labs(caption = extract_date_range(data, return = "text"))

  if(return == "table"){

    myTable %>%
      as_tibble() %>%
      mutate(Collaboration_hours = select(., main_vars) %>%
               apply(1, sum, na.rm = TRUE))

  } else if(return == "plot"){

    return(plot_object)

  } else {

    stop("Please enter a valid input for `return`.")

  }

}

#' @rdname collaboration_area
#' @export
collab_area <- collaboration_area

# --------------------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See LICENSE.txt in the project root for license information.
# --------------------------------------------------------------------------------------------

# Internal helpers shared by create_radar* and create_survival* functions.
# Not exported.

.check_inputs_safe <- function(data, requirements) {

  if (exists("check_inputs", mode = "function")) {
    data %>% check_inputs(requirements = requirements)
    return(invisible(TRUE))
  }

  missing <- setdiff(requirements, names(data))
  if (length(missing) > 0) {
    stop("Missing required column(s): ", paste(missing, collapse = ", "))
  }

  invisible(TRUE)
}

.theme_wpa_safe <- function() {

  # Use theme_wpa_basic() (no custom font) to ensure compatibility across
  # platforms and devices (including the PostScript device used by R CMD check).
  if (exists("theme_wpa_basic", mode = "function")) return(theme_wpa_basic())

  if ("vivainsights" %in% loadedNamespaces() &&
      exists("theme_wpa_basic", envir = asNamespace("vivainsights"), mode = "function")) {
    return(get("theme_wpa_basic", envir = asNamespace("vivainsights"))())
  }

  ggplot2::theme_minimal()
}

# Produce a human-readable label from an hrvar column name, consistent with
# the convention used by other create_* functions (e.g. create_bar).
.pretty_hrvar_name <- function(hrvar) {

  if (exists("camel_clean", mode = "function")) return(tolower(camel_clean(hrvar)))

  gsub("_", " ", tolower(hrvar), fixed = TRUE)
}

# Derive a segment column from identify_usage_segments().
# `metrics`: non-empty character vector of metric column names.
.auto_segment_using_identify_usage <- function(data,
                                               metrics,
                                               usage_version = "12w") {

  if (!is.character(metrics) || length(metrics) < 1) {
    stop("`metrics` must be a non-empty character vector.")
  }

  miss <- setdiff(metrics, names(data))
  if (length(miss) > 0) {
    stop("Some metric columns are missing: ", paste(miss, collapse = ", "))
  }

  # Locate identify_usage_segments() (package namespace preferred)
  ident_fun <- NULL
  if ("vivainsights" %in% loadedNamespaces() &&
      exists("identify_usage_segments", envir = asNamespace("vivainsights"), mode = "function")) {
    ident_fun <- get("identify_usage_segments", envir = asNamespace("vivainsights"))
  } else if (exists("identify_usage_segments", mode = "function")) {
    ident_fun <- identify_usage_segments
  } else {
    stop("`identify_usage_segments()` not found. Load `vivainsights` first.")
  }

  original_cols <- names(data)

  if (length(metrics) == 1) {
    seg_data <- ident_fun(
      data = data,
      metric = metrics[[1]],
      metric_str = NULL,
      version = usage_version,
      return = "data"
    )
  } else {
    seg_data <- ident_fun(
      data = data,
      metric = NULL,
      metric_str = metrics,
      version = usage_version,
      return = "data"
    )
  }

  # Infer segment column from newly-added columns
  new_cols <- setdiff(names(seg_data), original_cols)

  candidates <- Filter(function(cn) {
    x <- seg_data[[cn]]
    (is.factor(x) || is.character(x)) &&
      dplyr::n_distinct(x, na.rm = TRUE) > 1 &&
      dplyr::n_distinct(x, na.rm = TRUE) <= 10
  }, new_cols)

  if (length(candidates) == 0) {
    stop("No suitable segment column detected after running `identify_usage_segments()`.")
  }

  # Prefer a version-matching column name if uniquely available
  if (!is.null(usage_version) && is.character(usage_version) && length(usage_version) == 1) {
    vmatch <- candidates[grepl(usage_version, candidates, fixed = TRUE)]
    if (length(vmatch) == 1) {
      return(list(data = seg_data, segment_col = vmatch[[1]]))
    }
  }

  # Otherwise choose smallest cardinality
  nunique <- vapply(candidates, function(cn) {
    dplyr::n_distinct(seg_data[[cn]], na.rm = TRUE)
  }, numeric(1))

  segment_col <- candidates[[which.min(nunique)]]

  list(data = seg_data, segment_col = segment_col)
}

If you believe abnormal Outlook settings are distorting your results, consider standardizing working hours across your analysis population. You can override Outlook settings by setting a global parameter in the _Dependencies_ section of the Person query.  

 

Focus
=====================================

<body style="background-color:white;font-family:arial">

<p style="color:gray;background-color:white;margin-left: 20px">
<br>
<B>
  <font size="+3">
    Are employees able to engage in uninterrupted focus time?  
  </font>
</B>
<br>
<br>
</p>

Column {data-width=30%}
-----------------------------------------------------------------------

### total hours available for focus work per person per day

```{r}

KPI_1 <- my_sq_data %>%
  create_bar(hrvar = NULL,
             metric = "Total_focus_hours_daily",
             return = "table") %>%
  pull("Total_focus_hours_daily") %>%
  round(1)
  
paste(KPI_1, "total focus hours") %>%
  flexdashboard::valueBox(icon = "fa-user-edit",
                          color = "#34b1e2")
  
```

### <B> Are employees able to engage in uninterrupted focus time? </B> <br> Meeting-free focus time is vital for employees to be able to complete individual tasks, think creatively, and address critical business demands. Employees are able  to engage in high quality focus time if there is a break of 2 hours between meetings.

```{r}
resilience1_w1_plot1 <-
  my_sq_data %>%
  create_bar(hrvar = hrvar,
             metric = "Total_focus_hours_daily",
             rank = NULL,
             percent = FALSE) 

resilience1_w1_plot1 +
  labs(title = "Focus Time",
       subtitle = paste("Average hours per person per day"))

```

Column {data-width=30%}
-----------------------------------------------------------------------

### Average unscheduled collaboration per person each day

```{r}

if(sum(my_sq_data$Unscheduled_collaboration_hours_daily, na.rm = TRUE) == 0){
  
  KPI_4 <- 0
  
} else {


KPI_4 <- 
  my_sq_data %>%
  create_bar(hrvar = NULL,
             metric = "Unscheduled_collaboration_hours_daily",
             return ="table") %>%
  pull(Unscheduled_collaboration_hours_daily) %>%
  .[[1]] %>%
  round(1)

}

paste(KPI_4, "unscheduled collaboration hours") %>%
  flexdashboard::valueBox(icon = "fa-phone",
                          color = "#f59b76")
```

### <B> Is time for individual work prioritized and respected? </B> <br> High levels of unscheduled collaboration (emails, chats, calls) could risk the quality of focus time by breaking employees’ concentration and cause disruption.

```{r}

if(sum(my_sq_data$Unscheduled_collaboration_hours_daily, na.rm = TRUE) == 0){
  
  md2html("## Note: there is insufficient data to display.")
  
} else {
  
  resilience1_w2_plot1 <- my_sq_data %>%
  create_bar(hrvar = hrvar,
             rank = NULL,
             bar_colour = "#f59b76",
             metric = "Unscheduled_collaboration_hours_daily") 

  resilience1_w2_plot1 +
    labs(title = "Unscheduled Collaboration",
         subtitle = paste("Average hours per person per day"))
  
}

```

---
params:
  data: data
  stopwords: stopwords
  set_title: report_title
  keep: keep
  seed: seed
title: "`r params$set_title`"  
---

```{r echo=FALSE, message=FALSE, warning=FALSE}
library(wpa)

## Get user data
data <- params$data
stopwords <- params$stopwords
keep <- params$keep
seed <- params$seed
```

Introduction
===============================================

Column {data-width=40%}
-------------------------------------

### Introduction

In this report, you will find analysis on **meeting subject lines**. This will allow you to refine meeting exclusion rules and identify topics that drive collaboration patterns.

Column {data-width=60%}
-------------------------------------

### Word cloud

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>% tm_wordcloud(stopwords = stopwords, keep = keep)
```

Word Frequency
===============================================

Column {data-width=50%}
-------------------------------------

### Word Frequency - Plot

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>% tm_freq(token = "words", stopwords = stopwords, keep = keep)
```

Column {data-width=50%}
-------------------------------------

### Word Frequency - Table

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>%
  tm_freq(
    token = "words",
    stopwords = stopwords,
    keep = keep,
    return = "table"
    ) %>%
  create_dt()
```

Phrase Frequency
===============================================

Column {data-width=50%}
-------------------------------------

### Phrase Frequency - Plot

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>% tm_freq(token = "ngrams", stopwords = stopwords, keep = keep)
```

Column {data-width=50%}
-------------------------------------

### Phrase Frequency - Table

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>%
  tm_freq(
    token = "ngrams",
    stopwords = stopwords,
    keep = keep,
    return = "table"
    ) %>%
  create_dt()
```

Word co-occurrence
===============================================

Column {data-width=50%}
-------------------------------------

### Word co-occurrence - Plot

```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>% tm_cooc(stopwords = stopwords, seed = seed, return = "plot")
```

Column {data-width=50%}
-------------------------------------

### Word co-occurrence - Table
```{r echo=FALSE, message=FALSE, warning=FALSE}
data %>%
  tm_cooc(stopwords = stopwords, seed = seed, return = "table") %>%
  create_dt()
```

This report contains a full **Information Value (IV)** Analysis. IV is a data exploration technique that helps identify which columns in a data set have predictive power or influence on the value of a specified dependent variable. This approach is useful to determine which Viva Insights metrics are correlated to a specific outcome variable.

Among other things, this report should allow analysts to answer:

* What collaboration habits explain positive / negative answers to questions in an engagement survey?

* What collaboration habits differentiate top-performers from low-performers?

* What collaboration habits distinguish members from a specific group to others?

## Overview

In this report, you will find a series of summary and analysis relating to key **connectivity** metrics in Viva Insights, including external/internal network size vs breadth. 

For full metric definitions, please visit our [official documentation](https://docs.microsoft.com/en-us/workplace-analytics/use/metric-definitions).

---

---
params:
  wbq: wbq
  hcq: hcq
  set_title: report_title
  hrvar: hrvar
  mingroup: mingroup
  start_hour: start_hour
  end_hour: end_hour
title: "`r params$set_title`"      
---

<body style="background-color:#ffffff;">

```{r setup, include=FALSE}
start_time <- Sys.time()

# 1. Load Library
library(wpa)
library(dplyr)
library(tidyr)

# 1a. Load auxiliary functions
source("auxiliary.R")

# Glossary
gloss_tb <-
  readr::read_csv("glossary.csv")

# 2. Load Data
my_sq_data <- params$wbq
my_em_data <- params$hcq
hrvar <- params$hrvar
mingroup <- params$mingroup
start_hour <- params$start_hour
end_hour <- params$end_hour

intro_toc <- readLines("toc.md")

# Add col checker ----------------------------------------------------------

# If `replacement` is unspecified, it uses `col`

col_checker <- function(x, col, replacement = col){

  if(!(col %in% names(x)) & !(replacement %in% names(x))){
    
    # column does not exist at all
    # ACTION: DUMMY COLUMN WITH REPLACEMENT
    dplyr::mutate(x, !!sym(replacement) := NA) # create dummy column
    
  } else if(col %in% names(x) & !(replacement %in% names(x))){
    
    # column exists in x but not replacement
    # ACTION: RENAME
    dplyr::rename(x, !!sym(replacement) := col)
    
  } else if(!(col %in% names(x)) & replacement %in% names(x)){  
    
    # column does not exists in x but in replacement
    # ACTION: RETURN
    x
  
  } else if(col %in% names(x) & replacement %in% names(x)){  
    
    # column exists in both x and replacement
    # ACTION: RETURN
    x    

  } else {

    stop("Internal error with conditional.")
    
  }
}

# 3a. Simulate variables for custom Wellbeing query
my_sq_data <-
  my_sq_data %>%
  
  # Column checks ----------------------------------------------------------
  col_checker(col = "Instant_Message_hours", replacement = "Instant_message_hours") %>%
  col_checker(col = "Collaboration_hrs", replacement = "Collaboration_hours") %>%
  col_checker(col = "Unscheduled_call_hours", replacement = "Unscheduled_Call_hours") %>%
  col_checker(col = "Urgent_email_hours") %>%
  col_checker(col = "Urgent_meeting_hours") %>%
  col_checker(col = "Weekend_Email", replacement = "Weekend_emails_sent") %>%
  col_checker(col = "Weekend_IMs_sent") %>%
  col_checker(col = "IMs_sent_same_level") %>%
  col_checker(col = "IMs_sent_other_level") %>%
  col_checker(col = "Meeting_hours_1on1", replacement = "Intimate_1_on_1_meeting_hours") %>%
  col_checker(col = "Meeting_hours_intimate_group",
              replacement = "Intimate_group_meeting_hours") %>%
  col_checker(col = "IMs_sent", replacement = "Instant_messages_sent") %>%
  col_checker(col = "Workweek_span") %>%
  
  # Daily estimates --------------------------------------------------------
  
  mutate(Work_time = Workweek_span / 5) %>% # Average day span
  mutate(dailyCollabHours = Collaboration_hours / 5)  %>% # Average daily CH
  mutate(dailyAfterHours = After_hours_collaboration_hours / 5) %>%
  
  # Urgent collaboration ---------------------------------------------------
  
  # mutate(Urgent_collaboration_hours = Urgent_email_hours) %>%
  mutate(Urgent_collaboration_hours = Urgent_meeting_hours + Urgent_email_hours) %>%
  mutate(IsUrgent = ifelse(Urgent_collaboration_hours > 0, TRUE, FALSE)) %>%
  
  # Weekend work ------------------------------------------------------------

  # mutate(Weekend_work = ifelse(Weekend_Email > 0 | Weekend_Meeting > 0, TRUE, FALSE)) %>%
  mutate(Weekend_work = ifelse(Weekend_emails_sent > 0 | Weekend_IMs_sent > 0, TRUE, FALSE)) %>%
  group_by(PersonId)  %>%
  mutate(Frequency_of_weekend_work = 1 / (sum(Weekend_work) / n())) %>% #TODO: Verify logic
  mutate(monthly_weekend_work = Frequency_of_weekend_work < (52/12)) %>%
  ungroup() %>%
  
  # Two Hour Focus Blocks ---------------------------------------------------

  mutate(focus_per = (Total_focus_hours/ Workweek_span)) %>%
  mutate(focus_per = ifelse(is.infinite(focus_per), 0, focus_per)) %>%
  rename(`% of 2-hour focus block` = "focus_per") %>% 
  mutate(Total_focus_hours_daily = Total_focus_hours / 5) %>%
  
  # Unscheduled collaboration -----------------------------------------------
  
  mutate(Unscheduled_collaboration_hours_daily = (Unscheduled_Call_hours + Instant_message_hours + Email_hours)/5)

# Values containing groups over minimum group size
mingroup_str <-
  my_sq_data %>%
  hrvar_count(hrvar = hrvar,
              return = "table") %>%
  filter(n >= mingroup) %>%
  pull(!!sym(hrvar))

# 4. Compute working patterns list and flexibility index data
wp_list <-
  my_em_data %>%
  workpatterns_classify(
    start_hour = start_hour,
    end_hour = end_hour,
    signals = c("email", "IM"),
    return = "list",
    hrvar = hrvar)

flex_index_data <- 
  my_em_data %>%
  flex_index(
    return = "data",
    hrvar = hrvar,
    signals = c("email", "IM"),
    start_hour = start_hour,
    end_hour = end_hour
    )

```

```{js, echo=FALSE}
var scale = 'scale(1)';
document.body.style.webkitTransform = scale; // Chrome, Opera, Safari
document.body.style.msTransform = scale; // IE 9
document.body.style.transform = scale; // General
```

```{r child = "db_cover_4.Rmd"}

```

```{r child = "db_1.Rmd"}

```

```{r child = "db_2.Rmd"}

```

```{r child = "db_3.Rmd"}

```

```{r child = "db_4.Rmd"}

```

```{r child = "db_5.Rmd"}

```

```{r child = "db_6.Rmd"}

```

```{r child = "db_7.Rmd"}

```

```{r child = "db_8.Rmd"}

```

```{r child = "db_trends.Rmd"}

```

```{r child = "db_notes.Rmd"}

```

Abnormal Outlook settings (i.e. significant number of users defining very short or very long working days) may skew analysis results, making after-hours collaboration look particularly high or small.  

Viva Insights uses the working days and hours settings from each measured **Microsoft 365 Exchange** mailbox to calculate collaboration metrics. This data allows the system to distinguish between collaboration activity (email, meetings, and Teams calls & IMs) that takes place during and outside of working hours.  

The most frequent working hours set in Outlook in this dataset are the following:  

**Non-knowledge workers**  refer to **persons** with unusually low average collaboration hours. These may represent individuals who are not required to collaborate via Outlook and Teams as part of their role or shift or may be part-time staff. Viva Insights data may not be representative of these individuals' workday experience.  

For this reason, we suggest excluding non-knowledge workers from your analysis. You can easily remove them from your dataset by using the function `identify_nkw(return = "data_clean")`.  

If you believe that your meeting data requires further cleanup, please consider defining a new meeting exclusion rule under Settings in Viva Insights and re-running your queries. If you want to further investigate this issue, you can flag these meetings in your dataset using `subject_validate(data, return = "data")`. You can also generate a more detailed report using `subject_validate_report()`.  

---

Flexibility
=====================================

<body style="background-color:white;font-family:arial">

<p style="color:gray;background-color:white;margin-left: 20px">
<br>
<B>
  <font size="+3">
    Are employees embracing flexible work schedules?
  </font>
</B>
<br>
<br>
</p>


Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of weeks employees define their own start times

```{r}

KPI_1 <- 
  flex_index_data %>%
  create_bar(
    metric = "ChangeHours",
    hrvar = NULL,
	return="table") %>%
  select(ChangeHours) %>%
  pull(1) %>%
  round(3)*100 
  

paste(KPI_1, "% define start time")  %>%
  flexdashboard::valueBox(icon = "fa-hourglass-start",
                          color = "#34b1e2")
						  
```

### <B>Are employees freely defining their start time?</B> <br> Teams that embrace flexibility allow members of the team to start their workday at different times. Employees should be able to follow a schedule that suits their needs, than those imposed by an employer.

```{r}
# Convert `start_hour` into an hour slot string
hr_slot <- function(x){
  
  h_str <- as.numeric(substr(x, start = 1, stop = 2))
  m_str <- substr(x, start = 3, stop = 4) # keep as string
  
  apm <- ifelse(h_str < 12, "AM", "PM")
  
  slot1 <- paste0(h_str)
  slot2 <- paste0(h_str + 1)
  
  paste0(slot1, "-", slot2, apm)
}

flex2_w1_plot <- 
  flex_index_data %>%
  mutate(Percentage_of_weeks = ChangeHours)  %>%
  create_bar(metric = "Percentage_of_weeks",
             hrvar = hrvar,
			 rank = NULL,
             xlim = 1,
             bar_colour = "#34b1e2",
             percent = TRUE)

flex2_w1_plot +
  labs(title = "Define start times",
       subtitle = paste("% of weeks employees start outside", hr_slot(start_hour), "window"))

```



Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of weeks employees have recurring disconnection time

```{r}

KPI_3 <-  flex_index_data %>%
  create_bar(
    metric = "TakeBreaks",
    hrvar = NULL,
	return="table") %>%
  select(TakeBreaks) %>%
  pull(1) %>%
  round(3)*100 

paste(KPI_3, "% define quiet hours") %>%
  flexdashboard::valueBox(icon = "fa-stopwatch",
                          color = rgb2hex(1, 147, 157))
						  
```

### <B>Are employees disconnecting at a recurring time during the week?</B> <br> Employees should have the freedom to define their weekday by taking recurring disconnection time to suit their needs. In teams that embrace flexibility, members will choose to organize / split their day in different ways (e.g. take a long lunch-break, disconnect in the afternoon and reconnect in the evening, etc.)

```{r}

flex2_w3_plot <-
  flex_index_data %>%
  mutate(Percentage_of_weeks = TakeBreaks) %>%
  create_bar(
    metric = "Percentage_of_weeks",
    hrvar = hrvar,
    xlim = 1,
    rank = NULL,
    bar_colour = rgb2hex(1, 147, 157),
    percent = TRUE
  )

flex2_w3_plot +
  labs(title = "Recurring disconnection time",
       subtitle = paste("% of weeks employees have recurring disconnection"))

```

Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of weeks employees limit their activity to 8 or less distinct hours

```{r}

KPI_2 <- flex_index_data %>%
  create_bar(
    metric = "ControlHours",
    hrvar = NULL,
	return="table") %>%
  select(ControlHours) %>%
  pull(1) %>%
  round(3)*100 


paste(KPI_2, "% control active hours") %>%
  flexdashboard::valueBox(icon = "fa-balance-scale",
                          color = "#00508F")
						  
```

### <B>Are employees able to control their active hours?</B> <br> Employees who choose alternative work schedules should be able to maintain a workload that is broadly equivalent to the standard 8 hours. Flexible working should not result in longer hours spread across the day. 

```{r}
flex2_w2_plot <- flex_index_data %>%
  mutate(Percentage_of_weeks = ControlHours) %>%
  create_bar(
    metric = "Percentage_of_weeks",
    hrvar = hrvar,
    xlim = 1,
    rank = NULL,
    bar_colour = "#00508F",
    percent = TRUE,
    text_just = 2.5,
    text_colour = "#00508F"
    )

flex2_w2_plot +
  labs(title = "Control active hours",
       subtitle = paste("% of weeks employees control active hours"))

```

Activity patterns
=====================================


<body style="background-color:white;font-family:arial">

<p style="color:gray;background-color:white;margin-left: 20px">
<br>
<B>
  <font size="+3">
    Are employees able to switch off?
  </font>
</B>
<br>
<br>
</p>


Column {data-width=30%}
-----------------------------------------------------------------------

### Distinct hours with email / chat in the most frequent activity pattern

```{r}

KPI_1 <- 
  my_em_data %>% workpatterns_rank(return="table") %>%  arrange( desc(WeekCount)) %>%  filter(row_number()==1)  %>% 
  mutate(Signals_Total = select(., starts_with("Signals_sent_")) %>%
           apply(1, sum, na.rm = TRUE)) %>% select(Signals_Total) %>% pull(1)
  
paste(KPI_1 ,"hours with activity") %>%
  flexdashboard::valueBox(icon = "fa-arrows-alt", color = "#f59b76")
  
```

### <B> When are employees engaging with work? </B> <br> Individuals may work outside regular working hours to deal with excessive workload, or to take advantage of flexible working arragements. Digital activity patterns reveals if groups are able to disconnect regularly.


```{r}

flexibility1_w3_plot1 <- my_em_data %>% workpatterns_rank()


flexibility1_w3_plot1 

```

Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of "always on" weeks based on collaboration patterns


```{r}

KPI_1 <- 
  wp_list$data %>%
  count(Personas) %>%
  mutate(prop = n / sum(n)) %>%
  select(Personas, Total = "prop") %>%
  filter(Personas == "6 Always on (13h+)") %>%
  select(Total) %>%
  pull(1) %>%
  round(3)*100
						
						
paste(KPI_1, "% always-on") %>%
  flexdashboard::valueBox(icon = "fa-lightbulb", color = "#325369" )
  
```

### <B>Are employees able to switch off? </B> <br> Individuals that work long, continuous hours without breaks or remain actively engaged with work after hours can experience a deterioration of their wellbeing. 

```{r}

flexibility1_w1_plot1 <- wp_list$plot

flexibility1_w1_plot1 +
  labs(title = "Classification of activity patterns", subtitle = "Frequency of common archetypes")

						
```

Column {data-width=30%}
-----------------------------------------------------------------------

###  is the group where employees have the highest % of "always on" weeks 

```{r}

KPI_2 <-  
  wp_list$table %>%
  filter(Personas =="6 Always on (13h+)") %>%
  pivot_longer(cols = -Personas, names_to = "group", values_to = "alwaysOn") %>%
  filter(group %in% mingroup_str) %>%
  arrange(desc(alwaysOn)) %>%
  pull(group) %>%
  .[[1]]

KPI_2  %>% flexdashboard::valueBox(icon = "fa-search")  

```

### <B>Which teams are most affected? </B> <br> Identify groups with highest prevalence the negative activity patterns and  encourage them to disconnect and build regular breaks in their work day.

```{r}

round_percent <- function(x){
  scales::percent(x, accuracy = 1)
}

wp_list$data %>%
  mutate(Personas = case_when(Personas == "0 < 3 hours on" ~ "Low\nactivity",
                              Personas == "1 Standard with breaks workday" ~ "Flexible",
                              Personas == "2 Standard continuous workday" ~ "Standard",
                              Personas == "3 Standard flexible workday" ~ "Flexible",
                              Personas == "4 Long flexible workday" ~ "Long\nflexible",
                              Personas == "5 Long continuous workday" ~ "Long\ncontinuous",
                              Personas == "6 Always on (13h+)" ~ "Always\non"
                              ) %>%
           factor(levels = 
                    c("Low\nactivity",
                      "Standard",
                      "Flexible",
                      "Long\nflexible",
                      "Long\ncontinuous",
                      "Always\non"))) %>%
  count(!!sym(hrvar), Personas) %>%
  filter(!!sym(hrvar) %in% mingroup_str) %>%
  group_by(!!sym(hrvar)) %>%
  mutate(percent = n / sum(n)) %>%
  ungroup() %>%
  ggplot(aes(x = Personas,
             y = !!sym(hrvar),
             fill = percent)) +
  geom_tile() +
  geom_text(aes(label = scales::percent(percent, accuracy = 1)),
            size = 3) +
  scale_fill_gradientn(name = "Row percentages",
                       colours = c("steelblue4",
                                   "aliceblue",
                                   "white",
                                   "mistyrose1",
                                   "tomato1"),
                       labels = round_percent) + 
  # viridis::scale_fill_viridis(labels = scales::percent) +
  scale_x_discrete(position = "top") +
  theme_wpa_basic() +
  theme(axis.text.x = element_text(angle = 50,
                                   vjust = 0.5,
                                   hjust = 0),
        axis.title = element_blank(),
        plot.margin=unit(c(0, 0, 0, 0),"cm"),
        legend.text=element_text(size = 8)) +
  labs(title = "Activity pattern distribution",
       subtitle = "Distribution of archetypes",
       caption = extract_date_range(wp_list$data, return = "text"))

```

The table below shows the organizational attributes available in this dataset. Use this table to understand the data's quality and completeness.  

* Be mindful of attributes that have many unique values, as this may limit data aggregation and filtering (For example, if a job function or code is too narrowly defined, it might not give you a useful view of the overall group).   
* Additionally, review missing values as some attributes may only be partially available for the population in this sample:  

This section evaluates the quality of the collaboration data available in your tenant, that is calculated from email, meeting, calls and IM flows within your company (all gathered from M365 Exchange and Teams). In general, collaboration data provides a very accurate description of the digital habits of employees and their daily experience as they interact with peers and other teams. However, data may not be available for all employees, or may only partially capture their day to day experience (for example, in teams that use other communication platforms or that interact face-to-face without planning meetings in advance).     
 

Community
=====================================

<body style="background-color:white;font-family:arial">

<p style="color:gray;background-color:white;margin-left: 20px">
<br>
<B>
  <font size="+3">
    Are employees maintaining communities within the workplace?  
  </font>
</B>
<br>
<br>
</p>

Column {data-width=30%}
-----------------------------------------------------------------------

### Average hours in 1:1 meetings per person each week

```{r}
if(sum(my_sq_data$Intimate_1_on_1_meeting_hours, na.rm = TRUE) == 0){
  
  p_text <- "0"
  
} else {

  p_text <- 
  my_sq_data %>%
  summarise(
    across(
      .cols = c(Intimate_1_on_1_meeting_hours),
      .fns = ~mean(., na.rm = TRUE)
    )
  ) %>%
  pull(Intimate_1_on_1_meeting_hours) %>%
  round(digits = 1)
  
}

p_text <- paste(p_text[[1]], "hours 1:1 meetings")
  

flexdashboard::valueBox(value = p_text,
                        icon = "fa-users",
                        color = rgb2hex(1, 147, 157))

```

### <B>Are employees part of communities in the workplace?</B> <br> Social and professional support at work ensures employees are safeguarded against feeling isolated. Successful rapport is built when employees meet in small group settings with two to five people attending.

```{r}

if(
  sum(my_sq_data$Intimate_group_meeting_hours, na.rm = TRUE) == 0 |
  sum(my_sq_data$Intimate_1_on_1_meeting_hours, na.rm = TRUE) == 0
  ){
  
  md2html("## Note: there is insufficient collaboration data to display.")
  
} else {

my_sq_data %>%
  create_stacked(
    hrvar = hrvar,
    rank = NULL,
    metrics = c("Intimate_group_meeting_hours", "Intimate_1_on_1_meeting_hours"),
    stack_colours = c("Intimate_group_meeting_hours" = rgb2hex(49, 97, 124),
                      "Intimate_1_on_1_meeting_hours" = rgb2hex(1, 147, 157)),
    plot_title = "Intimate meetings",
    plot_subtitle = "Average meeting hours per person each week"
  )

}  

```

Column {data-width=30%}
-----------------------------------------------------------------------

### Average hours in intimate group meetings per person each week 
```{r}

if(sum(my_sq_data$Intimate_group_meeting_hours, na.rm = TRUE) == 0){
  
  p_text <- "0"
  
} else {

p_text <-
  my_sq_data %>%
  summarise(
    across(
      .cols = c(Intimate_group_meeting_hours),
      .fns = ~mean(., na.rm = TRUE)
    )
  ) %>%
  pull(Intimate_group_meeting_hours) %>%
  round(digits = 1) 

}

p_text <- paste(p_text[[1]], "hours intimate group meetings")

flexdashboard::valueBox(value = p_text, 
                        icon = "fa-users",
                        color = rgb2hex(49, 97, 124))
```

### <B>Are employees maintaining these communities?</B> <br> Over time, relationships can fade and thus it is important to continue strengthening existing relationships and building new connections.

```{r}

if(
  sum(my_sq_data$Intimate_group_meeting_hours, na.rm = TRUE) == 0 |
  sum(my_sq_data$Intimate_1_on_1_meeting_hours, na.rm = TRUE) == 0
  ){
  
  md2html("## Note: there is insufficient collaboration data to display.")
  
} else {
  
  my_sq_data %>%
  mutate(Date = as.Date(Date, format = "%m/%d/%Y")) %>%
  group_by(Date) %>%
  summarise(
    across(
      .cols = c(Intimate_group_meeting_hours, Intimate_1_on_1_meeting_hours),
      .fns = ~mean(., na.rm = TRUE)
    )
  ) %>%
  pivot_longer(cols = c(Intimate_group_meeting_hours,
                        Intimate_1_on_1_meeting_hours),
               names_to = "Metrics",
               values_to = "Hours") %>%
  ggplot(aes(x = Date,
             y = Hours,
             group = Metrics,
             fill = Metrics)) +
  geom_area() +
  scale_fill_manual(values = 
                      c("Intimate_group_meeting_hours" = rgb2hex(49, 97, 124),
                        "Intimate_1_on_1_meeting_hours" = rgb2hex(1, 147, 157)),
                    labels = us_to_space) +
  theme_wpa_basic() +
  labs(
    title = "Time in intimate meetings",
    subtitle = "Average meeting hours per person each week",
    caption = extract_date_range(my_sq_data, return = "text")
  )
  
}



```

Balance
=====================================

<body style="background-color:white;font-family:arial">

<p style="color:gray;background-color:white;margin-left: 20px">
<br>
<B><font size="+3">Can employees balance collaboration and personal time?</font></B>
<br>
<br>
</p>

Column {data-width=30%}
-----------------------------------------------------------------------

### Average daily collaboration taking place after-hours  

```{r}


KPI_1 <- my_sq_data %>%
  create_bar(metric="dailyAfterHours", hrvar= NULL, return="table") %>%
  select(dailyAfterHours) %>%
  pull(1) %>%
  round(1)

paste(KPI_1, "hrs after work-hours")  %>%
  flexdashboard::valueBox(icon = "fa-moon",
                          color = rgb2hex(49, 97, 124))
```

### <B>Is after-hours work common practice?</B> <br> Although sometimes it may be necessary, habitually extending work into evenings is particularly detrimental to workers’ mental health.

```{r}
balance2_w1_plot1 <- my_sq_data  %>%
  rename(`After Hours Collaboration` = "dailyAfterHours") %>%
  create_bar(metric = "After Hours Collaboration",
             hrvar = hrvar,
             return = "plot",
             rank = NULL,
             bar_colour =  rgb2hex(49, 97, 124)) # Need to add mode of communication

balance2_w1_plot1 + labs(title = "After hours", subtitle = "Average hours per person per day")


```

Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of employees engaging in 2+ after-hours per day 

```{r}
KPI_2 <-
  my_sq_data %>%
    create_dist(metric = "dailyAfterHours",
                hrvar = NULL,
                return = "table",
                cut = c(1,2))

if(!("2+ hours" %in% names(KPI_2))){
  
  KPI_2 <- 0
  
} else {
  
  KPI_2 <- 
    KPI_2 %>%
    pull("2+ hours") %>%
    .[[1]] %>%
    round(3) * 100
}

paste(KPI_2, "% long after-hours") %>%
  flexdashboard::valueBox(icon = "fa-calendar-plus",
                          color = "#f59b76")
```

### <B>Which employees are engaging in the most after hours work? </B> <br> Identify groups most at risk of losing personal time and take steps to intervene and help reduce regular after-hours.

```{r}
balance2_w2_plot1 <- 
  my_sq_data %>%
  rename(`After Hours Collaboration` = "dailyAfterHours")  %>% 
  create_dist(metric = "After Hours Collaboration",
              hrvar = hrvar,
              return = "plot",
              cut = c(1,2),
              dist_colours = c("#f59b76", "#fcf0eb", "#bfe5ee"))
		
		
balance2_w2_plot1 +
  labs(title = "After hours distribution",
       subtitle = "% of employees by daily after hours collaboration")

		
```

Column {data-width=30%}
-----------------------------------------------------------------------

### Percentage of employees active on weekends at least once per month 

```{r}

if(sum(my_sq_data$monthly_weekend_work, na.rm = TRUE) == 0){
  
  KPI_3 <- 0
  
} else {
  
  KPI_3 <- 
    my_sq_data %>%
    create_bar(metric = "monthly_weekend_work", hrvar = NULL, return="table") %>%
    pull("monthly_weekend_work") %>%
    .[[1]] %>%
    round(3)* 100
  
}

# Need to calculate right KPI
paste(KPI_3, "% weekend workers") %>%
  flexdashboard::valueBox(icon = "fa-calendar-times",
                          color = "#5B0F66")

```

### <B>Are employees engaging in regular weekend work?</B> <br> Switching on for even a short period of time on weekends can siginifcantly harm employee wellbeing.  

```{r}

if(sum(my_sq_data$Frequency_of_weekend_work, na.rm = TRUE) == 0){
  
  md2html("## Note: there is insufficient data to display.")
  
} else {
    
  my_sq_data %>%
  mutate(
    across(.cols = Frequency_of_weekend_work,
           .fns = ~ifelse(!is.finite(.), 52, .))) %>% # Assume once a year = Never
  group_by(!!sym(hrvar), PersonId) %>%
  summarise(
    across(
      .cols = Frequency_of_weekend_work,
      .fns = ~median(., na.rm = TRUE)
    ),
    .groups = "drop"
  ) %>%
  group_by(!!sym(hrvar)) %>%
  summarise(
    Frequency_of_weekend_work = median(Frequency_of_weekend_work, na.rm = TRUE),
    n = n_distinct(PersonId)
  ) %>%
  filter(n >= 5) %>%
  ggplot(aes(x = Frequency_of_weekend_work,
             y = !!sym(hrvar),
             colour = "Frequency of weekend work")) +
  geom_point(size = 3) +
  scale_colour_manual(
    name="",
	values = "#5B0F66",
    # guide = "Frequency of weekend work"
    ) +
  scale_x_reverse(
    limits = c(15, 1),
    breaks = c(1, 52/12, 52/6, 13),
    labels = c("Weekly", "Monthly", "Bi-Monthly", "Quarterly"),
    position = "top"
  ) +
  labs(title = "Weekend work", 
       subtitle = "Median frequency of weekend work", 
       caption = extract_date_range(my_sq_data, return = "text")) +
  theme_wpa_basic() + 
  theme(axis.line.y = element_blank(),
        axis.ticks = element_blank(),
        axis.title = element_blank(),
        panel.grid.major.y = element_line(color="gray"),
        panel.grid.major.x = element_line(colour = "#D9E7F7", size = 5)) 
  
}

```

Viva Insights uses email and calendar activities that are stored in a person's Office 365 account to reveal internal and external collaboration trends. However, a person's calendar and email can contain a diverse set of activities (such as personal meetings or appointments, social activities, all-day training meetings, and so forth) that are not relevant to work-related collaboration, and, if included in the metrics, would skew query results.  

This section analyses the subject lines from the supplied meeting query, to identify if common exclusion terms are present in your data (e.g. happy hour, yoga class, team dinner, etc.). For more information, please visit [meeting exclusion rules](https://docs.microsoft.com/en-us/Workplace-Analytics/tutorials/meeting-exclusions-intro).    

**Inactive weeks** are **person-weeks** in the data where the collaboration hours of the sample are unusually low. These are typically removed as they represent individual holidays where the patterns of collaboration are not representative of the norm. Note that this applies to *person-weeks*, i.e. the data is only removed for an individual for a given week if it is low for that employee.    


 
 
     
 

**Holiday weeks**: these refer to **weeks** in the data where the collaboration hours of the sample are unusually low. These are typically removed from analysis as they represent public holidays where the patterns of collaboration are not representative of the norm. Note that this applies to weeks, i.e. the data of the week is removed for all employees in the sample.  


 
 
     
 

This section provides a view of the licensed population **available in the query** over time. Note that the values seen on this plot could differ from the actual licensed population due to filters on Activeness, holiday weeks, and non-knowledge workers.  
     
 

## Overview

In this report, you will find a series of summary and analysis relating to key **collaboration** metrics in Viva Insights, including email and meeting hours. 

For full metric definitions, please visit our [official documentation](https://docs.microsoft.com/en-us/workplace-analytics/use/metric-definitions).

---

Introduction
=====================================

<div class="jumbotron" style="background-color:#FFFFFF;">
<!--<img src="Microsoft-Viva-Insights-logo.png" style="float:right;width:180px;height:180px;">-->
  <h1 class="display-4">Employee Wellbeing Report</h1>
  <p class="lead" style="color:gray;"> <B> Microsoft Viva | Organisational Insights </B></p>
  <hr class="my-4">
  <p>  <font size="+1"> <em> Employee wellbeing has demonstrated the ability to improve employee engagement, retention and productivity within a company. 
  <br> Get insights into employee wellbeing across your company and uncover opportunities to improve work life balance, flexible working opportunities, organizational resilience and a sense of community. </em> </font></p>
  <br>
  <h4>Table of Contents</p>
  <div class="row">
  <div class="col-md-6"><!-- first column -->
  <div class="list-group">
  <a href="#collaboration" class="list-group-item">1. Collaboration</a>
  <a href="#balance" class="list-group-item">2. Balance</a>
  <a href="#urgency" class="list-group-item">3. Urgency</a>
  <a href="#flexibility" class="list-group-item">4. Flexibility</a>
  </div>
  </div>
  <div class="col-md-6"><!-- second column -->
  <div class="list-group">
  <a href="#activity-patterns" class="list-group-item">5. Activity Patterns</a>
  <a href="#focus" class="list-group-item">6. Focus</a>
  <a href="#community" class="list-group-item">7. Community</a>
  <a href="#informal-communication" class="list-group-item">8. Informal communication</a>
  </div>
  </div>
  </div>
  <p class="lead">
    <a class="btn btn-primary btn-lg" href="#collaboration" role="button">Start exploring</a>
  </p>
</div>
<br>

Introduction =====================================

# Employee Wellbeing Report

Microsoft Viva | Organisational Insights

Employee wellbeing has demonstrated the ability to improve employee engagement, retention and productivity within a company.
Get insights into employee wellbeing across your company and uncover opportunities to improve work life balance, flexible working opportunities, organizational resilience and a sense of community.

#### Table of Contents
1. Collaboration 2. Balance 3. Urgency 4. Flexibility
5. Activity Patterns 6. Focus 7. Community 8. Informal communication

Start exploring

## 1. Balance
    - 1.1 Are employees able to maintain work life balance?
    - 1.2 Do employees feel empowered to exercise flexible working patterns?

## 2. Flexibility
    - 2.1 Are employees embracing a flexible working schedule?
    - 2.2 What are the most common working patterns?

## 3. Resilience
    - 3.1 Are employees able to manage uninterrupted focus time?
    - 3.2 Can teams respond to urgent needs without risking employee wellbeing?

## 4. Community
    - 4.1 Do employees feel a sense of belonging and community?
    - 4.2 Are employees receiving enough coaching?

## Overview

In this report, you will find a series of summary and analysis relating to key **capacity** metrics in Viva Insights, including length of week and time in after-hours collaboration.

For full metric definitions, please visit our [official documentation](https://docs.microsoft.com/en-us/workplace-analytics/use/metric-definitions).

---

When the employee's *HireDate* is available as an organizational data attribute, it can be used to calculate tenure of employees. This section does a quality check on the calculated tenure field, calculated as the employee's last weekly collaboration date in your query minus the *HireDate*. The findings of the plot below will shed light on your analysis population's tenure distribution.   

This section runs checks against the core collaboration metrics (Email, Meeting, Teams Call, and Teams Instant Message hours) to flag any extreme values. If a significant number of extreme high or low values is identified, the Analyst is recommended to investigate the cause before proceeding further with the analysis.         


 
 
     
 

## Introduction

This report allows you to review the quality of the Viva Insights data available and highlights specific issues that may require your attention before starting analysis. This report is structured in three sections:  

1. Viva Insights Settings
2. Organizational Data Quality
3. M365 Data Quality  

The Microsoft Team behind Viva Insights has developed a series of data checks for each section. For the areas that have issues, we also provide you with suggestions to further clean up the data before performing additional analysis.   

This report will automatically conduct certain data quality tests. Results will be indicated as a `[Pass]` or `[Warning]` throughout the report. `[Warning]` messages will direct you to items that need your attention and potential action.     

For additional information about Viva Insights, including metric definitions, please visit our [official documentation](https://learn.microsoft.com/en-us/viva/insights/advanced/reference/metrics).  

---

It is recommended for Viva Insights administrators to keep up to date the organizational data that is uploaded into Workplace Analytics. These updates help guarantee that relevant changes in the organizational structure are reflected in the system, that the collaboration data of new joiners is captured, and that all Office 365 data flows are attributed to the right teams and departments (even when some employees may change roles or be promoted internally).  

The following chart shows the observed mobility of employees between teams in your organization. Lack of changes could indicate that the organizational data has not been frequently updated during the period under consideration.  
 

Organizational data is descriptive information about the employees in your organization, such as the employee's organization, job function, level, etc. This data has been uploaded by your organization's Viva Insights Administrator.  The quality of this information is important as it enables Viva Insights to attribute Office 365 data to specific groups, and slice the collaboration data in different ways to uncover relevant trends for your organization.  

## Overview

In this report, you will find a series of summary and analysis relating to key **coaching** metrics in Viva Insights, specifically in relation to the time spent between managers and their direct reports. 

For full metric definitions, please visit our [official documentation](https://docs.microsoft.com/en-us/workplace-analytics/use/metric-definitions).

---

To minimize privacy risk, queries from Viva Insights are anonymized. We also recommend that during analysis,  collaboration patterns from teams or departments are reported in an aggregated way, respecting a minimum-group-size privacy threshold (your Viva Insights Administration has already defined a minimum-group-size rule that affects Explore charts and in Plans within Viva Insights).  

The default minimum-group setting in this report is *five*, but this setting can be changed according to the privacy requirements of your organization. Re-run this report using the *mingroup* parameter to use a custom minimum group size setting.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/anonymise.R
\name{jitter_metrics}
\alias{jitter_metrics}
\title{Jitter metrics in a data frame}
\usage{
jitter_metrics(data, cols = NULL, ...)
}
\arguments{
\item{data}{Data frame containing a query.}

\item{cols}{Character vector containing the metrics to jitter. When set to
\code{NULL} (default), all numeric columns in the data frame are jittered.}

\item{...}{Additional arguments to pass to \code{jitter()}.}
}
\value{
data frame where numeric columns specified by \code{cols} are jittered using the
function \code{jitter()}.
}
\description{
Convenience wrapper around \code{jitter()} to add a layer of
anonymity to a query. This can be used in combination with \code{anonymise()} to
produce a demo dataset from real data.
}
\examples{
jittered <- jitter_metrics(pq_data, cols = "Collaboration_hours")

# compare jittered vs original results of top rows
head(
  data.frame(
    original = pq_data$Collaboration_hours,
    jittered = jittered$Collaboration_hours
  )
)

}
\seealso{
anonymise
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is_date_format.R
\name{is_date_format}
\alias{is_date_format}
\title{Identify whether string is a date format}
\usage{
is_date_format(string)
}
\arguments{
\item{string}{Character string to test whether is a date format.}
}
\value{
logical value indicating whether the string is a date format.
}
\description{
This function uses regular expression to determine whether a string is of the
format \code{"mdy"}, separated by \code{"-"}, \code{"/"}, or \code{"."}, returning a logical
vector.
}
\examples{
is_date_format("1/5/2020")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/validation_report.R
\name{validation_report}
\alias{validation_report}
\title{Generate a Data Validation report in HTML}
\usage{
validation_report(
  data,
  meeting_data = NULL,
  hrvar = "Organization",
  path = "validation report",
  hrvar_threshold = 150,
  timestamp = TRUE
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{meeting_data}{An optional Meeting Query dataset in the form of a data
frame.}

\item{hrvar}{HR Variable by which to split metrics, defaults to "Organization"
but accepts any character vector, e.g. "Organization"}

\item{path}{Pass the file path and the desired file name, \emph{excluding the file
extension}.}

\item{hrvar_threshold}{Numeric value determining the maximum number of unique
values to be allowed to qualify as a HR variable. This is passed directly
to the \code{threshold} argument within \code{hrvar_count_all()}.}

\item{timestamp}{Logical vector specifying whether to include a timestamp in
the file name. Defaults to \code{TRUE}.}
}
\value{
An HTML report with the same file name as specified in the arguments is
generated in the working directory. No outputs are directly returned by the
function.
}
\description{
The function generates an interactive HTML report using
Standard Person Query data as an input. The report contains checks on
Viva Insights query outputs to provide diagnostic information
for the Analyst prior to analysis.

An additional Standard Meeting Query can be provided to perform meeting
subject line related checks. This is optional and the validation report can
be run without it.
}
\details{
For your input to \code{data} or \code{meeting_data}, please use the function
\code{vivainsights::import_query()} to import your csv query files into R. This function will
standardize format and prepare the data as input for this report.

For most variables, a note is returned in-line instead of an error if the variable
is not available.
}
\section{Checking functions within \code{validation_report()}}{

\itemize{
\item \code{check_query()}
\item \code{flag_ch_ratio()}
\item \code{hrvar_count_all()}
\item \code{identify_privacythreshold()}
\item \code{identify_nkw()}
\item \code{identify_holidayweeks()}
\item \code{subject_validate()} (available in 'wpa')
\item \code{identify_tenure()}
\item \code{flag_outlooktime()}
\item \code{identify_shifts()}
\item \code{track_HR_change()}
}

You can browse each individual function for details on calculations.
}

\section{Creating a report}{


Below is an example on how to run the report.

\if{html}{\out{<div class="sourceCode">}}\preformatted{validation_report(pq_data,
                  hrvar = "Organization")
}\if{html}{\out{</div>}}
}

\seealso{
Other Reports: 
\code{\link{IV_report}()},
\code{\link{generate_report}()},
\code{\link{meeting_tm_report}()},
\code{\link{read_preamble}()}

Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()}
}
\concept{Data Validation}
\concept{Reports}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/email_dist.R
\name{email_dist}
\alias{email_dist}
\title{Distribution of Email Hours as a 100\% stacked bar}
\usage{
email_dist(
  data,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  cut = c(0.5, 1, 1.5)
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{cut}{A numeric vector of length three to specify the breaks for the
distribution,
e.g. c(10, 15, 20)}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A stacked bar plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Analyze Email Hours distribution.
Returns a stacked bar plot by default.
Additional options available to return a table with distribution elements.
}
\examples{
# Return plot
email_dist(pq_data, hrvar = "Organization")

# Return summary table
email_dist(pq_data, hrvar = "Organization", return = "table")

# Return result with a custom specified breaks
email_dist(pq_data, hrvar = "LevelDesignation", cut = c(1, 2, 3))

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Emails: 
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()}
}
\concept{Emails}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_report2.R
\name{generate_report2}
\alias{generate_report2}
\title{Generate HTML report based on existing RMarkdown documents}
\usage{
generate_report2(
  output_format = rmarkdown::html_document(toc = TRUE, toc_depth = 6, theme = "cosmo"),
  output_file = "report.html",
  output_dir = getwd(),
  report_title = "Report",
  rmd_dir = system.file("rmd_template/minimal.rmd", package = "vivainsights"),
  ...
)
}
\arguments{
\item{output_format}{output format in \code{rmarkdown::render()}. Default is
\code{rmarkdown::html_document(toc = TRUE, toc_depth = 6, theme = "cosmo")}.}

\item{output_file}{output file name in \code{rmarkdown::render()}. Default is
\code{"report.html"}.}

\item{output_dir}{output directory for report in \code{rmarkdown::render()}.
Default is user's current directory.}

\item{report_title}{report title. Default is \code{"Report"}.}

\item{rmd_dir}{string specifying the path to the directory containing the
RMarkdown template files.}

\item{\dots}{other arguments to be passed to \code{params}. For instance, pass
\code{hrvar} if the RMarkdown document requires a 'hrvar' parameter.}
}
\description{
This is a support function that accepts parameters and creates a HTML
document based on an RMarkdown template. This is an alternative to
\code{generate_report()} which instead creates an RMarkdown document from scratch
using individual code chunks.
}
\note{
The implementation of this function was inspired by the 'DataExplorer'
package by boxuancui, with credits due to the original author.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{extract_date_range}
\alias{extract_date_range}
\title{Extract date period}
\usage{
extract_date_range(data, return = "table")
}
\arguments{
\item{data}{Data frame containing a query to pass through.
The data frame must contain a \code{Date} column.
Accepts a Person query or a Meeting query.}

\item{return}{String specifying what output to return.
Returns a table by default ("table"), but allows returning
a descriptive string ("text").}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"table"}: data frame. A summary table containing the start and end date
for the dataset.
\item \code{"text"}: string. Contains a descriptive string on the start and end date
for the dataset.
}
}
\description{
Return a data frame with the start and end date
of the query data by default. There are options to return a descriptive
string, which is used in the caption of plots in this package.
}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_report.R
\name{generate_report}
\alias{generate_report}
\title{Generate HTML report with list inputs}
\usage{
generate_report(
  title = "My minimal HTML generator",
  filename = "minimal_html",
  outputs = output_list,
  titles,
  subheaders,
  echos,
  levels,
  theme = "united",
  preamble = ""
)
}
\arguments{
\item{title}{Character string to specify the title of the chunk.}

\item{filename}{File name to be used in the exported HTML.}

\item{outputs}{A list of outputs to be added to the HTML report.
Note that \code{outputs}, \code{titles}, \code{echos}, and \code{levels} must have the same
length}

\item{titles}{A list/vector of character strings to specify the title of the
chunks.}

\item{subheaders}{A list/vector of character strings to specify the
subheaders for each chunk.}

\item{echos}{A list/vector of logical values to specify whether to display
code.}

\item{levels}{A list/vector of numeric value to specify the header level of
the chunk.}

\item{theme}{Character vector to specify theme to be used for the report.
E.g. \code{"united"}, \code{"default"}.}

\item{preamble}{A preamble to appear at the beginning of the report, passed
as a text string.}
}
\value{
An HTML report with the same file name as specified in the arguments is
generated in the working directory. No outputs are directly returned by the
function.
}
\description{
This is a support function using a list-pmap workflow to
create a HTML document, using RMarkdown as the engine.
}
\section{Creating a custom report}{


Below is an example on how to set up a custom report.

The first step is to define the content that will go into a report and assign
the outputs to a list.

\if{html}{\out{<div class="sourceCode">}}\preformatted{# Step 1: Define Content
output_list <-
  list(pq_data \%>\% workloads_summary(return = "plot"),
       pq_data \%>\% workloads_summary(return = "table")) \%>\%
  purrr::map_if(is.data.frame, create_dt)
}\if{html}{\out{</div>}}

The next step is to add a list of titles for each of the objects on the list:

\if{html}{\out{<div class="sourceCode">}}\preformatted{# Step 2: Add Corresponding Titles
title_list <- c("Workloads Summary - Plot", "Workloads Summary - Table")
n_title <- length(title_list)
}\if{html}{\out{</div>}}

The final step is to run \code{generate_report()}. This can all be wrapped within
a function such that the function can be used to generate a HTML report.

\if{html}{\out{<div class="sourceCode">}}\preformatted{# Step 3: Generate Report
generate_report(title = "My First Report",
                filename = "My First Report",
                outputs = output_list,
                titles = title_list,
                subheaders = rep("", n_title),
                echos = rep(FALSE, n_title
}\if{html}{\out{</div>}}
}

\seealso{
Other Reports: 
\code{\link{IV_report}()},
\code{\link{meeting_tm_report}()},
\code{\link{read_preamble}()},
\code{\link{validation_report}()}
}
\author{
Martin Chan \href{mailto:martin.chan@microsoft.com}{martin.chan@microsoft.com}
}
\concept{Reports}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/network_p2p.R
\name{network_p2p}
\alias{network_p2p}
\title{Perform network analysis with the person-to-person query}
\usage{
network_p2p(
  data,
  hrvar = "Organization",
  return = "plot",
  centrality = NULL,
  community = NULL,
  weight = NULL,
  comm_args = NULL,
  layout = "mds",
  path = paste("p2p", community, sep = "_"),
  style = "igraph",
  bg_fill = "#FFFFFF",
  font_col = "grey20",
  legend_pos = "right",
  palette = "rainbow",
  node_alpha = 0.7,
  edge_alpha = 1,
  edge_col = "#777777",
  node_sizes = c(1, 20),
  seed = 1
)
}
\arguments{
\item{data}{Data frame containing a person-to-person query.}

\item{hrvar}{String containing the label for the HR attribute.}

\item{return}{A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{'plot'} (default)
\item \code{'plot-pdf'}
\item \code{'sankey'}
\item \code{'table'}
\item \code{'data'}
\item \code{'network'}
}}

\item{centrality}{string to determines which centrality measure is used to
scale the size of the nodes. All centrality measures are automatically
calculated when it is set to one of the below values, and reflected in the
\code{'network'} and \code{'data'} outputs.
Measures include:
\itemize{
\item \code{betweenness}
\item \code{closeness}
\item \code{degree}
\item \code{eigenvector}
\item \code{pagerank}
}

When \code{centrality} is set to NULL, no centrality is calculated in the outputs
and all the nodes would have the same size.}

\item{community}{String determining which community detection algorithms to
apply. Valid values include:
\itemize{
\item \code{NULL} (default): compute analysis or visuals without computing
communities.
\item \code{"louvain"}
\item \code{"leiden"}
\item \code{"edge_betweenness"}
\item \code{"fast_greedy"}
\item \code{"fluid_communities"}
\item \code{"infomap"}
\item \code{"label_prop"}
\item \code{"leading_eigen"}
\item \code{"optimal"}
\item \code{"spinglass"}
\item \code{"walk_trap"}
}

These values map to the community detection algorithms offered by \code{igraph}.
For instance, \code{"leiden"} is based on \code{igraph::cluster_leiden()}. Please see
the bottom of \url{https://igraph.org/r/html/1.3.0/cluster_leiden.html} on all
applications and parameters of these algorithms.
.}

\item{weight}{String to specify which column to use as weights for the
network. To create a graph without weights, supply \code{NULL} to this argument.}

\item{comm_args}{list containing the arguments to be passed through to
igraph's clustering algorithms. Arguments must be named. See examples
section on how to supply arguments in a named list.}

\item{layout}{String to specify the node placement algorithm to be used.
Defaults to \code{"mds"} for the deterministic multi-dimensional scaling of
nodes. See
\url{https://rdrr.io/cran/ggraph/man/layout_tbl_graph_igraph.html} for a full
list of options.}

\item{path}{File path for saving the PDF output. Defaults to a timestamped
path based on current parameters.}

\item{style}{String to specify which plotting style to use for the network
plot. Valid values include:
\itemize{
\item \code{"igraph"}
\item \code{"ggraph"}
}}

\item{bg_fill}{String to specify background fill colour.}

\item{font_col}{String to specify font colour.}

\item{legend_pos}{String to specify position of legend. Defaults to
\code{"right"}. See \code{ggplot2::theme()}. This is applicable for both the
'ggraph' and the fast plotting method. Valid inputs include:
\itemize{
\item \code{"bottom"}
\item \code{"top"}
\item \code{"left"}
-\code{"right"}
}}

\item{palette}{String specifying the function to generate a colour palette
with a single argument \code{n}. Uses \code{"rainbow"} by default.}

\item{node_alpha}{A numeric value between 0 and 1 to specify the transparency
of the nodes. Defaults to 0.7.}

\item{edge_alpha}{A numeric value between 0 and 1 to specify the transparency
of the edges (only for 'ggraph' mode). Defaults to 1.}

\item{edge_col}{String to specify edge link colour.}

\item{node_sizes}{Numeric vector of length two to specify the range of node
sizes to rescale to, when \code{centrality} is set to a non-null value.}

\item{seed}{Seed for the random number generator passed to either
\code{set.seed()} when the louvain or leiden community detection algorithm is
used, to ensure consistency. Only applicable when \code{community} is set to
one of the valid non-null values.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{'plot'}: return a network plot, interactively within R.
\item \code{'plot-pdf'}: save a network plot as PDF. This option is recommended when
the graph is large, which make take a long time to run if \code{return = 'plot'}
is selected. Use this together with \code{path} to control the save location.
\item \code{'sankey'}: return a sankey plot combining communities and HR attribute.
This is only valid if a community detection method is selected at
\code{community}.
\item \code{'table'}: return a vertex summary table with counts in communities and
HR attribute. When \code{centrality} is non-NULL, the average centrality values
are calculated per group.
\item \code{'data'}: return a vertex data file that matches vertices with
communities and HR attributes.
\item \code{'network'}: return 'igraph' object.
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

Analyse a person-to-person (P2P) network query, with multiple visualisation
and analysis output options. Pass a data frame containing a person-to-person
query and return a network visualization. Options are available for community
detection using either the Louvain or the Leiden algorithms.

Note: The data frame must only contain a single \code{MetricDate} value, as the network
represents a snapshot at a specific point in time. If multiple date values are present,
filter the data frame to a specific date before using this function.
}
\examples{
p2p_df <- p2p_data_sim(dim = 1, size = 100)

# default - ggraph visual
network_p2p(data = p2p_df, style = "ggraph")

# return vertex table
network_p2p(data = p2p_df, return = "table")

\donttest{
# return vertex table with community detection
network_p2p(data = p2p_df, community = "leiden", return = "table")

# leiden - igraph style with custom resolution parameters
network_p2p(data = p2p_df, community = "leiden", comm_args = list("resolution" = 0.1))

# louvain - ggraph style, using custom palette
network_p2p(
  data = p2p_df,
  style = "ggraph",
  community = "louvain",
  palette = "heat_colors"
)

# leiden - return a sankey visual with custom resolution parameters
network_p2p(
  data = p2p_df,
  community = "leiden",
  return = "sankey",
  comm_args = list("resolution" = 0.1)
)

# using `fluid_communities` algorithm with custom parameters
network_p2p(
  data = p2p_df,
  community = "fluid_communities",
  comm_args = list("no.of.communities" = 5)
)

# Calculate centrality measures and leiden communities, return at node level
network_p2p(
  data = p2p_df,
  centrality = "betweenness",
  community = "leiden",
  return = "data"
) \%>\%
  dplyr::glimpse()
}

}
\seealso{
Other Network: 
\code{\link{g2g_data}},
\code{\link{network_g2g}()},
\code{\link{network_summary}()},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()}
}
\concept{Network}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_radar.R
\name{create_radar_viz}
\alias{create_radar_viz}
\title{Radar Chart (Visualization)}
\usage{
create_radar_viz(data, metrics, hrvar, fill_missing = "zero", caption = NULL)
}
\arguments{
\item{data}{Output table from \code{create_radar_calc()}.}

\item{metrics}{Character vector of metric column names.}

\item{hrvar}{Character string of grouping column name.}

\item{fill_missing}{Character string specifying how to handle missing values.
If \code{"zero"} (default), fill NA values as 0 for plotting. This ensures
polygons close properly in the radar visualization.}

\item{caption}{Character string for the plot caption. Typically the output
of \code{extract_date_range(data, return = "text")} plus an index-mode label,
as constructed by \code{create_radar()}. Defaults to \code{NULL} (no caption).}
}
\value{
ggplot object.
}
\description{
Renders a multi-group radar chart using \code{ggplot2} + \code{coord_polar()}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/IV_report.R
\name{IV_report}
\alias{IV_report}
\title{Generate a Information Value HTML Report}
\usage{
IV_report(
  data,
  predictors = NULL,
  outcome,
  bins = 5,
  max_var = 9,
  path = "IV report",
  timestamp = TRUE
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{predictors}{A character vector specifying the columns to be used as
predictors. Defaults to NULL, where all numeric vectors in the data will be
used as predictors.}

\item{outcome}{A string specifying a binary variable, i.e. can only contain
the values 1 or 0.}

\item{bins}{Number of bins to use in \code{Information::create_infotables()},
defaults to 10.}

\item{max_var}{Numeric value to represent the maximum number of variables to
show on plots.}

\item{path}{Pass the file path and the desired file name, \emph{excluding the file
extension}. For example, \code{"IV report"}.}

\item{timestamp}{Logical vector specifying whether to include a timestamp in
the file name. Defaults to TRUE.}
}
\value{
An HTML report with the same file name as specified in the arguments is
generated in the working directory. No outputs are directly returned by the
function.
}
\description{
The function generates an interactive HTML report using Standard Person Query
data as an input. The report contains a full Information Value analysis,  a
data exploration technique that helps determine which columns in a data set
have predictive power or influence on the value of a specified dependent
variable.
}
\section{Creating a report}{


Below is an example on how to run the report.

\if{html}{\out{<div class="sourceCode">}}\preformatted{library(dplyr)

pq_data \%>\%
  mutate(CH_binary = ifelse(Collaboration_hours > 12, 1, 0)) \%>\% # Simulate binary variable
  IV_report(outcome =  "CH_binary",
            predictors = c("Email_hours", "Meeting_hours"))
}\if{html}{\out{</div>}}
}

\seealso{
Other Reports: 
\code{\link{generate_report}()},
\code{\link{meeting_tm_report}()},
\code{\link{read_preamble}()},
\code{\link{validation_report}()}

Other Variable Association: 
\code{\link{create_IV}()}

Other Information Value: 
\code{\link{create_IV}()}
}
\concept{Information Value}
\concept{Reports}
\concept{Variable Association}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_bubble.R
\name{create_bubble}
\alias{create_bubble}
\title{Create a bubble plot with two selected Viva Insights metrics (General
Purpose), with size representing the number of employees in the group.}
\usage{
create_bubble(
  data,
  metric_x,
  metric_y,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  bubble_size = c(1, 10)
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric_x}{Character string containing the name of the metric, e.g.
"Collaboration_hours"}

\item{metric_y}{Character string containing the name of the metric, e.g.
"Collaboration_hours"}

\item{hrvar}{HR Variable by which to split metrics, defaults to
"Organization" but accepts any character vector, e.g. "LevelDesignation"}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings: - \code{"plot"} - \code{"table"}}

\item{bubble_size}{A numeric vector of length two to specify the size range
of the bubbles}
}
\value{
A different output is returned depending on the value passed to the
\code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A bubble plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Returns a bubble plot of two selected metrics, using size to map
the number of employees.
}
\details{
This is a general purpose function that powers all the functions in
the package that produce bubble plots.
}
\examples{
create_bubble(pq_data, "Collaboration_hours", "Multitasking_hours", hrvar ="Organization")


}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/export.R
\name{export}
\alias{export}
\title{Export 'vivainsights' outputs to CSV, clipboard, or save as images}
\usage{
export(
  x,
  method = "clipboard",
  path = "insights export",
  timestamp = TRUE,
  width = 12,
  height = 9
)
}
\arguments{
\item{x}{Data frame or 'ggplot' object to be passed through.}

\item{method}{Character string specifying the method of export.
Valid inputs include:
\itemize{
\item \code{"clipboard"} (default if input is data frame)
\item \code{"csv"}
\item \code{"png"} (default if input is 'ggplot' object)
\item \code{"svg"}
\item \code{"jpeg"}
\item \code{"pdf"}
}}

\item{path}{If exporting a file, enter the path and the desired file name,
\emph{excluding the file extension}. For example, \code{"Analysis/SQ Overview"}.}

\item{timestamp}{Logical vector specifying whether to include a timestamp in
the file name. Defaults to \code{TRUE}.}

\item{width}{Width of the plot}

\item{height}{Height of the plot}
}
\value{
A different output is returned depending on the value passed to the \code{method}
argument:
\itemize{
\item \code{"clipboard"}: no return - data frame is saved to clipboard.
\item \code{"csv"}: CSV file containing data frame is saved to specified path.
\item \code{"png"}: PNG file containing 'ggplot' object is saved to specified path.
\item \code{"svg"}: SVG file containing 'ggplot' object is saved to specified path.
\item \code{"jpeg"}: JPEG file containing 'ggplot' object is saved to specified path.
\item \code{"pdf"}: PDF file containing 'ggplot' object is saved to specified path.
}
}
\description{
A general use function to export 'vivainsights' outputs to CSV, clipboard, or save as
images. By default, \code{export()} copies a data frame to the clipboard. If the
input is a 'ggplot' object, the default behaviour is to export a PNG.
}
\seealso{
Other Import and Export: 
\code{\link{copy_df}()},
\code{\link{create_dt}()},
\code{\link{import_query}()},
\code{\link{prep_query}()}
}
\author{
Martin Chan \href{mailto:martin.chan@microsoft.com}{martin.chan@microsoft.com}
}
\concept{Import and Export}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_itsa.R
\name{create_itsa}
\alias{create_itsa}
\title{Estimate an effect of intervention on every Viva Insights metric in input
file by applying single-group Interrupted Time-Series Analysis (ITSA)}
\usage{
create_itsa(
  data,
  metrics = NULL,
  before_start = NULL,
  before_end = NULL,
  after_start = NULL,
  after_end = NULL,
  ac_lags_max = 7,
  return = "table"
)
}
\arguments{
\item{data}{Person Query as a dataframe including date column named
\code{MetricDate}. This function assumes the data format is \verb{\%Y-\%m-\%d} as is
standard in a Viva Insights query output.}

\item{metrics}{A character vector containing the variable names to perform
the interrupted time series analysis for.}

\item{before_start}{String specifying the start date of the 'before'
time period in \verb{\%Y-\%m-\%d} format. The 'before' time period refers to the
period before the intervention (e.g. training program, re-org, shift to
remote work) occurs and bounded by \code{before_start} and \code{before_end}
parameters. Longer period increases likelihood of achieving more
statistically significant results. Defaults to earliest date in dataset. If
not provided, this defaults to the earliest date in the dataset.}

\item{before_end}{String specifying the end date of 'before' time
period in \verb{\%Y-\%m-\%d} format. If \code{NULL}, an error will be raised, as this
value is required.}

\item{after_start}{String specifying the start date of the 'after'
time period in \verb{\%Y-\%m-\%d} format. If \code{NULL}, this will default to the value
of \code{before_end}. The 'after' time period refers to the period after the
intervention occurs and is bounded by \code{after_start} and \code{after_end}
parameters. Longer periods increase the likelihood of achieving more
statistically significant results.}

\item{after_end}{String specifying the end date of the 'after' time
period in \verb{\%Y-\%m-\%d} format. Defaults to the latest date in the dataset.}

\item{ac_lags_max}{Numeric value specifying the maximum lag for the autocorrelation test.
The Ljung-Box test is used to check for autocorrelation in the model residuals
up to this specified number of lags. Higher values check for longer-term
dependencies in the time series data.}

\item{return}{String specifying what output to return. Defaults to "table".
Valid return options include:
\itemize{
\item \code{'plot'}: return a list of plots.
\item \code{'table'}: return data.frame with estimated models' coefficients and
their corresponding p-values You should look for significant p-values in
beta_2 to indicate an immediate treatment effect, and/or in beta_3 to
indicate a treatment effect over time
}}
}
\value{
When 'data' is passed to \code{return}, a data frame with the following columns:
\itemize{
\item \code{metric_name}: Name of the metric being analyzed.
\item \code{beta_2}: Coefficient for the immediate treatment effect.
\item \code{beta_3}: Coefficient for the treatment effect over time.
\item \code{beta_2_pvalue}: P-value for the immediate treatment effect.
\item \code{beta_3_pvalue}: P-value for the treatment effect over time.
\item \code{AR_flag}: Logical flag indicating whether autocorrelation was detected.
\item \code{error_warning}: Error or warning message if applicable.
}
}
\description{
r lifecycle::badge('experimental')

This function implements ITSA method described in the paper 'Conducting
interrupted time-series analysis for single- and multiple-group comparisons',
Ariel Linden, The Stata Journal (2015), 15, Number 2, pp. 480-500

This function further requires the installation of 'sandwich' and 'lmtest' in
order to work. These packages can be installed from CRAN using
\code{install.packages()}.
}
\details{
This function uses the additional package dependencies 'sandwich' and
'lmtest'. Please install these separately from CRAN prior to running the
function.

As of May 2022, the 'portes' package was archived from CRAN. The dependency
has since been removed and dependent functions \code{Ljungbox()} incorporated into
the \strong{wpa} package.
}
\examples{
\dontrun{
# Returns summary table
create_itsa(
  data = pq_data,
  metrics = c("Collaboration_span", "Internal_network_size"),
  before_end = "2024-07-01",
  after_start = "2024-07-01",
  ac_lags_max = 7,
  return = "table"
)

# Returns list of plots
plot_list <-
  create_itsa(
    data = pq_data,
    metrics = c("Collaboration_span", "Internal_network_size"),
    before_end = "2024-07-01",
    after_start = "2024-07-01",
    ac_lags_max = 7,
    return = "plot"
  )

# Extract a plot as an example
plot_list$Collaboration_span
}

}
\author{
Aleksey Ashikhmin \href{mailto:alashi@microsoft.com}{alashi@microsoft.com}
}
\concept{Flexible Input}
\concept{Interrupted Time-Series Analysis}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_dt.R
\name{create_dt}
\alias{create_dt}
\title{Create interactive tables in HTML with 'download' buttons.}
\usage{
create_dt(x, rounding = 1, freeze = 2, percent = FALSE)
}
\arguments{
\item{x}{Data frame to be passed through.}

\item{rounding}{Numeric vector to specify the number of decimal points to display}

\item{freeze}{Number of columns from the left to 'freeze'. Defaults to 2,
which includes the row number column.}

\item{percent}{Logical value specifying whether to display numeric columns
as percentages.}
}
\value{
Returns an HTML widget displaying rectangular data.
}
\description{
See
\url{https://martinctc.github.io/blog/vignette-downloadable-tables-in-rmarkdown-with-the-dt-package/}
for more.
}
\details{
This is exported from \code{wpa::create_dt()}.
}
\examples{
output <- hrvar_count(pq_data, return = "table")
create_dt(output)

}
\seealso{
Other Import and Export: 
\code{\link{copy_df}()},
\code{\link{export}()},
\code{\link{import_query}()},
\code{\link{prep_query}()}
}
\concept{Import and Export}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_radar.R
\name{create_radar_calc}
\alias{create_radar_calc}
\title{Radar Chart (Calculation)}
\usage{
create_radar_calc(
  data,
  metrics,
  hrvar,
  id_col = "PersonId",
  mingroup = 5,
  agg = "mean",
  index_mode = "total",
  index_ref_group = NULL,
  na.rm = FALSE
)
}
\arguments{
\item{data}{data.frame.}

\item{metrics}{character vector of metric column names.}

\item{hrvar}{character string specifying grouping column.}

\item{id_col}{character string specifying person id column.}

\item{mingroup}{numeric minimum unique people per group.}

\item{agg}{"mean" or "median".}

\item{index_mode}{"total","none","ref_group","minmax".}

\item{index_ref_group}{reference group name when index_mode="ref_group".}

\item{na.rm}{logical.}
}
\value{
list(table=group_level_table, ref=reference_used)
}
\description{
Computes group-level metric values and applies optional indexing.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_lorenz.R
\name{create_lorenz}
\alias{create_lorenz}
\title{Calculate the Lorenz Curve and Gini Coefficient in a Person Query}
\usage{
create_lorenz(data, metric, return = "plot")
}
\arguments{
\item{data}{Data frame containing a Person Query.}

\item{metric}{Character string identifying the metric to be used for the
Lorenz curve and Gini coefficient calculation.}

\item{return}{Character string identifying the return type. Options are:
\itemize{
\item \code{"gini"} - Numeric value representing the Gini coefficient.
\item \code{"table"} - Data frame containing a summary table of population share and
value share.
\item \code{"plot"} (default) - \code{ggplot} object representing a plot of the Lorenz
curve.
}}
}
\description{
This function computes the Gini coefficient and plots the Lorenz curve based
on a selected metric from a Person Query data frame. It provides a way to
measure inequality in the distribution of the selected metric.This function
can be integrated into a larger analysis pipeline to assess inequality in
metric distribution.
}
\section{Gini coefficient}{

The Gini coefficient is a measure of statistical dispersion most commonly
used to represent income inequality within a population. It is calculated as
the ratio of the area between the Lorenz curve and the line of perfect
equality (the 45-degree line) to the total area under the line of perfect
equality. It has a range of 0 to 1, where 0 represents perfect equality and
1 represents perfect inequality. It can be applied to any Viva Insights
metric where inequality is of interest.
}

\examples{
create_lorenz(data = pq_data, metric = "Emails_sent", return = "gini")

create_lorenz(data = pq_data, metric = "Emails_sent", return = "plot")

create_lorenz(data = pq_data, metric = "Emails_sent", return = "table")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{camel_clean}
\alias{camel_clean}
\title{Convert "CamelCase" to "Camel Case"}
\usage{
camel_clean(string)
}
\arguments{
\item{string}{A string vector in 'CamelCase' format to format}
}
\value{
Returns a formatted string.
}
\description{
Convert a text string from the format "CamelCase" to "Camel Case".
This is used for converting variable names such as
"LevelDesignation" to "Level Designation" for the purpose
of prettifying plot labels.
}
\examples{
camel_clean("NoteHowTheStringIsFormatted")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_rank.R
\name{create_rank_combine}
\alias{create_rank_combine}
\title{Create combination pairs of HR variables and run 'create_rank()'}
\usage{
create_rank_combine(data, hrvar = extract_hr(data), metric, mingroup = 5)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}
}
\value{
Data frame containing the following variables:
\itemize{
\item \code{hrvar}: placeholder column that denotes the output as \code{"Combined"}.
\item \code{group}: pairwise combinations of HR attributes with the HR attribute
in square brackets followed by the value of the HR attribute.
\item Name of the metric (as passed to \code{metric})
\item \code{n}
}
}
\description{
Create pairwise combinations of HR variables and compute an
average of a specified advanced insights metric.
}
\details{
This function is called when the \code{mode} argument in \code{create_rank()} is
specified as \code{"combine"}.
}
\examples{
# Use a small sample for faster runtime
pq_data_small <- dplyr::slice_sample(pq_data, prop = 0.1)

create_rank_combine(
  data = pq_data_small,
  metric = "Email_hours",
  hrvar = c("Organization", "FunctionType", "LevelDesignation")
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flag_outlooktime.R
\name{flag_outlooktime}
\alias{flag_outlooktime}
\title{Flag unusual outlook time settings for work day start and end time}
\usage{
flag_outlooktime(data, threshold = c(4, 15), return = "message")
}
\arguments{
\item{data}{A data frame containing a Person Query.}

\item{threshold}{A numeric vector of length two, specifying the hour
threshold for flagging. Defaults to c(4, 15).}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"text"} (default)
\item \code{"message"}
\item \code{"data"}
}}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"text"}: string. A diagnostic message.
\item \code{"message"}: message on console. A diagnostic message.
\item \code{"data"}: data frame. Data where flag is present.
}

See \code{Value} for more information.
}
\description{
This function flags unusual outlook calendar settings for
start and end time of work day.
}
\examples{
# Demo with `pq_data` example where Outlook Start and End times are imputed
spq_df <- pq_data

spq_df$WorkingStartTimeSetInOutlook <- "6:30"

spq_df$WorkingEndTimeSetInOutlook <- "23:30"

# Return a message
flag_outlooktime(spq_df, threshold = c(5, 13))

# Return data
flag_outlooktime(spq_df, threshold = c(5, 13), return = "data")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pq_data.R
\docType{data}
\name{pq_data}
\alias{pq_data}
\title{Sample Person Query dataset}
\format{
A data frame with 6900 rows and 73 variables:
\describe{
\item{PersonId}{}
\item{MetricDate}{}
\item{Collaboration_hours}{}
\item{Copilot_actions_taken_in_Teams}{}
\item{Meeting_and_call_hours}{}
\item{Internal_network_size}{}
\item{Email_hours}{}
\item{Channel_message_posts}{}
\item{Conflicting_meeting_hours}{}
\item{Large_and_long_meeting_hours}{}
\item{External_collaboration_hours}{}
\item{Active_connected_hours}{}
\item{Meetings}{}
\item{After_hours_collaboration_hours}{}
\item{Call_hours}{}
\item{Calls}{}
\item{Channel_message_hours}{}
\item{Chat_hours}{}
\item{Collaboration_span}{}
\item{Emails_read}{}
\item{Emails_sent}{}
\item{External_network_size}{}
\item{Meeting_and_call_hours_with_manager}{}
\item{Meeting_and_call_hours_with_manager_1_1}{}
\item{Meeting_and_call_hours_with_skip_level}{}
\item{Meeting_hours}{}
\item{Multitasking_hours}{}
\item{Network_outside_company}{}
\item{Network_outside_organisation}{}
\item{Time_with_leadership}{}
\item{Unscheduled_call_hours}{}
\item{Weekend_collaboration_hours}{}
\item{Copilot_actions_taken_in_Copilot_chat__work_}{}
\item{Copilot_actions_taken_in_Excel}{}
\item{Copilot_actions_taken_in_Outlook}{}
\item{Copilot_actions_taken_in_Powerpoint}{}
\item{Copilot_actions_taken_in_Word}{}
\item{Days_of_active_Copilot_chat__work__usage}{}
\item{Days_of_active_Copilot_usage_in_Excel}{}
\item{Days_of_active_Copilot_usage_in_Loop}{}
\item{Days_of_active_Copilot_usage_in_OneNote}{}
\item{Days_of_active_Copilot_usage_in_Outlook}{}
\item{Days_of_active_Copilot_usage_in_Powerpoint}{}
\item{Days_of_active_Copilot_usage_in_Teams}{}
\item{Days_of_active_Copilot_usage_in_Word}{}
\item{Total_Copilot_active_days}{}
\item{Total_Copilot_enabled_days}{}
\item{Barriers_to_Execution}{}
\item{Change_Adaptation}{}
\item{Collaboration}{}
\item{Communication_Flow}{}
\item{Continuous_Improvement}{}
\item{eSat}{}
\item{Initiative}{}
\item{Manager_Recommend}{}
\item{Resources}{}
\item{Speak_My_Mind}{}
\item{Wellbeing}{}
\item{Work_Life_Balance}{}
\item{Workload}{}
\item{Create_Excel_formula_actions_taken_using_Copilot}{}
\item{Create_presentation_actions_taken_using_Copilot}{}
\item{Generate_email_draft_actions_taken_using_Copilot_in_Outlook}{}
\item{Summarise_chat_actions_taken_using_Copilot_in_Teams}{}
\item{Summarise_email_thread_actions_taken_using_Copilot_in_Outlook}{}
\item{Summarise_meeting_actions_taken_using_Copilot_in_Teams}{}
\item{Summarise_presentation_actions_taken_using_Copilot_in_PowerPoint}{}
\item{Summarise_Word_document_actions_taken_using_Copilot_in_Word}{}
\item{FunctionType}{}
\item{SupervisorIndicator}{}
\item{Level}{}
\item{Organization}{}
\item{LevelDesignation}{}
}
}
\source{
\url{https://learn.microsoft.com/en-us/viva/insights/advanced/analyst/person-query/}
}
\usage{
pq_data
}
\value{
data frame.
}
\description{
A dataset generated from a Person Query from Viva Insights.
}
\seealso{
Other Data: 
\code{\link{g2g_data}},
\code{\link{mt_data}},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()}
}
\concept{Data}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_inactiveweeks.R
\name{identify_inactiveweeks}
\alias{identify_inactiveweeks}
\title{Identify Inactive Weeks}
\usage{
identify_inactiveweeks(data, sd = 2, return = "text")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{sd}{The standard deviation below the mean for collaboration hours that
should define an outlier week. Enter a positive number. Default is 1
standard deviation.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"text"}
\item \code{"data_cleaned"}
\item \code{"data_clean"}
\item \code{"data_dirty"}
}

See \code{Value} for more information.}
}
\value{
Returns an error message by default, where \code{'text'} is returned. When
\code{'data_cleaned'} or \code{'data_clean'} is passed, a dataset with outlier weeks removed is returned
as a dataframe. When \code{'data_dirty'} is passed, a dataset with outlier weeks
is returned as a dataframe.
}
\description{
This function scans a standard query output for weeks where collaboration
hours is far outside the mean for any individual person in the dataset.
Returns a list of weeks that appear to be inactive weeks and optionally an
edited dataframe with outliers removed.

As best practice, run this function prior to any analysis to remove atypical
collaboration weeks from your dataset.
}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_boxplot.R
\name{create_boxplot}
\alias{create_boxplot}
\title{Box Plot for any metric}
\usage{
create_boxplot(
  data,
  metric,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.
This must be a \strong{panel dataset} where each row represents one employee
per time period, with the columns \code{PersonId} and \code{MetricDate} present.
If your data is already aggregated (e.g. one row per group), use the
equivalent \verb{*_asis()} variant of this function instead.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
\item \code{"data"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A box plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric, containing the
following columns:
\itemize{
\item \code{group}: The HR variable by which the metric is split.
\item \code{mean}: The mean of the metric.
\item \code{min}: The minimum value of the metric.
\item \code{p10}: The 10th percentile of the metric.
\item \code{p25}: The 25th percentile of the metric.
\item \code{p50}: The 50th percentile of the metric.
\item \code{p75}: The 75th percentile of the metric.
\item \code{p90}: The 90th percentile of the metric.
\item \code{max}: The maximum value of the metric.
\item \code{sd}: The standard deviation of the metric.
\item \code{range}: The range of the metric.
\item \code{n}: The number of observations.
}
\item \code{"data"}: data frame. A data frame containing the metric and group.
}
}
\description{
Analyzes a selected metric and returns a box plot by default.
Additional options available to return a table with distribution elements.
}
\details{
This is a general purpose function that powers all the functions
in the package that produce box plots.
}
\examples{
# Create a box plot for Collaboration_hours by Level Designation
create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation", return = "plot")

# Create a box plot for Collaboration_hours by Organization
create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "plot")

# Create a summary statistics table for Collaboration_hoursby Organization
create_boxplot(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_radar}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_survival}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_radar}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_survival}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keymetrics_scan.R
\name{keymetrics_scan}
\alias{keymetrics_scan}
\title{Run a summary of Key Metrics from the Standard Person Query data}
\usage{
keymetrics_scan(
  data,
  hrvar = "Organization",
  mingroup = 5,
  metrics = c("Collaboration_span", "Collaboration_hours",
    "After_hours_collaboration_hours", "Meetings", "Meeting_hours",
    "After_hours_meeting_hours", "Meeting_and_call_hours_with_manager_1_1",
    "Meeting_and_call_hours_with_manager", "Emails_sent", "Email_hours",
    "After_hours_email_hours", "Internal_network_size", "External_network_size"),
  return = "plot",
  low = rgb2hex(7, 111, 161),
  mid = rgb2hex(241, 204, 158),
  high = rgb2hex(216, 24, 42),
  textsize = 2
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{metrics}{A character vector containing the variable names to calculate
averages of.}

\item{return}{Character vector specifying what to return, defaults to "plot".
Valid inputs are "plot" and "table".}

\item{low}{String specifying colour code to use for low-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{mid}{String specifying colour code to use for mid-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{high}{String specifying colour code to use for high-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{textsize}{A numeric value specifying the text size to show in the plot.}
}
\value{
Returns a ggplot object by default, when \code{'plot'} is passed in \code{return}.
When \code{'table'} is passed, a summary table is returned as a data frame.
}
\description{
Returns a heatmapped table by default, with options to return a table.
}
\examples{
\dontrun{
# Heatmap plot is returned by default
keymetrics_scan(pq_data)

# Heatmap plot with custom colours
keymetrics_scan(pq_data, low = "purple", high = "yellow")

# Return summary table
keymetrics_scan(pq_data, hrvar = "LevelDesignation", return = "table")
}

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}
}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_dist.R
\name{create_dist}
\alias{create_dist}
\title{Horizontal 100 percent stacked bar plot for any metric}
\usage{
create_dist(
  data,
  metric,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  cut = c(15, 20, 25),
  dist_colours = c("#facebc", "#fcf0eb", "#b4d5dd", "#bfe5ee"),
  unit = "hours",
  lbound = 0,
  ubound = 200,
  sort_by = NULL,
  labels = NULL
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{String containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{cut}{A numeric vector of length three to specify the breaks for the
distribution,
e.g. c(10, 15, 20)}

\item{dist_colours}{A character vector of length four to specify colour
codes for the stacked bars.}

\item{unit}{String to specify what unit to use. This defaults to \code{"hours"}
but can accept any custom string. See \code{cut_hour()} for more details.}

\item{lbound}{Numeric. Specifies the lower bound (inclusive) value for the
minimum label. Defaults to 0.}

\item{ubound}{Numeric. Specifies the upper bound (inclusive) value for the
maximum label. Defaults to 100.}

\item{sort_by}{String to specify the bucket label to sort by. Defaults to
\code{NULL} (no sorting).}

\item{labels}{Character vector to override labels for the created
categorical variables. Must be a named vector - see examples.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A stacked bar plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Provides an analysis of the distribution of a selected metric.
Returns a stacked bar plot by default.
Additional options available to return a table with distribution elements.
}
\examples{
# Return plot
create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization")

# Return summary table
create_dist(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")

# Use custom labels by providing a label vector
eh_labels <- c(
  "Fewer than fifteen" = "< 15 hours",
  "Between fifteen and twenty" = "15 - 20 hours",
  "Between twenty and twenty-five" = "20 - 25 hours",
  "More than twenty-five" = "25+ hours"
)

pq_data \%>\% create_dist(metric = "Meeting_hours", labels = eh_labels, return = "plot")

# Sort by a category
pq_data \%>\%  create_dist(metric = "Collaboration_hours", sort_by = "25+ hours")
}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hrvar_count_all.R
\name{hrvar_count_all}
\alias{hrvar_count_all}
\title{Create count of distinct fields and percentage of employees with
missing values for all HR variables}
\usage{
hrvar_count_all(
  data,
  n_var = 50,
  return = "message",
  threshold = 100,
  maxna = 20
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{n_var}{number of HR variables to include in report as rows. Default is
set to 50 HR variables.}

\item{return}{String to specify what to return}

\item{threshold}{The max number of unique values allowed for any attribute.
Default is 100.}

\item{maxna}{The max percentage of NAs allowable for any column. Default is
20.}
}
\value{
Returns an error message by default, where 'text' is passed in \code{return}.
\itemize{
\item \code{'table'}: data frame. A summary table listing the number of distinct
fields and percentage of missing values for the specified number of HR
attributes will be returned.
\item \code{'message'}: outputs a message indicating which values are
beyond the specified thresholds.
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

This function enables you to create a summary table to validate
organizational data. This table will provide a summary of the data found in
the Viva Insights \emph{Data sources} page. This function will return a summary
table with the count of distinct fields per HR attribute and the percentage
of employees with missing values for that attribute. See \code{hrvar_count()}
function for more detail on the specific HR attribute of interest.
}
\examples{
# Return a summary table of all HR attributes
hrvar_count_all(pq_data, return = "table")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/themes.R
\name{theme_wpa}
\alias{theme_wpa}
\title{Main theme for 'vivainsights' visualisations}
\usage{
theme_wpa(font_size = 12, font_family = "Segoe UI")
}
\arguments{
\item{font_size}{Numeric value that prescribes the base font size
for the plot. The text elements are defined relatively to this
base font size. Defaults to 12.}

\item{font_family}{Character value specifying the font family
to be used in the plot. The default value is \code{"Segoe UI"}. To ensure
you can use this font, install and load 'extrafont' prior to
plotting. There is an initialisation process that is described by:
\url{https://stackoverflow.com/questions/34522732/changing-fonts-in-ggplot2}}
}
\value{
Returns a ggplot object with the applied theme.
}
\description{
A theme function applied to 'ggplot' visualisations in 'vivainsights'.
Install and load 'extrafont' to use custom fonts for plotting.
}
\seealso{
Other Themes: 
\code{\link{theme_wpa_basic}()}
}
\concept{Themes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_churn.R
\name{identify_churn}
\alias{identify_churn}
\title{Identify employees who have churned from the dataset}
\usage{
identify_churn(data, n1 = 6, n2 = 6, return = "message", flip = FALSE)
}
\arguments{
\item{data}{A Person Query as a data frame. Must contain a \code{PersonId}.}

\item{n1}{A numeric value specifying the number of weeks at the beginning of
the period that defines the measured employee set. Defaults to 6.}

\item{n2}{A numeric value specifying the number of weeks at the end of the
period to calculate whether employees have churned from the data. Defaults
to 6.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"message"} (default)
\item \code{"text"}
\item \code{"data"}
}

See \code{Value} for more information.}

\item{flip}{Logical, defaults to FALSE. This determines whether to reverse
the logic of identifying the non-overlapping set. If set to \code{TRUE}, this
effectively identifies new-joiners, or those who were not present in the
first n weeks of the data but were present in the final n weeks.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"message"}: Message on console. A diagnostic message.
\item \code{"text"}: String. A diagnostic message.
\item \code{"data"}: Character vector containing the the \code{PersonId} of
employees who have been identified as churned.
}
}
\description{
This function identifies and counts the number of employees who have churned
from the dataset by measuring whether an employee who is present in the first
\code{n} (n1) weeks of the data is present in the last \code{n} (n2) weeks of the data.
}
\details{
An additional use case of this function is the ability to identify
"new-joiners" by using the argument \code{flip}.

If an employee is present in the first \code{n} weeks of the data but not present
in the last \code{n} weeks of the data, the function considers the employee as
churned. As the measurement period is defined by the number of weeks from the
start and the end of the passed data frame, you may consider filtering the
dates accordingly before running this function.

Another assumption that is in place is that any employee whose \code{PersonId} is
not available in the data has churned. Note that there may be other reasons
why an employee's \code{PersonId} may not be present, e.g. maternity/paternity
leave, Viva Insights license has been removed, shift to a
low-collaboration role (to the extent that he/she becomes inactive).
}
\examples{
pq_data \%>\% identify_churn(n1 = 3, n2 = 3, return = "message")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{wrap_text}
\alias{wrap_text}
\title{Wrap text based on character threshold}
\usage{
wrap_text(x, threshold = 15)
}
\arguments{
\item{x}{String to wrap text}

\item{threshold}{Numeric, defaults to 15. Number of character units by which
the next space would be replaced with \verb{\\n} to move text to next line.}
}
\value{
String output representing a processed version of \code{x}, with spaces replaced
by \verb{\\n.}
}
\description{
Wrap text in visualizations according to a preset character
threshold. The next space in the string is replaced with \verb{\\n}, which will
render as next line in plots and messages.
}
\examples{
wrapped <- wrap_text(
  "The total entropy of an isolated system can never decrease."
  )
message(wrapped)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_line_asis.R
\name{create_line_asis}
\alias{create_line_asis}
\title{Create a line chart without aggregation for any metric}
\usage{
create_line_asis(
  data,
  date_var = "MetricDate",
  metric,
  title = NULL,
  subtitle = NULL,
  caption = NULL,
  ylab = date_var,
  xlab = metric,
  line_colour = rgb2hex(0, 120, 212),
  label = FALSE
)
}
\arguments{
\item{data}{Plotting data as a data frame.}

\item{date_var}{String containing name of variable for the horizontal axis.}

\item{metric}{String containing name of variable representing the line.}

\item{title}{Title of the plot.}

\item{subtitle}{Subtitle of the plot.}

\item{caption}{Caption of the plot.}

\item{ylab}{Y-axis label for the plot (group axis)}

\item{xlab}{X-axis label of the plot (bar axis).}

\item{line_colour}{String to specify colour to use for the line.
Hex codes are accepted. You can also supply
RGB values via \code{rgb2hex()}.}

\item{label}{Logical value to determine whether to show data point labels on
the plot. If \code{TRUE}, both \code{geom_point()} and \code{geom_text()} are added to
display data labels rounded to 1 decimal place above each data point.
Defaults to \code{FALSE}.}
}
\value{
Returns a 'ggplot' object representing a line plot.
}
\description{
This function creates a line chart directly from the aggregated / summarised data.
Unlike \code{create_line()} which performs a person-level aggregation, there is no
calculation for \code{create_line_asis()} and the values are rendered as they are passed
into the function. The only requirement is that a \code{date_var} is provided for the x-axis.
}
\examples{
library(dplyr)

# Median `Emails_sent` grouped by `MetricDate`
# Without Person Averaging
med_df <-
  pq_data \%>\%
  group_by(MetricDate) \%>\%
  summarise(Emails_sent_median = median(Emails_sent))

med_df \%>\%
  create_line_asis(
    date_var = "MetricDate",
    metric = "Emails_sent_median",
    title = "Median Emails Sent",
    subtitle = "Person Averaging Not Applied",
    caption = extract_date_range(pq_data, return = "text")
  )

# Create line plot with data point labels
med_df \%>\%
  create_line_asis(
    date_var = "MetricDate",
    metric = "Emails_sent_median",
    title = "Median Emails Sent",
    subtitle = "Person Averaging Not Applied",
    caption = extract_date_range(pq_data, return = "text"),
    label = TRUE
  )

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}

Other Time-series: 
\code{\link{create_line}()},
\code{\link{create_period_scatter}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Time-series}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_radar.R
\name{create_radar}
\alias{create_radar}
\title{Radar Chart for multiple metrics}
\usage{
create_radar(
  data,
  metrics,
  hrvar = "Organization",
  mingroup = 5,
  agg = "mean",
  index_mode = "total",
  index_ref_group = NULL,
  na.rm = FALSE,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metrics}{Character vector of metric column names.}

\item{hrvar}{Character string specifying the grouping column.
Defaults to \code{"Organization"}. If \code{NULL}, usage segments will be derived
via \code{identify_usage_segments()}.}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group size.
Defaults to 5.}

\item{agg}{String specifying aggregation method. Either \code{"mean"} (default) or \code{"median"}.}

\item{index_mode}{String specifying indexing mode. One of:
\itemize{
\item \code{"total"} (default): Total = 100 for each metric
\item \code{"none"}: no indexing (raw group values)
\item \code{"ref_group"}: reference group = 100 (requires \code{index_ref_group})
\item \code{"minmax"}: scale to [0, 100] within observed group ranges per metric
}}

\item{index_ref_group}{Character string specifying reference group name when
\code{index_mode = "ref_group"}.}

\item{na.rm}{Logical value indicating whether NA rows in required columns are removed
prior to aggregation. Defaults to \code{FALSE}.}

\item{return}{String specifying what to return. One of:
\itemize{
\item \code{"plot"} (default)
\item \code{"table"}
}}
}
\value{
A different output is returned depending on the value passed to \code{return}:
\itemize{
\item \code{"plot"}: ggplot object (radar chart)
\item \code{"table"}: data frame (group-level indexed table)
}
}
\description{
Creates a multi-group radar (spider) chart across a set of metrics.

Core pipeline:
\enumerate{
\item Person-level aggregation within group
\item Group-level aggregation
\item Privacy filtering via \code{mingroup}
\item Optional indexing modes: "total", "none", "ref_group", "minmax"
}

Optional auto-segmentation:
\itemize{
\item If \code{hrvar} is not supplied, the function will call
\code{identify_usage_segments()} and infer the resulting segment column.
}
}
\examples{
create_radar(
  data = pq_data,
  metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
  hrvar = "Organization",
  mingroup = 1
)

# Return the indexed table instead of a plot
create_radar(
  data = pq_data,
  metrics = c("Collaboration_hours", "Email_hours", "Meeting_hours"),
  hrvar = "LevelDesignation",
  mingroup = 1,
  return = "table"
)
}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_survival}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_survival}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/maxmin.R
\name{maxmin}
\alias{maxmin}
\title{Max-Min Scaling Function}
\usage{
maxmin(x)
}
\arguments{
\item{x}{Pass a vector or the required columns of a data frame through this
argument.}
}
\value{
Returns a numeric vector with the input rescaled.
}
\description{
This function allows you to scale vectors or an entire data
frame using the max-min scaling method A numeric vector is always returned.
}
\details{
This is used within \code{keymetrics_scan()} to enable row-wise
heatmapping. Originally implemented in
\url{https://github.com/martinctc/surveytoolbox}.
}
\examples{
numbers <- c(15, 40, 10, 2)
maxmin(numbers)

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}
\keyword{max-min}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_shifts.R
\name{identify_shifts}
\alias{identify_shifts}
\title{Identify shifts based on outlook time settings for work day start and end
time}
\usage{
identify_shifts(data, return = "plot")
}
\arguments{
\item{data}{A data frame containing data from the Hourly Collaboration query.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
\item \code{"data"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: ggplot object. A bar plot for the weekly count of shifts.
\item \code{"table"}: data frame. A summary table for the count of shifts.
\item \verb{"data}: data frame. Input data appended with the \code{Shifts} columns.
}
}
\description{
This function uses outlook calendar settings for start and end time of work
day to identify work shifts. The relevant variables are
\code{WorkingStartTimeSetInOutlook} and \code{WorkingEndTimeSetInOutlook}.
}
\examples{
# Demo with `pq_data` example where Outlook Start and End times are imputed
# Use a small sample for faster runtime
pq_data_small <- dplyr::slice_sample(pq_data, prop = 0.1)

pq_data_small$WorkingStartTimeSetInOutlook <- "6:30"
pq_data_small$WorkingEndTimeSetInOutlook <- "23:30"

# Return plot
pq_data_small \%>\% identify_shifts()

# Return summary table
pq_data_small \%>\% identify_shifts(return = "table")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}
\concept{Working Patterns}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/heat_colours.R
\name{heat_colours}
\alias{heat_colours}
\alias{heat_colors}
\title{Generate a vector of \code{n} contiguous colours, as a red-yellow-green palette.}
\usage{
heat_colours(n, alpha, rev = FALSE)

heat_colors(n, alpha, rev = FALSE)
}
\arguments{
\item{n}{the number of colors (>= 1) to be in the palette.}

\item{alpha}{an alpha-transparency level in the range of 0 to 1
(0 means transparent and 1 means opaque)}

\item{rev}{logical indicating whether the ordering of the colors should be
reversed.}
}
\value{
A character vector containing the HEX codes and the same length as \code{n} is
returned.
}
\description{
Takes a numeric value \code{n} and returns a character vector of colour HEX codes
corresponding to the heat map palette.
}
\examples{
barplot(rep(10, 50), col = heat_colours(n = 50), border = NA)

barplot(rep(10, 50), col = heat_colours(n = 50, alpha = 0.5, rev = TRUE),
border = NA)

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/track_hr_change.R
\name{track_HR_change}
\alias{track_HR_change}
\title{Sankey chart of organizational movement between HR attributes and
missing values (outside company move) (Data Overview)}
\usage{
track_HR_change(
  data,
  start_date = min(data$MetricDate),
  end_date = max(data$MetricDate),
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  NA_replacement = "Out of Company"
)
}
\arguments{
\item{data}{A Person Query dataset in the form of a data frame.}

\item{start_date}{A start date to compare changes. See \code{end_date}.}

\item{end_date}{An end date to compare changes. See \code{start_date}.}

\item{hrvar}{HR Variable by which to compare changes between, defaults to
\code{"Organization"} but accepts any character vector, e.g.
\code{"LevelDesignation"}}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{Character vector specifying what to return, defaults to
\code{"plot"}. Valid inputs are \code{"plot"} and \code{"table"}.}

\item{NA_replacement}{Character replacement for NA defaults to "out of
company"}
}
\value{
Returns a 'NetworkD3' object by default, where 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
}
\description{
Creates a list of everyone at a specified start date and a specified end date
then aggregates up people who have moved between organizations between this
to points of time and visualizes the move through a sankey chart.

Through this chart you can see:
\itemize{
\item The HR attribute/orgs that have the highest move out
\item The HR attribute/orgs that have the highest move in
\item The number of people that do not have that HR attribute or if they are no
longer in the system
}
}
\examples{

pq_data \%>\% track_HR_change()

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{validation_report}()}
}
\author{
Tannaz Sattari Tabrizi \href{mailto:Tannaz.Sattari@microsoft.com}{Tannaz.Sattari@microsoft.com}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/p2p_data_sim.R
\name{p2p_data_sim}
\alias{p2p_data_sim}
\title{Simulate a person-to-person query using a Watts-Strogatz model}
\usage{
p2p_data_sim(dim = 1, size = 300, nei = 5, p = 0.05)
}
\arguments{
\item{dim}{Integer constant, the dimension of the starting lattice.}

\item{size}{Integer constant, the size of the lattice along each dimension.}

\item{nei}{Integer constant, the neighborhood within which the vertices of
the lattice will be connected.}

\item{p}{Real constant between zero and one, the rewiring probability.}
}
\value{
data frame with the same column structure as a person-to-person flexible
query. This has an edgelist structure and can be used directly as an input
to \code{network_p2p()}.
}
\description{
Generate an person-to-person query / edgelist based on the graph
according to the Watts-Strogatz small-world network model. Organizational
data fields are also simulated for \code{Organization}, \code{LevelDesignation}, and
\code{City}.
}
\details{
This is a wrapper around \code{igraph::watts.strogatz.game()}. See igraph
documentation for details on methodology. Loop edges and multiple edges are
disabled. Size of the network can be changing the arguments \code{size} and \code{nei}.
}
\examples{
# Simulate a p2p dataset with 800 edges
p2p_data_sim(size = 200, nei = 4)

}
\seealso{
Other Data: 
\code{\link{g2g_data}},
\code{\link{mt_data}},
\code{\link{p2p_data}},
\code{\link{pq_data}}

Other Network: 
\code{\link{g2g_data}},
\code{\link{network_g2g}()},
\code{\link{network_p2p}()},
\code{\link{network_summary}()},
\code{\link{p2p_data}}
}
\concept{Data}
\concept{Network}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{comma}
\alias{comma}
\title{Add comma separator for thousands}
\usage{
comma(x)
}
\arguments{
\item{x}{A numeric value}
}
\value{
Returns a formatted string.
}
\description{
Takes a numeric value and returns a character value
which is rounded to the whole number, and adds a comma
separator at the thousands. A convenient wrapper function
around \code{round()} and \code{format()}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check_query.R
\name{check_query}
\alias{check_query}
\title{Check a query to ensure that it is suitable for analysis}
\usage{
check_query(data, return = "message", validation = FALSE)
}
\arguments{
\item{data}{A person-level query in the form of a data frame. This includes:
\itemize{
\item Standard Person Query
\item Ways of Working Assessment Query
\item Hourly Collaboration Query
}

All person-level query have a \code{PersonId} column and a \code{MetricDate} column.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"message"} (default)
\item \code{"text"}
}

See \code{Value} for more information.}

\item{validation}{Logical value to specify whether to show summarized version. Defaults to \code{FALSE}. To hide checks on variable
names, set \code{validation} to \code{TRUE}.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"message"}: a message is returned to the console.
\item \code{"text"}: string containing the diagnostic message.
}
}
\description{
Prints diagnostic data about the data query to the R console,
with information such as date range, number of employees, HR attributes
identified, etc.
}
\details{
This can be used with any person-level query, such as the standard
person query, Ways of Working assessment query, and the hourly collaboration
query. When run, this prints diagnostic data to the R console.
}
\examples{
check_query(pq_data)

}
\seealso{
Other Data Validation: 
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/collaboration_area.R
\name{collaboration_area}
\alias{collaboration_area}
\alias{collab_area}
\title{Collaboration - Stacked Area Plot}
\usage{
collaboration_area(data, hrvar = NULL, mingroup = 5, return = "plot")

collab_area(data, hrvar = NULL, mingroup = 5, return = "plot")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.
A Ways of Working assessment dataset may also be provided, in which
Unscheduled call hours would be included in the output.}

\item{hrvar}{HR Variable by which to split metrics, defaults to \code{NULL}, but
accepts any character vector, e.g. "LevelDesignation". If \code{NULL} is passed,
the organizational attribute is automatically populated as "Total".}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A stacked area plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Provides an overview analysis of Weekly Digital Collaboration.
Returns an stacked area plot of Email and Meeting Hours by default.
Additional options available to return a summary table.
}
\details{
Uses the metrics \code{Meeting_hours}, \code{Email_hours}, \code{Unscheduled_Call_hours},
and \code{Instant_Message_hours}.
}
\examples{
\dontrun{
# Return plot with total (default)
collaboration_area(pq_data)

# Return plot with hrvar split
collaboration_area(pq_data, hrvar = "Organization")

# Return summary table
collaboration_area(pq_data, return = "table")
}

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Collaboration: 
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()}
}
\concept{Collaboration}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tm_freq.R
\name{tm_freq}
\alias{tm_freq}
\title{Perform a Word or Ngram Frequency Analysis and return a Circular Bar
Plot}
\usage{
tm_freq(data, token = "words", stopwords = NULL, keep = 100, return = "plot")
}
\arguments{
\item{data}{A Meeting Query dataset in the form of a data frame.}

\item{token}{A character vector accepting either \code{"words"} or \code{"ngram"},
determining type of tokenisation to return.}

\item{stopwords}{A character vector OR a single-column data frame labelled
\code{'word'} containing custom stopwords to remove.}

\item{keep}{A numeric vector specifying maximum number of words to keep.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A circular bar plot.
\item \code{"table"}: data frame. A summary table.
}
}
\description{
Generate a circular bar plot with frequency of words / ngrams.
This function is used within \code{meeting_tm_report()}.
}
\details{
This function uses \code{tm_clean()} as the underlying data wrangling function.
There is an option to remove stopwords by passing a data frame into the
\code{stopwords} argument.
}
\examples{
# circular network plot with words
tm_freq(mt_data, token = "words")

# circular network plot with ngrams
tm_freq(mt_data, token = "ngrams")

# summary table of text frequency
tm_freq(mt_data, token = "words", return = "table")

}
\seealso{
Other Text-mining: 
\code{\link{meeting_tm_report}()},
\code{\link{pairwise_count}()},
\code{\link{tm_clean}()},
\code{\link{tm_cooc}()},
\code{\link{tm_wordcloud}()}
}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/one2one_freq.R
\name{one2one_freq}
\alias{one2one_freq}
\title{Frequency of Manager 1:1 Meetings as bar or 100\% stacked bar chart}
\usage{
one2one_freq(
  data,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  mode = "dist",
  sort_by = NULL
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}}

\item{mode}{String specifying what method to use. This must be one of the
following strings:
\itemize{
\item \code{"dist"}
\item \code{"sum"}
}}

\item{sort_by}{String to specify the bucket label to sort by. Defaults to
\code{NULL} (no sorting).}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A stacked bar plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

This function calculates the average number of weeks (cadence) between of 1:1
meetings between an employee and their manager. Returns a  distribution plot
for typical cadence of 1:1 meetings. Additional options available to return a
bar plot, tables, or a data frame with a cadence of 1 on 1 meetings metric.
}
\section{Distribution view}{

For this view, there are four categories of cadence:
\itemize{
\item Weekly (once per week)
\item Twice monthly or more (up to 3 weeks)
\item Monthly (3 - 6 weeks)
\item Every two months (6 - 10 weeks)
\item Quarterly or less (> 10 weeks)
}

In the occasion there are zero 1:1 meetings with managers, this is included
into the last category, i.e. 'Quarterly or less'. Note that when \code{mode} is
set to \code{"sum"}, these rows are simply excluded from the calculation.
}

\examples{
# Return plot, mode dist
one2one_freq(pq_data, hrvar = "Organization", return = "plot", mode = "dist")

# Return plot, mode sum
one2one_freq(pq_data,
             hrvar = "Organization",
             return = "plot",
             mode = "sum")

# Return summary table
one2one_freq(pq_data, hrvar = "Organization", return = "table")

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Managerial Relations: 
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}
}
\concept{Managerial Relations}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_nkw.R
\name{identify_nkw}
\alias{identify_nkw}
\title{Identify Non-Knowledge workers in a Person Query using Collaboration
Hours}
\usage{
identify_nkw(data, collab_threshold = 5, return = "data_summary")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{collab_threshold}{Positive numeric value representing the collaboration
hours threshold that should be exceeded as an average for the entire
analysis period for the employee to be categorized as a knowledge worker
("kw"). Default is set to 5 collaboration hours. Any versions after v1.4.3,
this uses a "greater than or equal to" logic (\code{>=}), in which case persons
with exactly 5 collaboration hours will pass.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"text"}
\item \code{"data_with_flag"}
\item \code{"data_clean"}
\item \code{"data_cleaned"}
\item \code{"data_summary"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"text"}: string. Returns a diagnostic message.
\item \code{"data_with_flag"}: data frame. Original input data with an additional
column containing the \code{kw}/\code{nkw} flag.
\item \code{"data_clean"} or \code{"data_cleaned"}: data frame. Data frame with non-knowledge workers
excluded.
\item \code{"data_summary"}: data frame. A summary table by organization listing
the number and \% of non-knowledge workers.
}
}
\description{
This function scans a standard query output to identify employees with
consistently low collaboration signals. Returns the \% of non-knowledge
workers identified by Organization, and optionally an edited data frame with
non-knowledge workers removed, or the full data frame with the kw/nkw flag
added.
}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cut_hour.R
\name{cut_hour}
\alias{cut_hour}
\title{Convert a numeric variable for hours into categorical}
\usage{
cut_hour(metric, cuts, unit = "hours", lbound = 0, ubound = 100)
}
\arguments{
\item{metric}{A numeric variable representing hours.}

\item{cuts}{A numeric vector of minimum length 3 to represent the
cut points required. The minimum and maximum values provided in the vector
are inclusive.}

\item{unit}{String to specify the unit of the labels. Defaults to "hours".}

\item{lbound}{Numeric. Specifies the lower bound (inclusive) value for the
minimum label. Defaults to 0.}

\item{ubound}{Numeric. Specifies the upper bound (inclusive) value for the
maximum label. Defaults to 100.}
}
\value{
Character vector representing a converted categorical variable, appended
with the label of the unit. See \code{examples} for more information.
}
\description{
Supply a numeric variable, e.g. \code{Collaboration_hours}, and return a character
vector.
}
\details{
This is used within \code{create_dist()} for numeric to categorical conversion.
}
\examples{
# Direct use
cut_hour(1:30, cuts = c(15, 20, 25))

# Use on a query
cut_hour(pq_data$Collaboration_hours, cuts = c(10, 15, 20), ubound = 150)

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_stacked.R
\name{create_stacked}
\alias{create_stacked}
\title{Horizontal stacked bar plot for any metric}
\usage{
create_stacked(
  data,
  hrvar = "Organization",
  metrics = c("Meeting_hours", "Email_hours"),
  mingroup = 5,
  return = "plot",
  stack_colours = c("#1d627e", "#34b1e2", "#b4d5dd", "#adc0cb"),
  percent = FALSE,
  plot_title = "Collaboration Hours",
  plot_subtitle = paste("Average by", tolower(camel_clean(hrvar))),
  legend_lab = NULL,
  rank = "descending",
  xlim = NULL,
  text_just = 0.5,
  text_colour = "#FFFFFF"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{metrics}{A character vector to specify variables to be used
in calculating the "Total" value, e.g. c("Meeting_hours", "Email_hours").
The order of the variable names supplied determine the order in which they
appear on the stacked plot.}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{Character vector specifying what to return, defaults to "plot".
Valid inputs are "plot" and "table".}

\item{stack_colours}{A character vector to specify the colour codes for the stacked bar charts.}

\item{percent}{Logical value to determine whether to show labels as
percentage signs. Defaults to \code{FALSE}.}

\item{plot_title}{String. Option to override plot title.}

\item{plot_subtitle}{String. Option to override plot subtitle.}

\item{legend_lab}{String. Option to override legend title/label. Defaults to
\code{NULL}, where the metric name will be populated instead.}

\item{rank}{String specifying how to rank the bars. Valid inputs are:
\itemize{
\item \code{"descending"} - ranked highest to lowest from top to bottom (default).
\item \code{"ascending"} - ranked lowest to highest from top to bottom.
\item \code{NULL} - uses the original levels of the HR attribute.
}}

\item{xlim}{An option to set max value in x axis.}

\item{text_just}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}} A numeric value
controlling for the horizontal position of the text labels. Defaults to
0.5.}

\item{text_colour}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}} String to specify
colour to use for the text labels. Defaults to \code{"#FFFFFF"}.}
}
\value{
Returns a 'ggplot' object by default, where 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
}
\description{
Creates either a single bar plot, of a stacked bar using selected metrics
(where the typical use case is to create different definitions of
collaboration hours).
Returns a plot by default.
Additional options available to return a summary table.
}
\examples{
pq_data \%>\%
  create_stacked(hrvar = "LevelDesignation",
                 metrics = c("Meeting_hours", "Email_hours"),
                 return = "plot")

pq_data \%>\%
  create_stacked(hrvar = "FunctionType",
                 metrics = c("Meeting_hours",
                             "Email_hours",
                             "Call_hours",
                             "Chat_hours"),
                 return = "plot",
                 rank = "ascending")

pq_data \%>\%
  create_stacked(hrvar = "FunctionType",
                 metrics = c("Meeting_hours",
                             "Email_hours",
                             "Call_hours",
                             "Chat_hours"),
                 return = "table")

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{rgb2hex}
\alias{rgb2hex}
\title{Convert rgb to HEX code}
\usage{
rgb2hex(r, g, b)
}
\arguments{
\item{r, g, b}{Values that correspond to the three RGB parameters}
}
\value{
Returns a string containing a HEX code.
}
\description{
Convert rgb to HEX code
}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_trend.R
\name{create_trend}
\alias{create_trend}
\title{Heat mapped horizontal bar plot over time for any metric}
\usage{
create_trend(
  data,
  metric,
  hrvar = "Organization",
  mingroup = 5,
  palette = c("steelblue4", "aliceblue", "white", "mistyrose1", "tomato1"),
  return = "plot",
  legend_title = "Hours"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{palette}{Character vector containing colour codes, ranked from the
lowest value to the highest value. This is passed directly to
\code{ggplot2::scale_fill_gradientn()}.}

\item{return}{Character vector specifying what to return, defaults to
\code{"plot"}.
Valid inputs are "plot" and "table".}

\item{legend_title}{String to be used as the title of the legend. Defaults to
\code{"Hours"}.}
}
\value{
Returns a 'ggplot' object by default, where 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
}
\description{
Provides a week by week view of a selected Viva Insights metric. By
default returns a week by week heatmap bar plot, highlighting the points in
time with most activity. Additional options available to return a summary
table.
}
\examples{
create_trend(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation")

# custom colours
create_trend(
  pq_data,
  metric = "Collaboration_hours",
  hrvar = "LevelDesignation",
  palette = c(
    "#FB6107",
    "#F3DE2C",
    "#7CB518",
    "#5C8001"
  )
  )

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()}

Other Time-series: 
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()}
}
\concept{Flexible}
\concept{Time-series}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/us_to_space.R
\name{us_to_space}
\alias{us_to_space}
\title{Replace underscore with space}
\usage{
us_to_space(x)
}
\arguments{
\item{x}{String to replace all occurrences of \verb{_} with a single space}
}
\value{
Character vector containing the modified string.
}
\description{
Convenience function to convert underscores to space
}
\examples{
us_to_space("Meeting_and_call_hours_with_manager_1_on_1")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tm_wordcloud.R
\name{tm_wordcloud}
\alias{tm_wordcloud}
\title{Generate a wordcloud with meeting subject lines}
\usage{
tm_wordcloud(
  data,
  stopwords = NULL,
  seed = 100,
  keep = 100,
  return = "plot",
  ...
)
}
\arguments{
\item{data}{A Meeting Query dataset in the form of a data frame.}

\item{stopwords}{A character vector OR a single-column data frame labelled
\code{'word'} containing custom stopwords to remove.}

\item{seed}{A numeric vector to set seed for random generation.}

\item{keep}{A numeric vector specifying maximum number of words to keep.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{...}{Additional parameters to be passed to
\code{ggwordcloud::geom_text_wordcloud()}}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object containing a word cloud.
\item \code{"table"}: data frame returning the data used to generate the word cloud.
}
}
\description{
Generate a wordcloud with the meeting query.
This is a sub-function that feeds into \code{meeting_tm_report()}.
}
\details{
Uses the 'ggwordcloud' package for the underlying implementation, thus
returning a 'ggplot' object. Additional layers can be added onto the plot
using a ggplot \code{+} syntax.
The recommendation is not to return over 100 words in a word cloud.

This function uses \code{tm_clean()} as the underlying data wrangling function.
There is an option to remove stopwords by passing a data frame into the
\code{stopwords} argument.
}
\examples{
tm_wordcloud(mt_data, keep = 30)

# Removing stopwords
tm_wordcloud(mt_data, keep = 30, stopwords = c("weekly", "update"))

}
\seealso{
Other Text-mining: 
\code{\link{meeting_tm_report}()},
\code{\link{pairwise_count}()},
\code{\link{tm_clean}()},
\code{\link{tm_cooc}()},
\code{\link{tm_freq}()}
}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_IV.R
\name{create_IV}
\alias{create_IV}
\title{Compute Information Value for Predictive Variables}
\usage{
create_IV(
  data,
  predictors = NULL,
  outcome,
  bins = 5,
  siglevel = 0.05,
  exc_sig = FALSE,
  return = "plot"
)
}
\arguments{
\item{data}{A Person Query dataset in the form of a data frame.}

\item{predictors}{A character vector specifying the columns to be used as
predictors. Defaults to NULL, where all numeric vectors in the data will be
used as predictors.}

\item{outcome}{String specifying the column name for a binary variable,
containing only the values 1 or 0.}

\item{bins}{Number of bins to use, defaults to 5.}

\item{siglevel}{Significance level to use in comparing populations for the
outcomes, defaults to 0.05}

\item{exc_sig}{Logical value determining whether to exclude values where the
p-value lies below what is set at \code{siglevel}. Defaults to \code{FALSE}, where
p-value calculation does not happen altogether.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"summary"}
\item \code{"list"}
\item \code{"plot-WOE"}
\item \code{"IV"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A bar plot showing the IV value of the top
(maximum 12) variables.
\item \code{"summary"}: data frame. A summary table for the metric.
\item \code{"list"}: list. A list of outputs for all the input variables.
\item \code{"plot-WOE"}: A list of 'ggplot' objects that show the WOE for each
predictor used in the model.
\item \code{"IV"} returns a list object which mirrors the return
in \code{Information::create_infotables()}.
}
}
\description{
This function calculates the Information Value (IV) for the
selected numeric predictor variables in the dataset, given a specified
outcome variable. The Information Value provides a measure of the predictive
power of each variable in relation to the outcome variable, which can be
useful in feature selection for predictive modeling.
}
\details{
This is a wrapper around \code{wpa::create_IV()}.
}
\examples{
# Return a summary table of IV
pq_data \%>\%
  dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) \%>\%
  create_IV(outcome = "X",
            predictors = c("Email_hours",
                           "Meeting_hours",
                           "Chat_hours"),
            return = "plot")


# Return summary
pq_data \%>\%
  dplyr::mutate(X = ifelse(Internal_network_size > 40, 1, 0)) \%>\%
  create_IV(outcome = "X",
            predictors = c("Email_hours", "Meeting_hours"),
            return = "summary")

}
\seealso{
Other Variable Association: 
\code{\link{IV_report}()}

Other Information Value: 
\code{\link{IV_report}()}
}
\concept{Information Value}
\concept{Variable Association}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/totals_bind.R
\name{totals_bind}
\alias{totals_bind}
\title{Row-bind an identical data frame for computing grouped totals}
\usage{
totals_bind(data, target_col, target_value = "Total")
}
\arguments{
\item{data}{data frame}

\item{target_col}{Character value of the column in which to impute \code{"Total"}.
This is usually the intended grouping column.}

\item{target_value}{Character value to impute in the new data frame to
row-bind. Defaults to \code{"Total"}.}
}
\value{
data frame with twice the number of rows of the input data frame, where half
of those rows will have the \code{target_col} column imputed with the value from
\code{target_value}.
}
\description{
Row-bind an identical data frame and impute a specific
column with the \code{target_value}, which defaults as "Total". The purpose of
this is to enable to creation of summary tables with a calculated "Total"
row. See example below on usage.
}
\examples{
pq_data \%>\%
  totals_bind(target_col = "LevelDesignation", target_value = "Total") \%>\%
  create_bar(hrvar = "LevelDesignation", metric = "Email_hours", return = "table")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mt_data.R
\docType{data}
\name{mt_data}
\alias{mt_data}
\title{Sample Meeting Query dataset}
\format{
A data frame with 612 rows and 41 variables:
\describe{
\item{MeetingId}{ }
\item{Attendee_meeting_hours}{ }
\item{Number_of_attendees}{ }
\item{Number_of_attendees_multitasking}{ }
\item{Number_of_attendees_who_didn_t_end_the_meeting_on_time}{ }
\item{Number_of_attendees_who_didn_t_join_the_meeting_on_time}{ }
\item{Number_of_attendees_who_ended_the_meeting_on_time}{ }
\item{Number_of_attendees_who_joined_the_meeting_on_time}{ }
\item{Number_of_chats_sent_during_the_meeting}{ }
\item{Number_of_emails_sent_during_the_meeting}{ }
\item{Number_of_redundant_attendees}{ }
\item{Subject}{ }
\item{All_Day_Meeting}{ }
\item{Cancelled}{ }
\item{Recurring}{ }
\item{Accept_count}{ }
\item{No_response_count}{ }
\item{Decline_count}{ }
\item{Tentatively_accepted_count}{ }
\item{Intended_participant_count}{ }
\item{Collaboration_start_time}{ }
\item{Organizer}{ }
\item{zId}{ }
\item{attainment}{ }
\item{TimeZone}{ }
\item{SupervisorIndicator}{ }
\item{Region}{ }
\item{Population_Type}{ }
\item{Organization}{ }
\item{OnsiteDays}{ }
\item{Number_of_directs}{ }
\item{LevelDesignation}{ }
\item{Layer}{ }
\item{HireDate}{ }
\item{GroupNum}{ }
\item{GroupName}{ }
\item{FunctionType}{ }
\item{Domain}{ }
\item{ADO_PersonSK}{ }
\item{ADO_PersonIndicator}{ }
\item{Duration}{ }

}
}
\source{
\url{https://learn.microsoft.com/en-us/viva/insights/advanced/analyst/meeting-query/}
}
\usage{
mt_data
}
\value{
data frame.
}
\description{
A dataset generated from a Meeting Query from Viva Insights.
}
\seealso{
Other Data: 
\code{\link{g2g_data}},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()},
\code{\link{pq_data}}
}
\concept{Data}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flag_em_ratio.R
\name{flag_em_ratio}
\alias{flag_em_ratio}
\title{Flag Persons with unusually high Email Hours to Emails Sent ratio}
\usage{
flag_em_ratio(data, threshold = 1, return = "text")
}
\arguments{
\item{data}{A data frame containing a Person Query.}

\item{threshold}{Numeric value specifying the threshold for flagging.
Defaults to 1.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"text"}
\item \code{"data"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"text"}: string. A diagnostic message.
\item \code{"data"}: data frame. Person-level data with those flagged with unusual
ratios.
}
}
\description{
This function flags persons who have an unusual ratio
of email hours to emails sent. If the ratio between Email Hours and
Emails Sent is greater than the threshold, then observations tied to
a \code{PersonId} is flagged as unusual.
}
\examples{
flag_em_ratio(pq_data)

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/totals_col.R
\name{totals_col}
\alias{totals_col}
\title{Fabricate a 'Total' HR variable}
\usage{
totals_col(data, total_value = "Total")
}
\arguments{
\item{data}{data frame}

\item{total_value}{Character value defining the name and the value of the
\code{"Total"} column. Defaults to \code{"Total"}. An error is returned if an
existing variable has the same name as the supplied value.}
}
\value{
data frame containing an additional 'Total' column on top of the input data
frame.
}
\description{
Create a 'Total' column of character type comprising exactly of
one unique value. This is a convenience function for returning a no-HR
attribute view when \code{NULL} is supplied to the \code{hrvar} argument in
functions.
}
\examples{
# Create a visual without HR attribute breaks
pq_data \%>\%
  totals_col() \%>\%
  create_fizz(hrvar = "Total", metric = "Email_hours")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_inc.R
\name{create_inc}
\alias{create_inc}
\alias{create_incidence}
\title{Create an incidence analysis reflecting proportion of population scoring above
or below a threshold for a metric}
\usage{
create_inc(
  data,
  metric,
  hrvar,
  mingroup = 5,
  threshold,
  position,
  return = "plot"
)

create_incidence(
  data,
  metric,
  hrvar,
  mingroup = 5,
  threshold,
  position,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{Character vector of at most length 2 containing the name of the
HR Variable by which to split metrics. Accepts \code{NULL}, where the total
population is used for the analysis.}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{threshold}{Numeric value specifying the threshold.}

\item{position}{String containing the below valid values:
\itemize{
\item \code{"above"}: show incidence of those equal to or above the threshold
\item \code{"below"}: show incidence of those equal to or below the threshold
}}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A heat map.
\item \code{"table"}: data frame. A summary table.
}
}
\description{
An incidence analysis is generated, with each value in the table reflecting
the proportion of the population that is above or below a threshold for a
specified metric. There is an option to only provide a single \code{hrvar} in
which a bar plot is generated, or two \code{hrvar} values where an incidence table
(heatmap) is generated.
}
\examples{
# Only a single HR attribute
create_inc(
  data = pq_data,
  metric = "After_hours_collaboration_hours",
  hrvar = "Organization",
  threshold = 4,
  position = "above"
)

# Total population (NULL hrvar)
create_inc(
  data = pq_data,
  metric = "Collaboration_hours",
  hrvar = NULL,
  threshold = 20,
  position = "below"
)

# Two HR attributes
create_inc(
  data = pq_data,
  metric = "Collaboration_hours",
  hrvar = c("LevelDesignation", "Organization"),
  threshold = 20,
  position = "below"
)

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/keymetrics_scan_asis.R
\name{keymetrics_scan_asis}
\alias{keymetrics_scan_asis}
\title{Run a summary of Key Metrics without aggregation}
\usage{
keymetrics_scan_asis(
  data,
  row_var,
  col_var,
  group_var = col_var,
  value_var = "value",
  title = NULL,
  subtitle = NULL,
  caption = NULL,
  ylab = row_var,
  xlab = "Metrics",
  rounding = 1,
  low = rgb2hex(7, 111, 161),
  mid = rgb2hex(241, 204, 158),
  high = rgb2hex(216, 24, 42),
  textsize = 2
)
}
\arguments{
\item{data}{data frame containing data to plot. It is recommended to provide
data in a 'long' table format where one grouping column forms the rows, a
second column forms the columns, and a third numeric columns forms the}

\item{row_var}{String containing name of the grouping variable that will form
the rows of the heatmapped table.}

\item{col_var}{String containing name of the grouping variable that will form
the columns of the heatmapped table.}

\item{group_var}{String containing name of the grouping variable by which
heatmapping would apply. Defaults to \code{col_var}.}

\item{value_var}{String containing name of the value variable that will form
the values of the heatmapped table. Defaults to \code{"value"}.}

\item{title}{Title of the plot.}

\item{subtitle}{Subtitle of the plot.}

\item{caption}{Caption of the plot.}

\item{ylab}{Y-axis label for the plot (group axis)}

\item{xlab}{X-axis label of the plot (bar axis).}

\item{rounding}{Numeric value to specify number of digits to show in data
labels}

\item{low}{String specifying colour code to use for low-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{mid}{String specifying colour code to use for mid-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{high}{String specifying colour code to use for high-value metrics.
Arguments are passed directly to \code{ggplot2::scale_fill_gradient2()}.}

\item{textsize}{A numeric value specifying the text size to show in the plot.}
}
\value{
ggplot object for a heatmap table.
}
\description{
Return a heatmapped table directly from the aggregated / summarised data.
Unlike \code{keymetrics_scan()} which performs a person-level aggregation, there
is no calculation for \code{keymetrics_scan_asis()} and the values are rendered as
they are passed into the function.
}
\examples{

library(dplyr)

# Compute summary table
out_df <-
  pq_data \%>\%
  group_by(Organization) \%>\%
  summarise(
    across(
      .cols = c(
        Email_hours,
        Collaboration_hours
        ),
      .fns = ~median(., na.rm = TRUE)
      ),
      .groups = "drop"
    ) \%>\%
tidyr::pivot_longer(
  cols = c("Email_hours", "Collaboration_hours"),
  names_to = "metrics"
)

keymetrics_scan_asis(
  data = out_df,
  col_var = "metrics",
  row_var = "Organization"
)

# Show data the other way round
keymetrics_scan_asis(
  data = out_df,
  col_var = "Organization",
  row_var = "metrics",
  group_var = "metrics"
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pairwise_count.R
\name{pairwise_count}
\alias{pairwise_count}
\title{Perform a pairwise count of words by id}
\usage{
pairwise_count(data, id = "line", word = "word")
}
\arguments{
\item{data}{Data frame output from \code{tm_clean()}.}

\item{id}{String to represent the id variable. Defaults to \code{"line"}.}

\item{word}{String to represent the word variable. Defaults to \code{"word"}.}
}
\value{
data frame with the following columns representing a pairwise count:
\itemize{
\item \code{"item1"}
\item \code{"item2"}
\item \code{"n"}
}
}
\description{
This is a 'data.table' implementation that mimics the output of
\code{pairwise_count()} from 'widyr' to reduce package dependency. This is used
internally within \code{tm_cooc()}.
}
\examples{
td <- data.frame(line = c(1, 1, 2, 2),
                 word = c("work", "meeting", "catch", "up"))

pairwise_count(td, id = "line", word = "word")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}

Other Text-mining: 
\code{\link{meeting_tm_report}()},
\code{\link{tm_clean}()},
\code{\link{tm_cooc}()},
\code{\link{tm_freq}()},
\code{\link{tm_wordcloud}()}
}
\concept{Support}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flag_extreme.R
\name{flag_extreme}
\alias{flag_extreme}
\title{Warn for extreme values by checking against a threshold}
\usage{
flag_extreme(
  data,
  metric,
  person = TRUE,
  threshold,
  mode = "above",
  return = "message"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{A character string specifying the metric to test.}

\item{person}{A logical value to specify whether to calculate
person-averages. Defaults to \code{TRUE} (person-averages calculated).}

\item{threshold}{Numeric value specifying the threshold for flagging.}

\item{mode}{String determining mode to use for identifying extreme values.
\itemize{
\item \code{"above"}: checks whether value is great than the threshold (default)
\item \code{"equal"}: checks whether value is equal to the threshold
\item \code{"below"}: checks whether value is below the threshold
}}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"text"}
\item \code{"message"}
\item \code{"table"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"text"}: string. A diagnostic message.
\item \code{"message"}: message on console. A diagnostic message.
\item \code{"table"}: data frame. A person-level table with \code{PersonId} and the
extreme values of the selected metric.
}
}
\description{
This is used as part of data validation to check if there are extreme values
in the dataset.
}
\examples{
# The threshold values are intentionally set low to trigger messages.
flag_extreme(pq_data, "Email_hours", threshold = 15)

# Return a summary table
flag_extreme(pq_data, "Email_hours", threshold = 15, return = "table")

# Person-week level
flag_extreme(pq_data, "Email_hours", person = FALSE, threshold = 15)

# Check for values equal to threshold
flag_extreme(pq_data, "Email_hours", person = TRUE, mode = "equal", threshold = 0)

# Check for values below threshold
flag_extreme(pq_data, "Email_hours", person = TRUE, mode = "below", threshold = 5)

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/themes.R
\name{theme_wpa_basic}
\alias{theme_wpa_basic}
\title{Basic theme for 'vivainsights' visualisations}
\usage{
theme_wpa_basic(font_size = 12)
}
\arguments{
\item{font_size}{Numeric value that prescribes the base font size
for the plot. The text elements are defined relatively to this
base font size. Defaults to 12.}
}
\value{
Returns a ggplot object with the applied theme.
}
\description{
A theme function applied to 'ggplot' visualisations in 'vivainsights'.
Based on \code{theme_wpa()} but has no font requirements.
}
\seealso{
Other Themes: 
\code{\link{theme_wpa}()}
}
\concept{Themes}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{pad2}
\alias{pad2}
\title{Create the two-digit zero-padded format}
\usage{
pad2(x)
}
\arguments{
\item{x}{numeric value or vector with maximum two characters.}
}
\value{
Numeric value containing two-digit zero-padded values.
}
\description{
Create the two-digit zero-padded format
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is_date_format.R
\name{any_idate}
\alias{any_idate}
\title{Identify whether variable is an IDate class.}
\usage{
any_idate(x)
}
\arguments{
\item{x}{Variable to test whether an IDate class.}
}
\value{
logical value indicating whether the string is of an IDate class.
}
\description{
This function checks whether the variable is an IDate class.
}
\examples{
any_idate("2023-12-15")

}
\seealso{
Other Support: 
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_tenure.R
\name{identify_tenure}
\alias{identify_tenure}
\title{Tenure calculation based on different input dates, returns data
summary table or histogram}
\usage{
identify_tenure(
  data,
  end_date = "MetricDate",
  beg_date = "HireDate",
  maxten = 40,
  return = "message"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{end_date}{A string specifying the name of the date variable
representing the latest date. Defaults to "MetricDate".}

\item{beg_date}{A string specifying the name of the date variable
representing the hire date. Defaults to "HireDate".}

\item{maxten}{A numeric value representing the maximum tenure.
If the tenure exceeds this threshold, it would be accounted for in the flag message.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"message"}
\item \code{"text"}
\item \code{"plot"}
\item \code{"data_cleaned"}
\item \code{"data_dirty"}
\item \code{"data"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"message"}: message on console with a diagnostic message.
\item \code{"text"}: string containing a diagnostic message.
\item \code{"plot"}: 'ggplot' object. A line plot showing tenure.
\item \code{"data_cleaned"}: data frame filtered only by rows with tenure values
lying within the threshold.
\item \code{"data_dirty"}: data frame filtered only by rows with tenure values
lying outside the threshold.
\item \code{"data"}: data frame with the \code{PersonId} and a calculated variable called
\code{TenureYear} is returned.
}
}
\description{
This function calculates employee tenure based on different input dates.
\code{identify_tenure} uses the latest Date available if user selects "MetricDate",
but also have flexibility to select a specific date, e.g. "1/1/2020".
}
\examples{
library(dplyr)
# Add HireDate to `pq_data`
pq_data2 <-
  pq_data \%>\%
  mutate(HireDate = as.Date("1/1/2015", format = "\%m/\%d/\%Y"))

identify_tenure(pq_data2)

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_survival_prep.R
\name{create_survival_prep}
\alias{create_survival_prep}
\title{Prepare Survival Data from a Panel Dataset}
\usage{
create_survival_prep(
  data,
  metric,
  event_condition = function(x) x > 0,
  hrvar = "Organization"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{Character string containing the name of the metric column to
evaluate the event condition on.}

\item{event_condition}{A function that takes a numeric vector and returns a
logical vector. Applied to \code{metric} to mark whether the event occurred
in a given period. Defaults to \code{function(x) x > 0} (any non-zero
value is treated as the event).}

\item{hrvar}{Character string containing the name of the HR attribute column
to carry through into the output. The most recent (last observed) value per
person is used. Defaults to \code{"Organization"}. Set to \code{NULL} to
omit.}
}
\value{
A data frame with one row per person containing:
\itemize{
\item \code{PersonId}
\item \code{time}: numeric — periods until event, or total observed periods
if censored
\item \code{event}: integer — \code{1} (event) or \code{0} (censored)
\item The \code{hrvar} column, if supplied
}
}
\description{
Converts a Standard Person Query (panel) dataset into a person-level survival
table suitable for direct use with \code{\link{create_survival}}.

Each person's weekly rows are reduced to a single row containing:
\itemize{
\item \code{time}: the number of periods from the first observation until
the event condition is first met. If the condition is never met,
\code{time} equals the total number of observed periods (censored).
\item \code{event}: \code{1} if the condition was met at any point in the
observation window, \code{0} if the person was censored (never met it).
}

Although rooted in survival analysis, the \code{event_condition} is typically
a \strong{positive milestone} in a workforce context — first use of a tool, first
week as a power user, first week crossing a collaboration threshold.
The resulting curve is therefore often better described as a
\strong{time-to-adoption}, \strong{conversion}, or \strong{graduation} curve.
See \code{\link{create_survival}} for further framing guidance.
}
\examples{
# \dontrun{
# library(vivainsights)
# data("pq_data", package = "vivainsights")
#
# # Step 1: derive person-level survival data
# surv_data <- create_survival_prep(
#   data = pq_data,
#   metric = "Copilot_actions_taken_in_Teams",
#   event_condition = function(x) x > 0
# )
#
# # Step 2: visualise
# create_survival(
#   data = surv_data,
#   time_col = "time",
#   event_col = "event",
#   hrvar = "Organization"
# )
# }
}
\seealso{
\code{\link{create_survival}}
}
\concept{Transformation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/wrap.R
\name{wrap}
\alias{wrap}
\title{Add a character at the start and end of a character string}
\usage{
wrap(string, wrapper = "\\"")
}
\arguments{
\item{string}{Character string to be wrapped around}

\item{wrapper}{Character to wrap around \code{string}}
}
\value{
Character vector containing the modified string.
}
\description{
This function adds a character at the start and end of a character
string, where the default behaviour is to add a double quote.
}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/network_g2g.R
\name{network_g2g}
\alias{network_g2g}
\title{Create a network plot with the group-to-group query}
\usage{
network_g2g(
  data,
  primary = NULL,
  secondary = NULL,
  metric = "Group_collaboration_time_invested",
  algorithm = "fr",
  node_colour = "lightblue",
  exc_threshold = 0.1,
  org_count = NULL,
  subtitle = "Collaboration Across Organizations",
  return = "plot"
)
}
\arguments{
\item{data}{Data frame containing a group-to-group query.}

\item{primary}{String containing the variable name for the Primary
Collaborator column.}

\item{secondary}{String containing the variable name for the Secondary
Collaborator column.}

\item{metric}{String containing the variable name for metric. Defaults to
\code{Group_collaboration_time_invested}.}

\item{algorithm}{String to specify the node placement algorithm to be used.
Defaults to \code{"fr"} for the force-directed algorithm of Fruchterman and
Reingold. See
\url{https://rdrr.io/cran/ggraph/man/layout_tbl_graph_igraph.html} for a full
list of options.}

\item{node_colour}{String or named vector to specify the colour to be used
for displaying nodes. Defaults to \code{"lightblue"}.
\itemize{
\item If \code{"vary"} is supplied, a different colour is shown for each node at
random.
\item If a named vector is supplied, the names must match the values of the
variable provided for the \code{primary} and \code{secondary} columns. See
example section for details.
}}

\item{exc_threshold}{Numeric value between 0 and 1 specifying the exclusion
threshold to apply. Defaults to 0.1, which means that the plot will only
display collaboration above 10\% of a node's total collaboration. This
argument has no impact on \code{"data"} or \code{"table"} return.}

\item{org_count}{Optional data frame to provide the size of each organization
in the \code{secondary} attribute. The data frame should contain only two
columns:
\itemize{
\item Name of the \code{secondary} attribute excluding any prefixes, e.g.
\code{"Organization"}. Must be of character or factor type.
\item \code{"n"}. Must be of numeric type.
Defaults to \code{NULL}, where node sizes will be fixed.
}}

\item{subtitle}{String to override default plot subtitle.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
\item \code{"network"}
\item \code{"data"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A group-to-group network plot.
\item \code{"table"}: data frame. An interactive matrix of the network.
\item \verb{"network}: 'igraph' object used for creating the network plot.
\item \code{"data"}: data frame. A long table of the underlying data.
}
}
\description{
Pass a data frame containing a group-to-group query and return a network
plot. Automatically handles \code{"Within Group"} and \code{"Other_collaborators"}
values within query data.
}
\examples{
# Return a network plot
g2g_data \%>\% network_g2g()

# Return a network plot - Meeting hours and 5\% threshold
network_g2g(
  data = g2g_data,
  primary = "PrimaryCollaborator_Organization",
  secondary = "SecondaryCollaborator_Organization",
  exc_threshold = 0.05
)

# Return a network plot - custom-specific colours
# Get labels of orgs and assign random colours
org_str <- unique(g2g_data$PrimaryCollaborator_Organization)

col_str <-
  sample(
    x = heat_colours(n = length(org_str)), # generate colour codes for each one
    size = length(org_str),
    replace = TRUE
  )

# Create and supply a named vector to `node_colour`
names(col_str) <- org_str

g2g_data \%>\%
  network_g2g(node_colour = col_str)


# Return a network plot with circle layout
# Vary node colours and add org sizes
org_tb <-
  data.frame(
    Organization = c(
      "G&A East",
      "G&A West",
      "G&A North",
      "South Sales",
      "North Sales",
      "G&A South"
    ),
    n = sample(30:1000, size = 6)
  )

g2g_data \%>\%
  network_g2g(algorithm = "circle",
              node_colour = "vary",
              org_count = org_tb)

# Return an interaction matrix
# Minimum arguments specified
g2g_data \%>\%
  network_g2g(return = "table")

}
\seealso{
Other Network: 
\code{\link{g2g_data}},
\code{\link{network_p2p}()},
\code{\link{network_summary}()},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()}
}
\concept{Network}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_habit.R
\name{identify_habit}
\alias{identify_habit}
\title{Identify whether a habitual behaviour exists over a given interval of time}
\usage{
identify_habit(
  data,
  metric,
  threshold = 1,
  width,
  max_window,
  hrvar = NULL,
  return = "plot",
  plot_mode = "time",
  fill_col = c("#E5E5E5", "#0078D4")
)
}
\arguments{
\item{data}{Data frame containing Person Query to be analysed. The data frame
must have a \code{PersonId}, \code{MetricDate} and a column containing a metric for
classifying behaviour.}

\item{metric}{Character string specifying the metric to be analysed.}

\item{threshold}{Numeric value specifying the minimum number of times the
metric sum up to in order to be a valid count. A 'greater than or equal to'
logic is used.}

\item{width}{Integer specifying the number of qualifying counts to consider
for a habit. The function assumes a \strong{weekly} interval is used.}

\item{max_window}{Integer specifying the maximum unit of dates to consider a
qualifying window for a habit. If your data is grouped at a weekly level,
then \code{max_window = 12} would consider 12 weeks.}

\item{hrvar}{Character string specifying the HR attribute or organisational
variable to group by. Default is \code{NULL}.}

\item{return}{Character string specifying the type of output to be returned.
Valid options include:
\itemize{
\item \code{"data"}: Returns the data frame with the habit classification.
\item \code{"plot"}: Returns a ggplot object of a boxplot, showing the percentage of
periods with where habitual behaviour occurred.
\item \code{"summary"}: Returns a summary table of the habit analysis.
}}

\item{plot_mode}{Character string specifying the type of plot to be returned.
Only applicable when \code{return = "plot"}. Valid options include:
\itemize{
\item \code{"time"}: Returns a time series plot with the breakdown of users with
habitual behaviour.
\item \code{"boxplot"}: Returns a boxplot of the percentage of periods with habitual
behaviour.
}}

\item{fill_col}{Character vector of length 2 specifying the colours to be
used in the plot. Only applicable when \code{return = "plot"} and \code{plot_mode = "time"}.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

Based on the principle of consistency, this function identifies whether a
habit exists over a given interval of time. A habit is defined as a behaviour
(action taken) that is repeated at least x number of times consistently over
n weeks.
}
\details{
Each week is considered as a binary variable on whether sufficient action has
been taken for that given week (a qualifying count). Sufficiency is
determined by the \code{threshold} parameter. For instance, if the threshold is
set to 2, this means that there must be 2 qualifying actions (e.g. summarise
meeting in Copilot) in a week for there to be a qualifying count for the
week.
One way of determining the parameters would be to consider, \emph{how many counts
of \code{width} should occur within a \code{max_window} period for it to be considered
a habit?}
}
\examples{
# Return a plot
identify_habit(
  pq_data,
  metric = "Multitasking_hours",
  threshold = 1,
  width = 9,
  max_window = 12,
  return = "plot"
)

# Return a summary
identify_habit(
  pq_data,
  metric = "Multitasking_hours",
  threshold = 1,
  width = 9,
  max_window = 12,
  return = "summary"
)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_usage_segments.R
\name{identify_usage_segments}
\alias{identify_usage_segments}
\title{Identify Usage Segments based on a metric}
\usage{
identify_usage_segments(
  data,
  metric = NULL,
  metric_str = NULL,
  version = "12w",
  threshold = NULL,
  width = NULL,
  max_window = NULL,
  power_thres = 15,
  return = "data"
)
}
\arguments{
\item{data}{A data frame with a Person query containing the metric to be
classified. The data frame must include a \code{PersonId} column and a
\code{MetricDate} column.}

\item{metric}{A string representing the name of the metric column to be
classified. This parameter is used when a single column represents the
metric.}

\item{metric_str}{A character vector representing the names of multiple
columns to be aggregated for calculating a target metric, using row sum for
aggregation. This is used when \code{metric} is not provided.}

\item{version}{A string indicating the version of the classification to be
used. Valid options are \code{"12w"} for a 12-week rolling average, \code{"4w"}
for a 4-week rolling average, or \code{NULL} when using custom parameters. Defaults to \code{"12w"}.}

\item{threshold}{Numeric value specifying the minimum number of times the
metric sum up to in order to be a valid count. A 'greater than or equal to'
logic is used. Only used when \code{version} is \code{NULL}.}

\item{width}{Integer specifying the number of qualifying counts to consider
for a habit. Only used when \code{version} is \code{NULL}.}

\item{max_window}{Integer specifying the maximum unit of dates to consider a
qualifying window for a habit. Only used when \code{version} is \code{NULL}.}

\item{power_thres}{Numeric value specifying the minimum weekly average
actions required to be classified as a 'Power User'. Defaults to 15.}

\item{return}{A string indicating what to return from the function. Valid
options are:
\itemize{
\item \code{"data"}: Returns the data frame with usage segments.
\item \code{"plot"}: Returns a plot of the usage segments.
\item \code{"table"}: Returns a summary table with usage segments as columns.
}}
}
\value{
Depending on the \code{return} parameter, either a data frame with usage
segments or a plot visualizing the segments over time. If \code{"data"} is passed
to \code{return}, the following additional columns are appended:
\itemize{
\item When \code{version} is \code{"12w"} or \code{"4w"}:
\itemize{
\item \code{IsHabit12w}: Indicates whether the user has a habit based on the 12-week
rolling average.
\item \code{IsHabit4w}: Indicates whether the user has a habit based on the 4-week
rolling average.
\item \code{UsageSegments_12w}: The usage segment classification based on the
12-week rolling average.
\item \code{UsageSegments_4w}: The usage segment classification based on the 4-week
rolling average.
}
\item When \code{version} is \code{NULL}:
\itemize{
\item \code{IsHabit}: Indicates whether the user has a habit based on the provided
parameters.
\item \code{UsageSegments}: The usage segment classification based on the provided
parameters.
}
\item \code{IsHabit12w}: Indicates whether the user has a habit based on the 12-week
rolling average.
\item \code{IsHabit4w}: Indicates whether the user has a habit based on the 4-week
rolling average.
\item \code{UsageSegments_12w}: The usage segment classification based on the
12-week rolling average.
\item \code{UsageSegments_4w}: The usage segment classification based on the 4-week
rolling average.
}

If \code{"table"} is passed to \code{return}, a summary table is returned with one row
per \code{MetricDate} and usage segments as columns containing percentages. The
table includes:
\itemize{
\item \code{MetricDate}: The date of the metric
\item Segment columns (in order): \code{Non-user}, \verb{Low User}, \verb{Novice User},
\verb{Habitual User}, \verb{Power User} (only segments present in the data are included)
\item \code{n}: The total number of distinct persons for that date
}

@import slider slide_dbl
@import tidyr
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

This function identifies users into usage segments based on their usage
volume and consistency. The segments 'Power Users', 'Habitual Users', 'Novice
Users', 'Low Users', and 'Non-users' are created. There are two versions, one
based on a rolling 12-week average (\code{version = "12w"}) and the other on a
rolling 4-week average (\code{version = "4w"}). While a main use case is for
Copilot metrics e.g. 'Total_Copilot_actions', this function can be applied to
other metrics, such as 'Chats_sent'.
}
\details{
There are three ways to use this function for usage segments classification:
\enumerate{
\item \strong{12-week version} (\code{version = "12w"}): Based on a rolling 12-week period
\item \strong{4-week version} (\code{version = "4w"}): Based on a rolling 4-week period
\item \strong{Custom parameters} (\code{version = NULL}): Based on user-defined parameters
}

This function assumes that the input dataset is grouped at the weekly level
by the \code{MetricDate} column.

The definitions of the segments as per the 12-week definition are
as follows:
\itemize{
\item \strong{Power User}: Averaging 15+ weekly actions (customizable via \code{power_thres}) and any actions in at least
9 out of past 12 weeks
\item \strong{Habitual User}: Any action in at least 9 out of past 12 weeks
\item \strong{Novice User}: Averaging at least one action over the last 12 weeks
\item \strong{Low User}: Any action in the past 12 weeks
\item \strong{Non-user}: No actions in the past 12 weeks
}

The definitions of the segments as per the 4-week definition are
as follows:
\itemize{
\item \strong{Power User}: Averaging 15+ weekly actions (customizable via \code{power_thres}) and any actions in at least 4
out of past 4 weeks
\item \strong{Habitual User}: Any action in at least 4 out of past 4 weeks
\item \strong{Novice User}: Averaging at least one action over the last 4 weeks
\item \strong{Low User}: Any action in the past 4 weeks
\item \strong{Non-user}: No actions in the past 4 weeks
}

When using custom parameters (\code{version = NULL}), you must provide values for
\code{threshold}, \code{width}, \code{max_window}, and optionally \code{power_thres}. The segment definitions become:
\itemize{
\item \strong{Power User}: Minimum of \code{threshold} actions per week in at least \code{width}
out of past \code{max_window} weeks, with 15+ average weekly actions (customizable via \code{power_thres})
\item \strong{Habitual User}: Minimum of \code{threshold} actions per week in at least
\code{width} out of past \code{max_window} weeks
\item \strong{Novice User}: Average of at least one action over the last \code{max_window} weeks
\item \strong{Low User}: Any action in the past \code{max_window} weeks
\item \strong{Non-user}: No actions in the past \code{max_window} weeks
}
}
\examples{
# Example usage with a single metric column
identify_usage_segments(
  data = pq_data,
  metric = "Emails_sent",
  version = "12w",
  return = "plot"
)

# Example usage with multiple metric columns
identify_usage_segments(
  data = pq_data,
  metric_str = c(
    "Copilot_actions_taken_in_Teams",
    "Copilot_actions_taken_in_Outlook",
    "Copilot_actions_taken_in_Excel",
    "Copilot_actions_taken_in_Word",
    "Copilot_actions_taken_in_Powerpoint"
  ),
  version = "4w",
  return = "plot"
)

# Example usage with custom parameters
identify_usage_segments(
  data = pq_data,
  metric = "Emails_sent",
  version = NULL,
  threshold = 2,
  width = 5,
  max_window = 8,
  return = "plot"
)

# Example usage with custom power user threshold
identify_usage_segments(
  data = pq_data,
  metric = "Emails_sent",
  version = "12w",
  power_thres = 20,
  return = "plot"
)

# Return summary table
identify_usage_segments(
  data = pq_data,
  metric = "Emails_sent",
  version = "12w",
  return = "table"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_survival.R
\name{create_survival}
\alias{create_survival}
\title{Kaplan–Meier Survival Curve}
\usage{
create_survival(
  data,
  time_col,
  event_col,
  hrvar = NULL,
  mingroup = 5,
  na.rm = TRUE,
  return = "plot"
)
}
\arguments{
\item{data}{A person-level data frame with one row per person, as produced by
\code{\link{create_survival_prep}}. Must contain \code{time_col}, \code{event_col}, and
(when \code{hrvar} is not \code{NULL}) the grouping column.}

\item{time_col}{Character string containing the name of the time-to-event column.}

\item{event_col}{Character string containing the name of the event indicator column.
Accepted forms:
\itemize{
\item Logical (TRUE/FALSE)
\item Numeric 0/1
\item Numeric event-like (>=0): values >0 treated as event, 0 as censored
\item Character tokens ("true"/"false", "yes"/"no", "1"/"0")
}}

\item{hrvar}{Character string containing the name of the grouping column.
Supply \code{NULL} (without quotes) to compute a single overall curve.}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group size. Defaults to 5.}

\item{na.rm}{A logical value indicating whether \code{NA} should be stripped before computation proceeds.
Defaults to \code{TRUE}.}

\item{return}{String specifying what to return. This must be one of:
\itemize{
\item \code{"plot"} (default)
\item \code{"table"}
}}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A Kaplan–Meier survival curve by group.
\item \code{"table"}: data frame. A long-format survival table by group.
}
}
\description{
Computes Kaplan–Meier survival curves and returns a step-function plot by default,
with an option to return the underlying long-format survival table.

Although this function is built on \strong{survival analysis}, the framing applies
equally to positive milestones in a workforce context. In classical survival
analysis the "event" is typically something negative (death, failure); here it
is often a positive outcome — first use of a tool, first week as a power user,
first week crossing a collaboration threshold. The curve is therefore better
read as a \strong{time-to-adoption}, \strong{conversion}, or \strong{graduation} curve:
\itemize{
\item The y-axis ("survival probability") represents the share of people who have
\emph{not yet} reached the milestone.
\item A curve that drops steeply early means most people converted quickly.
\item A curve that stays high means many people had not yet converted by the end
of the observation window.
}

Supports:
\itemize{
\item Flexible grouping via \code{hrvar}
\item Privacy filtering via \code{mingroup}
}

This function expects \strong{one row per person} with a pre-computed time-to-event
column and an event indicator. Use \code{\link{create_survival_prep}} to derive
these from a Standard Person Query panel dataset.
}
\examples{
\dontrun{
library(vivainsights)
data("pq_data", package = "vivainsights")

# Step 1: convert panel data to person-level survival format
surv_data <- create_survival_prep(
  data = pq_data,
  metric = "Copilot_actions_taken_in_Teams"
)

# Step 2: plot Kaplan-Meier curves by organisation
create_survival(
  data = surv_data,
  time_col = "time",
  event_col = "event",
  hrvar = "Organization"
)

# Return the survival table instead
create_survival(
  data = surv_data,
  time_col = "time",
  event_col = "event",
  hrvar = "Organization",
  return = "table"
)
}
}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_radar}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_radar}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_sankey.R
\name{create_sankey}
\alias{create_sankey}
\title{Create a sankey chart from a two-column count table}
\usage{
create_sankey(data, var1, var2, count = "n")
}
\arguments{
\item{data}{Data frame of the long count table.}

\item{var1}{String containing the name of the variable to be shown on the
left.}

\item{var2}{String containing the name of the variable to be shown on the
right.}

\item{count}{String containing the name of the count variable.}
}
\value{
A 'sankeyNetwork' and 'htmlwidget' object containing a two-tier
sankey plot. The output can be saved locally with
\code{htmlwidgets::saveWidget()}.
}
\description{
Create a 'networkD3' style sankey chart based on a long count table
with two variables. The input data should have three columns, where
each row is a unique group:
\enumerate{
\item Variable 1
\item Variable 2
\item Count
}
}
\examples{
\donttest{
pq_data \%>\%
  dplyr::count(Organization, FunctionType) \%>\%
  create_sankey(var1 = "Organization", var2 = "FunctionType")
}

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generate_report.R
\name{read_preamble}
\alias{read_preamble}
\title{Read preamble}
\usage{
read_preamble(path)
}
\arguments{
\item{path}{Text string containing the path for the appropriate Markdown file.}
}
\value{
String containing the text read in from the specified Markdown file.
}
\description{
Read in a preamble to be used within each individual reporting function.
Reads from the Markdown file installed with the package.
}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}

Other Reports: 
\code{\link{IV_report}()},
\code{\link{generate_report}()},
\code{\link{meeting_tm_report}()},
\code{\link{validation_report}()}
}
\concept{Reports}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_hr.R
\name{extract_hr}
\alias{extract_hr}
\title{Extract HR attribute variables}
\usage{
extract_hr(data, max_unique = 50, exclude_constants = TRUE, return = "names")
}
\arguments{
\item{data}{A data frame to be passed through.}

\item{max_unique}{A numeric value representing the maximum
number of unique values to accept for an HR attribute. Defaults to 50.}

\item{exclude_constants}{Logical value to specify whether single-value HR
attributes are to be excluded. Defaults to \code{TRUE}.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"names"}
\item \code{"vars"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"names"}: character vector identifying all the names of HR variables
present in the data.
\item \code{"vars"}: data frame containing all the columns of HR variables present
in the data.
}
}
\description{
This function uses a combination of variable class,
number of unique values, and regular expression matching
to extract HR / organisational attributes from a data frame.
}
\examples{
pq_data \%>\% extract_hr(return = "names")

pq_data \%>\% extract_hr(return = "vars")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}

Other Data Validation: 
\code{\link{check_query}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_usage_segments.R
\name{plot_ts_us}
\alias{plot_ts_us}
\title{Plot Usage Segments over time}
\usage{
plot_ts_us(
  data,
  metric,
  cus,
  caption,
  threshold = NULL,
  width = NULL,
  max_window = NULL,
  power_thres = 15,
  version = NULL
)
}
\arguments{
\item{data}{A data frame with a column containing the Usage Segments, denoted
by \code{cus}. The data frame must also include a \code{MetricDate} column.}

\item{metric}{A string representing the name of the metric column to be
classified.}

\item{cus}{A string representing the name of the column containing the usage
segment classifications (e.g., "UsageSegments_12w").}

\item{caption}{A string representing the caption for the plot. This is
typically used to provide additional context or information about the
visualization.}

\item{threshold}{Numeric value specifying the minimum threshold for a valid
count. Only used when creating custom parameter captions. Defaults to NULL.}

\item{width}{Integer specifying the number of qualifying counts to consider
for a habit. Only used when creating custom parameter captions. Defaults to
NULL.}

\item{max_window}{Integer specifying the maximum window to consider for a
habit. Only used when creating custom parameter captions. Defaults to NULL.}

\item{power_thres}{Numeric value specifying the minimum weekly average
actions required to be classified as a 'Power User'. Defaults to 15.}

\item{version}{A string indicating the version of the classification. Valid
options are "12w", "4w", or NULL for custom parameters. Used to determine
which definitions to show in the caption.}
}
\value{
A ggplot object representing the stacked bar plot of usage segments.
}
\description{
Returns a vertical stacked bar plot that displays the proportion
of the Usage Segments over time. This visualization helps to understand the
distribution of user segments across different time periods. While a main
use case is for Copilot metrics, this function can be applied to other
metrics, such as 'Chats_sent'.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import_query.R
\name{import_query}
\alias{import_query}
\title{Import a query from Viva Insights Analyst Experience}
\usage{
import_query(
  x,
  pid = NULL,
  dateid = NULL,
  date_format = "\%m/\%d/\%Y",
  convert_date = TRUE,
  encoding = "UTF-8"
)
}
\arguments{
\item{x}{String containing the path to the Viva Insights query to be
imported. The input file must be a .csv file, and the file extension must
be explicitly entered, e.g. \code{"/files/standard query.csv"}}

\item{pid}{String specifying the unique person or individual identifier
variable. \code{import_query} renames this to \code{PersonId} so that this is
compatible with other functions in the package. Defaults to \code{NULL}, where
no action is taken.}

\item{dateid}{String specifying the date variable. \code{import_query} renames
this to \code{MetricDate} so that this is compatible with other functions in the
package. Defaults to \code{NULL}, where no action is taken.}

\item{date_format}{String specifying the date format for converting any
variable that may be a date to a Date variable. Defaults to \code{"\%m/\%d/\%Y"}.}

\item{convert_date}{Logical. Defaults to \code{TRUE}. When set to \code{TRUE}, any
variable that matches true with \code{is_date_format()} gets converted to a Date
variable. When set to \code{FALSE}, this step is skipped.}

\item{encoding}{String to specify encoding to be used within
\code{data.table::fread()}. See \code{data.table::fread()} documentation for more
information. Defaults to \code{'UTF-8'}.}
}
\value{
A \code{tibble} is returned.
}
\description{
Import a Viva Insights Query from a .csv file, with variable
classifications optimised for other functions in the package.
}
\details{
\code{import_query()} uses \code{data.table::fread()} to import .csv files for
speed, and by default \code{stringsAsFactors} is set to FALSE. A data frame is
returned by the function (not a \code{data.table}). Column names are automatically
cleaned, replacing spaces and special characters with underscores.
}
\seealso{
Other Import and Export: 
\code{\link{copy_df}()},
\code{\link{create_dt}()},
\code{\link{export}()},
\code{\link{prep_query}()}
}
\concept{Import and Export}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_bar.R
\name{create_bar}
\alias{create_bar}
\title{Mean Bar Plot for any metric}
\usage{
create_bar(
  data,
  metric,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  bar_colour = "default",
  na.rm = FALSE,
  percent = FALSE,
  plot_title = us_to_space(metric),
  plot_subtitle = paste("Average by", tolower(camel_clean(hrvar))),
  legend_lab = NULL,
  rank = "descending",
  xlim = NULL,
  text_just = 0.5,
  text_colour = "#FFFFFF"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{bar_colour}{String to specify colour to use for bars.
In-built accepted values include \code{"default"} (default), \code{"alert"} (red), and
\code{"darkblue"}. Otherwise, hex codes are also accepted. You can also supply
RGB values via \code{rgb2hex()}.}

\item{na.rm}{A logical value indicating whether \code{NA} should be stripped
before the computation proceeds. Defaults to \code{FALSE}.}

\item{percent}{Logical value to determine whether to show labels as
percentage signs. Defaults to \code{FALSE}.}

\item{plot_title}{An option to override plot title.}

\item{plot_subtitle}{An option to override plot subtitle.}

\item{legend_lab}{String. Option to override legend title/label. Defaults to
\code{NULL}, where the metric name will be populated instead.}

\item{rank}{String specifying how to rank the bars. Valid inputs are:
\itemize{
\item \code{"descending"} - ranked highest to lowest from top to bottom (default).
\item \code{"ascending"} - ranked lowest to highest from top to bottom.
\item \code{NULL} - uses the original levels of the HR attribute.
}}

\item{xlim}{An option to set max value in x axis.}

\item{text_just}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}} A numeric value
controlling for the horizontal position of the text labels. Defaults to
0.5.}

\item{text_colour}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}} String to specify
colour to use for the text labels. Defaults to \code{"#FFFFFF"}.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A bar plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Provides an overview analysis of a selected metric by calculating a mean per
metric.
Returns a bar plot showing the average of a selected metric by default.
Additional options available to return a summary table.
}
\examples{
# Return a ggplot bar chart
create_bar(pq_data, metric = "Collaboration_hours", hrvar = "LevelDesignation")

# Change bar colour
create_bar(pq_data,
           metric = "After_hours_collaboration_hours",
           bar_colour = "alert")

# Custom data label positions and formatting
pq_data \%>\%
  create_bar(
    metric = "Meetings",
    text_just = 1.1,
    text_colour = "black",
    xlim = 20)

# Return a summary table
create_bar(pq_data,
           metric = "Collaboration_hours",
           hrvar = "LevelDesignation",
           return = "table")
}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_bar_asis.R
\name{create_bar_asis}
\alias{create_bar_asis}
\title{Create a bar chart without aggregation for any metric}
\usage{
create_bar_asis(
  data,
  group_var,
  bar_var,
  title = NULL,
  subtitle = NULL,
  caption = NULL,
  ylab = group_var,
  xlab = bar_var,
  percent = FALSE,
  bar_colour = "default",
  rounding = 1
)
}
\arguments{
\item{data}{Plotting data as a data frame.}

\item{group_var}{String containing name of variable for the group.}

\item{bar_var}{String containing name of variable representing the value of
the bars.}

\item{title}{Title of the plot.}

\item{subtitle}{Subtitle of the plot.}

\item{caption}{Caption of the plot.}

\item{ylab}{Y-axis label for the plot (group axis)}

\item{xlab}{X-axis label of the plot (bar axis).}

\item{percent}{Logical value to determine whether to show labels as
percentage signs. Defaults to \code{FALSE}.}

\item{bar_colour}{String to specify colour to use for bars.
In-built accepted values include "default" (default), "alert" (red), and
"darkblue". Otherwise, hex codes are also accepted. You can also supply
RGB values via \code{rgb2hex()}.}

\item{rounding}{Numeric value to specify number of digits to show in data
labels}
}
\value{
'ggplot' object. A horizontal bar plot.
}
\description{
This function creates a bar chart directly from the aggregated / summarised
data. Unlike \code{create_bar()} which performs a person-level aggregation, there
is no calculation for \code{create_bar_asis()} and the values are rendered as they
are passed into the function.
}
\examples{
# Creating a custom bar plot without mean aggregation
library(dplyr)

pq_data \%>\%
  group_by(Organization) \%>\%
  summarise(across(.cols = Meeting_hours,
                   .fns = ~sum(., na.rm = TRUE))) \%>\%
  create_bar_asis(group_var = "Organization",
                  bar_var = "Meeting_hours",
                  title = "Total Meeting Hours over period",
                  subtitle = "By Organization",
                  caption = extract_date_range(pq_data, return = "text"),
                  bar_colour = "darkblue",
                  rounding = 0)

library(dplyr)

# Summarise Non-person-average median `Emails_sent`
med_df <-
  pq_data \%>\%
  group_by(Organization) \%>\%
  summarise(Emails_sent_median = median(Emails_sent))

med_df \%>\%
  create_bar_asis(
    group_var = "Organization",
    bar_var = "Emails_sent_median",
    title = "Emails sent by organization",
    subtitle = "Median values",
    bar_colour = "darkblue",
    caption = extract_date_range(pq_data, return = "text")
  )


}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/supporting_functions.R
\name{check_inputs}
\alias{check_inputs}
\title{Check whether a data frame contains all the required variable}
\usage{
check_inputs(input, requirements, return = "stop")
}
\arguments{
\item{input}{Pass a data frame for checking}

\item{requirements}{A character vector specifying the required variable names}

\item{return}{A character string specifying what to return.
The default value is "stop". Also accepts "names" and "warning".}
}
\value{
The default behaviour is to return an error message, informing the
user what variables are not included. When \code{return} is set to "names", a
character vector containing the unmatched variable names is returned.
}
\description{
Checks whether a data frame contains all the required variables.
Matching works via variable names, and used to support individual
functions in the package. Not used directly.
}
\examples{

# Return error message
\dontrun{
check_inputs(iris, c("Sepal.Length", "mpg"))
}

#' # Return warning message
check_inputs(iris, c("Sepal.Length", "mpg"), return = "warning")

# Return variable names
check_inputs(iris, c("Sepal.Length", "Sepal.Width", "RandomVariable"), return = "names")

}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{tstamp}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_scatter.R
\name{create_scatter}
\alias{create_scatter}
\title{Create a Scatter plot with two selected Viva Insights metrics (General Purpose)}
\usage{
create_scatter(
  data,
  metric_x,
  metric_y,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric_x}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{metric_y}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{HR Variable by which to split metrics, defaults to "Organization"
but accepts any character vector, e.g. "LevelDesignation"}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group size. Defaults to 5.}

\item{return}{Character vector specifying what to return, defaults to "plot".
Valid inputs are "plot" and "table".}
}
\value{
Returns a 'ggplot' object by default, where 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
}
\description{
Returns a scatter plot of two selected metrics, using colour to map
an HR attribute.
Returns a scatter plot by default, with additional options
to return a summary table.
}
\details{
This is a general purpose function that powers all the functions
in the package that produce scatter plots.
}
\examples{
create_scatter(
  pq_data,
  metric_x = "Collaboration_hours",
  metric_y = "Multitasking_hours",
  hrvar = "Organization"
  )

create_scatter(
  pq_data,
  metric_x = "Collaboration_hours",
  metric_y = "Multitasking_hours",
  hrvar = "Organization",
  mingroup = 100,
  return = "plot"
)

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/copy_df.R
\name{copy_df}
\alias{copy_df}
\title{Copy a data frame to clipboard for pasting in Excel}
\usage{
copy_df(x, row.names = FALSE, col.names = TRUE, quietly = FALSE, ...)
}
\arguments{
\item{x}{Data frame to be passed through. Cannot contain list-columns or
nested data frames.}

\item{row.names}{A logical vector for specifying whether to allow row names.
Defaults to \code{FALSE}.}

\item{col.names}{A logical vector for specifying whether to allow column
names. Defaults to \code{FALSE}.}

\item{quietly}{Set this to TRUE to not print data frame on console}

\item{...}{Additional arguments for write.table().}
}
\value{
Copies a data frame to the clipboard with no return value.
}
\description{
This is a pipe-optimised function, that feeds into \code{vivainsights::export()},
but can be used as a stand-alone function.

Based on the original function from
\url{https://github.com/martinctc/surveytoolbox}.
}
\seealso{
Other Import and Export: 
\code{\link{create_dt}()},
\code{\link{export}()},
\code{\link{import_query}()},
\code{\link{prep_query}()}
}
\concept{Import and Export}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calculate_distribution_summary.R
\name{calculate_distribution_summary}
\alias{calculate_distribution_summary}
\title{Calculate Distribution Summary Statistics}
\usage{
calculate_distribution_summary(plot_data, metric)
}
\arguments{
\item{plot_data}{A data frame containing the metric data with columns:
\itemize{
\item \code{group}: The grouping variable
\item \verb{<metric>}: The metric column (name specified in metric parameter)
}}

\item{metric}{Character string containing the name of the metric column}
}
\value{
A data frame with distribution statistics:
\itemize{
\item \code{group}: The grouping variable
\item \code{mean}: Mean of the metric
\item \code{min}: Minimum value of the metric
\item \code{p10}: 10th percentile of the metric
\item \code{p25}: 25th percentile of the metric
\item \code{p50}: 50th percentile (median) of the metric
\item \code{p75}: 75th percentile of the metric
\item \code{p90}: 90th percentile of the metric
\item \code{max}: Maximum value of the metric
\item \code{sd}: Standard deviation of the metric
\item \code{range}: Range of the metric (max - min)
\item \code{n}: Number of observations
}
}
\description{
Internal helper function to calculate comprehensive distribution statistics
for a given metric grouped by a categorical variable. Used by create_hist(),
create_density(), and create_boxplot() to ensure consistent output.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/anonymise.R
\name{anonymise}
\alias{anonymise}
\alias{anonymize}
\title{Anonymise a categorical variable by replacing values}
\usage{
anonymise(x, scramble = FALSE, replacement = NULL)

anonymize(x, scramble = FALSE, replacement = NULL)
}
\arguments{
\item{x}{Character vector to be passed through.}

\item{scramble}{Logical value determining whether to randomise values in the
categorical variable.}

\item{replacement}{Character vector containing the values to replace original
values in the categorical variable. The length of the vector must be at
least as great as the number of unique values in the original variable.
Defaults to \code{NULL}, where the replacement would consist of \code{"Team A"},
\code{"Team B"}, etc.}
}
\value{
Character vector with the same length as input \code{x}, replaced with values
provided in \code{replacement}.
}
\description{
Anonymize categorical variables such as HR variables by replacing values with
dummy team names such as 'Team A'. The behaviour is to make 1 to 1
replacements by default, but there is an option to completely randomise
values in the categorical variable.
}
\examples{
unique(anonymise(pq_data$Organization))

rep <- c("Manager+", "Manager", "IC")
unique(anonymise(pq_data$Layer), replacement = rep)

}
\seealso{
jitter
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/g2g_data.R
\docType{data}
\name{g2g_data}
\alias{g2g_data}
\title{Sample Group-to-Group dataset}
\format{
A data frame with 150 rows and 11 variables:
\describe{
\item{PrimaryCollaborator_Organization}{ }
\item{PrimaryCollaborator_GroupSize}{ }
\item{SecondaryCollaborator_Organization}{ }
\item{SecondaryCollaborator_GroupSize}{ }
\item{MetricDate}{ }
\item{Percent_Group_collaboration_time_invested}{ }
\item{Group_collaboration_time_invested}{ }
\item{Group_email_sent_count}{ }
\item{Group_email_time_invested}{ }
\item{Group_meeting_count}{ }
\item{Group_meeting_time_invested}{ }
...
}
}
\source{
\url{https://analysis.insights.cloud.microsoft/analyst/analysis/}
}
\usage{
g2g_data
}
\value{
data frame.
}
\description{
A demo dataset representing a Group-to-Group Query. The grouping
organizational attribute used here is \code{Organization}, where the variable have
been prefixed with \code{PrimaryCollaborator_} and \code{SecondaryCollaborator_} to represent the
direction of collaboration.
}
\seealso{
Other Data: 
\code{\link{mt_data}},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()},
\code{\link{pq_data}}

Other Network: 
\code{\link{network_g2g}()},
\code{\link{network_p2p}()},
\code{\link{network_summary}()},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()}
}
\concept{Data}
\concept{Network}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/email_line.R
\name{email_line}
\alias{email_line}
\title{Email Time Trend - Line Chart}
\usage{
email_line(
  data,
  hrvar = "Organization",
  mingroup = 5,
  return = "plot",
  label = FALSE
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{label}{Logical value to determine whether to show data point labels on
the plot. If \code{TRUE}, both \code{geom_point()} and \code{geom_text()} are added to
display data labels rounded to 1 decimal place above each data point.
Defaults to \code{FALSE}.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A faceted line plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
Provides a week by week view of email time, visualised as line charts.
By default returns a line chart for email hours,
with a separate panel per value in the HR attribute.
Additional options available to return a summary table.
}
\examples{
# Return a line plot
email_line(pq_data, hrvar = "LevelDesignation")

# Return summary table
email_line(pq_data, hrvar = "LevelDesignation", return = "table")

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Emails: 
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()}
}
\concept{Emails}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_rogers.R
\name{create_rogers}
\alias{create_rogers}
\title{Generate Rogers Adoption Curve plots for Copilot usage}
\usage{
create_rogers(
  data,
  hrvar = NULL,
  metric,
  width = 9,
  max_window = 12,
  threshold = 1,
  start_metric = NULL,
  return = "plot",
  plot_mode = 1,
  label = FALSE
)
}
\arguments{
\item{data}{Data frame containing Person Query data to be analyzed. Must
contain \code{PersonId}, \code{MetricDate}, and the specified metrics.}

\item{hrvar}{Character string specifying the HR attribute or organizational
variable to group by. Default is \code{NULL}, for no grouping.}

\item{metric}{Character string containing the name of the metric to analyze
for habit identification, e.g. "Total_Copilot_actions". This is passed to
\code{identify_habit()}.}

\item{width}{Integer specifying the number of qualifying counts to consider
for a habit. Passed to \code{identify_habit()}. Default is 9.}

\item{max_window}{Integer specifying the maximum unit of dates to consider a
qualifying window for a habit. Passed to \code{identify_habit()}. Default is 12.}

\item{threshold}{Numeric value specifying the minimum threshold for the
metric to be considered a qualifying count. Passed to \code{identify_habit()}.
Default is 1.}

\item{start_metric}{Character string containing the name of the metric used
for determining enablement start date. This metric should track when users
first gained access to the technology being analyzed. The function identifies
the earliest date where this metric is greater than 0 for each user as their
"enablement date". This is then used in plot modes 3 and 4 to calculate
time-to-adoption and Rogers segment classifications. The suggested variable
is "Total_Copilot_enabled_days", but any metric that indicates access or
licensing status can be used (e.g., "License_assigned_days", "Access_granted").
This parameter is optional for plot modes 1 and 2, but required for plot modes
3 and 4. When \code{return = "data"} and \code{start_metric} is provided, Rogers segment
classifications will be included in the returned data frame. Default is \code{NULL}.}

\item{return}{Character vector specifying what to return. Valid inputs are
"plot", "data", and "table". Default is "plot".}

\item{plot_mode}{Integer or character string determining which plot to return.
Valid inputs are:
\itemize{
\item 1 or "cumulative": Rogers Adoption Curve showing cumulative adoption
\item 2 or "weekly": Weekly Rate of adoption showing new habitual users
\item 3 or "enablement": Enablement-based adoption rate with Rogers segments
\item 4 or "cumulative_enablement": Cumulative adoption adjusted for enablement
}
Default is 1.}

\item{label}{Logical value to determine whether to show data point labels on
the plot for cumulative adoption curves (plot modes 1 and 4). If \code{TRUE},
both \code{geom_point()} and \code{geom_text()} are added to display data labels
rounded to 1 decimal place above each data point. Defaults to \code{FALSE}.}
}
\value{
Returns a 'ggplot' object by default when 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
When 'data' is passed, the processed data with habit classifications is returned.

When \code{return = "data"}, the returned data frame includes:
\itemize{
\item All original columns from the input data
\item \code{IsHabit}: Binary indicator of whether the user has developed a habit
\item \code{adoption_week}: The week when the user first exhibited habitual behavior
\item \code{enable_week}: (if \code{start_metric} provided) The week when the user was first enabled
\item \code{weeks_to_adopt}: (if \code{start_metric} provided) Number of weeks from enablement to adoption
\item \code{RogersSegment}: (if \code{start_metric} provided) Rogers adoption segment classification:
\itemize{
\item "Innovators" (fastest 2.5\\%)
\item "Early Adopters" (next 13.5\\%)
\item "Early Majority" (next 34\\%)
\item "Late Majority" (next 34\\%)
\item "Laggards" (slowest 16\\%)
}
}
}
\description{
Creates various visualizations based on the Rogers adoption curve theory,
analyzing the adoption patterns of Copilot usage. The function identifies
habitual users using the \code{identify_habit()} function and then creates
adoption curve visualizations based on different time frames and
organizational groupings.
}
\details{
This function provides four distinct plot modes to analyze adoption patterns:

\strong{Plot Mode 1 - Cumulative Adoption Curve:}
Shows the classic Rogers adoption curve with cumulative percentage of habitual
users over time. This S-shaped curve helps identify the pace of adoption and
when saturation begins. Steep sections indicate rapid adoption periods, while
flat sections suggest slower uptake or natural limits.

\strong{Plot Mode 2 - Weekly Adoption Rate:}
Displays the number of new habitual users identified each week, with a
3-week moving average line to smooth volatility. This view helps identify
adoption spikes, seasonal patterns, and the natural ebb and flow of user
onboarding. High bars indicate successful onboarding periods.

\strong{Plot Mode 3 - Enablement-Based Adoption:}
Analyzes adoption relative to when users were first enabled (had access).
Users are classified into Rogers segments (Innovators, Early Adopters,
Early/Late Majority, Laggards) based on how quickly they adopted after
enablement. This helps understand the natural distribution of adoption
speed within your organization.

\strong{Plot Mode 4 - Cumulative Enablement-Adjusted:}
Similar to Mode 1 but only includes users who had enablement data, providing
a more accurate view of adoption among those who actually had access to the
technology. This removes noise from users who may not have been properly
enabled.

\strong{Interpretation Guidelines:}
\itemize{
\item Early steep curves suggest strong product-market fit
\item Plateaus may indicate training needs or feature limitations
\item Seasonal patterns often reflect organizational training cycles
\item Rogers segments help identify user personas for targeted interventions
}
}
\examples{
# Basic Rogers adoption curve
create_rogers(
  data = pq_data,
  metric = "Copilot_actions_taken_in_Teams",
  plot_mode = 1
)

# Weekly adoption rate by organization
create_rogers(
  data = pq_data,
  hrvar = "Organization",
  metric = "Copilot_actions_taken_in_Teams",
  plot_mode = 2
)

# Enablement-based adoption
create_rogers(
  data = pq_data,
  metric = "Copilot_actions_taken_in_Teams",
  start_metric = "Total_Copilot_enabled_days",
  plot_mode = 3
)

# Return data with Rogers segments
rogers_data <- create_rogers(
  data = pq_data,
  metric = "Copilot_actions_taken_in_Teams",
  start_metric = "Total_Copilot_enabled_days",
  return = "data"
)

# Rogers adoption curve with data point labels
create_rogers(
  data = pq_data,
  metric = "Copilot_actions_taken_in_Teams",
  plot_mode = 1,
  label = TRUE
)

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}
}
\author{
Chris Gideon \href{mailto:chris.gideon@microsoft.com}{chris.gideon@microsoft.com}
}
\concept{Adoption Analysis}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_holidayweeks.R
\name{identify_holidayweeks}
\alias{identify_holidayweeks}
\title{Identify Holiday Weeks based on outliers}
\usage{
identify_holidayweeks(data, sd = 1, return = "message")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{sd}{The standard deviation below the mean for collaboration hours that
should define an outlier week. Enter a positive number. Default is 1
standard deviation.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"message"} (default)
\item \code{"data"}
\item \code{"data_cleaned"}
\item \code{"data_dirty"}
\item \code{"plot"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"message"}: message on console. a message is printed identifying holiday
weeks.
\item \code{"data"}: data frame. A dataset with outlier weeks flagged in a new
column is returned as a dataframe.
\item \code{"data_cleaned"}: data frame. A dataset with outlier weeks removed is
returned.
\item \code{"data_dirty"}: data frame. A dataset with only outlier weeks is
returned.
\item \code{"plot"}: ggplot object. A line plot of Collaboration Hours with holiday
weeks highlighted.
}
}
\description{
This function scans a standard query output for weeks where collaboration
hours is far outside the mean. Returns a list of weeks that appear to be
holiday weeks and optionally an edited dataframe with outliers removed. By
default, missing values are excluded.

As best practice, run this function prior to any analysis to remove atypical
collaboration weeks from your dataset.
}
\section{Metrics used}{

The metric \code{Collaboration_hours} is used in the calculations. Please ensure
that your query contains a metric with the exact same name.
}

\examples{
# Return a message by default
identify_holidayweeks(pq_data)

# Return plot
identify_holidayweeks(pq_data, return = "plot")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/network_summary.R
\name{network_summary}
\alias{network_summary}
\title{Summarise node centrality statistics with an igraph object}
\usage{
network_summary(graph, hrvar = NULL, return = "table")
}
\arguments{
\item{graph}{'igraph' object that can be returned from \code{network_g2g()} or
\code{network_p2p()}when the \code{return} argument is set to \code{"network"}.}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{NULL}.}

\item{return}{String specifying what output to return. Valid inputs include:
\itemize{
\item \code{"table"}
\item \code{"network"}
\item \code{"plot"}
}

See \code{Value} for more information.}
}
\value{
By default, a data frame containing centrality statistics. Available
statistics include:
\itemize{
\item betweenness: number of shortest paths going through a node.
\item closeness: number of steps required to access every other node from a
given node.
\item degree: number of connections linked to a node.
\item eigenvector: a measure of the influence a node has on a network.
\item pagerank: calculates the PageRank for the specified vertices.
Please refer to the igraph package documentation for the detailed technical
definition.
}

When \code{"network"} is passed to \code{"return"}, an 'igraph' object is returned with
additional node attributes containing centrality scores.

When \code{"plot"} is passed to \code{"return"}, a summary table is returned showing
the average centrality scores by HR attribute. This is currently available if
there is a valid HR attribute.
}
\description{
Pass an igraph object to the function and obtain centrality statistics for
each node in the object as a data frame. This function works as a wrapper of
the centralization functions in 'igraph'.
}
\examples{
# Simulate a p2p network
p2p_data <- p2p_data_sim(size = 100)
g <- network_p2p(data = p2p_data, return = "network")

# Return summary table
network_summary(graph = g, return = "table")

# Return network with node centrality statistics
network_summary(graph = g, return = "network")

# Return summary plot
network_summary(graph = g, return = "plot", hrvar = "Organization")

# Simulate a g2g network and return table
g2 <- g2g_data \%>\% network_g2g(return = "network")
network_summary(graph = g2, return = "table")

}
\seealso{
Other Network: 
\code{\link{g2g_data}},
\code{\link{network_g2g}()},
\code{\link{network_p2p}()},
\code{\link{p2p_data}},
\code{\link{p2p_data_sim}()}
}
\concept{Network}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_datefreq.R
\name{identify_datefreq}
\alias{identify_datefreq}
\title{Identify date frequency based on a series of dates}
\usage{
identify_datefreq(x)
}
\arguments{
\item{x}{Vector containing a series of dates.}
}
\value{
String describing the detected date frequency, i.e.:
\itemize{
\item \code{'daily'}
\item \code{'weekly'}
\item \code{'monthly'}
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

Takes a vector of dates and identify whether the frequency is 'daily',
'weekly', or 'monthly'. The primary use case for this function is to provide
an accurate description of the query type used and for raising errors should
a wrong date grouping be used in the data input.
}
\details{
Date frequency detection works as follows:
\itemize{
\item If at least three days of the week are present (e.g., Monday, Wednesday,
Thursday) in the series, then the series is classified as 'daily'
\item If the total number of months in the series is equal to the length, then
the series is classified as 'monthly'
\item If the total number of sundays in the series is equal to the length of
the series, then the series is classified as 'weekly
}
}
\section{Limitations}{

One of the assumptions made behind the classification is that weeks are
denoted with Sundays, hence the count of sundays to measure the number of
weeks. In this case, weeks where a Sunday is missing would result in an
'unable to classify' error.

Another assumption made is that dates are evenly distributed, i.e. that the
gap between dates are equal. If dates are unevenly distributed, e.g. only two
days of the week are available for a given week, then the algorithm will fail
to identify the frequency as 'daily'.
}

\examples{
start_date <- as.Date("2022/06/26")
end_date <- as.Date("2022/11/27")

# Daily
day_seq <-
  seq.Date(
    from = start_date,
    to = end_date,
    by = "day"
  )

identify_datefreq(day_seq)

# Weekly
week_seq <-
  seq.Date(
    from = start_date,
    to = end_date,
    by = "week"
  )

identify_datefreq(week_seq)

# Monthly
month_seq <-
  seq.Date(
    from = start_date,
    to = end_date,
    by = "month"
  )
identify_datefreq(month_seq)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hrvar_count.R
\name{hrvar_count}
\alias{hrvar_count}
\alias{analysis_scope}
\title{Create a count of distinct people in a specified HR variable}
\usage{
hrvar_count(data, hrvar = "Organization", return = "plot")

analysis_scope(data, hrvar = "Organization", return = "plot")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{HR Variable by which to split metrics, defaults to
"Organization" but accepts any character vector, e.g. "LevelDesignation".
If a vector with more than one value is provided, the HR attributes are
automatically concatenated.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object containing a bar plot.
\item \code{"table"}: data frame containing a count table.
}
}
\description{
This function enables you to create a count of the distinct people
by the specified HR attribute.The default behaviour is to return a
bar chart as typically seen in 'Analysis Scope'.
}
\examples{
# Return a bar plot
hrvar_count(pq_data, hrvar = "LevelDesignation")

# Return a summary table
hrvar_count(pq_data, hrvar = "LevelDesignation", return = "table")

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_density.R
\name{create_density}
\alias{create_density}
\title{Create a density plot for any metric}
\usage{
create_density(
  data,
  metric,
  hrvar = "Organization",
  mingroup = 5,
  ncol = NULL,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{String containing the name of the metric,
e.g. "Collaboration_hours"}

\item{hrvar}{String containing the name of the HR Variable by which to split
metrics. Defaults to \code{"Organization"}. To run the analysis on the total
instead of splitting by an HR attribute, supply \code{NULL} (without quotes).}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{ncol}{Numeric value setting the number of columns on the plot. Defaults
to \code{NULL} (automatic).}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
\item \code{"data"}
\item \code{"frequency"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A faceted density plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric, containing the
following columns:
\itemize{
\item \code{group}: The HR variable by which the metric is split.
\item \code{mean}: The mean of the metric.
\item \code{min}: The minimum value of the metric.
\item \code{p10}: The 10th percentile of the metric.
\item \code{p25}: The 25th percentile of the metric.
\item \code{p50}: The 50th percentile of the metric.
\item \code{p75}: The 75th percentile of the metric.
\item \code{p90}: The 90th percentile of the metric.
\item \code{max}: The maximum value of the metric.
\item \code{sd}: The standard deviation of the metric.
\item \code{range}: The range of the metric.
\item \code{n}: The number of observations.
}
\item \code{"data"}: data frame. Data with calculated person averages.
\item \verb{"frequency}: list of data frames. Each data frame contains the
frequencies used in each panel of the plotted histogram.
}
}
\description{
Provides an analysis of the distribution of a selected metric.
Returns a faceted density plot by default.
Additional options available to return the underlying frequency table.
}
\examples{
# Return plot for whole organization
create_density(pq_data, metric = "Collaboration_hours", hrvar = NULL)

# Return plot
create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization")

# Return plot but coerce plot to three columns
create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", ncol = 3)

# Return summary table
create_density(pq_data, metric = "Collaboration_hours", hrvar = "Organization", return = "table")
}
\seealso{
Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}
}
\concept{Flexible}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flag_ch_ratio.R
\name{flag_ch_ratio}
\alias{flag_ch_ratio}
\title{Flag unusual high collaboration hours to after-hours collaboration
hours ratio}
\usage{
flag_ch_ratio(data, threshold = c(1, 30), return = "message")
}
\arguments{
\item{data}{A data frame containing a Person Query.}

\item{threshold}{Numeric value specifying the threshold for flagging.
Defaults to 30.}

\item{return}{String to specify what to return. Options include:
\itemize{
\item \code{"message"}
\item \code{"text"}
\item \code{"data"}
}}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"message"}: message in the console containing diagnostic summary
\item \code{"text"}: string containing diagnostic summary
\item \code{"data"}: data frame. Person-level data with flags on unusually high or
low ratios
}
}
\description{
This function flags persons who have an unusual ratio
of collaboration hours to after-hours collaboration hours.
Returns a character string by default.
}
\section{Metrics used}{

The metric \code{Collaboration_hours} is used in the calculations. Please ensure
that your query contains a metric with the exact same name.
}

\examples{
flag_ch_ratio(pq_data)


data.frame(PersonId = c("Alice", "Bob"),
           Collaboration_hours = c(30, 0.5),
           After_hours_collaboration_hours = c(0.5, 30)) \%>\%
  flag_ch_ratio()

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_survival.R
\name{create_survival_viz}
\alias{create_survival_viz}
\title{Kaplan–Meier Survival Curve (Visualization)}
\usage{
create_survival_viz(
  data,
  hrvar = "group",
  title = "Survival Curve",
  subtitle = "Kaplan–Meier estimate",
  caption = NULL
)
}
\arguments{
\item{data}{Long survival table produced by \code{create_survival_calc()}.}

\item{hrvar}{Character. Group column name in \code{data}.}

\item{title, subtitle}{Character. Plot annotations.}

\item{caption}{Character string for the plot caption. Typically the output
of \code{extract_date_range(data, return = "text")}, as constructed by
\code{create_survival()}. Defaults to \code{NULL} (no caption).}
}
\value{
ggplot object.
}
\description{
Renders a Kaplan–Meier step curve by group from a long-format survival table.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meeting_tm_report.R
\name{meeting_tm_report}
\alias{meeting_tm_report}
\title{Generate a Meeting Text Mining report in HTML}
\usage{
meeting_tm_report(
  data,
  path = "meeting text mining report",
  stopwords = NULL,
  timestamp = TRUE,
  keep = 100,
  seed = 100
)
}
\arguments{
\item{data}{A Meeting Query dataset in the form of a data frame.}

\item{path}{Pass the file path and the desired file name, \emph{excluding the file
extension}. For example, \code{"meeting text mining report"}.}

\item{stopwords}{A character vector OR a single-column data frame labelled
\code{'word'} containing custom stopwords to remove.}

\item{timestamp}{Logical vector specifying whether to include a timestamp in
the file name. Defaults to TRUE.}

\item{keep}{A numeric vector specifying maximum number of words to keep.}

\item{seed}{A numeric vector to set seed for random generation.}
}
\value{
An HTML report with the same file name as specified in the arguments is
generated in the working directory. No outputs are directly returned by the
function.
}
\description{
Create a text mining report in HTML based on Meeting Subject Lines
}
\details{
Note that the column \code{Subject} must be available within the input data frame
in order to run.d
}
\section{How to run}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{meeting_tm_report(mt_data)
}\if{html}{\out{</div>}}

This will generate a HTML report as specified in \code{path}.
}

\seealso{
Other Reports: 
\code{\link{IV_report}()},
\code{\link{generate_report}()},
\code{\link{read_preamble}()},
\code{\link{validation_report}()}

Other Meetings: 
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()}

Other Text-mining: 
\code{\link{pairwise_count}()},
\code{\link{tm_clean}()},
\code{\link{tm_cooc}()},
\code{\link{tm_freq}()},
\code{\link{tm_wordcloud}()}
}
\concept{Meetings}
\concept{Reports}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xicor.R
\name{xicor}
\alias{xicor}
\title{Calculate Chatterjee's Rank Correlation Coefficient}
\usage{
xicor(x, y, ties = FALSE)
}
\arguments{
\item{x}{A numeric vector representing the independent variable.}

\item{y}{A numeric vector representing the dependent variable.}

\item{ties}{A logical value indicating whether to handle ties in the data.
Default is FALSE.

If \code{ties = TRUE}, the function adjusts for tied ranks (repeated values in the
data). This is important when there are many tied values in either \code{x} or
\code{y}, as it ensures accurate calculation by considering the maximum rank for
tied observations.

If \code{ties = FALSE}, the function assumes that there are no ties, or that ties
can be handled without additional computational effort. This option can offer
better performance when ties are rare or absent.}
}
\value{
A numeric value representing Chatterjee's rank correlation coefficient.
}
\description{
This function calculates Chatterjee's rank correlation coefficient, which
measures the association between two variables. It is particularly useful for
identifying monotonic relationships between variables, even if they are not
linear.
}
\details{
Unlike Pearson's correlation (which measures linear relationships),
Chatterjee's coefficient can handle non-linear monotonic relationships. It is
robust to outliers and can handle tied ranks, making it versatile for
datasets with ordinal data or tied ranks. This makes it a valuable
alternative to Spearman's and Kendall's correlations, especially when the
data may not meet the assumptions required by these methods.

By default, \code{ties = FALSE} is set to prioritize computational efficiency, as
handling ties requires additional processing. In cases where ties are present
or likely (such as when working with ordinal or categorical data), it is
recommended to set \code{ties = TRUE}.
}
\examples{
xicor(x = pq_data$Collaboration_hours, y = pq_data$Internal_network_size, ties = TRUE)
xicor(x = pq_data$Collaboration_hours, y = pq_data$Internal_network_size, ties = FALSE)


}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_privacythreshold.R
\name{identify_privacythreshold}
\alias{identify_privacythreshold}
\title{Identify groups under privacy threshold}
\usage{
identify_privacythreshold(
  data,
  hrvar = extract_hr(data),
  mingroup = 5,
  return = "table"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{A list of HR Variables to consider in the scan.
Defaults to all HR attributes identified.}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group
size. Defaults to 5.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"table"}
\item \code{"text"}
}

See \code{Value} for more information.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"table"}: data frame. A summary table of groups that fall below the
privacy threshold.
\item \code{"text"}: string. A diagnostic message.
}

Returns a ggplot object by default, where 'plot' is passed in \code{return}.
When 'table' is passed, a summary table is returned as a data frame.
}
\description{
This function scans a standard query output for groups with of employees
under the privacy threshold. The method consists in reviewing each individual
HR attribute, and count the distinct people within each group.
}
\examples{
\dontrun{
# Return a summary table
pq_data \%>\% identify_privacythreshold(return = "table")

# Return a diagnostic message
pq_data \%>\% identify_privacythreshold(return = "text")
}

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_outlier}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_survival.R
\name{create_survival_calc}
\alias{create_survival_calc}
\title{Kaplan–Meier Survival Curve (Calculation)}
\usage{
create_survival_calc(
  data,
  time_col,
  event_col,
  hrvar = NULL,
  id_col = "PersonId",
  mingroup = 5,
  na.rm = TRUE
)
}
\arguments{
\item{data}{data.frame.}

\item{time_col}{Character. Time-to-event column name.}

\item{event_col}{Character. Event indicator column name.}

\item{hrvar}{Character or NULL. Grouping column name.}

\item{id_col}{Character. Optional id column name for distinct counts.}

\item{mingroup}{Numeric. Minimum group size.}

\item{na.rm}{Logical. Drop missing values in required columns.}
}
\value{
A list with elements:
\itemize{
\item \code{table}: long survival table with columns (group, time, survival, at_risk, events, n)
\item \code{counts}: group size table
}
}
\description{
Computes a long-format Kaplan–Meier survival table by group and applies a minimum group
size threshold (\code{mingroup}).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_tracking.R
\name{create_tracking}
\alias{create_tracking}
\title{Create a line chart that tracks metrics over time with a 4-week
rolling average}
\usage{
create_tracking(
  data,
  metric,
  plot_title = us_to_space(metric),
  plot_subtitle = "Measure over time",
  percent = FALSE
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"
percentage signs. Defaults to \code{FALSE}.}

\item{plot_title}{An option to override plot title.}

\item{plot_subtitle}{An option to override plot subtitle.}

\item{percent}{Logical value to determine whether to show labels as
percentage signs. Defaults to \code{FALSE}.}
}
\value{
A different output is returned depending on the value passed to the \code{return} argument:
\itemize{
\item \code{"plot"}: 'ggplot' object. A time-series plot for the metric.
\item \code{"table"}: data frame. A summary table for the metric.
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

Create a two-series line chart that visualizes a set of metric over time for
the selected population, with one of the series being a four-week rolling
average.
}
\examples{
pq_data \%>\%
  create_tracking(
    metric = "Collaboration_hours",
    percent = FALSE
  )

}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_period_scatter}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/p2p_data.R
\docType{data}
\name{p2p_data}
\alias{p2p_data}
\title{Sample person-to-person dataset}
\format{
A data frame with 11550 rows and 13 variables:
\describe{
\item{PrimaryCollaborator_PersonId}{ }
\item{SecondaryCollaborator_PersonId}{ }
\item{MetricDate}{ }
\item{Diverse_tie_score}{ }
\item{Diverse_tie_type}{ }
\item{Strong_tie_score}{ }
\item{Strong_tie_type}{ }
\item{PrimaryCollaborator_Organization}{ }
\item{SecondaryCollaborator_Organization}{ }
\item{PrimaryCollaborator_LevelDesignation}{ }
\item{SecondaryCollaborator_LevelDesignation}{ }
\item{PrimaryCollaborator_FunctionType}{ }
\item{SecondaryCollaborator_FunctionType}{ }

...
}
}
\source{
\url{https://analysis.insights.cloud.microsoft/analyst/analysis/}
}
\usage{
p2p_data
}
\value{
data frame.
}
\description{
A demo dataset representing a person-to-person query, structured as an
edgelist. The identifier variable for each person is \code{PersonId}, where the
variables have been prefixed with \code{PrimaryCollaborator_} and
\code{SecondaryCollaborator_} to represent the direction of collaboration.
}
\seealso{
Other Data: 
\code{\link{g2g_data}},
\code{\link{mt_data}},
\code{\link{p2p_data_sim}()},
\code{\link{pq_data}}

Other Network: 
\code{\link{g2g_data}},
\code{\link{network_g2g}()},
\code{\link{network_p2p}()},
\code{\link{network_summary}()},
\code{\link{p2p_data_sim}()}
}
\concept{Data}
\concept{Network}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prep_query.R
\name{prep_query}
\alias{prep_query}
\title{Prepare variable names and types in query data frame for analysis}
\usage{
prep_query(data, convert_date = TRUE, date_format = "\%m/\%d/\%Y")
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame. You
should pass the data frame that is read into R using \emph{any other method}
other than \code{import_query()}, as \code{import_query()} automatically performs the
same variable operations.}

\item{convert_date}{Logical. Defaults to \code{TRUE}. When set to \code{TRUE}, any
variable that matches true with \code{is_date_format()} gets converted to a Date
variable. When set to \code{FALSE}, this step is skipped.}

\item{date_format}{String specifying the date format for converting any
variable that may be a date to a Date variable. Defaults to \code{"\%m/\%d/\%Y"}.}
}
\value{
A \code{tibble} with the cleaned data frame is returned.
}
\description{
For applying to data frames that are read into R using \emph{any
other method} other than \code{import_query()}, this function cleans variable
names by replacing special characters and converting the relevant variable
types so that they are compatible with the rest of the functions in
\strong{vivainsights}.
}
\section{Examples}{


The following shows when and how to use \code{prep_query()}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{ pq_df <- read.csv("path_to_query.csv")
 cleaned_df <- pq_df |> prep_query()
}\if{html}{\out{</div>}}

You can then run checks to see that the variables are of the correct type:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{dplyr::glimpse(cleaned_df)
}\if{html}{\out{</div>}}
}

\seealso{
Other Import and Export: 
\code{\link{copy_df}()},
\code{\link{create_dt}()},
\code{\link{export}()},
\code{\link{import_query}()}
}
\concept{Import and Export}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tm_cooc.R
\name{tm_cooc}
\alias{tm_cooc}
\title{Analyse word co-occurrence in subject lines and return a network plot}
\usage{
tm_cooc(data, stopwords = NULL, seed = 100, return = "plot", lmult = 0.05)
}
\arguments{
\item{data}{A Meeting Query dataset in the form of a data frame.}

\item{stopwords}{A character vector OR a single-column data frame labelled
\code{'word'} containing custom stopwords to remove.}

\item{seed}{A numeric vector to set seed for random generation.}

\item{return}{String specifying what to return. This must be one of the
following strings:
\itemize{
\item \code{"plot"}
\item \code{"table"}
}

See \code{Value} for more information.}

\item{lmult}{A multiplier to adjust the line width in the output plot.
Defaults to 0.05.}
}
\value{
A different output is returned depending on the value passed to the \code{return}
argument:
\itemize{
\item \code{"plot"}: 'ggplot' and 'ggraph' object. A network plot.
\item \code{"table"}: data frame. A summary table.
}
}
\description{
This function generates a word co-occurrence network plot, with options to
return a table. This function is used within \code{meeting_tm_report()}.
}
\details{
This function uses \code{tm_clean()} as the underlying data wrangling function.
There is an option to remove stopwords by passing a data frame into the
\code{stopwords} argument.
}
\section{Example}{

The function can be run with subject lines from \code{mt_data}, as per below.

\if{html}{\out{<div class="sourceCode">}}\preformatted{mt_data \%>\%
  tm_cooc(lmult = 0.01)
}\if{html}{\out{</div>}}
}

\examples{
# Demo using a subset of `mt_data`
}
\seealso{
Other Text-mining: 
\code{\link{meeting_tm_report}()},
\code{\link{pairwise_count}()},
\code{\link{tm_clean}()},
\code{\link{tm_freq}()},
\code{\link{tm_wordcloud}()}
}
\author{
Carlos Morales \href{mailto:carlos.morales@microsoft.com}{carlos.morales@microsoft.com}
}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_period_scatter.R
\name{create_period_scatter}
\alias{create_period_scatter}
\title{Period comparison scatter plot for any two metrics}
\usage{
create_period_scatter(
  data,
  hrvar = "Organization",
  metric_x = "Large_and_long_meeting_hours",
  metric_y = "Meeting_hours",
  before_start = min(as.Date(data$MetricDate, "\%m/\%d/\%Y")),
  before_end,
  after_start = as.Date(before_end) + 1,
  after_end = max(as.Date(data$MetricDate, "\%m/\%d/\%Y")),
  before_label = "Period 1",
  after_label = "Period 2",
  mingroup = 5,
  return = "plot"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{hrvar}{HR Variable by which to split metrics. Accepts a character vector,
defaults to "Organization" but accepts any character vector, e.g. "LevelDesignation"}

\item{metric_x}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{metric_y}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}

\item{before_start}{Start date of "before" time period in YYYY-MM-DD}

\item{before_end}{End date of "before" time period in YYYY-MM-DD}

\item{after_start}{Start date of "after" time period in YYYY-MM-DD}

\item{after_end}{End date of "after" time period in YYYY-MM-DD}

\item{before_label}{String to specify a label for the "before" period. Defaults to "Period 1".}

\item{after_label}{String to specify a label for the "after" period. Defaults to "Period 2".}

\item{mingroup}{Numeric value setting the privacy threshold / minimum group size.
Defaults to 5.}

\item{return}{Character vector specifying what to return, defaults to "plot".
Valid inputs are "plot" and "table".}
}
\value{
Returns a 'ggplot' object showing two scatter plots side by side representing
the two periods.
}
\description{
Returns two side-by-side scatter plots representing two selected metrics,
using colour to map an HR attribute and size to represent number of employees.
Returns a faceted scatter plot by default, with additional options
to return a summary table.
}
\details{
This is a general purpose function that powers all the functions
in the package that produce faceted scatter plots.
}
\examples{
# Return plot
create_period_scatter(pq_data,
                      hrvar = "LevelDesignation",
                      before_start = "2024-05-01",
                      before_end = "2024-05-31",
                      after_start = "2024-06-01",
                      after_end = "2024-07-03")

# Return a summary table
create_period_scatter(pq_data, before_end = "2024-05-31", return = "table")


}
\seealso{
Other Visualization: 
\code{\link{afterhours_dist}()},
\code{\link{afterhours_fizz}()},
\code{\link{afterhours_line}()},
\code{\link{afterhours_rank}()},
\code{\link{afterhours_summary}()},
\code{\link{afterhours_trend}()},
\code{\link{collaboration_area}()},
\code{\link{collaboration_dist}()},
\code{\link{collaboration_fizz}()},
\code{\link{collaboration_line}()},
\code{\link{collaboration_rank}()},
\code{\link{collaboration_sum}()},
\code{\link{collaboration_trend}()},
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_rank}()},
\code{\link{create_rogers}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()},
\code{\link{email_dist}()},
\code{\link{email_fizz}()},
\code{\link{email_line}()},
\code{\link{email_rank}()},
\code{\link{email_summary}()},
\code{\link{email_trend}()},
\code{\link{external_dist}()},
\code{\link{external_fizz}()},
\code{\link{external_line}()},
\code{\link{external_rank}()},
\code{\link{external_sum}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_trend}()},
\code{\link{keymetrics_scan}()},
\code{\link{meeting_dist}()},
\code{\link{meeting_fizz}()},
\code{\link{meeting_line}()},
\code{\link{meeting_rank}()},
\code{\link{meeting_summary}()},
\code{\link{meeting_trend}()},
\code{\link{one2one_dist}()},
\code{\link{one2one_fizz}()},
\code{\link{one2one_freq}()},
\code{\link{one2one_line}()},
\code{\link{one2one_rank}()},
\code{\link{one2one_sum}()},
\code{\link{one2one_trend}()}

Other Flexible: 
\code{\link{create_bar}()},
\code{\link{create_bar_asis}()},
\code{\link{create_boxplot}()},
\code{\link{create_bubble}()},
\code{\link{create_density}()},
\code{\link{create_dist}()},
\code{\link{create_fizz}()},
\code{\link{create_hist}()},
\code{\link{create_inc}()},
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_rank}()},
\code{\link{create_sankey}()},
\code{\link{create_scatter}()},
\code{\link{create_stacked}()},
\code{\link{create_tracking}()},
\code{\link{create_trend}()}

Other Time-series: 
\code{\link{create_line}()},
\code{\link{create_line_asis}()},
\code{\link{create_trend}()}
}
\concept{Flexible}
\concept{Time-series}
\concept{Visualization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vivainsights-package.R
\docType{package}
\name{vivainsights-package}
\alias{vivainsights}
\alias{vivainsights-package}
\title{vivainsights: Analyze and Visualize Data from 'Microsoft Viva Insights'}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Provides a versatile range of functions, including exploratory data analysis, time-series analysis, organizational network analysis, and data validation, whilst at the same time implements a set of best practices in analyzing and visualizing data specific to 'Microsoft Viva Insights'.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://microsoft.github.io/vivainsights/}
  \item Report bugs at \url{https://github.com/microsoft/vivainsights/issues/}
}

}
\author{
\strong{Maintainer}: Martin Chan \email{martin.chan@microsoft.com}

Authors:
\itemize{
  \item Carlos Morales \email{carlos.morales@microsoft.com}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_outlier.R
\name{identify_outlier}
\alias{identify_outlier}
\title{Identify metric outliers over a date interval}
\usage{
identify_outlier(
  data,
  group_var = "MetricDate",
  metric = "Collaboration_hours"
)
}
\arguments{
\item{data}{A Standard Person Query dataset in the form of a data frame.}

\item{group_var}{A string with the name of the grouping variable.
Defaults to \code{Date}.}

\item{metric}{Character string containing the name of the metric,
e.g. "Collaboration_hours"}
}
\value{
Returns a data frame with \code{MetricDate} (if grouping variable is not set),
the metric, and the corresponding z-score.
}
\description{
This function takes in a selected metric and uses
z-score (number of standard deviations) to identify outliers
across time. There are applications in this for identifying
weeks with abnormally low collaboration activity, e.g. holidays.
Time as a grouping variable can be overridden with the \code{group_var}
argument.
}
\examples{
identify_outlier(pq_data, metric = "Collaboration_hours")

}
\seealso{
Other Data Validation: 
\code{\link{check_query}()},
\code{\link{extract_hr}()},
\code{\link{flag_ch_ratio}()},
\code{\link{flag_em_ratio}()},
\code{\link{flag_extreme}()},
\code{\link{flag_outlooktime}()},
\code{\link{hr_trend}()},
\code{\link{hrvar_count}()},
\code{\link{hrvar_count_all}()},
\code{\link{hrvar_trend}()},
\code{\link{identify_churn}()},
\code{\link{identify_holidayweeks}()},
\code{\link{identify_inactiveweeks}()},
\code{\link{identify_nkw}()},
\code{\link{identify_privacythreshold}()},
\code{\link{identify_shifts}()},
\code{\link{identify_tenure}()},
\code{\link{track_HR_change}()},
\code{\link{validation_report}()}
}
\concept{Data Validation}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tm_clean.R
\name{tm_clean}
\alias{tm_clean}
\title{Clean subject line text prior to analysis}
\usage{
tm_clean(data, token = "words", stopwords = NULL, ...)
}
\arguments{
\item{data}{A Meeting Query dataset in the form of a data frame.}

\item{token}{A character vector accepting either \code{"words"} or \code{"ngrams"},
determining type of tokenisation to return.}

\item{stopwords}{A character vector OR a single-column data frame labelled
\code{'word'} containing custom stopwords to remove.}

\item{...}{Additional parameters to pass to \code{tidytext::unnest_tokens()}.}
}
\value{
data frame with two columns:
\itemize{
\item \code{line}
\item \code{word}
}
}
\description{
This function processes the \code{Subject} column in a Meeting Query by applying
tokenisation using\code{tidytext::unnest_tokens()}, and removing any stopwords
supplied in a data frame (using the argument \code{stopwords}). This is a
sub-function that feeds into \code{tm_freq()}, \code{tm_cooc()}, and \code{tm_wordcloud()}.
The default is to return a data frame with tokenised counts of words or
ngrams.
}
\examples{
# words
tm_clean(mt_data)

# ngrams
tm_clean(mt_data, token = "ngrams")

}
\seealso{
Other Text-mining: 
\code{\link{meeting_tm_report}()},
\code{\link{pairwise_count}()},
\code{\link{tm_cooc}()},
\code{\link{tm_freq}()},
\code{\link{tm_wordcloud}()}
}
\concept{Text-mining}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tstamp.R
\name{tstamp}
\alias{tstamp}
\title{Generate a time stamp}
\usage{
tstamp()
}
\value{
String containing the timestamp in the format \code{'yymmdd_hhmmss'}.
}
\description{
This function generates a time stamp of the format \code{'yymmdd_hhmmss'}.
This is a support function and is not intended for direct use.
}
\seealso{
Other Support: 
\code{\link{any_idate}()},
\code{\link{camel_clean}()},
\code{\link{check_inputs}()},
\code{\link{cut_hour}()},
\code{\link{extract_date_range}()},
\code{\link{extract_hr}()},
\code{\link{heat_colours}()},
\code{\link{is_date_format}()},
\code{\link{maxmin}()},
\code{\link{pairwise_count}()},
\code{\link{read_preamble}()},
\code{\link{rgb2hex}()},
\code{\link{totals_bind}()},
\code{\link{totals_col}()},
\code{\link{us_to_space}()},
\code{\link{wrap}()}
}
\concept{Support}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/identify_retention.R
\name{identify_retention}
\alias{identify_retention}
\title{Identify Retention Rate Between Two Time Periods}
\usage{
identify_retention(
  data,
  start_x,
  end_x,
  start_y,
  end_y = NULL,
  category,
  category_values = TRUE,
  return = "summary"
)
}
\arguments{
\item{data}{A data frame containing person-level time series data with at
minimum \code{PersonId}, \code{MetricDate}, and the column specified in \code{category}.}

\item{start_x}{Start date for the first time period (Date or character in
\code{"YYYY-MM-DD"} format).}

\item{end_x}{End date for the first time period (exclusive).}

\item{start_y}{Start date for the second time period.}

\item{end_y}{End date for the second time period (exclusive). If \code{NULL},
uses all data from \code{start_y} onwards.}

\item{category}{A string specifying the column name containing the
binary/categorical variable to evaluate (e.g. \code{"IsHabitualUser"}).}

\item{category_values}{A character vector of values in \code{category} that
define the "positive" condition (e.g. \code{c("Power User", "Habitual User")}).
Defaults to \code{TRUE} for binary columns.}

\item{return}{A string specifying the return type. Valid options are:
\itemize{
\item \code{"summary"} (default): A tibble with retention statistics.
\item \code{"data"}: A list with person-level retention status and breakdown.
\item \code{"message"}: Prints a formatted message and returns the summary tibble
invisibly.
}}
}
\value{
Depending on \code{return}:
\itemize{
\item \code{"summary"}: A tibble with the following columns:
\itemize{
\item \code{PeriodX_Start}, \code{PeriodX_End}: Start and end dates of period X.
\item \code{PeriodY_Start}, \code{PeriodY_End}: Start and end dates of period Y.
\item \code{Category}: The category column name.
\item \code{CategoryValues}: The category values used.
\item \code{N_Original}: Number of individuals meeting the condition in period X.
\item \code{N_Tracked}: Number of those individuals found in period Y.
\item \code{N_Lost}: Number of individuals not found in period Y.
\item \code{N_Retained}: Number still meeting the condition in period Y.
\item \code{RetentionPct}: Retention percentage.
}
\item \code{"data"}: A list containing \code{summary}, \code{person_status}, and \code{breakdown}.
\item \code{"message"}: Prints a formatted message; returns the summary tibble
invisibly.
}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#experimental}{\figure{lifecycle-experimental.svg}{options: alt='[Experimental]'}}}{\strong{[Experimental]}}

This function calculates the retention rate of individuals who meet a
specific category condition in one time period and checks whether they still
meet that condition in a subsequent time period. This function complements
\code{identify_usage_segments()}.
}
\examples{
\dontrun{
# Retention of Power/Habitual users from Nov 2025 to Jan 2026
identify_retention(
  data = pq_week_df,
  start_x = "2025-11-01",
  end_x = "2025-12-01",
  start_y = "2026-01-01",
  end_y = "2026-02-01",
  category = "UsageSegments_12w",
  category_values = c("Power User", "Habitual User")
)
}

}
\author{
Martin Chan
}
